GNU bug report logs - #36649
27.0.50; pure space and pdumper

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Pip Cet <pipcet@HIDDEN>; Keywords: patch; dated Sun, 14 Jul 2019 14:27:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 18 May 2021 13:33:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue May 18 09:33:45 2021
Received: from localhost ([127.0.0.1]:54690 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lizqz-0001IL-Ak
	for submit <at> debbugs.gnu.org; Tue, 18 May 2021 09:33:45 -0400
Received: from quimby.gnus.org ([95.216.78.240]:41922)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lizqx-0001I7-7f
 for 36649 <at> debbugs.gnu.org; Tue, 18 May 2021 09:33:44 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=R8ub67kEwKZzeR4n4QZSb1GzikA1CDLWeMu2CuG5Asw=; b=W3S6H6TI19wI2U/fuBK7MoP4Hc
 UaY9vckUzU7I07vDAtCYNRXAnf7BwxJRezxxWisAdxULR/hjA7J0eixk4lnACKtlCzLtFP/xQFjne
 WAS6zBA2VEBheIl1yomE+AqFp1qQjSHOda38RrAJ5/fGc4czFUiO1CCotoziDikITWFY=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lizqk-0005a4-EG; Tue, 18 May 2021 15:33:33 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN> <87a6oupzn1.fsf@HIDDEN>
 <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
 <83k0nxu062.fsf@HIDDEN> <87y2cdjvjh.fsf@HIDDEN>
 <87im3h8m85.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEX+/vzlzZ6/lWz7
 98+XbEs2Lif///9n/utRAAAAAWJLR0QGYWa4fQAAAAd0SU1FB+UFEg0PE7NT/rcAAAGpSURBVDjL
 ddRLdusgDABQJ7TzAO68UsncDukCqoj5ey3sfyuVIORLPXAc3YMEipxpul7OrzHG6ekyEOMQNju5
 XeFr6U+Huiz27+W7g32A0gHq/ZKrlPe/4N/5iWAyfok9V7kUOdnFSPwKvQjhYuJ0OYnArp1PYIO7
 W2hFjJfI/Yr/DXbnXfVtuVTOsNyDUI2Y9yc4N/e02qXC8gR+GsH0tcYx0AE/hsAr+CGEKMXlmE/w
 qSdcB/BykrgdpNqytdYPYMOEQ9gygR+NVuC24BGOzNhm8T6XY2Yq5B9gdUEgp5LhNpd1YEOoUEq2
 lyVbQrkCJ1YohTrNEoZag0u7oGUTADvfQmHfAGwtjpS61Mn5RGu1BiHtO2SFV5A4EkvGuQZTbnO7
 Bd0Vkm4hl5Q5/TQwkqcSAuTC3ylJyjpjR5Y1TtfBnIn2bN8aHAIgoEOy6DjvCVNQMHElhxJDuVnC
 ULdVIWpZmLWQlR/LhgbSzVkhBDkIEEinzFzqCxOP2kZpSajgo9EebuIVWE8jo7Iq6D/OAZAFpFvy
 KUOk74OOXnRLYO2iJMvyy0uy6RfLPnvmOhjsugAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMS0wNS0x
 OFQxMzoxNToxOCswMDowMCmsDEEAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEtMDUtMThUMTM6MTU6
 MTgrMDA6MDBY8bT9AAAAAElFTkSuQmCC
X-Now-Playing: Zola Jesus's _Taiga_: "Nail"
Date: Tue, 18 May 2021 15:33:29 +0200
In-Reply-To: <87im3h8m85.fsf@HIDDEN> (Andreas Schwab's message of "Mon, 17
 May 2021 16:32:26 +0200")
Message-ID: <871ra4go9i.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Andreas Schwab <schwab@HIDDEN> writes: > On Mai 17
 2021, Lars Ingebrigtsen wrote: > >> worries about unexec is what's stalling
 the removal of pure space, >> too. > > unexec does not really depend on pure
 space. Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: Paul Eggert <eggert@HIDDEN>, rpluim@HIDDEN, stefan@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andreas Schwab <schwab@HIDDEN> writes:

> On Mai 17 2021, Lars Ingebrigtsen wrote:
>
>> worries about unexec is what's stalling the removal of pure space,
>> too.
>
> unexec does not really depend on pure space.

No, but Eli was worried that applying this patch would further
destabilise the unexec code, which I think is fair.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 14:32:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 10:32:40 2021
Received: from localhost ([127.0.0.1]:53343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lieIO-0005R2-VM
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 10:32:40 -0400
Received: from mail-out.m-online.net ([212.18.0.10]:34087)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1lieIJ-0005Qq-Of
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 10:32:35 -0400
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4FkM6N6BQPz1sHpG;
 Mon, 17 May 2021 16:32:28 +0200 (CEST)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4FkM6N03WQz1qqkv;
 Mon, 17 May 2021 16:32:27 +0200 (CEST)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id 3is3aMFXaFOL; Mon, 17 May 2021 16:32:27 +0200 (CEST)
X-Auth-Info: ZBXq7yF8r5sObLR6deREd1L4TUZRtwfY6A8MRJHNzCHqCgdzVYC2N/o5wzMN6Z2O
Received: from igel.home (ppp-46-244-160-196.dynamic.mnet-online.de
 [46.244.160.196])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Mon, 17 May 2021 16:32:27 +0200 (CEST)
Received: by igel.home (Postfix, from userid 1000)
 id A11692C367F; Mon, 17 May 2021 16:32:26 +0200 (CEST)
From: Andreas Schwab <schwab@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN> <87a6oupzn1.fsf@HIDDEN>
 <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
 <83k0nxu062.fsf@HIDDEN> <87y2cdjvjh.fsf@HIDDEN>
X-Yow: HELLO KITTY gang terrorizes town, family STICKERED to death!
Date: Mon, 17 May 2021 16:32:26 +0200
In-Reply-To: <87y2cdjvjh.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Mon,
 17 May 2021 16:15:46 +0200")
Message-ID: <87im3h8m85.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 36649
Cc: Paul Eggert <eggert@HIDDEN>, rpluim@HIDDEN, stefan@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

On Mai 17 2021, Lars Ingebrigtsen wrote:

> worries about unexec is what's stalling the removal of pure space,
> too.

unexec does not really depend on pure space.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 14:24:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 10:24:22 2021
Received: from localhost ([127.0.0.1]:53326 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lieAK-0005DW-MH
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 10:24:22 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33422)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lieAE-0005DG-Sc
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 10:24:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43938)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lieA7-0004C1-7A; Mon, 17 May 2021 10:24:03 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4216
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lie9s-0005Jp-W4; Mon, 17 May 2021 10:24:03 -0400
Date: Mon, 17 May 2021 17:23:50 +0300
Message-Id: <83a6ottp55.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87y2cdjvjh.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 17 May 2021 16:15:46 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN> <87a6oupzn1.fsf@HIDDEN>
 <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
 <83k0nxu062.fsf@HIDDEN> <87y2cdjvjh.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Paul Eggert <eggert@HIDDEN>,  rpluim@HIDDEN,  stefan@HIDDEN,
>   schwab@HIDDEN,  monnier@HIDDEN,  pipcet@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Mon, 17 May 2021 16:15:46 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Since we decided not to remove unexec in Emacs 28, we do need to keep
> > the unexec configuration working.  So I find it unfortunate that you
> > keep saying that, because the result is a direct contradiction of what
> > we decided.
> 
> Well, if we decided something at one point, we can decide something else
> now.

We can, but we really shouldn't in this case.  We never remove
obsolete features so quickly, and I see no reason to do this now.

> The question is whether it makes sense to spend time trying to fix
> something that's not being used.  Keeping unexec around in a broken
> state isn't very satisfying, and worries about unexec is what's stalling
> the removal of pure space, too.
> 
> So at this point I think I'd rather just remove unexec now instead of
> waiting until Emacs 29.

I see no reason for the rush, Emacs 28 is not around the corner
anyway.  We have enough new and important features there that will
take us time to shake out all the bugs and stabilize the codebase.

If no one else is willing to debug the unexec problems, I will do it
myself, at my own pace.  Just leave it to me.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 14:16:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 10:16:02 2021
Received: from localhost ([127.0.0.1]:53316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lie2M-0003l7-38
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 10:16:02 -0400
Received: from quimby.gnus.org ([95.216.78.240]:58102)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lie2J-0003e2-FZ
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 10:15:59 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=b5/yGqxTZJkWt+fDn61VaMC0eUU1tH5QwbNbIJiLu1k=; b=hequGs79tAtI4X2sqjA77OoKRO
 YaKtzaOhoyMcdz1gIOr2clf2+SSWcWE9GHnNrNB1/eQEBHZeD3Dm5lg9izX1qaIFsANgYI/TFnRk5
 20em9I0FlD8A6O2c/h7sxD6OcCrtqWFcZPsAiaAXnKG5bH3Cp+CFbxjStWwYA817D0l4=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lie27-0000Jt-IQ; Mon, 17 May 2021 16:15:49 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN> <87a6oupzn1.fsf@HIDDEN>
 <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
 <83k0nxu062.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEVIbDtPakO1k4Fh
 VTidTDe6PjlIUD////+9YGZ5AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+UFEQ01Gv2TN4QAAAGlSURB
 VDjLdZNBb+sgDMed0fWcbNLOT920c/RMOFcCen5S8D0Trb//R3g27RZIO6tExj//bZNQgG4oBl0/
 dEMPALrkMWysl8QOYLgC8cTpb6DXjaxeHtBJKflJrFOnk5guFTyV2ppyLSVpr7p/OUANygCvYwE3
 xWoDWIkdDn/uQG+S+zr8/XRtXEexc0ZEXrAhOqNjRp9d2JQCMMwcEPOmuYI3jh5Ll2ND2QY6cekx
 N2CPuJjMi7i2CuMIGSVoji2IRC57vpVZZ94RUToHrymI4w/orQAKgRajWlqbT6oIRGhDpERjVUr3
 wkSaKK0vC2Kk+VKA8EoBONEpS5egzag++TPNbxd/jW9AOp1LPEX6VwE5SYglfZZ2fgXmB+h0qZJE
 iqEEy+THSiF7H1W0ObtsE9jvgmsTNGikso3JUXNETZl0eSfiaip1n0cwclF2Y/VKCtid3BktLs1d
 0DJm5gsFxw0wRYbTzF/cXhL9kB4xyL3zWwApO7m/jHdg3Ctx070EsuMAOR7vCZj32/Bb230oHR+A
 kv0A7JfyLL783x/brwB+BY/tP0rubGCTDWEYAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTA1LTE3
 VDEzOjUzOjI2KzAwOjAwxDEUAAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wNS0xN1QxMzo1Mzoy
 NiswMDowMLVsrLwAAAAASUVORK5CYII=
X-Now-Playing: Jay Glass Dubs's _Nyx_: "An Ambivalent Path"
Date: Mon, 17 May 2021 16:15:46 +0200
In-Reply-To: <83k0nxu062.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 17 May
 2021 13:25:41 +0300")
Message-ID: <87y2cdjvjh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Since we decided not
 to remove unexec in Emacs 28, we do need to keep > the unexec configuration
 working. So I find it unfortunate that you > keep saying that, because the
 result is a direct contrad [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: Paul Eggert <eggert@HIDDEN>, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Since we decided not to remove unexec in Emacs 28, we do need to keep
> the unexec configuration working.  So I find it unfortunate that you
> keep saying that, because the result is a direct contradiction of what
> we decided.

Well, if we decided something at one point, we can decide something else
now.

The question is whether it makes sense to spend time trying to fix
something that's not being used.  Keeping unexec around in a broken
state isn't very satisfying, and worries about unexec is what's stalling
the removal of pure space, too.

So at this point I think I'd rather just remove unexec now instead of
waiting until Emacs 29.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 14:13:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 10:13:48 2021
Received: from localhost ([127.0.0.1]:53310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lie0C-0002li-Ll
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 10:13:48 -0400
Received: from quimby.gnus.org ([95.216.78.240]:58074)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lie0A-0002lU-E7
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 10:13:47 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=86GaWaaVTbp28NUuhns2XQzzhQ55b7HWbhvHz4r8BnY=; b=UtVugDWFG+x0qYbQEM/G7WwXJK
 tWyb9nLpPMAU597e1LPUMt6FOgEpJQeQ7rndZu0LIsNGvn4icZfN7KFegf+6tXU+5wyPEEhASEVfS
 DLLx3W52TD7zflVxD7/iAOwcYiEoVhnuik5ZbilOtgy9CDfKv6BHw2taYJ9JDDyWsXQs=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lidzx-0000G1-Lu; Mon, 17 May 2021 16:13:35 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Paul Eggert <eggert@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN> <87a6oupzn1.fsf@HIDDEN>
 <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEVIbDtPakO1k4Fh
 VTidTDe6PjlIUD////+9YGZ5AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+UFEQ01Gv2TN4QAAAGlSURB
 VDjLdZNBb+sgDMed0fWcbNLOT920c/RMOFcCen5S8D0Trb//R3g27RZIO6tExj//bZNQgG4oBl0/
 dEMPALrkMWysl8QOYLgC8cTpb6DXjaxeHtBJKflJrFOnk5guFTyV2ppyLSVpr7p/OUANygCvYwE3
 xWoDWIkdDn/uQG+S+zr8/XRtXEexc0ZEXrAhOqNjRp9d2JQCMMwcEPOmuYI3jh5Ll2ND2QY6cekx
 N2CPuJjMi7i2CuMIGSVoji2IRC57vpVZZ94RUToHrymI4w/orQAKgRajWlqbT6oIRGhDpERjVUr3
 wkSaKK0vC2Kk+VKA8EoBONEpS5egzag++TPNbxd/jW9AOp1LPEX6VwE5SYglfZZ2fgXmB+h0qZJE
 iqEEy+THSiF7H1W0ObtsE9jvgmsTNGikso3JUXNETZl0eSfiaip1n0cwclF2Y/VKCtid3BktLs1d
 0DJm5gsFxw0wRYbTzF/cXhL9kB4xyL3zWwApO7m/jHdg3Ctx070EsuMAOR7vCZj32/Bb230oHR+A
 kv0A7JfyLL783x/brwB+BY/tP0rubGCTDWEYAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTA1LTE3
 VDEzOjUzOjI2KzAwOjAwxDEUAAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wNS0xN1QxMzo1Mzoy
 NiswMDowMLVsrLwAAAAASUVORK5CYII=
X-Now-Playing: Jay Glass Dubs's _Nyx_: "An Ambivalent Path"
Date: Mon, 17 May 2021 16:13:33 +0200
In-Reply-To: <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN> (Paul Eggert's
 message of "Mon, 17 May 2021 01:43:31 -0700")
Message-ID: <8735ulla7m.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Paul Eggert <eggert@HIDDEN> writes: > If unexec is used
 on GNU/Linux, Emacs is supposed to switch ASLR off > by using "setfattr -n
 user.pax.flags -v er temacs",
 and if that > doesn't work by using the personality
 syscall and then re-exe [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: rpluim@HIDDEN, stefan@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Paul Eggert <eggert@HIDDEN> writes:

> If unexec is used on GNU/Linux, Emacs is supposed to switch ASLR off
> by using "setfattr -n user.pax.flags -v er temacs", and if that
> doesn't work by using the personality syscall and then re-execing
> itself (see maybe_disable_address_randomization).

Ah, thanks.  My src/Makefile had

## If needed, the names of the paxctl and setfattr programs.
## On grsecurity/PaX systems, unexec will fail due to a gap between
## the bss section and the heap.  Older versions need paxctl to work
## around this, newer ones setfattr.  See Bug#11398 and Bug#16343.
PAXCTL = 
SETFATTR = 
## Commands to set PaX flags on dumped and not-dumped instances of Emacs.
PAXCTL_dumped = 
PAXCTL_notdumped = 

because the "attr" package wasn't installed, so there was no setfattr
executable. 

(So if we want to continue supporting unexec, we should probably add
that as a configure requirement, perhaps.)

With that, Emacs now fails in a different way -- instead of segfaulting,
I get to:

make[2]: Entering directory '/home/larsi/src/emacs/xo/lisp'
  ELC      international/titdic-cnv.elc
corrupted double-linked list
Fatal error 6: Aborted
Backtrace:
../src/bootstrap-emacs[0x525571]
../src/bootstrap-emacs[0x4203b6]
../src/bootstrap-emacs[0x420889]

But as you say, debugging this is pretty much a waste of time.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 10:25:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 06:25:59 2021
Received: from localhost ([127.0.0.1]:51951 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1liaRd-0003Qk-RR
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 06:25:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:56080)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1liaRb-0003QX-4Q
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 06:25:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34302)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1liaRO-0005lX-A1; Mon, 17 May 2021 06:25:42 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4790
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1liaRN-0002uu-TG; Mon, 17 May 2021 06:25:38 -0400
Date: Mon, 17 May 2021 13:25:41 +0300
Message-Id: <83k0nxu062.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Paul Eggert <eggert@HIDDEN>
In-Reply-To: <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN> (message from
 Paul Eggert on Mon, 17 May 2021 01:43:31 -0700)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN> <838s4j3l2e.fsf@HIDDEN>
 <87h7j7g7ft.fsf@HIDDEN> <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN> <83a6oy20bj.fsf@HIDDEN>
 <87a6oupzn1.fsf@HIDDEN> <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: rpluim@HIDDEN, stefan@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Cc: rpluim@HIDDEN, stefan@HIDDEN, schwab@HIDDEN,
>  monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
>  akrl@HIDDEN
> From: Paul Eggert <eggert@HIDDEN>
> Date: Mon, 17 May 2021 01:43:31 -0700
> 
> I doubt whether it's worth spending much time debugging the problem, 
> since nobody uses unexec on GNU/Linux any more.

Since we decided not to remove unexec in Emacs 28, we do need to keep
the unexec configuration working.  So I find it unfortunate that you
keep saying that, because the result is a direct contradiction of what
we decided.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 17 May 2021 08:43:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 17 04:43:41 2021
Received: from localhost ([127.0.0.1]:51846 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1liYqj-0000rf-7X
	for submit <at> debbugs.gnu.org; Mon, 17 May 2021 04:43:41 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:43266)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1liYqh-0000rQ-Sn
 for 36649 <at> debbugs.gnu.org; Mon, 17 May 2021 04:43:40 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 2F6E6160098;
 Mon, 17 May 2021 01:43:33 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id l873-RUear0o; Mon, 17 May 2021 01:43:32 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 7BEA71600A7;
 Mon, 17 May 2021 01:43:32 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id n-gDaalNLnFB; Mon, 17 May 2021 01:43:32 -0700 (PDT)
Received: from [192.168.1.9] (cpe-172-91-119-151.socal.res.rr.com
 [172.91.119.151])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 3B1A8160098;
 Mon, 17 May 2021 01:43:32 -0700 (PDT)
To: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN> <838s4j3l2e.fsf@HIDDEN>
 <87h7j7g7ft.fsf@HIDDEN> <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN> <83a6oy20bj.fsf@HIDDEN>
 <87a6oupzn1.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <85567d83-7ec6-c5e7-81f2-74b0b310eefc@HIDDEN>
Date: Mon, 17 May 2021 01:43:31 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.8.1
MIME-Version: 1.0
In-Reply-To: <87a6oupzn1.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: rpluim@HIDDEN, stefan@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 5/16/21 6:38 AM, Lars Ingebrigtsen wrote:

> I thought we had ASLR switched on on GNU/Linux builds?

If unexec is used on GNU/Linux, Emacs is supposed to switch ASLR off by=20
using "setfattr -n user.pax.flags -v er temacs", and if that doesn't=20
work by using the personality syscall and then re-execing itself (see=20
maybe_disable_address_randomization).

I doubt whether it's worth spending much time debugging the problem,=20
since nobody uses unexec on GNU/Linux any more.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 16 May 2021 13:46:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 16 09:46:50 2021
Received: from localhost ([127.0.0.1]:49888 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1liH6X-0006rf-QU
	for submit <at> debbugs.gnu.org; Sun, 16 May 2021 09:46:49 -0400
Received: from quimby.gnus.org ([95.216.78.240]:47028)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1liH6T-0006lJ-BJ
 for 36649 <at> debbugs.gnu.org; Sun, 16 May 2021 09:46:48 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=riG3iaH5AnBjqytMrwu+bnjyHQYBJxHl5g1BCfnbCS8=; b=ggKfAYyqCbLh6Y+u8jr+YHy16Y
 LtrN6ow0K9+bE9oQH3089m7G554K0f0mp0UNTkuk9NoUTTbcc+4W7EZUQpLs0PmPWXCpw6640mhKr
 hLpi3xpf0nmKtdI99ENLi2xJF7J5ZSDLHqU+KxeFoBqCO7QJ9j7nexg6JDNxknjXaEHA=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1liH6G-0007Uj-ER; Sun, 16 May 2021 15:46:35 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
 <877dk3enzm.fsf@HIDDEN>
 <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
 <xjfsg2qpbup.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAALVBMVEUifSYtgi8ngCce
 eyYchCE4aiVeXzDLKUviH1KkPkPbJFEhex4eeR0iaR7///9kUa2UAAAAAWJLR0QOb70wTwAAAAd0
 SU1FB+UFEA0VDspxoD4AAAGUSURBVDjLbZO9TsNADMfNpQvKkvYJLlYXtkj3AhVSkVgRojvqgNgY
 kHiCVmRCTBU7orqJPY/QvALvgu273kcSK4ru/Mvf9vkcuJh7QwRQiFjLrgKAWgOgRlTaETHyk5Pf
 oMCZQiWgCZ5oAkwBE4CCGDMGShQGAjJNAhp5PDBO75KnClMYJ8BB8KI5Kzh7SpoYKhNk5zCTQHOJ
 4YixWkxq9UA7RQXTB68rmLLxObLko1hyH3oyA19wVlVC9AQgoqncZjoYhCYWqwDqhQDfkPU2yxG+
 mm12Z4krihey/fq5T6ut/KzAZWtfVxBHUVZaQXGwdn/nd+Sn2eUlwm1r7fGDAJ+B/HOn1bMnS+DR
 Z0aZdgE3JLDvK9c/xX+CA7NnFnyyW3GKs0Kv31iA0eTHIbLh1C/RX3NyApJ6vxgCkNzH7yySD4UH
 224TQBJXFV61u+sU4MJ3Rx+2KgPSPyp/+ZAL3IVwd5ZDvxsfRUiGVvHaT4m7WoXxYsFHKuEX+Bla
 2Z+6rgQY4VPPhK3supT89X3fBYPA/gGhXXr1ewIzvQAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMS0w
 NS0xNlQxMzoyMToxNCswMDowMF6HVuUAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEtMDUtMTZUMTM6
 MjE6MTQrMDA6MDAv2u5ZAAAAAElFTkSuQmCC
X-Now-Playing: Gil Scott-Heron & Jamie Xx's _We're New Here_: "I'll Take
 Care Of U"
Date: Sun, 16 May 2021 15:46:31 +0200
In-Reply-To: <xjfsg2qpbup.fsf@HIDDEN> (Andrea Corallo's message of "Thu, 13
 May 2021 21:23:10 +0000")
Message-ID: <875yzipz9k.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Andrea Corallo <akrl@HIDDEN> writes: > Right, if you like
 me to have a look to the native-comp side would be > handy to have this patch
 pushed as a git branch on our repo. I've now pushed a new branch called
 scratch/no-purespace
 which has Pip's patch with some merge fix-ups from me. It builds fine without
 native-comp, but has many errors in comp.c if enabled. So feel fr [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, Stefan Monnier <monnier@HIDDEN>,
 Pip Cet <pipcet@HIDDEN>, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrea Corallo <akrl@HIDDEN> writes:

> Right, if you like me to have a look to the native-comp side would be
> handy to have this patch pushed as a git branch on our repo.

I've now pushed a new branch called scratch/no-purespace which has Pip's
patch with some merge fix-ups from me.  It builds fine without
native-comp, but has many errors in comp.c if enabled.  So feel free to
fix that up.  :-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 16 May 2021 13:38:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 16 09:38:44 2021
Received: from localhost ([127.0.0.1]:49879 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1liGyh-0005F4-Ox
	for submit <at> debbugs.gnu.org; Sun, 16 May 2021 09:38:43 -0400
Received: from quimby.gnus.org ([95.216.78.240]:46736)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1liGyf-0005Es-Uf
 for 36649 <at> debbugs.gnu.org; Sun, 16 May 2021 09:38:42 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=IBbMfNRE7dFnO6iUikgTigGNBLqbKE16mr99IpjOegY=; b=ftP12mxJLebYGae/otgGwLojQF
 ElUqK5fekLqzv2FOZ7VZtGZzNgkNBGZgsCcVzSCKxo7Y05qIbzC0TccPf/+mmpYXQvMS9bRzemapa
 6I0FAyaRwvP3ssaHzKaS0lta+YJiAvd98CKYv7+O9VnZRSq4PnukrSYBpY+iTK9pHaH4=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1liGyR-0007Nk-NY; Sun, 16 May 2021 15:38:30 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <83a6oy20bj.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAALVBMVEUifSYtgi8ngCce
 eyYchCE4aiVeXzDLKUviH1KkPkPbJFEhex4eeR0iaR7///9kUa2UAAAAAWJLR0QOb70wTwAAAAd0
 SU1FB+UFEA0VDspxoD4AAAGUSURBVDjLbZO9TsNADMfNpQvKkvYJLlYXtkj3AhVSkVgRojvqgNgY
 kHiCVmRCTBU7orqJPY/QvALvgu273kcSK4ru/Mvf9vkcuJh7QwRQiFjLrgKAWgOgRlTaETHyk5Pf
 oMCZQiWgCZ5oAkwBE4CCGDMGShQGAjJNAhp5PDBO75KnClMYJ8BB8KI5Kzh7SpoYKhNk5zCTQHOJ
 4YixWkxq9UA7RQXTB68rmLLxObLko1hyH3oyA19wVlVC9AQgoqncZjoYhCYWqwDqhQDfkPU2yxG+
 mm12Z4krihey/fq5T6ut/KzAZWtfVxBHUVZaQXGwdn/nd+Sn2eUlwm1r7fGDAJ+B/HOn1bMnS+DR
 Z0aZdgE3JLDvK9c/xX+CA7NnFnyyW3GKs0Kv31iA0eTHIbLh1C/RX3NyApJ6vxgCkNzH7yySD4UH
 224TQBJXFV61u+sU4MJ3Rx+2KgPSPyp/+ZAL3IVwd5ZDvxsfRUiGVvHaT4m7WoXxYsFHKuEX+Bla
 2Z+6rgQY4VPPhK3supT89X3fBYPA/gGhXXr1ewIzvQAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMS0w
 NS0xNlQxMzoyMToxNCswMDowMF6HVuUAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEtMDUtMTZUMTM6
 MjE6MTQrMDA6MDAv2u5ZAAAAAElFTkSuQmCC
X-Now-Playing: Gil Scott-Heron & Jamie Xx's _We're New Here_: "Parents
 [Interlude]"
Date: Sun, 16 May 2021 15:38:26 +0200
In-Reply-To: <83a6oy20bj.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 13 May
 2021 17:08:32 +0300")
Message-ID: <87a6oupzn1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Looks like some memory
 problem: xrealloc segfaults. > > Don't we need to disable ASLR for unexec
 to work? And doesn't that > require setfattr or paxctl commands to be
 available? If not, how do > we [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Looks like some memory problem: xrealloc segfaults.
>
> Don't we need to disable ASLR for unexec to work?  And doesn't that
> require setfattr or paxctl commands to be available?  If not, how do
> we disable ASLR in bootstrap-emacs and emacs binaries on GNU/Linux?

Hm...  the PROBLEMS file has this:

----
These segfaults should not occur on most modern systems, because the
Emacs build procedure uses the command 'setfattr' or 'paxctl' to mark
the Emacs executable as requiring non-randomized address space, and
Emacs uses the 'personality' system call to disable address space
randomization when dumping.
----

Is that correct?  I thought we had ASLR switched on on GNU/Linux builds?

----
To work around the ASLR problem in either an older or a newer kernel,
you can temporarily disable the feature while building Emacs.  On
GNU/Linux you can do so using the following command (as root).

    echo 0 > /proc/sys/kernel/randomize_va_space
----

I tried this recipe now on Debian/bullseye, but the unexec build still
segfaults.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 14 May 2021 07:08:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 14 03:08:01 2021
Received: from localhost ([127.0.0.1]:44809 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhRvP-0006nP-4o
	for submit <at> debbugs.gnu.org; Fri, 14 May 2021 03:08:01 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51864)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lhRvM-0006nB-Ki
 for 36649 <at> debbugs.gnu.org; Fri, 14 May 2021 03:07:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44800)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lhRvF-00080Y-N2; Fri, 14 May 2021 03:07:45 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1396
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lhRvF-00046C-8y; Fri, 14 May 2021 03:07:45 -0400
Date: Fri, 14 May 2021 10:07:58 +0300
Message-Id: <83eee9ztbl.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfbl9dq0u5.fsf@HIDDEN> (message from Andrea Corallo on Fri, 14
 May 2021 06:35:46 +0000)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
 <877dk3enzm.fsf@HIDDEN>
 <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
 <xjfsg2qpbup.fsf@HIDDEN> <83sg2pzv8h.fsf@HIDDEN> <xjfbl9dq0u5.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: pipcet@HIDDEN, larsi@HIDDEN, eggert@HIDDEN, rpluim@HIDDEN,
>         stefan@HIDDEN, schwab@HIDDEN, monnier@HIDDEN,
>         36649 <at> debbugs.gnu.org
> Date: Fri, 14 May 2021 06:35:46 +0000
> 
> > I'm not sure what native-comp has to do with this: AFAIK native-comp
> > doesn't support unexec at all, so any unexec build will not have
> > native compilation enabled.
> 
> Yes is not unexec related, native comp classifies immediates that
> originally went into pure space or not before hash consing then in order
> to retain compatibility.  We should just remove this distinction if we
> remove pure space.

Ah, okay.  If you ask me, this is one more reason to wait with
removing the purespace.  But that's me.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 14 May 2021 06:36:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 14 02:36:43 2021
Received: from localhost ([127.0.0.1]:44785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhRR7-00062M-Gd
	for submit <at> debbugs.gnu.org; Fri, 14 May 2021 02:36:43 -0400
Received: from mx.sdf.org ([205.166.94.24]:57479)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lhRR5-00062D-6j
 for 36649 <at> debbugs.gnu.org; Fri, 14 May 2021 02:36:36 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 14E6ZlXL029135
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 14 May 2021 06:35:47 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
 <877dk3enzm.fsf@HIDDEN>
 <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
 <xjfsg2qpbup.fsf@HIDDEN> <83sg2pzv8h.fsf@HIDDEN>
Date: Fri, 14 May 2021 06:35:46 +0000
In-Reply-To: <83sg2pzv8h.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 14 May
 2021 09:26:38 +0300")
Message-ID: <xjfbl9dq0u5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Andrea Corallo <akrl@HIDDEN>
>> Cc: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
>>         eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
>>         schwab@HIDDEN, Stefan Monnier <monnier@HIDDEN>,
>>         36649 <at> debbugs.gnu.org
>> Date: Thu, 13 May 2021 21:23:10 +0000
>> 
>> > So, yes, I'd misunderstood Eli and thought he had objections to this
>> > patch; if he doesn't, we should look into fixing the native-comp parts
>> > and apply it :-)
>> 
>> Right, if you like me to have a look to the native-comp side would be
>> handy to have this patch pushed as a git branch on our repo.
>
> I'm not sure what native-comp has to do with this: AFAIK native-comp
> doesn't support unexec at all, so any unexec build will not have
> native compilation enabled.

Yes is not unexec related, native comp classifies immediates that
originally went into pure space or not before hash consing then in order
to retain compatibility.  We should just remove this distinction if we
remove pure space.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 14 May 2021 06:26:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 14 02:26:41 2021
Received: from localhost ([127.0.0.1]:44768 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhRHO-0005lx-UT
	for submit <at> debbugs.gnu.org; Fri, 14 May 2021 02:26:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44444)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lhRHM-0005ll-Od
 for 36649 <at> debbugs.gnu.org; Fri, 14 May 2021 02:26:34 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44242)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lhRHF-00076u-1M; Fri, 14 May 2021 02:26:25 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2749
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lhRHE-0008GG-Fq; Fri, 14 May 2021 02:26:24 -0400
Date: Fri, 14 May 2021 09:26:38 +0300
Message-Id: <83sg2pzv8h.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Andrea Corallo <akrl@HIDDEN>
In-Reply-To: <xjfsg2qpbup.fsf@HIDDEN> (message from Andrea Corallo on Thu, 13
 May 2021 21:23:10 +0000)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
 <877dk3enzm.fsf@HIDDEN>
 <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
 <xjfsg2qpbup.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Andrea Corallo <akrl@HIDDEN>
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
>         eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
>         schwab@HIDDEN, Stefan Monnier <monnier@HIDDEN>,
>         36649 <at> debbugs.gnu.org
> Date: Thu, 13 May 2021 21:23:10 +0000
> 
> > So, yes, I'd misunderstood Eli and thought he had objections to this
> > patch; if he doesn't, we should look into fixing the native-comp parts
> > and apply it :-)
> 
> Right, if you like me to have a look to the native-comp side would be
> handy to have this patch pushed as a git branch on our repo.

I'm not sure what native-comp has to do with this: AFAIK native-comp
doesn't support unexec at all, so any unexec build will not have
native compilation enabled.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 13 May 2021 21:24:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 13 17:24:01 2021
Received: from localhost ([127.0.0.1]:44467 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhIoL-0000YI-5L
	for submit <at> debbugs.gnu.org; Thu, 13 May 2021 17:24:01 -0400
Received: from mx.sdf.org ([205.166.94.24]:65476)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1lhIoI-0000Y8-8j
 for 36649 <at> debbugs.gnu.org; Thu, 13 May 2021 17:23:59 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 14DLNAQ7021588
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Thu, 13 May 2021 21:23:11 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
 <877dk3enzm.fsf@HIDDEN>
 <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
Date: Thu, 13 May 2021 21:23:10 +0000
In-Reply-To: <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
 (Pip Cet's message of "Thu, 13 May 2021 14:44:03 +0000")
Message-ID: <xjfsg2qpbup.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, Stefan Monnier <monnier@HIDDEN>,
 36649 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> On Wed, May 12, 2021 at 7:44 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
>> Eli Zaretskii <eliz@HIDDEN> writes:
>>
>> > I don't know if this is an interesting configuration.  AFAIU,
>> > "--with-dumping=none" means you run the CANNOT_DUMP version, which
>> > doesn't dump Emacs at all.
>>
>> Ah, yes...  and in that case I guess there is no pure space?  Oh well, I
>> guess somebody has to look into getting unexec working on Linux if we're
>> to, er, see what the impact of pure space unexec would have been.  If it
>> was working.  :-)
>
> I had it working a while ago, just not using libc malloc(). AFAIU,
> that's just incompatible with unexec() now.
>
> (And it's still slightly but significantly faster building with
> unexec() on Linux than building with pdumper, at least in contrived
> benchmarks).
>
> So, yes, I'd misunderstood Eli and thought he had objections to this
> patch; if he doesn't, we should look into fixing the native-comp parts
> and apply it :-)

Right, if you like me to have a look to the native-comp side would be
handy to have this patch pushed as a git branch on our repo.

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 13 May 2021 14:44:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 13 10:44:49 2021
Received: from localhost ([127.0.0.1]:44043 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhCa0-0005JE-VA
	for submit <at> debbugs.gnu.org; Thu, 13 May 2021 10:44:49 -0400
Received: from mail-oo1-f47.google.com ([209.85.161.47]:38535)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lhCZx-0005Iz-Oa
 for 36649 <at> debbugs.gnu.org; Thu, 13 May 2021 10:44:48 -0400
Received: by mail-oo1-f47.google.com with SMTP id
 h9-20020a4a94090000b02901f9d4f64172so5696578ooi.5
 for <36649 <at> debbugs.gnu.org>; Thu, 13 May 2021 07:44:45 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=NAyLQ7iRZg3cmfRGG6mBr+5zmJhAQrsZF7nraK4PZ6Y=;
 b=KVBszvB6A6CIoskCIMxuc1vKJmhUkETf3tGSlPPDpXq5BNEYUX+W9MibMWInAYoWwa
 HrMmlwOhSSuPCkPK5wAtBD9LgHm9Ql5snud05fVLzkxbe6MlyvrVJKwyQH8Jr9dY3Xjl
 bo86Gad/DhJ9g4JmKVJ1aXArZLLa/Se49fNk/H6A3xN2hEfTWWDmAkipcCafo5FcETJE
 k1PaXof0cNPwcDDhjhVEn9PP4G+zewrT2h6/70gXTqAjcbbk82P+Fk3pjxqHVYDM3S+T
 eOE9njpr1FItPBZqoGPlnciFGfeccXUZl7GxYvt7TjMzkTLaoWI71IO6fEcPI+PzawwG
 KAIA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=NAyLQ7iRZg3cmfRGG6mBr+5zmJhAQrsZF7nraK4PZ6Y=;
 b=iozLu57FwCLL9gIZon6tFR4b6P/xiO23FiZEgjwCCp16WNujuk/0dmsWkQ9S1afR+n
 RiNurAtd/yIhKc0ShsM4WEAU0wMXiPq670VbEpvfaG3ddTIXaCNWIhspUHVbpc06Fy1C
 0MAxG/yeG+C6pjpGOu5mC837AxlRtvgN9ncCnhK18sBO+Vbr7wgkIZxKN1pplP0StgC7
 iIyMQ+Bayg3gL2NWzUhvJWAt2HEejFQoccIuCwUww33LKkY/9JwXu2RDv5DtyZIDKWGi
 Vn2VhTF0lSXMGcqCttJkI6xEOD3DvTz6Ubv/XWi03euQyPzi2muBjyl0fTWc2ZTaFl3X
 BVQg==
X-Gm-Message-State: AOAM531K5yS0kUW2B3Z0xx5OnmCmvEBveh+tktXa6MH9zpNGfHs71+X9
 k+AgdziaHsiCoeSAhEsM+ImDuWkixlN3wUk5Rp0=
X-Google-Smtp-Source: ABdhPJwoGqlj8O9+KK0gbFqT2QUmlb0h7eFjdA1oLDCrzJSiwFBtht/ElxM7YyP5eCjWK8J8ZFw4icvSJ8IMHoImzsE=
X-Received: by 2002:a4a:33cc:: with SMTP id q195mr30150633ooq.22.1620917080089; 
 Thu, 13 May 2021 07:44:40 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN>
 <87y2cjg9mu.fsf@HIDDEN> <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN> <878s4jg67i.fsf@HIDDEN>
 <834kf73iim.fsf@HIDDEN> <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN> <877dk3enzm.fsf@HIDDEN>
In-Reply-To: <877dk3enzm.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Thu, 13 May 2021 14:44:03 +0000
Message-ID: <CAOqdjBcU0WfVxnAxMEQri3jPYrJaftszTt9n_7=CgGboKjkjUQ@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, Stefan Monnier <monnier@HIDDEN>,
 36649 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Wed, May 12, 2021 at 7:44 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
>
> > I don't know if this is an interesting configuration.  AFAIU,
> > "--with-dumping=none" means you run the CANNOT_DUMP version, which
> > doesn't dump Emacs at all.
>
> Ah, yes...  and in that case I guess there is no pure space?  Oh well, I
> guess somebody has to look into getting unexec working on Linux if we're
> to, er, see what the impact of pure space unexec would have been.  If it
> was working.  :-)

I had it working a while ago, just not using libc malloc(). AFAIU,
that's just incompatible with unexec() now.

(And it's still slightly but significantly faster building with
unexec() on Linux than building with pdumper, at least in contrived
benchmarks).

So, yes, I'd misunderstood Eli and thought he had objections to this
patch; if he doesn't, we should look into fixing the native-comp parts
and apply it :-)

Pip




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 13 May 2021 14:08:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 13 10:08:39 2021
Received: from localhost ([127.0.0.1]:43986 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lhC0x-0004M8-U8
	for submit <at> debbugs.gnu.org; Thu, 13 May 2021 10:08:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44148)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lhC0u-0004Ll-Jm
 for 36649 <at> debbugs.gnu.org; Thu, 13 May 2021 10:08:34 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44262)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lhC0m-0006Ai-9H; Thu, 13 May 2021 10:08:24 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1896
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lhC0l-0008Bo-JM; Thu, 13 May 2021 10:08:24 -0400
Date: Thu, 13 May 2021 17:08:32 +0300
Message-Id: <83a6oy20bj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: larsi@HIDDEN
In-Reply-To: <8335ur3hu8.fsf@HIDDEN> (message from Eli Zaretskii on Wed, 12
 May 2021 21:52:31 +0300)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Wed, 12 May 2021 21:52:31 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
>  schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
>  36649 <at> debbugs.gnu.org, akrl@HIDDEN
> 
> I worked with him to fix it, yes.  But the problem and the fix were
> not Windows specific, AFAIR.  I guess there's more, and perhaps it
> happens only on systems which don't use mmap for buffer text.  I will
> try to take a look when I have time.

Looks like some memory problem: xrealloc segfaults.

Don't we need to disable ASLR for unexec to work?  And doesn't that
require setfattr or paxctl commands to be available?  If not, how do
we disable ASLR in bootstrap-emacs and emacs binaries on GNU/Linux?

Here's the backtrace from the crash I see:

  Thread 1 "bootstrap-emacs" received signal SIGSEGV, Segmentation fault.
  0x00007ffff21f4917 in _int_realloc (av=av@entry=0x7ffff254ac40 <main_arena>,
      oldp=oldp@entry=0x24a73b0, oldsize=oldsize@entry=32, nb=nb@entry=144)
      at malloc.c:4589
  4589    malloc.c: No such file or directory.
  (gdb) bt
  #0  0x00007ffff21f4917 in _int_realloc (av=av@entry=0x7ffff254ac40 <main_arena>, oldp=oldp@entry=0x24a73b0, oldsize=oldsize@entry=32, nb=nb@entry=144)
      at malloc.c:4589
  #1  0x00007ffff21f80db in __GI___libc_realloc (oldmem=0x24a73c0, bytes=128)
      at malloc.c:3240
  #2  0x0000000000664a28 in lrealloc (p=0x24a73c0, size=128) at alloc.c:1378
  #3  0x0000000000663e46 in xrealloc (block=0x24a73c0, size=128) at alloc.c:804
  #4  0x00000000006641f9 in xpalloc (pa=0x24a73c0, nitems=0xed8450 <searchbufs+1840>, nitems_incr_min=1, nitems_max=32768, item_size=1) at alloc.c:928
  #5  0x0000000000658823 in regex_compile (pattern=0x8011b8 "^;;;.\\(in Emacs version\\|bytecomp version FSF\\)", size=47, posix_backtracking=false, whitespace_regexp=0x0, bufp=0xed8448 <searchbufs+1832>) at regex-emacs.c:2617
  #6  0x0000000000660493 in rpl_re_compile_pattern (pattern=0x8011b8 "^;;;.\\(in Emacs version\\|bytecomp version FSF\\)", length=47, posix_backtracking=false, whitespace_regexp=0x0, bufp=0xed8448 <searchbufs+1832>) at regex-emacs.c:5116
  #7  0x00000000006456eb in compile_pattern_1 (cp=0xed8428 <searchbufs+1800>, pattern=XIL(0xaa125c), translate=XIL(0x19b7125), posix=false) at search.c:123
  #8  0x0000000000645b2f in compile_pattern (pattern=XIL(0xaa125c), regp=0x0, translate=XIL(0x19b7125), posix=false, multibyte=false) at search.c:237
  #9  0x0000000000646707 in fast_c_string_match_ignore_case (regexp=XIL(0xaa125c), string=0x7fffffffd09d "\n;; certain of its subdirectories.  Here we specify them.\n(normal-top-level-add-to-load-path '(\"vc\" \"url\" \"textmodes\" \"progmodes\" \"play\" \"org\" \"nxml\" \"net\" \"mh-e\" \"mail\" \"leim\" \"language\" \"internation"..., len=401) at search.c:497
  #10 0x00000000006dc284 in safe_to_load_version (fd=5) at lread.c:1060
  #11 0x00000000006dd06b in Fload (file=XIL(0x2556774), noerror=XIL(0x30), nomessage=XIL(0x30), nosuffix=XIL(0x30), must_suffix=XIL(0)) at lread.c:1398
  #12 0x000000000069b971 in eval_sub (form=XIL(0x1e70b03)) at eval.c:2525
  #13 0x0000000000695602 in Fprogn (body=XIL(0)) at eval.c:471
  #14 0x0000000000697784 in Flet (args=XIL(0x1e70b13)) at eval.c:1057
  #15 0x000000000069b451 in eval_sub (form=XIL(0x1e70b83)) at eval.c:2464
  #16 0x0000000000695602 in Fprogn (body=XIL(0x1e70863)) at eval.c:471
  #17 0x0000000000695636 in prog_ignore (body=XIL(0x1e70b93)) at eval.c:482
  #18 0x000000000069785a in Fwhile (args=XIL(0x1e71553)) at eval.c:1078
  #19 0x000000000069b451 in eval_sub (form=XIL(0x1e71563)) at eval.c:2464
  #20 0x0000000000695602 in Fprogn (body=XIL(0)) at eval.c:471
  #21 0x0000000000697784 in Flet (args=XIL(0x1e71573)) at eval.c:1057
  ---Type <return> to continue, or q <return> to quit---
  #22 0x000000000069b451 in eval_sub (form=XIL(0x1e71653)) at eval.c:2464
  #23 0x0000000000695602 in Fprogn (body=XIL(0x1d26063)) at eval.c:471
  #24 0x00000000006953c9 in Fif (args=XIL(0x1e41753)) at eval.c:427
  #25 0x000000000069b451 in eval_sub (form=XIL(0x1e41763)) at eval.c:2464
  #26 0x0000000000695602 in Fprogn (body=XIL(0)) at eval.c:471
  #27 0x000000000069e40b in funcall_lambda (fun=XIL(0x1d03ba3), nargs=0, arg_vector=0x7fffffffde00) at eval.c:3313
  #28 0x000000000069dc30 in apply_lambda (fun=XIL(0x1d03b93), args=XIL(0), count=4) at eval.c:3185
  #29 0x000000000069bcd4 in eval_sub (form=XIL(0x17d0813)) at eval.c:2588
  #30 0x000000000069ad2b in Feval (form=XIL(0x17d0813), lexical=XIL(0))
      at eval.c:2340
  #31 0x00000000005c4a3e in top_level_2 () at keyboard.c:1103
  #32 0x0000000000698abb in internal_condition_case (bfun=0x5c4a1b <top_level_2>, handlers=XIL(0x90), hfun=0x5c43dd <cmd_error>) at eval.c:1475
  #33 0x00000000005c4a86 in top_level_1 (ignore=XIL(0)) at keyboard.c:1111
  #34 0x0000000000697c09 in internal_catch (tag=XIL(0xe0d0), func=0x5c4a40 <top_level_1>, arg=XIL(0)) at eval.c:1198
  #35 0x00000000005c4967 in command_loop () at keyboard.c:1072
  #36 0x00000000005c3ec4 in recursive_edit_1 () at keyboard.c:720
  #37 0x00000000005c40bc in Frecursive_edit () at keyboard.c:789
  #38 0x00000000005bfb4b in main (argc=9, argv=0x7fffffffe368) at emacs.c:2297

  Lisp Backtrace:
  "load" (0xffffd570)
  "let" (0xffffd6f0)
  "while" (0xffffd8a0)
  "let" (0xffffdac0)
  "if" (0xffffdc40)
  "normal-top-level" (0xffffde00)
  (gdb)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:44:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:44:28 2021
Received: from localhost ([127.0.0.1]:40639 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgumR-0004YU-PC
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:44:27 -0400
Received: from quimby.gnus.org ([95.216.78.240]:34228)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgumP-0004YE-KR
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:44:26 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=66d20g8wudiVKmSSR3RQGsHaALn+k4BReelxoJLAqgo=; b=fO4C8PRZdREPwmiaRmXn9MuEc3
 14KqODaZmw6y4lJRWIBiBY7vjd9gQvIuk+RVPbIk9+15XLhV/YtUUd6+UZGHvKYV2+DCXjlPS+TRi
 86Gff8wpPywUNj8wEmgkqUAwqnoW1jxR/bL4FnLinbvxh0sUIHgwGzG8HjE1H3Gz7huw=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgumE-0000vk-5k; Wed, 12 May 2021 21:44:16 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN> <831rab3gwl.fsf@HIDDEN>
X-Now-Playing: Benjamin Lew's _Le personnage principal est un peuple
 =?utf-8?Q?isol=C3=A9=5F=3A?= "Little Birds Sit On Your Shoulder"
Date: Wed, 12 May 2021 21:44:13 +0200
In-Reply-To: <831rab3gwl.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 22:12:42 +0300")
Message-ID: <877dk3enzm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > I don't know if this
 is an interesting configuration. AFAIU, > "--with-dumping=none" means you
 run the CANNOT_DUMP version, which > doesn't dump Emacs at all. Ah, yes...
 and in that case I guess there is no pure space? Oh well, I guess somebody
 has to look into getting unexec working on Linux if we're to, er, see what
 the impact of pure space unexec would h [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I don't know if this is an interesting configuration.  AFAIU,
> "--with-dumping=none" means you run the CANNOT_DUMP version, which
> doesn't dump Emacs at all.

Ah, yes...  and in that case I guess there is no pure space?  Oh well, I
guess somebody has to look into getting unexec working on Linux if we're
to, er, see what the impact of pure space unexec would have been.  If it
was working.  :-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:17:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:17:45 2021
Received: from localhost ([127.0.0.1]:40622 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lguMV-0003dU-5k
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:17:45 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48154)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lguMT-0003Yq-4G
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:17:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41422)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lguMN-0003rS-8s; Wed, 12 May 2021 15:17:31 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3461
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lguMK-0002FN-O8; Wed, 12 May 2021 15:17:31 -0400
Date: Wed, 12 May 2021 22:17:22 +0300
Message-Id: <83zgwz224d.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvfsyrhj2y.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Wed, 12 May 2021 15:07:42 -0400)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <jwvlf8jhn15.fsf-monnier+emacs@HIDDEN>
 <837dk33kzg.fsf@HIDDEN> <jwvfsyrhj2y.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: larsi@HIDDEN,  pipcet@HIDDEN,  eggert@HIDDEN,
>   rpluim@HIDDEN,  schwab@HIDDEN,  stefan@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 15:07:42 -0400
> 
> > I just don't want to risk that, not at all.  Because if we are missing
> > something, it will require efforts I'd rather put elsewhere.
> 
> I can see a risk that removing purespace will break unexec because of
> some oversight of some detail somewhere (simply because it's
> a configuration that's basically never tested), but I can't imagine the
> breakage to be hard to fix: running without purespace has been used
> during the bootstrap for many many years, both with pdump and with
> unexec, so it's really not "special".

Last time I needed to fix a breakage in the unexec build it took a
non-trivial effort, and would have probably taken even more, had I not
been fortunate to have a user who could investigate the problems on
his own and present clear and correct causes of the problems.

So my bitter experience doesn't confirm your optimism.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:13:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:13:06 2021
Received: from localhost ([127.0.0.1]:40616 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lguI6-0001X0-Ip
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:13:06 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:31425)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1lguI4-0001WO-IJ
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:13:05 -0400
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 58FEF808CB;
 Wed, 12 May 2021 15:12:59 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 902AB80611;
 Wed, 12 May 2021 15:12:57 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1620846777;
 bh=pBC/pbEvftt5euPCvYaCIvCujyLEShkSWSMYug2CRmY=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=ZmVA9zDu1tQTDLoZY4wp0E4Cz5ckiOxUBMf/u9zJaoiN/4YF5A1HXCfdFCpgmSekF
 0hNTyekgRhesNRPVAp1LXqCnpkjLAVfzd6WfbPqgBnMTWlCwF2U7aAPNofVhsKEQLN
 EvexVW/fIOyD9vcSD+Jyr/RzIoXvuWFd2dq5wCTG0L8c/oOD0tt3e+6kZ05IHQ41HC
 UhEsCjxpRCSOtpm+TV9cppCL6FHMcARwCfFns2UED46zjSvw6oQxdLCH8ZX/HaphNz
 RHgTiszHL3+mOe88v+OPP8eg0l7Lcj/S2ksb+Dt2EYIK07ROru5HY3dwQk7mMVOqcr
 mHcC8cTxkhA8A==
Received: from alfajor (76-10-140-76.dsl.teksavvy.com [76.10.140.76])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 19D0E12022E;
 Wed, 12 May 2021 15:12:57 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <jwva6ozhirq.fsf-monnier+emacs@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
Date: Wed, 12 May 2021 15:12:56 -0400
In-Reply-To: <87h7j7g7ft.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 12 May 2021 19:58:46 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.032 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Lars Ingebrigtsen [2021-05-12 19:58:46] wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
>>> How crippled are we talking?
>> As in "less efficient".

It will be less efficient, indeed, because the GC will take longer
because it will also traverse the part of the heap that used to live in
the purespace.  This effect is more noticeable in sessions where the
heap is small (and hence what used to be purespace represents a more
significant fraction of the total) and becomes unmeasurable once the
heap becomes large enough to dwarf the purespace.

But please note that we have all been living with exactly this
inefficiency ever since we started using pdump.  So while it will be
slightly less efficient, it will still be as efficient as what we get
with pdump, which I believe we all consider as acceptable.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:12:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:12:57 2021
Received: from localhost ([127.0.0.1]:40611 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lguHr-0001W7-F1
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:12:57 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47290)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lguHp-0001Vs-4W
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:12:50 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41322)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lguHe-0000jO-10; Wed, 12 May 2021 15:12:38 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3172
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lguHb-0001dN-Sx; Wed, 12 May 2021 15:12:36 -0400
Date: Wed, 12 May 2021 22:12:42 +0300
Message-Id: <831rab3gwl.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87bl9feppn.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 21:07:00 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
 <87bl9feppn.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: eggert@HIDDEN,  rpluim@HIDDEN,  stefan@HIDDEN,
>   schwab@HIDDEN,  monnier@HIDDEN,  pipcet@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 21:07:00 +0200
> 
> Or...  is this the way do get an unexec build these days?
> 
> ./configure --with-unexec=yes --with-dumping=none
> 
> This does not segfault here.  I'll try to get some timings done with the
> pure space removal + unexec, then...

I don't know if this is an interesting configuration.  AFAIU,
"--with-dumping=none" means you run the CANNOT_DUMP version, which
doesn't dump Emacs at all.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:07:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:07:52 2021
Received: from localhost ([127.0.0.1]:40601 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lguD2-0001NO-Jb
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:07:52 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:46313)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1lguD0-0001N5-7z
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:07:50 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id DC8691002C8;
 Wed, 12 May 2021 15:07:44 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 5B60710008C;
 Wed, 12 May 2021 15:07:43 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1620846463;
 bh=xQq/QzulE5Nzmu+CoD3JPUNUNcdEvLR/oGGRuttCeI8=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=GN/NDE7oB5hfXdhHxy+McouB1MH3wvOM0bCOErv0y11tV/0c52SDAV0N6CFQGzFqz
 WRPaZjEiYEfcYbunIUvKfyFEA/Kx9I29OYF6PEr8ml8J1zC7lPHibQKdAJGiELkekv
 iMQByz6VEtSAGNXpp4gp8JzHugi4sq2LoDuEB3vQYMTqfXVkdmlIdAqGcFBU72WCPS
 n1ftpO8Zzeo5aE1RxidDP48TATSMpTC54cGIvnvLhxbZyofqV6UF1EqzzWAIfNLMhx
 iYKT3HLHPHsuNL7KUBmCeRV9Swsq6xCUErppYomHFGaAE8dKwwlzaMAHKvuPMNGkJp
 YsKT+f3s6vJxA==
Received: from alfajor (76-10-140-76.dsl.teksavvy.com [76.10.140.76])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 09CAB120281;
 Wed, 12 May 2021 15:07:43 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <jwvfsyrhj2y.fsf-monnier+emacs@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <jwvlf8jhn15.fsf-monnier+emacs@HIDDEN>
 <837dk33kzg.fsf@HIDDEN>
Date: Wed, 12 May 2021 15:07:42 -0400
In-Reply-To: <837dk33kzg.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 20:44:35 +0300")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.033 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> > Keeping unexec doesn't mean breaking it.  If we believe someone might
>> > need that configuration, then we should give them a full-fledged
>> > Emacs, not a crippled one.
>> 
>> Removing pure space from unexec builds doesn't make them
>> crippled, AFAIK.
>
> I just don't want to risk that, not at all.  Because if we are missing
> something, it will require efforts I'd rather put elsewhere.

I can see a risk that removing purespace will break unexec because of
some oversight of some detail somewhere (simply because it's
a configuration that's basically never tested), but I can't imagine the
breakage to be hard to fix: running without purespace has been used
during the bootstrap for many many years, both with pdump and with
unexec, so it's really not "special".

The only real consequence will be a slightly worse performance, but no
worse than what we get with pdump anyway ;-)


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 19:07:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 15:07:12 2021
Received: from localhost ([127.0.0.1]:40597 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lguCO-0001Lx-9T
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 15:07:12 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33934)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lguCM-0001Le-Lm
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 15:07:11 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=3I1wF6msipwQtAt8/r6IlbEfmbJ8UXbOkIbO2nSslbU=; b=QEp+uzzGS22KoW6DfuHgLJ5VN1
 MdFfUKH6yVF2vq5uolKQgtNH6jl4XcuS1ERrkBflzSb5I+Dcb1R2rjMJWofMXeDrGpDOT/oaY++y9
 GNOUo0gFyOHuDG9ZCYTkafgKjXiYDvCDjU4IPb/4pkyys3W+ELyNh8jy1t8Ut/N5WUa8=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lguCC-0000XX-P3; Wed, 12 May 2021 21:07:03 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN> <8335ur3hu8.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEXYebPYd7KtYpCK
 TnJHKDvwyeL////KdnvEAAAAAWJLR0QGYWa4fQAAAAlwSFlzAAAAZAAAAGQAD5bF3QAAAAd0SU1F
 B+UFDBIWBAw8FokAAAGlSURBVDjLbZNtjoQgDIYLM/wHXP8reIDNlBMMHABnw/2vsgVEUaeJIekj
 Lf14Aa7GZmYRw80PWhobXAB1GJOKaWOGgC4ESCKmmEQiExBFNPOyAbKYimUaP9p58lcgs3MsYFqH
 UKyANbMKIlvCcSN24IPdDZYSbED8uQ5AAzHND4e4hyrRMvibjEVvMRx1xCSjsM5jNk8EjqJVjY4F
 9r3SW9rgTb5x2BJ668DzDHICpSR93J8AVUCFUVtFpLY2t2t1xFz16uyWfe/VuJaBPOu73kstMHdo
 pQqpymjyz78lRxwrYKX9+oXO/xzJRZ0t/cEx2KO7dYjF4LE/t05btjPn9/wC6NEy+0EPe6h28vwq
 MOCAhkHpRT3HRA17M1gsgsqTYKqes6IdkQD8xU/rrCVYQ36QFKwHw8Symyma/AlwyYsOtEV3AlKa
 ogN91YdRE+GJW3cB3FB8rcrGndWk6KFNOBfjryaciy2zvq1P3TqKFNwXwEmy3wCzFr+GotJIm3gD
 A70H0d5AESxpwJ23veogq4Ng30TVdED6OPVqaBvtLznaRlX7B5KPsgegCyajAAAAJXRFWHRkYXRl
 OmNyZWF0ZQAyMDIxLTA1LTEyVDE4OjIyOjA0KzAwOjAwSuIeXAAAACV0RVh0ZGF0ZTptb2RpZnkA
 MjAyMS0wNS0xMlQxODoyMjowNCswMDowMDu/puAAAAAASUVORK5CYII=
X-Now-Playing: Hexting's _Post Post Rock Rock_: "ANAlien Confession"
Date: Wed, 12 May 2021 21:07:00 +0200
In-Reply-To: <8335ur3hu8.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 21:52:31 +0300")
Message-ID: <87bl9feppn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Or... is this the way do get an unexec build these days?
 ./configure
 --with-unexec=yes --with-dumping=none This does not segfault here. I'll try
 to get some timings done with the pure space removal + unexec, then... 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Or...  is this the way do get an unexec build these days?

./configure --with-unexec=yes --with-dumping=none

This does not segfault here.  I'll try to get some timings done with the
pure space removal + unexec, then...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 18:52:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 14:52:43 2021
Received: from localhost ([127.0.0.1]:40527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgtyH-000773-13
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 14:52:43 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41972)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgtyE-00076n-VG
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 14:52:35 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40848)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgty6-0005mh-Gc; Wed, 12 May 2021 14:52:26 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1871
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgty5-0004Dy-Ap; Wed, 12 May 2021 14:52:26 -0400
Date: Wed, 12 May 2021 21:52:31 +0300
Message-Id: <8335ur3hu8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <874kf7g54z.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 20:48:28 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
 <874kf7g54z.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: eggert@HIDDEN,  rpluim@HIDDEN,  stefan@HIDDEN,
>   schwab@HIDDEN,  monnier@HIDDEN,  pipcet@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 20:48:28 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Someone built the master branch with unexec just a few days ago, see
> >
> >   https://lists.gnu.org/archive/html/emacs-devel/2021-05/msg00060.html
> 
> That's on Windows, though, and I seem to recall you fixing unexec on
> Windows a couple weeks ago?

I worked with him to fix it, yes.  But the problem and the fix were
not Windows specific, AFAIR.  I guess there's more, and perhaps it
happens only on systems which don't use mmap for buffer text.  I will
try to take a look when I have time.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 18:48:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 14:48:47 2021
Received: from localhost ([127.0.0.1]:40523 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgtuZ-000709-Fd
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 14:48:47 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgtuT-0006zg-TW
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 14:48:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=yOWXz9RRuigFN+73V1RXIgxPvAvJ9en6ghOsR480rQA=; b=Kf3G8tNZLdtKW+ml9pXEzEdhod
 eneoHznh8Zciv6WbbPdg/err7udkoDuBqMqEz/qznMkMMS9W93hkAnxQ1cpszzem/LmO3Zzx+O7L3
 bHr+CGiVFYnHMVEL66GvCsGqkL0rsdU1cfW3rQEGRq58bs7FBS0wiQHeINCCNMSvxpDs=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgtuH-0000LL-Jp; Wed, 12 May 2021 20:48:32 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN> <834kf73iim.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEXYebPYd7KtYpCK
 TnJHKDvwyeL////KdnvEAAAAAWJLR0QGYWa4fQAAAAlwSFlzAAAAZAAAAGQAD5bF3QAAAAd0SU1F
 B+UFDBIWBAw8FokAAAGlSURBVDjLbZNtjoQgDIYLM/wHXP8reIDNlBMMHABnw/2vsgVEUaeJIekj
 Lf14Aa7GZmYRw80PWhobXAB1GJOKaWOGgC4ESCKmmEQiExBFNPOyAbKYimUaP9p58lcgs3MsYFqH
 UKyANbMKIlvCcSN24IPdDZYSbED8uQ5AAzHND4e4hyrRMvibjEVvMRx1xCSjsM5jNk8EjqJVjY4F
 9r3SW9rgTb5x2BJ668DzDHICpSR93J8AVUCFUVtFpLY2t2t1xFz16uyWfe/VuJaBPOu73kstMHdo
 pQqpymjyz78lRxwrYKX9+oXO/xzJRZ0t/cEx2KO7dYjF4LE/t05btjPn9/wC6NEy+0EPe6h28vwq
 MOCAhkHpRT3HRA17M1gsgsqTYKqes6IdkQD8xU/rrCVYQ36QFKwHw8Symyma/AlwyYsOtEV3AlKa
 ogN91YdRE+GJW3cB3FB8rcrGndWk6KFNOBfjryaciy2zvq1P3TqKFNwXwEmy3wCzFr+GotJIm3gD
 A70H0d5AESxpwJ23veogq4Ng30TVdED6OPVqaBvtLznaRlX7B5KPsgegCyajAAAAJXRFWHRkYXRl
 OmNyZWF0ZQAyMDIxLTA1LTEyVDE4OjIyOjA0KzAwOjAwSuIeXAAAACV0RVh0ZGF0ZTptb2RpZnkA
 MjAyMS0wNS0xMlQxODoyMjowNCswMDowMDu/puAAAAAASUVORK5CYII=
X-Now-Playing: Hexting's _Post Post Rock Rock_: "Jayden K. Smith vs. Hu
 Yan... Final Round"
Date: Wed, 12 May 2021 20:48:28 +0200
In-Reply-To: <834kf73iim.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 21:37:53 +0300")
Message-ID: <874kf7g54z.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Someone built the
 master branch with unexec just a few days ago,
 see > > https://lists.gnu.org/archive/html/emacs-devel/2021-05/msg00060.html
 That's on Windows, though, and I seem to recall you fixing unexec on Windows
 a couple weeks ago? 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Someone built the master branch with unexec just a few days ago, see
>
>   https://lists.gnu.org/archive/html/emacs-devel/2021-05/msg00060.html

That's on Windows, though, and I seem to recall you fixing unexec on
Windows a couple weeks ago?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 18:38:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 14:38:06 2021
Received: from localhost ([127.0.0.1]:40519 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgtk8-0006fB-2s
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 14:38:06 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39080)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgtk4-0006et-S0
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 14:37:58 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40512)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgtjw-0004oP-Rv; Wed, 12 May 2021 14:37:48 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4890
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgtjw-0002vU-Cp; Wed, 12 May 2021 14:37:48 -0400
Date: Wed, 12 May 2021 21:37:53 +0300
Message-Id: <834kf73iim.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <878s4jg67i.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 20:25:21 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
 <878s4jg67i.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: eggert@HIDDEN,  rpluim@HIDDEN,  stefan@HIDDEN,
>   schwab@HIDDEN,  monnier@HIDDEN,  pipcet@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 20:25:21 +0200
> 
> make[2]: Entering directory '/home/larsi/src/emacs/pure/lisp'
>   ELC      international/titdic-cnv.elc
> Fatal error 11: Segmentation fault
> Backtrace:
> ../src/bootstrap-emacs[0x525571]
> ../src/bootstrap-emacs[0x4203b6]
> ../src/bootstrap-emacs[0x420889]
> ../src/bootstrap-emacs[0x523b5d]
> ../src/bootstrap-emacs[0x523bd9]
> /lib/x86_64-linux-gnu/libpthread.so.0(+0x14140)[0x7f3d1517c140]
> 
> So I'm not able to build an unexec build on GNU/Linux at all.
> 
> If this is the case in general, and not just here on this
> Debian/bullseye system, then I think we should consider getting rid of
> both unexec and pure space now, and not wait any longer.

Someone built the master branch with unexec just a few days ago, see

  https://lists.gnu.org/archive/html/emacs-devel/2021-05/msg00060.html




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 18:25:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 14:25:40 2021
Received: from localhost ([127.0.0.1]:40510 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgtYB-0006HL-UZ
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 14:25:40 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33382)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgtY7-0006Gw-1O
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 14:25:38 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=u97tfO7yO3Ove9sKS3NKRnaF0mHutl6yLVImF7SK2Ro=; b=Lb0P8hpdai7003Bx4FZppe3SFP
 U9yKz7gq1JbsiDlq0ol5Aowm0fi/MzkB4TmbduiiaI/Ys6O3d7dRQWzJ2qH4jO+q4lc++Cxg4x76V
 t/3z9TD2qvPTrsqnkrYWX9NmtsdO/olPbXMMSdPpDLwNqK9ZAjCZ1p2h/zURFnli0oDk=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgtXu-00009u-Dz; Wed, 12 May 2021 20:25:24 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN> <87h7j7g7ft.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAFVBMVEXYebPYd7KtYpCK
 TnJHKDvwyeL////KdnvEAAAAAWJLR0QGYWa4fQAAAAlwSFlzAAAAZAAAAGQAD5bF3QAAAAd0SU1F
 B+UFDBIWBAw8FokAAAGlSURBVDjLbZNtjoQgDIYLM/wHXP8reIDNlBMMHABnw/2vsgVEUaeJIekj
 Lf14Aa7GZmYRw80PWhobXAB1GJOKaWOGgC4ESCKmmEQiExBFNPOyAbKYimUaP9p58lcgs3MsYFqH
 UKyANbMKIlvCcSN24IPdDZYSbED8uQ5AAzHND4e4hyrRMvibjEVvMRx1xCSjsM5jNk8EjqJVjY4F
 9r3SW9rgTb5x2BJ668DzDHICpSR93J8AVUCFUVtFpLY2t2t1xFz16uyWfe/VuJaBPOu73kstMHdo
 pQqpymjyz78lRxwrYKX9+oXO/xzJRZ0t/cEx2KO7dYjF4LE/t05btjPn9/wC6NEy+0EPe6h28vwq
 MOCAhkHpRT3HRA17M1gsgsqTYKqes6IdkQD8xU/rrCVYQ36QFKwHw8Symyma/AlwyYsOtEV3AlKa
 ogN91YdRE+GJW3cB3FB8rcrGndWk6KFNOBfjryaciy2zvq1P3TqKFNwXwEmy3wCzFr+GotJIm3gD
 A70H0d5AESxpwJ23veogq4Ng30TVdED6OPVqaBvtLznaRlX7B5KPsgegCyajAAAAJXRFWHRkYXRl
 OmNyZWF0ZQAyMDIxLTA1LTEyVDE4OjIyOjA0KzAwOjAwSuIeXAAAACV0RVh0ZGF0ZTptb2RpZnkA
 MjAyMS0wNS0xMlQxODoyMjowNCswMDowMDu/puAAAAAASUVORK5CYII=
X-Now-Playing: Hexting's _Post Post Rock Rock_: "Annie Lennox Shreds"
Date: Wed, 12 May 2021 20:25:21 +0200
In-Reply-To: <87h7j7g7ft.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 12 May 2021 19:58:46 +0200")
Message-ID: <878s4jg67i.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Lars Ingebrigtsen <larsi@HIDDEN> writes: > Hm... I wonder
 whether it would be easy to get some numbers. I'll try > to get an unexec
 build (without purespace) running and see how bad it is. Easier said than
 done. Is this how it's supposed to be done? 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Hm...  I wonder whether it would be easy to get some numbers.  I'll try
> to get an unexec build (without purespace) running and see how bad it is.

Easier said than done.  Is this how it's supposed to be done?

./configure --with-unexec=yes --with-dumping=unexec

In that case, Emacs just segfaults:

make[2]: Entering directory '/home/larsi/src/emacs/pure/lisp'
  ELC      international/titdic-cnv.elc
Fatal error 11: Segmentation fault
Backtrace:
../src/bootstrap-emacs[0x525571]
../src/bootstrap-emacs[0x4203b6]
../src/bootstrap-emacs[0x420889]
../src/bootstrap-emacs[0x523b5d]
../src/bootstrap-emacs[0x523bd9]
/lib/x86_64-linux-gnu/libpthread.so.0(+0x14140)[0x7f3d1517c140]

So I'm not able to build an unexec build on GNU/Linux at all.

If this is the case in general, and not just here on this
Debian/bullseye system, then I think we should consider getting rid of
both unexec and pure space now, and not wait any longer.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 18:02:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 14:02:45 2021
Received: from localhost ([127.0.0.1]:40487 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgtC1-0005bI-Ju
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 14:02:45 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:36946)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1lgtC0-0005b3-04
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 14:02:44 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 7C74C160103;
 Wed, 12 May 2021 11:02:38 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id veCkR7DC5KLE; Wed, 12 May 2021 11:02:37 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id D1CA6160100;
 Wed, 12 May 2021 11:02:37 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id eBQtTIbhquXy; Wed, 12 May 2021 11:02:37 -0700 (PDT)
Received: from [192.168.1.9] (cpe-172-91-119-151.socal.res.rr.com
 [172.91.119.151])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 3C4CB160103;
 Wed, 12 May 2021 11:02:37 -0700 (PDT)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <42d3efea-835c-7d65-9088-7e0e996a34bb@HIDDEN>
Date: Wed, 12 May 2021 11:02:36 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.8.1
MIME-Version: 1.0
In-Reply-To: <87lf8jg8o2.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: rpluim@HIDDEN, stefan@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 5/12/21 10:32 AM, Lars Ingebrigtsen wrote:
> That would be a whole lot of #ifs in the code, and wouldn't make the
> change worth it -- in that case, I'd rather wait until we get rid of
> unexec before getting rid of pure space.

+1. It's not worth the hassle. Just wait. We've got time.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:59:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:59:04 2021
Received: from localhost ([127.0.0.1]:40479 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgt8R-0005TZ-Tz
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:59:04 -0400
Received: from quimby.gnus.org ([95.216.78.240]:33114)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgt8O-0005T0-Kv
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:59:02 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=+aZ+7TtUBj0ZdrOQ/WFXEVb1ZtfgbOGAPGv5PJdb1AU=; b=hWIiJC15dZ+FlrDBW2yutb6LjA
 J5rtDUZ5XFQ7HGHB3rFJt4TI8iVsJb+T9SyiXKxPAe02ep+Y3WN893JRZDPABwrixOPlkYYPIEPc/
 s2vixbeZVYxjHUc1QVmyo9x+gUPCdG/uv5ANYjjmDnkYVNqFSkDktp4QcQ1SAd5A4+Jc=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgt8B-000869-GQ; Wed, 12 May 2021 19:58:50 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
 <838s4j3l2e.fsf@HIDDEN>
X-Now-Playing: Aksak Maboul's _Un =?utf-8?Q?Ca=C3=AFd?= EP_: "Un
 =?utf-8?Q?Ca=C3=AFd?= (Radio Edit)"
Date: Wed, 12 May 2021 19:58:46 +0200
In-Reply-To: <838s4j3l2e.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 20:42:49 +0300")
Message-ID: <87h7j7g7ft.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: >> How crippled are we
 talking? > > As in "less efficient". As long as it doesn't render the unexec
 Emacs unusably slow, I think that's OK for a thing that's on its way out.
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> How crippled are we talking?
>
> As in "less efficient".

As long as it doesn't render the unexec Emacs unusably slow, I think
that's OK for a thing that's on its way out.

Hm...  I wonder whether it would be easy to get some numbers.  I'll try
to get an unexec build (without purespace) running and see how bad it is.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:45:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:45:01 2021
Received: from localhost ([127.0.0.1]:40462 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsul-00055z-If
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:45:01 -0400
Received: from eggs.gnu.org ([209.51.188.92]:55750)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgsui-00055g-Ek
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:44:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39142)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgsub-0007T4-B4; Wed, 12 May 2021 13:44:45 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1262
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgsuY-0006cl-RD; Wed, 12 May 2021 13:44:45 -0400
Date: Wed, 12 May 2021 20:44:35 +0300
Message-Id: <837dk33kzg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvlf8jhn15.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Wed, 12 May 2021 13:37:43 -0400)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <jwvlf8jhn15.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Lars Ingebrigtsen <larsi@HIDDEN>,  pipcet@HIDDEN,
>   eggert@HIDDEN,  rpluim@HIDDEN,  schwab@HIDDEN,
>   stefan@HIDDEN,  36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 13:37:43 -0400
> 
> > Keeping unexec doesn't mean breaking it.  If we believe someone might
> > need that configuration, then we should give them a full-fledged
> > Emacs, not a crippled one.
> 
> Removing pure space from unexec builds doesn't make them
> crippled, AFAIK.

I just don't want to risk that, not at all.  Because if we are missing
something, it will require efforts I'd rather put elsewhere.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:43:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:43:03 2021
Received: from localhost ([127.0.0.1]:40450 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgssr-000521-4G
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:43:03 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54878)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgsso-00051o-9z
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:42:55 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38980)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgssf-000693-OX; Wed, 12 May 2021 13:42:45 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1151
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgssf-0006HK-74; Wed, 12 May 2021 13:42:45 -0400
Date: Wed, 12 May 2021 20:42:49 +0300
Message-Id: <838s4j3l2e.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87lf8jg8o2.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 19:32:13 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN> <87lf8jg8o2.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: monnier@HIDDEN,  pipcet@HIDDEN,  eggert@HIDDEN,
>   rpluim@HIDDEN,  schwab@HIDDEN,  stefan@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 19:32:13 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Keeping unexec doesn't mean breaking it .  If we believe someone might
> > need that configuration, then we should give them a full-fledged
> > Emacs, not a crippled one.
> 
> How crippled are we talking?

As in "less efficient".

> > The patch can easily be tweaked to make the changes conditioned by
> > HAVE_PDUMPER, so I believe there's no need to argue about this nit:
> > let's simply remove purespace from the pdumper builds, and leave it
> > alone in the unexec builds.
> 
> That would be a whole lot of #ifs in the code, and wouldn't make the
> change worth it -- in that case, I'd rather wait until we get rid of 
> unexec before getting rid of pure space.

I don't think it will be so ugly as being prohibitive: we already have
quite a few of "#if HAVE_PDUMPER" in the sources.  But if you prefer
to wait with purespace removal until after unexec is removed, I don't
mind too much: Emacs 28 will have quite a lot of important changes
even without that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:37:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:37:54 2021
Received: from localhost ([127.0.0.1]:40417 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsny-0004s9-CV
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:37:54 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:39175)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1lgsnv-0004rt-MC
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:37:53 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id EA374440CB4;
 Wed, 12 May 2021 13:37:45 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C93F644016E;
 Wed, 12 May 2021 13:37:44 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1620841064;
 bh=BN8B5vRzjN70CwUkU8QHpWTrzRH7KZDX4nbESUGnwj4=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=Oju5zClI4cXVOlC+5sgJPA00p1Eh7HifOOyELQ77PvGcqE3I/wDKznJ/ZkPArBRz9
 hcbdEiMGoq3dqlyPXC5oHFdwo0gJqbVkUi3COOwEGlBxzK39AjFI9HivmJ27NXaTqp
 u4hxre0AjPdOtuIzWlr2zpLEFe8GCfxLaKrpeC6+onZsJbnoFaLnYL6OqCAPDi+37B
 VrbME0jlCRcRk0Ssai8LbpiBDrgMbtjDcmPZiKy+74k03Wj9GfsFQBIXFJbSnahHSm
 LvrIaUOF5zUqkipqEw3H01HxAEZ+VvEdg2RcxCcRuOf+lkGFHZvG9GjmTTg1azxlpl
 qhohSPjs0oCGg==
Received: from alfajor (76-10-140-76.dsl.teksavvy.com [76.10.140.76])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id ECF921202FE;
 Wed, 12 May 2021 13:37:43 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <jwvlf8jhn15.fsf-monnier+emacs@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN>
Date: Wed, 12 May 2021 13:37:43 -0400
In-Reply-To: <83a6oz3lpm.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 20:28:53 +0300")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.063 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Lars Ingebrigtsen <larsi@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Keeping unexec doesn't mean breaking it.  If we believe someone might
> need that configuration, then we should give them a full-fledged
> Emacs, not a crippled one.

Removing pure space from unexec builds doesn't make them
crippled, AFAIK.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:32:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:32:36 2021
Received: from localhost ([127.0.0.1]:40400 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsii-0004k3-Pf
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:32:36 -0400
Received: from quimby.gnus.org ([95.216.78.240]:32862)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgsih-0004jp-9V
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:32:27 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=ZxMsSYN+WdINEVxSDZn0Bu4F8V3er71XSAwNo/nviPM=; b=bYAgotOdv6unl5Z0syOFHpqNT4
 K2tpLJFj0Lc5n+ApTmbL8ICUXNCAUuBsuwxEgElXVydI46JEbk/lxj2NaqpzKsyUhcKrcUW8OXpY/
 2FkY0J/acoF3srnypM4Rx2jNoT1aRkPOKkA+S9mojQq1DqzBXMaTWqw1PjbAeZ9rGNac=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgsiU-0007Dc-CZ; Wed, 12 May 2021 19:32:16 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
 <83a6oz3lpm.fsf@HIDDEN>
X-Now-Playing: Tous KO's _Tous KO EP_: "An Aksak Maboul Reconstruction"
Date: Wed, 12 May 2021 19:32:13 +0200
In-Reply-To: <83a6oz3lpm.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 20:28:53 +0300")
Message-ID: <87lf8jg8o2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Keeping unexec doesn't
 mean breaking it . If we believe someone might > need that configuration,
 then we should give them a full-fledged > Emacs, not a crippled one. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Keeping unexec doesn't mean breaking it .  If we believe someone might
> need that configuration, then we should give them a full-fledged
> Emacs, not a crippled one.

How crippled are we talking?

> The patch can easily be tweaked to make the changes conditioned by
> HAVE_PDUMPER, so I believe there's no need to argue about this nit:
> let's simply remove purespace from the pdumper builds, and leave it
> alone in the unexec builds.

That would be a whole lot of #ifs in the code, and wouldn't make the
change worth it -- in that case, I'd rather wait until we get rid of 
unexec before getting rid of pure space.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:29:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:29:05 2021
Received: from localhost ([127.0.0.1]:40392 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsfK-0004dB-S3
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:29:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51510)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgsfJ-0004cz-4L
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:28:58 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38558)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgsfA-0006Em-PS; Wed, 12 May 2021 13:28:49 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4110
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgsf8-0004H7-VD; Wed, 12 May 2021 13:28:48 -0400
Date: Wed, 12 May 2021 20:28:53 +0300
Message-Id: <83a6oz3lpm.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87y2cjg9mu.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 19:11:21 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> <87y2cjg9mu.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, monnier@HIDDEN, pipcet@HIDDEN,
 36649 <at> debbugs.gnu.org, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  pipcet@HIDDEN,  eggert@HIDDEN,
>   rpluim@HIDDEN,  schwab@HIDDEN,  stefan@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 19:11:21 +0200
> 
> Stefan Monnier <monnier@HIDDEN> writes:
> 
> > I thought the question was not directly relevant because removal of the
> > pure space does not imply removing unexec.
> 
> It just makes unexec Emacs a little less efficient?  In which case I say
> we should just ignore the issue and apply the patch.

Keeping unexec doesn't mean breaking it .  If we believe someone might
need that configuration, then we should give them a full-fledged
Emacs, not a crippled one.

The patch can easily be tweaked to make the changes conditioned by
HAVE_PDUMPER, so I believe there's no need to argue about this nit:
let's simply remove purespace from the pdumper builds, and leave it
alone in the unexec builds.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:24:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:24:16 2021
Received: from localhost ([127.0.0.1]:40383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsam-0004V4-3n
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:24:16 -0400
Received: from quimby.gnus.org ([95.216.78.240]:32794)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgsak-0004Uq-B9
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:24:14 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=cKmsrgwqE8y+GT2gBhrGPa8nVyzjbQRN+O/VsEfC2qc=; b=IXzBsiWWUQz6tj/mlA2X0Jo98s
 9qqz2uQ5CgnVG99eZC5qptfdv13aUr0aojnOwq7yGnNvUWmkfx/Ap8GRq2yuHTXOVNQMsPLWP1HDZ
 4mQwM8wIQt5f1eVBuImAR4905z0rBxDxGzXXPvKuWlbJATFRAkW4oBl7oH5UNmpGhIfQ=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgsaa-0007Al-Mm; Wed, 12 May 2021 19:24:07 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <83cztv3mji.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEU/LzJrjDvYcZvl
 xdL1jKf////tcwcgAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+UFDBEWGvR1lbMAAAG/SURBVDjLfZSN
 mcIgDIYDOkBSGQAqA1hxgJZm/5nuCy1avfPyiEJew0f4CdHfxkROmMURs/XgYSF8YI45DUQi0ScA
 SVOSC9N30y9GKb+N6xNU8obWR3OzfwJdiAZ0AGo8zIwehjRubspHoG1t5qagb6D2FXp9Bzpvfqef
 oMmYEOdRY65Vxx1oE4jVZ67ez1FdB9UEeDkrzWcfo3IHOkMA8XlAm10lS1AkNHUvoktGC3vmIvIC
 g6h0EPQD5L9AANDfILeIA6jQkUFSAFiOYC2wxw7Cb7D8C9IRXMsULzvYVvsC6fqQGpaQn9u+TXXz
 w0M0mMBas+1q25JVbuQABoD1PmY7obaJ7TwAoLKWibNG16bS1QGcG9DrHUeG672BW9uSbMAXxlHR
 DqYXiCX66HpEEgNq2Y3lHin1CIgZSAB11dluza7BDSxYILKI9tS6RunAcnhFFL5OHUTK9Slebqey
 gWp+vNQOplO5NzA7+CHYQTnhPFpE8w95v4ml4LFVu4y4lJ78ONK4W0XLaCDZKwChKBCKAeoCSoHj
 EEDTZwFg+0MfOBFbHeqJWOCG7ddttYadw2TCzrotjzq+W1b7Xn8AG7OliekufbEAAAAldEVYdGRh
 dGU6Y3JlYXRlADIwMjEtMDUtMTJUMTc6MjI6MjUrMDA6MDCJwMegAAAAJXRFWHRkYXRlOm1vZGlm
 eQAyMDIxLTA1LTEyVDE3OjIyOjI1KzAwOjAw+J1/HAAAAABJRU5ErkJggg==
X-Now-Playing: Vicious Pink's _Cccan't You See (Version)_: "Cccan't You
 See...(Master Mix)"
Date: Wed, 12 May 2021 19:24:03 +0200
In-Reply-To: <83cztv3mji.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 20:10:57 +0300")
Message-ID: <87tun7g91o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: I had a look at the patch to see whether it had diverged from
 the current code base a lot -- and it mostly applies. The major thing that's
 changed, though, is that comp.c has a lot of code to handle p [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN, stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I had a look at the patch to see whether it had diverged from the
current code base a lot -- and it mostly applies.  The major thing
that's changed, though, is that comp.c has a lot of code to handle
purespace, and those bits have to be removed, too.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:20:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:20:00 2021
Received: from localhost ([127.0.0.1]:40374 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsWY-0004Nv-Tc
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:20:00 -0400
Received: from eggs.gnu.org ([209.51.188.92]:49714)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgsWW-0004Ng-Pf
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:19:53 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38344)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgsWO-00011R-0L; Wed, 12 May 2021 13:19:44 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3481
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgsWN-0008Pp-EP; Wed, 12 May 2021 13:19:43 -0400
Date: Wed, 12 May 2021 20:19:50 +0300
Message-Id: <83bl9f3m4p.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Wed, 12 May 2021 13:06:24 -0400)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  pipcet@HIDDEN,  eggert@HIDDEN,
>   rpluim@HIDDEN,  schwab@HIDDEN,  stefan@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 13:06:24 -0400
> 
> >>   https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68
> >
> > Right -- what to do about unexec builds?  Was the plan to stop
> > supporting that in this cycle or the next?
> 
> I thought the question was not directly relevant because removal of the
> pure space does not imply removing unexec.

The beginning of the bug discussion explains why they are related.
Specifically: (a) the motivation for removing purespace comes from the
pdumper build, and (b) we don't want to waste efforts on fixing
possible breakage of the unexec build as result of this change.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:11:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:11:37 2021
Received: from localhost ([127.0.0.1]:40365 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsOX-0004Bg-3a
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:11:37 -0400
Received: from quimby.gnus.org ([95.216.78.240]:60920)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgsOU-0004BS-Ib
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:11:35 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=FgrP178YiGLRGd7rKx4sIgNPCOPNlvgcAdnMeg+ILwA=; b=AnPjs5Vm0655nT4lwGwFOgii6a
 wPJ3EaxztUiHiCqsGEqnN6OKxcpzdTOGZwqYrKxv9YPxpAOBWOkCenQ8cdQyLYSedq6VaoyC7do08
 bcqYFvwZvgl61xmfwIwvgptIzdWkg81DwPVw/AG/z3iZ5wsjpqPRE4md/3n0B9VBGJMQ=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgsOH-00072S-Na; Wed, 12 May 2021 19:11:24 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
 <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN>
X-Now-Playing: Tuxedomoon's _Live in Alberobello, Italy_: "Litebulb Overkill"
Date: Wed, 12 May 2021 19:11:21 +0200
In-Reply-To: <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Wed, 12 May 2021 13:06:24 -0400")
Message-ID: <87y2cjg9mu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Stefan Monnier <monnier@HIDDEN> writes: > I thought
 the question was not directly relevant because removal of the > pure space
 does not imply removing unexec. It just makes unexec Emacs a little less
 efficient? In which case I say we should just ignore the issue and apply the
 patch. Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> I thought the question was not directly relevant because removal of the
> pure space does not imply removing unexec.

It just makes unexec Emacs a little less efficient?  In which case I say
we should just ignore the issue and apply the patch.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:11:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:11:03 2021
Received: from localhost ([127.0.0.1]:40358 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsNt-0004AE-QM
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:11:03 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47448)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgsNr-00049z-GS
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:10:56 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38116)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgsNk-0004N9-K1; Wed, 12 May 2021 13:10:48 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2899
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgsNk-0007Uf-2B; Wed, 12 May 2021 13:10:48 -0400
Date: Wed, 12 May 2021 20:10:57 +0300
Message-Id: <83cztv3mji.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <877dk3hoko.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 19:03:19 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN, stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: monnier@HIDDEN,  pipcet@HIDDEN,  eggert@HIDDEN,
>   rpluim@HIDDEN,  schwab@HIDDEN,  stefankangas@HIDDEN,
>   36649 <at> debbugs.gnu.org,  akrl@HIDDEN
> Date: Wed, 12 May 2021 19:03:19 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > I don't have any objections, but there was one issue on which we
> > didn't reach any agreed conclusions:
> >
> >   https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68
> 
> Right -- what to do about unexec builds?  Was the plan to stop
> supporting that in this cycle or the next?

I think we should keep unexec in Emacs 28 and remove it in Emacs 29.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:06:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:06:34 2021
Received: from localhost ([127.0.0.1]:40347 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsJd-00043D-RO
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:06:34 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:23309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1lgsJb-00042s-Tc
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:06:32 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 9F1D3440CB4;
 Wed, 12 May 2021 13:06:26 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 434CD440C17;
 Wed, 12 May 2021 13:06:25 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1620839185;
 bh=PIZAlej+3BjuYNiHzelLfdp6dzAjhxhIF/RmbSOUzEs=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=jDKnRfK9D4veStjTI5znEtKAvTVK7mttol4wR3BVThKDiUyEqPWwxt2q9YWZjLMjh
 dLvwy0uDK8/2gINsKgQFxxwjSmH/6SQPcTrz4lQsDitmeFi8S3tG4w5PaHklnwBC2m
 Vj41wgr6OvT8HmTz8w5RkayKZ/SDlIpY6cenbPJ2ZdaPMqK8oQOncVLYYGcTJDGhkN
 QXIpCS2FHt5RcYAWZ0bOBQmOd0blS4UCcjVzA20hIUfgMA1N7Y9CqYB6khUc78zUdI
 k6hE1v7LAycqRG1nWYpbo1mB3FN2To8hXIRLbRz7hdQ1kL0iKVHM0xdaWrl8zOETFO
 w/a2Kmg+yh+CA==
Received: from alfajor (76-10-140-76.dsl.teksavvy.com [76.10.140.76])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id E7A011204DC;
 Wed, 12 May 2021 13:06:24 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <jwvr1ibhohi.fsf-monnier+emacs@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN> <877dk3hoko.fsf@HIDDEN>
Date: Wed, 12 May 2021 13:06:24 -0400
In-Reply-To: <877dk3hoko.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 12 May 2021 19:03:19 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.063 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, stefan@HIDDEN,
 schwab@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Lars Ingebrigtsen [2021-05-12 19:03:19] wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
>> I don't have any objections, but there was one issue on which we
>> didn't reach any agreed conclusions:
>>
>>   https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68
>
> Right -- what to do about unexec builds?  Was the plan to stop
> supporting that in this cycle or the next?

I thought the question was not directly relevant because removal of the
pure space does not imply removing unexec.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 17:03:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 13:03:35 2021
Received: from localhost ([127.0.0.1]:40338 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgsGl-0003xB-64
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 13:03:35 -0400
Received: from quimby.gnus.org ([95.216.78.240]:60768)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgsGj-0003wy-Kp
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 13:03:34 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=k/PPMxtncIPOSNNP3PEyO277lXmQfkAwKuKZ1GguKPA=; b=A3bZVeO3xLtnvNb0bdzxNkjuA6
 EG2rFASdI4GS43e43vMzXuik+GgE3Y7YtR9tNTLLwbs+k+ORTRk0NzWwMg1PznjAF5DCaGQYASTjB
 hKsI3K5qvONow/UjFxjT1oYxXaR4F5hPV3VlVDGZXRYr2EKqf9vyDdn9qvsMm9C2udTw=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgsGW-0006xs-AE; Wed, 12 May 2021 19:03:22 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
 <83mtt02dyz.fsf@HIDDEN>
X-Now-Playing: Tuxedomoon's _Live in Alberobello, Italy_: "Waterfront Seat"
Date: Wed, 12 May 2021 19:03:19 +0200
In-Reply-To: <83mtt02dyz.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 12 May
 2021 18:01:24 +0300")
Message-ID: <877dk3hoko.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > I don't have any
 objections, 
 but there was one issue on which we > didn't reach any agreed conclusions:
 > > https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN, stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I don't have any objections, but there was one issue on which we
> didn't reach any agreed conclusions:
>
>   https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68

Right -- what to do about unexec builds?  Was the plan to stop
supporting that in this cycle or the next?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 15:01:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 11:01:42 2021
Received: from localhost ([127.0.0.1]:40054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgqMk-0002Wm-1H
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 11:01:42 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59180)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lgqMh-0002WZ-JH
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 11:01:36 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60778)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lgqMZ-0006m5-BG; Wed, 12 May 2021 11:01:28 -0400
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2394
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1lgqMO-0000AJ-Ml; Wed, 12 May 2021 11:01:23 -0400
Date: Wed, 12 May 2021 18:01:24 +0300
Message-Id: <83mtt02dyz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87mtt0hupl.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 12 May 2021 16:50:46 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN> <87mtt0hupl.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, schwab@HIDDEN,
 monnier@HIDDEN, pipcet@HIDDEN, 36649 <at> debbugs.gnu.org,
 akrl@HIDDEN, stefankangas@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Pip Cet <pipcet@HIDDEN>,  Paul Eggert <eggert@HIDDEN>,  Robert
>  Pluim <rpluim@HIDDEN>,  Andreas Schwab <schwab@HIDDEN>,  Stefan
>  Kangas <stefankangas@HIDDEN>,  36649 <at> debbugs.gnu.org,  Andrea Corallo
>  <akrl@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
> Date: Wed, 12 May 2021 16:50:46 +0200
> 
> Eli, did you have any objections?  If not, it sounds like a good idea to
> me, too.

I don't have any objections, but there was one issue on which we
didn't reach any agreed conclusions:

  https://debbugs.gnu.org/cgi/bugreport.cgi?bug=36649#68




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 12 May 2021 14:51:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 12 10:51:08 2021
Received: from localhost ([127.0.0.1]:40038 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lgqCa-0002F8-CE
	for submit <at> debbugs.gnu.org; Wed, 12 May 2021 10:51:08 -0400
Received: from quimby.gnus.org ([95.216.78.240]:59444)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lgqCX-0002Ed-AB
 for 36649 <at> debbugs.gnu.org; Wed, 12 May 2021 10:51:06 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=4B7OTfFkmfkE1kbjSHaADJ6tmaqOmmnhldypkSImuBQ=; b=hbt7BrB+VUEFFesyC8GlzFY0/H
 Mnq0l6HP5R9UnwlYBsH6kmJ5k9S7ZroZG6wALqO1Exe84SKJquk8Qo0kyG42kotlv/HjL8zkgaJd1
 X/3ophkQ5JQbuErI7WOXCoZUvzs4Hoz6fi8dzBbtqdMfbFs9MKvgy4YB8aG8zvvmkd7k=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lgqCF-0005mA-7B; Wed, 12 May 2021 16:50:49 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 <jwvim5txttk.fsf-monnier+emacs@HIDDEN>
X-Now-Playing: Fire!'s _Defeat_: "Alien (to my feet)"
Date: Wed, 12 May 2021 16:50:46 +0200
In-Reply-To: <jwvim5txttk.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Sun, 14 Mar 2021 18:19:42 -0400")
Message-ID: <87mtt0hupl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Stefan Monnier <monnier@HIDDEN> writes: >> Anyway, 
 it's easy enough to remove the assumption. Here's the current patch. > >
 Is anything still blocking this patch or can it go in? Skimming this thread,
 it seems like most people were very enthusiastic about removing pure space,
 but this patch was never applied. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: Paul Eggert <eggert@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 Andreas Schwab <schwab@HIDDEN>, Stefan Kangas <stefankangas@HIDDEN>,
 Pip Cet <pipcet@HIDDEN>, 36649 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

>> Anyway, it's easy enough to remove the assumption. Here's the current patch.
>
> Is anything still blocking this patch or can it go in?

Skimming this thread, it seems like most people were very enthusiastic
about removing pure space, but this patch was never applied.

Eli, did you have any objections?  If not, it sounds like a good idea to
me, too.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 14 Mar 2021 22:19:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 14 18:19:56 2021
Received: from localhost ([127.0.0.1]:34392 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lLZ5Y-0004HA-Hl
	for submit <at> debbugs.gnu.org; Sun, 14 Mar 2021 18:19:56 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:14875)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1lLZ5X-0004Gr-1u
 for 36649 <at> debbugs.gnu.org; Sun, 14 Mar 2021 18:19:55 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 53796440C48;
 Sun, 14 Mar 2021 18:19:49 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 01C80440559;
 Sun, 14 Mar 2021 18:19:43 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1615760384;
 bh=lEBaGIh1IyCnSdbf6GBiXdUY2Qm714h3+ns5GiA+wpI=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=ggjEwiGYOAstJZlWpixlMn6voNKB2EMOAaKHIrckyXaA07BgPA0UfvRovLwUg3BjP
 lb2CqNBO8DGfrXSLaPWb0bI93xMtESlp+uMUrDpCnF9BGkBY1ZEUQwwfYNyME88GOn
 90Piv8PhIZEmtCdtjr5FzAKKBrCLCIB9o1312EJh0YrI3aM2dl2zCGdsga/l6hCnmK
 Xo4Qd+RKq9p0w03sBsgHpbjYpf/yvZY/X1JzOVsD6AgkBh+OTSvOP5UckuFJqOc5W8
 Wn9Ln8PPqcktrGSVCxmfu3xdEZms3SQPX2ollz+AtEr3o2hlD9OZSoIBH236xX/u5G
 YH4OsunQ+IwRw==
Received: from alfajor (unknown [216.154.43.249])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id A6DE3120208;
 Sun, 14 Mar 2021 18:19:43 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Message-ID: <jwvim5txttk.fsf-monnier+emacs@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
 <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
Date: Sun, 14 Mar 2021 18:19:42 -0400
In-Reply-To: <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 (Pip Cet's message of "Fri, 5 Mar 2021 03:00:03 +0000")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.104 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: Paul Eggert <eggert@HIDDEN>, Robert Pluim <rpluim@HIDDEN>,
 Andreas Schwab <schwab@HIDDEN>, Stefan Kangas <stefankangas@HIDDEN>,
 36649 <at> debbugs.gnu.org, larsi@HIDDEN, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Anyway, it's easy enough to remove the assumption. Here's the current patch.

Is anything still blocking this patch or can it go in?


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 5 Mar 2021 07:20:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Mar 05 02:20:52 2021
Received: from localhost ([127.0.0.1]:60875 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lI4lY-0006BM-GC
	for submit <at> debbugs.gnu.org; Fri, 05 Mar 2021 02:20:52 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46170)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lI4lW-0006B8-PO
 for 36649 <at> debbugs.gnu.org; Fri, 05 Mar 2021 02:20:51 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52990)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lI4lO-0004n4-3y; Fri, 05 Mar 2021 02:20:42 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:3835
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lI4lN-000892-3f; Fri, 05 Mar 2021 02:20:41 -0500
Date: Fri, 05 Mar 2021 09:20:25 +0200
Message-Id: <838s72ysli.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
In-Reply-To: <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
 (message from Pip Cet on Fri, 5 Mar 2021 03:00:03 +0000)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
 <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, rpluim@HIDDEN, schwab@HIDDEN,
 stefankangas@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Pip Cet <pipcet@HIDDEN>
> Date: Fri, 5 Mar 2021 03:00:03 +0000
> Cc: Robert Pluim <rpluim@HIDDEN>, Andreas Schwab <schwab@HIDDEN>,
>  Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
>  Andrea Corallo <akrl@HIDDEN>
> 
> > The convention is to put a "verify (NIL_IS_ZERO);" near the rare bits of
> > code that assume Qnil is all-bits-zero.
> 
> That would be nice, but I'm quite certain there are places in the code
> that rely on this identity without doing that...

There shouldn't be.  If you find them, please report them.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 5 Mar 2021 03:00:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 22:00:47 2021
Received: from localhost ([127.0.0.1]:60719 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lI0hq-0007zV-Ve
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 22:00:46 -0500
Received: from mail-ot1-f54.google.com ([209.85.210.54]:40377)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lI0hp-0007zJ-Om
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 22:00:45 -0500
Received: by mail-ot1-f54.google.com with SMTP id b8so435671oti.7
 for <36649 <at> debbugs.gnu.org>; Thu, 04 Mar 2021 19:00:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=lj5PwhF1tTF2pLFdd3Z9FoUmjJRsN2K2zvITdjChweg=;
 b=YmCY4ybC4Th90uBks4GGLDFjA4cZmJRev66Xur/R0VwRtT/KMmHK4Deishmq5YTs5Z
 0Gni8ZpH/4nilcb8YTtQYIhJEitRoSBWoPhKmV1xO0E7jB6jADSNbTLk2e2pohACfYPD
 BErEMktr8gatL6MpK+EaHlAaQdE+hFlPI2lUVGKgSSJX8YMKRLLYQdMeE7uTLyEadWNf
 picc7AOsn3mIo7FuXmg6yYt0tY9OdqvP5A/SsNoBF5vyeqg7mTsM22aumEsTsNSx17e7
 ULtU69i9sFb1tpFGdulQZ5A989xM0mJC2OvH4eJOUlsZnwA2DqAf7Wrwd7gtSBYvexfv
 brmQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=lj5PwhF1tTF2pLFdd3Z9FoUmjJRsN2K2zvITdjChweg=;
 b=NfysqhVrHbcl54NnW36J01gBejS84f2ppULkUh8rp4oBDiDdgDA9opS6LOh4pNB/uv
 meVGb3FNLTtQz6Log99shxmTSgREZbIvfDW8dBBPjF7PBHLDl+2Ghb9hzV9TcfD3VINi
 7LnLpNaVzlI2UKQrMGjAV2cHfbksEeJ0ZegZPoZYHCuptb8xmpEOrN9c5HQSEjY69GWw
 CHDxXjUUKxAzZrreLUcfz6rBKRM4VOetY95IGK7nP6smVS8B1LV8xpYV1GtIW8Dt6pas
 qysxJmJ1+cPrz2Nuv6wDg/4huqX8YPZhGxvZviJc0kw6fktN3Xn4oXb4nHkkF8YKd0sB
 aB7A==
X-Gm-Message-State: AOAM532g3STqDrn2mv32oaGqrYowiDlS7eLeVNKt349DVpljEFNj2sUZ
 ij7rayVKOETy2Y/QLODTAyp1P8gHt3CsQZb0Jqk=
X-Google-Smtp-Source: ABdhPJw/AiADD+ejSWe9ppuxIESAFnd2ER9nVkbU4wBfQ5cDMy21u3cOzPIz5hVZAtjApzUKGfInaHd1MyDv8AQ79i8=
X-Received: by 2002:a05:6830:1e51:: with SMTP id
 e17mr6196512otj.292.1614913240080; 
 Thu, 04 Mar 2021 19:00:40 -0800 (PST)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
In-Reply-To: <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 5 Mar 2021 03:00:03 +0000
Message-ID: <CAOqdjBfzTDq4V0tMERP=74bHNKH7KZ1s7+XV9x+f7WoD+TgXWA@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Paul Eggert <eggert@HIDDEN>
Content-Type: multipart/mixed; boundary="00000000000004c45c05bcc14a64"
X-Debbugs-Envelope-To: 36649
Cc: Robert Pluim <rpluim@HIDDEN>, Andreas Schwab <schwab@HIDDEN>,
 Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--00000000000004c45c05bcc14a64
Content-Type: text/plain; charset="UTF-8"

On Thu, Mar 4, 2021 at 9:52 PM Paul Eggert <eggert@HIDDEN> wrote:
> On 3/4/21 6:56 AM, Robert Pluim wrote:
> >      Pip> - zero vector handling depends on Qnil being all zero in memory
> >
> > I think Emacs already assumes Qnil == 0, since there are places that
> > use ! to check for Qnil rather than using NILP.
>
> The convention is to put a "verify (NIL_IS_ZERO);" near the rare bits of
> code that assume Qnil is all-bits-zero.

That would be nice, but I'm quite certain there are places in the code
that rely on this identity without doing that...

> This is to help out any
> hypothetical future developer who wants to change Qnil to be some other
> value. Currently there are only two such locations. (There is one other
> location that uses NIL_IS_ZERO for an optimization.)

When I did the NaN boxing thing, I remember seeing quite a few 0.0s
popping up where I was expecting nil :-)

Anyway, it's easy enough to remove the assumption. Here's the current patch.

Pip

--00000000000004c45c05bcc14a64
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Remove-pure-space-Bug-36649.patch"
Content-Disposition: attachment; 
	filename="0001-Remove-pure-space-Bug-36649.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_klvpm4md0>
X-Attachment-Id: f_klvpm4md0

RnJvbSAzYTRlZWZjNDY0NmU1MjVhNzIwNTYxNzE2OTIzZWZlYTQ0ZTgxMDRlIE1vbiBTZXAgMTcg
MDA6MDA6MDAgMjAwMQpGcm9tOiBQaXAgQ2V0IDxwaXBjZXRAZ21haWwuY29tPgpEYXRlOiBXZWQs
IDMgTWFyIDIwMjEgMTU6Mjc6MDIgKzAwMDAKU3ViamVjdDogW1BBVENIXSBSZW1vdmUgcHVyZSBz
cGFjZSAoQnVnIzM2NjQ5KQoKKiBzcmMvbGlzcC5oIChzdHJ1Y3QgTGlzcF9TeW1ib2wpOiBSZW1v
dmUgYHBpbm5lZCcgZmxhZy4KKGJ1aWxkX3B1cmVfY19zdHJpbmcsIHB1cmVfbGlzdG4pOiBSZW1v
dmUuICBBbGwgY2FsbHMgcmVtb3ZlZC4KKiBzcmMvcHVyZXNpemUuaDogUmVtb3ZlIGZpbGUuCiog
c3JjL2Zucy5jIChGbWFrZV9oYXNoX3RhYmxlKTogSWdub3JlIGA6cHVyZWNvcHknIGFyZ3VtZW50
LgoqIHNyYy9kb2MuYyAoc3RvcmVfZnVuY3Rpb25fZG9jc3RyaW5nKTogUmVtb3ZlIGNvbW1lbnQg
YWJvdXQgcHVyZQpzcGFjZS4KKiBzcmMvZGF0YS5jIChwdXJlX3dyaXRlX2Vycm9yKTogUmVtb3Zl
LiAgQWxsIGNhbGxzIHJlbW92ZWQuCiogc3JjL2NvbmZfcG9zdC5oIChTWVNURU1fUFVSRVNJWkVf
RVhUUkEpOiBSZW1vdmUuCiogc3JjL2Zucy5jIChtYWtlX2hhc2hfdGFibGUpOiBEcm9wIGBwdXJl
Y29weScgYXJndW1lbnQuICBBbGwKY2FsbGVycyBjaGFuZ2VkIHRvIHJlbW92ZSBhcmd1bWVudC4K
KiBzcmMvYWxsb2MuYyAobWFrZV9wdXJlX3N0cmluZywgbWFrZV9wdXJlX2Nfc3RyaW5nLCBwdXJl
X2NvbnMpCihwdXJlX2xpc3QpOiBSZW1vdmUuICBBbGwgY2FsbHMgcmVtb3ZlZC4KKGNoZWNrX3B1
cmVfc2l6ZSk6IFJlbW92ZS4gIEFsbCBjYWxscyByZW1vdmVkLgooY29uc19saXN0bik6IFNpbXBs
aWZ5LgooRm1ha2VfYnl0ZV9jb2RlKTogUmVtb3ZlIGNvbW1lbnQgYWJvdXQgcHVyZSBzcGFjZS4K
KHBvaW50ZXJfYWxpZ24pOiBNb3ZlIGRlZmluaXRpb24gdG8gYXZvaWQgd2FybmluZy4KKiBzcmMv
TWFrZWZpbGUuaW46IFJlbW92ZSBjb21tZW50IGFib3V0IHB1cmUgc3BhY2UuCi0tLQogZG9jL2xp
c3ByZWYvZWxpc3AudGV4aSAgICAgfCAgIDEgLQogZG9jL2xpc3ByZWYvaW50ZXJuYWxzLnRleGkg
fCAgNzggLS0tLS0tCiBkb2MvbGlzcHJlZi9zeW1ib2xzLnRleGkgICB8ICAgMyArLQogc3JjL01h
a2VmaWxlLmluICAgICAgICAgICAgfCAgIDIgLQogc3JjL2FsbG9jLmMgICAgICAgICAgICAgICAg
fCA1NDkgKysrKy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQogc3JjL2J1ZmZlci5j
ICAgICAgICAgICAgICAgfCAgMTYgKy0KIHNyYy9jYWxsaW50LmMgICAgICAgICAgICAgIHwgICA4
ICstCiBzcmMvY2F0ZWdvcnkuYyAgICAgICAgICAgICB8ICAgNCArLQogc3JjL2NvZGluZy5jICAg
ICAgICAgICAgICAgfCAgMTggKy0KIHNyYy9jb25mX3Bvc3QuaCAgICAgICAgICAgIHwgIDMzIC0t
LQogc3JjL2RhdGEuYyAgICAgICAgICAgICAgICAgfCAgMjkgKy0KIHNyYy9kYnVzYmluZC5jICAg
ICAgICAgICAgIHwgICA0ICstCiBzcmMvZGVwcy5tayAgICAgICAgICAgICAgICB8ICAxMCArLQog
c3JjL2RvYy5jICAgICAgICAgICAgICAgICAgfCAgIDMgLQogc3JjL2VtYWNzLW1vZHVsZS5jICAg
ICAgICAgfCAgMjggKy0KIHNyYy9lbWFjcy5jICAgICAgICAgICAgICAgIHwgICA1ICstCiBzcmMv
ZXZhbC5jICAgICAgICAgICAgICAgICB8ICAxMiArLQogc3JjL2ZpbGVpby5jICAgICAgICAgICAg
ICAgfCAgMjIgKy0KIHNyYy9mbnMuYyAgICAgICAgICAgICAgICAgIHwgIDMyICstLQogc3JjL2Zv
bnRzZXQuYyAgICAgICAgICAgICAgfCAgIDQgKy0KIHNyYy9mcmFtZS5jICAgICAgICAgICAgICAg
IHwgICAyICstCiBzcmMvaW1hZ2UuYyAgICAgICAgICAgICAgICB8ICAgMiArLQogc3JjL2ludGVy
dmFscy5jICAgICAgICAgICAgfCAgIDIgLQogc3JjL2pzb24uYyAgICAgICAgICAgICAgICAgfCAg
IDQgKy0KIHNyYy9rZXlib2FyZC5jICAgICAgICAgICAgIHwgICA4ICstCiBzcmMva2V5bWFwLmMg
ICAgICAgICAgICAgICB8ICAzNCArLS0KIHNyYy9saXNwLmggICAgICAgICAgICAgICAgIHwgIDQx
ICstLQogc3JjL2xyZWFkLmMgICAgICAgICAgICAgICAgfCAgNTMgKystLQogc3JjL3BkdW1wZXIu
YyAgICAgICAgICAgICAgfCAgIDkgKy0KIHNyYy9wcmludC5jICAgICAgICAgICAgICAgIHwgICA2
IC0KIHNyYy9wcm9jZXNzLmMgICAgICAgICAgICAgIHwgICA0ICstCiBzcmMvcHJvZmlsZXIuYyAg
ICAgICAgICAgICB8ICAgMiArLQogc3JjL3B1cmVzaXplLmggICAgICAgICAgICAgfCAxMTUgLS0t
LS0tLS0KIHNyYy9zZWFyY2guYyAgICAgICAgICAgICAgIHwgIDEyICstCiBzcmMvc3ludGF4LmMg
ICAgICAgICAgICAgICB8ICAgNCArLQogc3JjL3czMmZucy5jICAgICAgICAgICAgICAgfCAgIDQg
Ky0KIHNyYy94ZGlzcC5jICAgICAgICAgICAgICAgIHwgIDE4ICstCiBzcmMveGZhY2VzLmMgICAg
ICAgICAgICAgICB8ICAgMiArLQogc3JjL3hmbnMuYyAgICAgICAgICAgICAgICAgfCAgIDkgKy0K
IHNyYy94dGVybS5jICAgICAgICAgICAgICAgIHwgICA0ICstCiA0MCBmaWxlcyBjaGFuZ2VkLCAy
MDEgaW5zZXJ0aW9ucygrKSwgOTk1IGRlbGV0aW9ucygtKQogZGVsZXRlIG1vZGUgMTAwNjQ0IHNy
Yy9wdXJlc2l6ZS5oCgpkaWZmIC0tZ2l0IGEvZG9jL2xpc3ByZWYvZWxpc3AudGV4aSBiL2RvYy9s
aXNwcmVmL2VsaXNwLnRleGkKaW5kZXggMTIyNTVkMTIyZjlmZS4uMjAxNDI5MjAyOGIyNiAxMDA2
NDQKLS0tIGEvZG9jL2xpc3ByZWYvZWxpc3AudGV4aQorKysgYi9kb2MvbGlzcHJlZi9lbGlzcC50
ZXhpCkBAIC0xNjAxLDcgKzE2MDEsNiBAQCBUb3AKIEdOVSBFbWFjcyBJbnRlcm5hbHMKIAogKiBC
dWlsZGluZyBFbWFjczo6ICAgICAgICAgIEhvdyB0aGUgZHVtcGVkIEVtYWNzIGlzIG1hZGUuCi0q
IFB1cmUgU3RvcmFnZTo6ICAgICAgICAgICAgS2x1ZGdlIHRvIG1ha2UgcHJlbG9hZGVkIExpc3Ag
ZnVuY3Rpb25zIHNoYXJlYWJsZS4KICogR2FyYmFnZSBDb2xsZWN0aW9uOjogICAgICBSZWNsYWlt
aW5nIHNwYWNlIGZvciBMaXNwIG9iamVjdHMgbm8gbG9uZ2VyIHVzZWQuCiAqIFN0YWNrLWFsbG9j
YXRlZCBPYmplY3RzOjogVGVtcG9yYXJ5IGNvbnNlcyBhbmQgc3RyaW5ncyBvbiBDIHN0YWNrLgog
KiBNZW1vcnkgVXNhZ2U6OiAgICAgICAgICAgIEluZm8gYWJvdXQgdG90YWwgc2l6ZSBvZiBMaXNw
IG9iamVjdHMgbWFkZSBzbyBmYXIuCmRpZmYgLS1naXQgYS9kb2MvbGlzcHJlZi9pbnRlcm5hbHMu
dGV4aSBiL2RvYy9saXNwcmVmL2ludGVybmFscy50ZXhpCmluZGV4IDQxNTBhMmIyMWI4ZmIuLmI2
ODQ5MzM4ODdiODAgMTAwNjQ0Ci0tLSBhL2RvYy9saXNwcmVmL2ludGVybmFscy50ZXhpCisrKyBi
L2RvYy9saXNwcmVmL2ludGVybmFscy50ZXhpCkBAIC0xMiw3ICsxMiw2IEBAIEdOVSBFbWFjcyBJ
bnRlcm5hbHMKIAogQG1lbnUKICogQnVpbGRpbmcgRW1hY3M6OiAgICAgIEhvdyB0aGUgZHVtcGVk
IEVtYWNzIGlzIG1hZGUuCi0qIFB1cmUgU3RvcmFnZTo6ICAgICAgICBLbHVkZ2UgdG8gbWFrZSBw
cmVsb2FkZWQgTGlzcCBmdW5jdGlvbnMgc2hhcmVhYmxlLgogKiBHYXJiYWdlIENvbGxlY3Rpb246
OiAgUmVjbGFpbWluZyBzcGFjZSBmb3IgTGlzcCBvYmplY3RzIG5vIGxvbmdlciB1c2VkLgogKiBT
dGFjay1hbGxvY2F0ZWQgT2JqZWN0czo6ICAgIFRlbXBvcmFyeSBjb25zZXMgYW5kIHN0cmluZ3Mg
b24gQyBzdGFjay4KICogTWVtb3J5IFVzYWdlOjogICAgICAgIEluZm8gYWJvdXQgdG90YWwgc2l6
ZSBvZiBMaXNwIG9iamVjdHMgbWFkZSBzbyBmYXIuCkBAIC0yNDMsNzEgKzI0Miw2IEBAIEJ1aWxk
aW5nIEVtYWNzCiB2YWx1ZSBpcyBuaWwuCiBAZW5kIGRlZnVuCiAKLUBub2RlIFB1cmUgU3RvcmFn
ZQotQHNlY3Rpb24gUHVyZSBTdG9yYWdlCi1AY2luZGV4IHB1cmUgc3RvcmFnZQotCi0gIEVtYWNz
IExpc3AgdXNlcyB0d28ga2luZHMgb2Ygc3RvcmFnZSBmb3IgdXNlci1jcmVhdGVkIExpc3Agb2Jq
ZWN0czoKLUBkZm57bm9ybWFsIHN0b3JhZ2V9IGFuZCBAZGZue3B1cmUgc3RvcmFnZX0uICBOb3Jt
YWwgc3RvcmFnZSBpcyB3aGVyZQotYWxsIHRoZSBuZXcgZGF0YSBjcmVhdGVkIGR1cmluZyBhbiBF
bWFjcyBzZXNzaW9uIGFyZSBrZXB0Ci0oQHB4cmVme0dhcmJhZ2UgQ29sbGVjdGlvbn0pLiAgUHVy
ZSBzdG9yYWdlIGlzIHVzZWQgZm9yIGNlcnRhaW4gZGF0YQotaW4gdGhlIHByZWxvYWRlZCBzdGFu
ZGFyZCBMaXNwIGZpbGVzLS0tZGF0YSB0aGF0IHNob3VsZCBuZXZlciBjaGFuZ2UKLWR1cmluZyBh
Y3R1YWwgdXNlIG9mIEVtYWNzLgotCi0gIFB1cmUgc3RvcmFnZSBpcyBhbGxvY2F0ZWQgb25seSB3
aGlsZSBAY29tbWFuZHt0ZW1hY3N9IGlzIGxvYWRpbmcgdGhlCi1zdGFuZGFyZCBwcmVsb2FkZWQg
TGlzcCBsaWJyYXJpZXMuICBJbiB0aGUgZmlsZSBAZmlsZXtlbWFjc30sIGl0IGlzCi1tYXJrZWQg
YXMgcmVhZC1vbmx5IChvbiBvcGVyYXRpbmcgc3lzdGVtcyB0aGF0IHBlcm1pdCB0aGlzKSwgc28g
dGhhdAotdGhlIG1lbW9yeSBzcGFjZSBjYW4gYmUgc2hhcmVkIGJ5IGFsbCB0aGUgRW1hY3Mgam9i
cyBydW5uaW5nIG9uIHRoZQotbWFjaGluZSBhdCBvbmNlLiAgUHVyZSBzdG9yYWdlIGlzIG5vdCBl
eHBhbmRhYmxlOyBhIGZpeGVkIGFtb3VudCBpcwotYWxsb2NhdGVkIHdoZW4gRW1hY3MgaXMgY29t
cGlsZWQsIGFuZCBpZiB0aGF0IGlzIG5vdCBzdWZmaWNpZW50IGZvcgotdGhlIHByZWxvYWRlZCBs
aWJyYXJpZXMsIEBmaWxle3RlbWFjc30gYWxsb2NhdGVzIGR5bmFtaWMgbWVtb3J5IGZvcgotdGhl
IHBhcnQgdGhhdCBkaWRuJ3QgZml0LiAgSWYgRW1hY3Mgd2lsbCBiZSBkdW1wZWQgdXNpbmcgdGhl
Ci1AY29kZXtwZHVtcH0gbWV0aG9kIChAcHhyZWZ7QnVpbGRpbmcgRW1hY3N9KSwgdGhlIHB1cmUt
c3BhY2Ugb3ZlcmZsb3cKLWlzIG9mIG5vIHNwZWNpYWwgaW1wb3J0YW5jZSAoaXQganVzdCBtZWFu
cyBzb21lIG9mIHRoZSBwcmVsb2FkZWQgc3R1ZmYKLWNhbm5vdCBiZSBzaGFyZWQgd2l0aCBvdGhl
ciBFbWFjcyBqb2JzKS4gIEhvd2V2ZXIsIGlmIEVtYWNzIHdpbGwgYmUKLWR1bXBlZCB1c2luZyB0
aGUgbm93IG9ic29sZXRlIEBjb2Rle3VuZXhlY30gbWV0aG9kLCB0aGUgcmVzdWx0aW5nCi1pbWFn
ZSB3aWxsIHdvcmssIGJ1dCBnYXJiYWdlIGNvbGxlY3Rpb24gKEBweHJlZntHYXJiYWdlIENvbGxl
Y3Rpb259KQotaXMgZGlzYWJsZWQgaW4gdGhpcyBzaXR1YXRpb24sIGNhdXNpbmcgYSBtZW1vcnkg
bGVhay4gIFN1Y2ggYW4KLW92ZXJmbG93IG5vcm1hbGx5IHdvbid0IGhhcHBlbiB1bmxlc3MgeW91
IHRyeSB0byBwcmVsb2FkIGFkZGl0aW9uYWwKLWxpYnJhcmllcyBvciBhZGQgZmVhdHVyZXMgdG8g
dGhlIHN0YW5kYXJkIG9uZXMuICBFbWFjcyB3aWxsIGRpc3BsYXkgYQotd2FybmluZyBhYm91dCB0
aGUgb3ZlcmZsb3cgd2hlbiBpdCBzdGFydHMsIGlmIGl0IHdhcyBkdW1wZWQgdXNpbmcKLUBjb2Rl
e3VuZXhlY30uICBJZiB0aGlzIGhhcHBlbnMsIHlvdSBzaG91bGQgaW5jcmVhc2UgdGhlIGNvbXBp
bGF0aW9uCi1wYXJhbWV0ZXIgQGNvZGV7U1lTVEVNX1BVUkVTSVpFX0VYVFJBfSBpbiB0aGUgZmls
ZQotQGZpbGV7c3JjL3B1cmVzaXplLmh9IGFuZCByZWJ1aWxkIEVtYWNzLgotCi1AZGVmdW4gcHVy
ZWNvcHkgb2JqZWN0Ci1UaGlzIGZ1bmN0aW9uIG1ha2VzIGEgY29weSBpbiBwdXJlIHN0b3JhZ2Ug
b2YgQHZhcntvYmplY3R9LCBhbmQgcmV0dXJucwotaXQuICBJdCBjb3BpZXMgYSBzdHJpbmcgYnkg
c2ltcGx5IG1ha2luZyBhIG5ldyBzdHJpbmcgd2l0aCB0aGUgc2FtZQotY2hhcmFjdGVycywgYnV0
IHdpdGhvdXQgdGV4dCBwcm9wZXJ0aWVzLCBpbiBwdXJlIHN0b3JhZ2UuICBJdAotcmVjdXJzaXZl
bHkgY29waWVzIHRoZSBjb250ZW50cyBvZiB2ZWN0b3JzIGFuZCBjb25zIGNlbGxzLiAgSXQgZG9l
cwotbm90IG1ha2UgY29waWVzIG9mIG90aGVyIG9iamVjdHMgc3VjaCBhcyBzeW1ib2xzLCBidXQg
anVzdCByZXR1cm5zCi10aGVtIHVuY2hhbmdlZC4gIEl0IHNpZ25hbHMgYW4gZXJyb3IgaWYgYXNr
ZWQgdG8gY29weSBtYXJrZXJzLgotCi1UaGlzIGZ1bmN0aW9uIGlzIGEgbm8tb3AgZXhjZXB0IHdo
aWxlIEVtYWNzIGlzIGJlaW5nIGJ1aWx0IGFuZCBkdW1wZWQ7Ci1pdCBpcyB1c3VhbGx5IGNhbGxl
ZCBvbmx5IGluIHByZWxvYWRlZCBMaXNwIGZpbGVzLgotQGVuZCBkZWZ1bgotCi1AZGVmdmFyIHB1
cmUtYnl0ZXMtdXNlZAotVGhlIHZhbHVlIG9mIHRoaXMgdmFyaWFibGUgaXMgdGhlIG51bWJlciBv
ZiBieXRlcyBvZiBwdXJlIHN0b3JhZ2UKLWFsbG9jYXRlZCBzbyBmYXIuICBUeXBpY2FsbHksIGlu
IGEgZHVtcGVkIEVtYWNzLCB0aGlzIG51bWJlciBpcyB2ZXJ5Ci1jbG9zZSB0byB0aGUgdG90YWwg
YW1vdW50IG9mIHB1cmUgc3RvcmFnZSBhdmFpbGFibGUtLS1pZiBpdCB3ZXJlIG5vdCwKLXdlIHdv
dWxkIHByZWFsbG9jYXRlIGxlc3MuCi1AZW5kIGRlZnZhcgotCi1AZGVmdmFyIHB1cmlmeS1mbGFn
Ci1UaGlzIHZhcmlhYmxlIGRldGVybWluZXMgd2hldGhlciBAY29kZXtkZWZ1bn0gc2hvdWxkIG1h
a2UgYSBjb3B5IG9mIHRoZQotZnVuY3Rpb24gZGVmaW5pdGlvbiBpbiBwdXJlIHN0b3JhZ2UuICBJ
ZiBpdCBpcyBub24tQGNvZGV7bmlsfSwgdGhlbiB0aGUKLWZ1bmN0aW9uIGRlZmluaXRpb24gaXMg
Y29waWVkIGludG8gcHVyZSBzdG9yYWdlLgotCi1UaGlzIGZsYWcgaXMgQGNvZGV7dH0gd2hpbGUg
bG9hZGluZyBhbGwgb2YgdGhlIGJhc2ljIGZ1bmN0aW9ucyBmb3IKLWJ1aWxkaW5nIEVtYWNzIGlu
aXRpYWxseSAoYWxsb3dpbmcgdGhvc2UgZnVuY3Rpb25zIHRvIGJlIHNoYXJlYWJsZSBhbmQKLW5v
bi1jb2xsZWN0aWJsZSkuICBEdW1waW5nIEVtYWNzIGFzIGFuIGV4ZWN1dGFibGUgYWx3YXlzIHdy
aXRlcwotQGNvZGV7bmlsfSBpbiB0aGlzIHZhcmlhYmxlLCByZWdhcmRsZXNzIG9mIHRoZSB2YWx1
ZSBpdCBhY3R1YWxseSBoYXMKLWJlZm9yZSBhbmQgYWZ0ZXIgZHVtcGluZy4KLQotWW91IHNob3Vs
ZCBub3QgY2hhbmdlIHRoaXMgZmxhZyBpbiBhIHJ1bm5pbmcgRW1hY3MuCi1AZW5kIGRlZnZhcgot
CiBAbm9kZSBHYXJiYWdlIENvbGxlY3Rpb24KIEBzZWN0aW9uIEdhcmJhZ2UgQ29sbGVjdGlvbgog
CkBAIC01MTQsMTIgKzQ0OCw2IEBAIEdhcmJhZ2UgQ29sbGVjdGlvbgogQGl0ZW0gZnJlZS1zaXpl
CiBIZWFwIHNwYWNlIHdoaWNoIGlzIG5vdCBjdXJyZW50bHkgdXNlZCwgaW4gQHZhcnt1bml0LXNp
emV9IHVuaXRzLgogQGVuZCB0YWJsZQotCi1JZiB0aGVyZSB3YXMgb3ZlcmZsb3cgaW4gcHVyZSBz
cGFjZSAoQHB4cmVme1B1cmUgU3RvcmFnZX0pLCBhbmQgRW1hY3MKLXdhcyBkdW1wZWQgdXNpbmcg
dGhlIChub3cgb2Jzb2xldGUpIEBjb2Rle3VuZXhlY30gbWV0aG9kCi0oQHB4cmVme0J1aWxkaW5n
IEVtYWNzfSksIHRoZW4gQGNvZGV7Z2FyYmFnZS1jb2xsZWN0fSByZXR1cm5zCi1AY29kZXtuaWx9
LCBiZWNhdXNlIGEgcmVhbCBnYXJiYWdlIGNvbGxlY3Rpb24gY2Fubm90IGJlIGRvbmUgaW4gdGhh
dAotY2FzZS4KIEBlbmQgZGVmZm4KIAogQGRlZm9wdCBnYXJiYWdlLWNvbGxlY3Rpb24tbWVzc2Fn
ZXMKQEAgLTkzNCwxMiArODYyLDYgQEAgV3JpdGluZyBFbWFjcyBQcmltaXRpdmVzCiBhcmd1bWVu
dHMgY291bGQgYmUgdmVyeSBsb25nLiAgVGhpcyBpbmNyZWFzZXMgRW1hY3MgcmVzcG9uc2l2ZW5l
c3MgYW5kCiBpbXByb3ZlcyB1c2VyIGV4cGVyaWVuY2UuCiAKLSAgWW91IG11c3Qgbm90IHVzZSBD
IGluaXRpYWxpemVycyBmb3Igc3RhdGljIG9yIGdsb2JhbCB2YXJpYWJsZXMgdW5sZXNzCi10aGUg
dmFyaWFibGVzIGFyZSBuZXZlciB3cml0dGVuIG9uY2UgRW1hY3MgaXMgZHVtcGVkLiAgVGhlc2Ug
dmFyaWFibGVzCi13aXRoIGluaXRpYWxpemVycyBhcmUgYWxsb2NhdGVkIGluIGFuIGFyZWEgb2Yg
bWVtb3J5IHRoYXQgYmVjb21lcwotcmVhZC1vbmx5IChvbiBjZXJ0YWluIG9wZXJhdGluZyBzeXN0
ZW1zKSBhcyBhIHJlc3VsdCBvZiBkdW1waW5nIEVtYWNzLgotQHhyZWZ7UHVyZSBTdG9yYWdlfS4K
LQogQGNpbmRleCBAY29kZXtkZWZzdWJyfSwgTGlzcCBzeW1ib2wgZm9yIGEgcHJpbWl0aXZlCiAg
IERlZmluaW5nIHRoZSBDIGZ1bmN0aW9uIGlzIG5vdCBlbm91Z2ggdG8gbWFrZSBhIExpc3AgcHJp
bWl0aXZlCiBhdmFpbGFibGU7IHlvdSBtdXN0IGFsc28gY3JlYXRlIHRoZSBMaXNwIHN5bWJvbCBm
b3IgdGhlIHByaW1pdGl2ZSBhbmQKZGlmZiAtLWdpdCBhL2RvYy9saXNwcmVmL3N5bWJvbHMudGV4
aSBiL2RvYy9saXNwcmVmL3N5bWJvbHMudGV4aQppbmRleCBlZDM2ZjUxMzlhODU2Li4xMTI0N2Nk
NjEyMTI4IDEwMDY0NAotLS0gYS9kb2MvbGlzcHJlZi9zeW1ib2xzLnRleGkKKysrIGIvZG9jL2xp
c3ByZWYvc3ltYm9scy50ZXhpCkBAIC01NjIsOCArNTYyLDcgQEAgU3RhbmRhcmQgUHJvcGVydGll
cwogSWYgdGhlIHZhbHVlIGlzIG5vbi1AY29kZXtuaWx9LCB0aGUgbmFtZWQgZnVuY3Rpb24gaXMg
Y29uc2lkZXJlZCB0byBiZQogcHVyZSAoQHB4cmVme1doYXQgSXMgYSBGdW5jdGlvbn0pLiAgQ2Fs
bHMgd2l0aCBjb25zdGFudCBhcmd1bWVudHMgY2FuCiBiZSBldmFsdWF0ZWQgYXQgY29tcGlsZSB0
aW1lLiAgVGhpcyBtYXkgc2hpZnQgcnVuIHRpbWUgZXJyb3JzIHRvCi1jb21waWxlIHRpbWUuICBO
b3QgdG8gYmUgY29uZnVzZWQgd2l0aCBwdXJlIHN0b3JhZ2UgKEBweHJlZntQdXJlCi1TdG9yYWdl
fSkuCitjb21waWxlIHRpbWUuCiAKIEBpdGVtIHJpc2t5LWxvY2FsLXZhcmlhYmxlCiBJZiB0aGUg
dmFsdWUgaXMgbm9uLUBjb2Rle25pbH0sIHRoZSBuYW1lZCB2YXJpYWJsZSBpcyBjb25zaWRlcmVk
IHJpc2t5CmRpZmYgLS1naXQgYS9zcmMvTWFrZWZpbGUuaW4gYi9zcmMvTWFrZWZpbGUuaW4KaW5k
ZXggNDEwMGVkZjQ3MTJmZS4uMDMzMGIyZDM1NGIxOCAxMDA2NDQKLS0tIGEvc3JjL01ha2VmaWxl
LmluCisrKyBiL3NyYy9NYWtlZmlsZS5pbgpAQCAtNDA2LDggKzQwNiw2IEBAIC5jLm86CiAubS5v
OgogCSQoQU1fVl9DQykkKENDKSAtYyAkKENQUEZMQUdTKSAkKEFMTF9PQkpDX0NGTEFHUykgJChQ
Uk9GSUxJTkdfQ0ZMQUdTKSAkPAogCi0jIyBsYXN0ZmlsZSBtdXN0IGZvbGxvdyBhbGwgZmlsZXMg
d2hvc2UgaW5pdGlhbGl6ZWQgZGF0YSBhcmVhcyBzaG91bGQKLSMjIGJlIGR1bXBlZCBhcyBwdXJl
IGJ5IGR1bXAtZW1hY3MuCiBiYXNlX29iaiA9IGRpc3BuZXcubyBmcmFtZS5vIHNjcm9sbC5vIHhk
aXNwLm8gbWVudS5vICQoWE1FTlVfT0JKKSB3aW5kb3cubyBcCiAJY2hhcnNldC5vIGNvZGluZy5v
IGNhdGVnb3J5Lm8gY2NsLm8gY2hhcmFjdGVyLm8gY2hhcnRhYi5vIGJpZGkubyBcCiAJJChDTV9P
QkopIHRlcm0ubyB0ZXJtaW5hbC5vIHhmYWNlcy5vICQoWE9CSikgJChHVEtfT0JKKSAkKERCVVNf
T0JKKSBcCmRpZmYgLS1naXQgYS9zcmMvYWxsb2MuYyBiL3NyYy9hbGxvYy5jCmluZGV4IGU3MmZj
NGM0MzMyZGUuLmJlZTcwMmU5MjE2OGMgMTAwNjQ0Ci0tLSBhL3NyYy9hbGxvYy5jCisrKyBiL3Ny
Yy9hbGxvYy5jCkBAIC0zNCw3ICszNCw2IEBAIENvcHlyaWdodCAoQykgMTk4NS0xOTg2LCAxOTg4
LCAxOTkzLTE5OTUsIDE5OTctMjAyMSBGcmVlIFNvZnR3YXJlCiAjaW5jbHVkZSAiYmlnbnVtLmgi
CiAjaW5jbHVkZSAiZGlzcGV4dGVybi5oIgogI2luY2x1ZGUgImludGVydmFscy5oIgotI2luY2x1
ZGUgInB1cmVzaXplLmgiCiAjaW5jbHVkZSAic2hlYXAuaCIKICNpbmNsdWRlICJzeXNzdGRpby5o
IgogI2luY2x1ZGUgInN5c3RpbWUuaCIKQEAgLTMzMywzMyArMzMyLDYgQEAgI2RlZmluZSBISV9U
SFJFU0hPTEQgKEVNQUNTX0lOVF9NQVggLyAyKQogCiAjZGVmaW5lIFNQQVJFX01FTU9SWSAoMSA8
PCAxNCkKIAotLyogSW5pdGlhbGl6ZSBpdCB0byBhIG5vbnplcm8gdmFsdWUgdG8gZm9yY2UgaXQg
aW50byBkYXRhIHNwYWNlCi0gICAocmF0aGVyIHRoYW4gYnNzIHNwYWNlKS4gIFRoYXQgd2F5IHVu
ZXhlYyB3aWxsIHJlbWFwIGl0IGludG8gdGV4dAotICAgc3BhY2UgKHB1cmUpLCBvbiBzb21lIHN5
c3RlbXMuICBXZSBoYXZlIG5vdCBpbXBsZW1lbnRlZCB0aGUKLSAgIHJlbWFwcGluZyBvbiBtb3Jl
IHJlY2VudCBzeXN0ZW1zIGJlY2F1c2UgdGhpcyBpcyBsZXNzIGltcG9ydGFudAotICAgbm93YWRh
eXMgdGhhbiBpbiB0aGUgZGF5cyBvZiBzbWFsbCBtZW1vcmllcyBhbmQgdGltZXNoYXJpbmcuICAq
LwotCi1FTUFDU19JTlQgcHVyZVsoUFVSRVNJWkUgKyBzaXplb2YgKEVNQUNTX0lOVCkgLSAxKSAv
IHNpemVvZiAoRU1BQ1NfSU5UKV0gPSB7MSx9OwotI2RlZmluZSBQVVJFQkVHIChjaGFyICopIHB1
cmUKLQotLyogUG9pbnRlciB0byB0aGUgcHVyZSBhcmVhLCBhbmQgaXRzIHNpemUuICAqLwotCi1z
dGF0aWMgY2hhciAqcHVyZWJlZzsKLXN0YXRpYyBwdHJkaWZmX3QgcHVyZV9zaXplOwotCi0vKiBO
dW1iZXIgb2YgYnl0ZXMgb2YgcHVyZSBzdG9yYWdlIHVzZWQgYmVmb3JlIHB1cmUgc3RvcmFnZSBv
dmVyZmxvd2VkLgotICAgSWYgdGhpcyBpcyBub24temVybywgdGhpcyBpbXBsaWVzIHRoYXQgYW4g
b3ZlcmZsb3cgb2NjdXJyZWQuICAqLwotCi1zdGF0aWMgcHRyZGlmZl90IHB1cmVfYnl0ZXNfdXNl
ZF9iZWZvcmVfb3ZlcmZsb3c7Ci0KLS8qIEluZGV4IGluIHB1cmUgYXQgd2hpY2ggbmV4dCBwdXJl
IExpc3Agb2JqZWN0IHdpbGwgYmUgYWxsb2NhdGVkLi4gICovCi0KLXN0YXRpYyBwdHJkaWZmX3Qg
cHVyZV9ieXRlc191c2VkX2xpc3A7Ci0KLS8qIE51bWJlciBvZiBieXRlcyBhbGxvY2F0ZWQgZm9y
IG5vbi1MaXNwIG9iamVjdHMgaW4gcHVyZSBzdG9yYWdlLiAgKi8KLQotc3RhdGljIHB0cmRpZmZf
dCBwdXJlX2J5dGVzX3VzZWRfbm9uX2xpc3A7Ci0KIC8qIElmIHBvc2l0aXZlLCBnYXJiYWdlIGNv
bGxlY3Rpb24gaXMgaW5oaWJpdGVkLiAgT3RoZXJ3aXNlLCB6ZXJvLiAgKi8KIAogc3RhdGljIGlu
dHB0cl90IGdhcmJhZ2VfY29sbGVjdGlvbl9pbmhpYml0ZWQ7CkBAIC00MzQsNyArNDA2LDYgQEAg
bm9fc2FuaXRpemVfbWVtY3B5ICh2b2lkICpkZXN0LCB2b2lkIGNvbnN0ICpzcmMsIHNpemVfdCBz
aXplKQogc3RhdGljIHZvaWQgdW5jaGFpbl9maW5hbGl6ZXIgKHN0cnVjdCBMaXNwX0ZpbmFsaXpl
ciAqKTsKIHN0YXRpYyB2b2lkIG1hcmtfdGVybWluYWxzICh2b2lkKTsKIHN0YXRpYyB2b2lkIGdj
X3N3ZWVwICh2b2lkKTsKLXN0YXRpYyBMaXNwX09iamVjdCBtYWtlX3B1cmVfdmVjdG9yIChwdHJk
aWZmX3QpOwogc3RhdGljIHZvaWQgbWFya19idWZmZXIgKHN0cnVjdCBidWZmZXIgKik7CiAKICNp
ZiAhZGVmaW5lZCBSRUxfQUxMT0MgfHwgZGVmaW5lZCBTWVNURU1fTUFMTE9DIHx8IGRlZmluZWQg
SFlCUklEX01BTExPQwpAQCAtNTc2LDE2ICs1NDcsNiBAQCAjZGVmaW5lIE1FTV9OSUwgJm1lbV96
CiAKIGludCBzdGF0aWNpZHg7CiAKLXN0YXRpYyB2b2lkICpwdXJlX2FsbG9jIChzaXplX3QsIGlu
dCk7Ci0KLS8qIFJldHVybiBQVFIgcm91bmRlZCB1cCB0byB0aGUgbmV4dCBtdWx0aXBsZSBvZiBB
TElHTk1FTlQuICAqLwotCi1zdGF0aWMgdm9pZCAqCi1wb2ludGVyX2FsaWduICh2b2lkICpwdHIs
IGludCBhbGlnbm1lbnQpCi17Ci0gIHJldHVybiAodm9pZCAqKSBST1VORFVQICgodWludHB0cl90
KSBwdHIsIGFsaWdubWVudCk7Ci19Ci0KIC8qIEV4dHJhY3QgdGhlIHBvaW50ZXIgaGlkZGVuIHdp
dGhpbiBPLiAgKi8KIAogc3RhdGljIEFUVFJJQlVURV9OT19TQU5JVElaRV9VTkRFRklORUQgdm9p
ZCAqCkBAIC0xMDc1LDYgKzEwMzYsMTUgQEAgdmVyaWZ5IChQT1dFUl9PRl8yIChCTE9DS19BTElH
TikpOwogIyBlbGlmICFkZWZpbmVkIEhZQlJJRF9NQUxMT0MgJiYgZGVmaW5lZCBIQVZFX1BPU0lY
X01FTUFMSUdOCiAjICBkZWZpbmUgVVNFX0FMSUdORURfQUxMT0MgMQogIyAgZGVmaW5lIGFsaWdu
ZWRfYWxsb2MgbXlfYWxpZ25lZF9hbGxvYyAvKiBBdm9pZCBjb2xsaXNpb24gd2l0aCBsaXNwLmgu
ICAqLworCisvKiBSZXR1cm4gUFRSIHJvdW5kZWQgdXAgdG8gdGhlIG5leHQgbXVsdGlwbGUgb2Yg
QUxJR05NRU5ULiAgKi8KKworc3RhdGljIHZvaWQgKgorcG9pbnRlcl9hbGlnbiAodm9pZCAqcHRy
LCBpbnQgYWxpZ25tZW50KQoreworICByZXR1cm4gKHZvaWQgKikgUk9VTkRVUCAoKHVpbnRwdHJf
dCkgcHRyLCBhbGlnbm1lbnQpOworfQorCiBzdGF0aWMgdm9pZCAqCiBhbGlnbmVkX2FsbG9jIChz
aXplX3QgYWxpZ25tZW50LCBzaXplX3Qgc2l6ZSkKIHsKQEAgLTE2NzksOSArMTY0OSw5IEBAICNk
ZWZpbmUgR0NfU1RSSU5HX0VYVFJBIEdDX1NUUklOR19PVkVSUlVOX0NPT0tJRV9TSVpFCiBzdGF0
aWMgdm9pZAogaW5pdF9zdHJpbmdzICh2b2lkKQogewotICBlbXB0eV91bmlieXRlX3N0cmluZyA9
IG1ha2VfcHVyZV9zdHJpbmcgKCIiLCAwLCAwLCAwKTsKKyAgZW1wdHlfdW5pYnl0ZV9zdHJpbmcg
PSBtYWtlX3NwZWNpZmllZF9zdHJpbmcgKCIiLCAwLCAwLCBmYWxzZSk7CiAgIHN0YXRpY3BybyAo
JmVtcHR5X3VuaWJ5dGVfc3RyaW5nKTsKLSAgZW1wdHlfbXVsdGlieXRlX3N0cmluZyA9IG1ha2Vf
cHVyZV9zdHJpbmcgKCIiLCAwLCAwLCAxKTsKKyAgZW1wdHlfbXVsdGlieXRlX3N0cmluZyA9IG1h
a2Vfc3BlY2lmaWVkX3N0cmluZyAoIiIsIDAsIDAsIHRydWUpOwogICBzdGF0aWNwcm8gKCZlbXB0
eV9tdWx0aWJ5dGVfc3RyaW5nKTsKIH0KIApAQCAtMTY5OSw3ICsxNjY5LDcgQEAgc3RyaW5nX2J5
dGVzIChzdHJ1Y3QgTGlzcF9TdHJpbmcgKnMpCiAgIHB0cmRpZmZfdCBuYnl0ZXMgPQogICAgIChz
LT51LnMuc2l6ZV9ieXRlIDwgMCA/IHMtPnUucy5zaXplICYgfkFSUkFZX01BUktfRkxBRyA6IHMt
PnUucy5zaXplX2J5dGUpOwogCi0gIGlmICghUFVSRV9QIChzKSAmJiAhcGR1bXBlcl9vYmplY3Rf
cCAocykgJiYgcy0+dS5zLmRhdGEKKyAgaWYgKCFwZHVtcGVyX29iamVjdF9wIChzKSAmJiBzLT51
LnMuZGF0YQogICAgICAgJiYgbmJ5dGVzICE9IFNEQVRBX05CWVRFUyAoU0RBVEFfT0ZfU1RSSU5H
IChzKSkpCiAgICAgZW1hY3NfYWJvcnQgKCk7CiAgIHJldHVybiBuYnl0ZXM7CkBAIC0yNDE1LDcg
KzIzODUsNyBAQCBtYWtlX3NwZWNpZmllZF9zdHJpbmcgKGNvbnN0IGNoYXIgKmNvbnRlbnRzLAog
ewogICBMaXNwX09iamVjdCB2YWw7CiAKLSAgaWYgKG5jaGFycyA8IDApCisgIGlmIChuY2hhcnMg
PD0gMCkKICAgICB7CiAgICAgICBpZiAobXVsdGlieXRlKQogCW5jaGFycyA9IG11bHRpYnl0ZV9j
aGFyc19pbl90ZXh0ICgoY29uc3QgdW5zaWduZWQgY2hhciAqKSBjb250ZW50cywKQEAgLTI0Njks
OCArMjQzOSw2IEBAIG1ha2VfY2xlYXJfbXVsdGlieXRlX3N0cmluZyAoRU1BQ1NfSU5UIG5jaGFy
cywgRU1BQ1NfSU5UIG5ieXRlcywgYm9vbCBjbGVhcml0KQogCiAgIGlmIChuY2hhcnMgPCAwKQog
ICAgIGVtYWNzX2Fib3J0ICgpOwotICBpZiAoIW5ieXRlcykKLSAgICByZXR1cm4gZW1wdHlfbXVs
dGlieXRlX3N0cmluZzsKIAogICBzID0gYWxsb2NhdGVfc3RyaW5nICgpOwogICBzLT51LnMuaW50
ZXJ2YWxzID0gTlVMTDsKQEAgLTI3NTEsMTcgKzI3MTksMTYgQEAgbGlzdDUgKExpc3BfT2JqZWN0
IGFyZzEsIExpc3BfT2JqZWN0IGFyZzIsIExpc3BfT2JqZWN0IGFyZzMsIExpc3BfT2JqZWN0IGFy
ZzQsCiB9CiAKIC8qIE1ha2UgYSBsaXN0IG9mIENPVU5UIExpc3BfT2JqZWN0cywgd2hlcmUgQVJH
IGlzIHRoZSBmaXJzdCBvbmUuCi0gICBVc2UgQ09OUyB0byBjb25zdHJ1Y3QgdGhlIHBhaXJzLiAg
QVAgaGFzIGFueSByZW1haW5pbmcgYXJncy4gICovCisgICBBUCBoYXMgYW55IHJlbWFpbmluZyBh
cmdzLiAgKi8KIHN0YXRpYyBMaXNwX09iamVjdAotY29uc19saXN0biAocHRyZGlmZl90IGNvdW50
LCBMaXNwX09iamVjdCBhcmcsCi0JICAgIExpc3BfT2JqZWN0ICgqY29ucykgKExpc3BfT2JqZWN0
LCBMaXNwX09iamVjdCksIHZhX2xpc3QgYXApCitjb25zX2xpc3RuIChwdHJkaWZmX3QgY291bnQs
IExpc3BfT2JqZWN0IGFyZywgdmFfbGlzdCBhcCkKIHsKICAgZWFzc3VtZSAoMCA8IGNvdW50KTsK
LSAgTGlzcF9PYmplY3QgdmFsID0gY29ucyAoYXJnLCBRbmlsKTsKKyAgTGlzcF9PYmplY3QgdmFs
ID0gRmNvbnMgKGFyZywgUW5pbCk7CiAgIExpc3BfT2JqZWN0IHRhaWwgPSB2YWw7CiAgIGZvciAo
cHRyZGlmZl90IGkgPSAxOyBpIDwgY291bnQ7IGkrKykKICAgICB7Ci0gICAgICBMaXNwX09iamVj
dCBlbGVtID0gY29ucyAodmFfYXJnIChhcCwgTGlzcF9PYmplY3QpLCBRbmlsKTsKKyAgICAgIExp
c3BfT2JqZWN0IGVsZW0gPSBGY29ucyAodmFfYXJnIChhcCwgTGlzcF9PYmplY3QpLCBRbmlsKTsK
ICAgICAgIFhTRVRDRFIgKHRhaWwsIGVsZW0pOwogICAgICAgdGFpbCA9IGVsZW07CiAgICAgfQpA
QCAtMjc3NCwxOCArMjc0MSw3IEBAIGxpc3RuIChwdHJkaWZmX3QgY291bnQsIExpc3BfT2JqZWN0
IGFyZzEsIC4uLikKIHsKICAgdmFfbGlzdCBhcDsKICAgdmFfc3RhcnQgKGFwLCBhcmcxKTsKLSAg
TGlzcF9PYmplY3QgdmFsID0gY29uc19saXN0biAoY291bnQsIGFyZzEsIEZjb25zLCBhcCk7Ci0g
IHZhX2VuZCAoYXApOwotICByZXR1cm4gdmFsOwotfQotCi0vKiBNYWtlIGEgcHVyZSBsaXN0IG9m
IENPVU5UIExpc3BfT2JqZWN0cywgd2hlcmUgQVJHMSBpcyB0aGUgZmlyc3Qgb25lLiAgKi8KLUxp
c3BfT2JqZWN0Ci1wdXJlX2xpc3RuIChwdHJkaWZmX3QgY291bnQsIExpc3BfT2JqZWN0IGFyZzEs
IC4uLikKLXsKLSAgdmFfbGlzdCBhcDsKLSAgdmFfc3RhcnQgKGFwLCBhcmcxKTsKLSAgTGlzcF9P
YmplY3QgdmFsID0gY29uc19saXN0biAoY291bnQsIGFyZzEsIHB1cmVfY29ucywgYXApOworICBM
aXNwX09iamVjdCB2YWwgPSBjb25zX2xpc3RuIChjb3VudCwgYXJnMSwgYXApOwogICB2YV9lbmQg
KGFwKTsKICAgcmV0dXJuIHZhbDsKIH0KQEAgLTI5NTEsNyArMjkwNyw3IEBAIGxhcmdlX3ZlY3Rv
cl92ZWMgKHN0cnVjdCBsYXJnZV92ZWN0b3IgKnApCiAKIHN0YXRpYyBzdHJ1Y3QgbGFyZ2VfdmVj
dG9yICpsYXJnZV92ZWN0b3JzOwogCi0vKiBUaGUgb25seSB2ZWN0b3Igd2l0aCAwIHNsb3RzLCBh
bGxvY2F0ZWQgZnJvbSBwdXJlIHNwYWNlLiAgKi8KKy8qIFRoZSBvbmx5IHZlY3RvciB3aXRoIDAg
c2xvdHMuICAqLwogCiBMaXNwX09iamVjdCB6ZXJvX3ZlY3RvcjsKIApAQCAtMjk4NywxNSArMjk0
Myw2IEBAIGFsbG9jYXRlX3ZlY3Rvcl9ibG9jayAodm9pZCkKICAgcmV0dXJuIGJsb2NrOwogfQog
Ci0vKiBDYWxsZWQgb25jZSB0byBpbml0aWFsaXplIHZlY3RvciBhbGxvY2F0aW9uLiAgKi8KLQot
c3RhdGljIHZvaWQKLWluaXRfdmVjdG9ycyAodm9pZCkKLXsKLSAgemVyb192ZWN0b3IgPSBtYWtl
X3B1cmVfdmVjdG9yICgwKTsKLSAgc3RhdGljcHJvICgmemVyb192ZWN0b3IpOwotfQotCiAvKiBB
bGxvY2F0ZSB2ZWN0b3IgZnJvbSBhIHZlY3RvciBibG9jay4gICovCiAKIHN0YXRpYyBzdHJ1Y3Qg
TGlzcF9WZWN0b3IgKgpAQCAtMzA4Niw2ICszMDMzLDggQEAgdmVjdG9ybGlrZV9uYnl0ZXMgKGNv
bnN0IHVuaW9uIHZlY3Rvcmxpa2VfaGVhZGVyICpoZHIpCiAgICAgfQogICBlbHNlCiAgICAgbndv
cmRzID0gc2l6ZTsKKyAgaWYgKG53b3JkcyA9PSAwKQorICAgIG53b3JkcyA9IDE7CiAgIHJldHVy
biB2cm91bmR1cCAoaGVhZGVyX3NpemUgKyB3b3JkX3NpemUgKiBud29yZHMpOwogfQogCkBAIC0z
MzQzLDYgKzMyOTIsMTggQEAgYWxsb2NhdGVfbmlsX3ZlY3RvciAocHRyZGlmZl90IGxlbikKIH0K
IAogCisvKiBDYWxsZWQgb25jZSB0byBpbml0aWFsaXplIHZlY3RvciBhbGxvY2F0aW9uLiAgKi8K
Kworc3RhdGljIHZvaWQKK2luaXRfdmVjdG9ycyAodm9pZCkKK3sKKyAgemVyb192ZWN0b3IgPQor
ICAgIG1ha2VfbGlzcF9wdHIgKGFsbG9jYXRlX3ZlY3Rvcmxpa2UgKDEsIHRydWUpLCBMaXNwX1Zl
Y3Rvcmxpa2UpOworICBYVkVDVE9SICh6ZXJvX3ZlY3RvciktPmhlYWRlci5zaXplID0gMDsKKyAg
WFZFQ1RPUiAoemVyb192ZWN0b3IpLT5jb250ZW50c1swXSA9IFFuaWw7CisgIHN0YXRpY3BybyAo
Jnplcm9fdmVjdG9yKTsKK30KKwogLyogQWxsb2NhdGUgb3RoZXIgdmVjdG9yLWxpa2Ugc3RydWN0
dXJlcy4gICovCiAKIHN0cnVjdCBMaXNwX1ZlY3RvciAqCkBAIC0zNTU1LDEzICszNTE2LDYgQEAg
I2RlZmluZSBTWU1CT0xfQkxPQ0tfU0laRSBcCiAKIHN0YXRpYyBzdHJ1Y3Qgc3ltYm9sX2Jsb2Nr
ICpzeW1ib2xfYmxvY2s7CiBzdGF0aWMgaW50IHN5bWJvbF9ibG9ja19pbmRleCA9IFNZTUJPTF9C
TE9DS19TSVpFOwotLyogUG9pbnRlciB0byB0aGUgZmlyc3Qgc3ltYm9sX2Jsb2NrIHRoYXQgY29u
dGFpbnMgcGlubmVkIHN5bWJvbHMuCi0gICBUZXN0cyBmb3IgMjQuNCBzaG93ZWQgdGhhdCBhdCBk
dW1wLXRpbWUsIEVtYWNzIGNvbnRhaW5zIGFib3V0IDE1SyBzeW1ib2xzLAotICAgMTBLIG9mIHdo
aWNoIGFyZSBwaW5uZWQgKGFuZCBhbGwgYnV0IDI1MCBvZiB0aGVtIGFyZSBpbnRlcm5lZCBpbiBv
YmFycmF5KSwKLSAgIHdoZXJlYXMgYSAidHlwaWNhbCBzZXNzaW9uIiBoYXMgaW4gdGhlIG9yZGVy
IG9mIDMwSyBzeW1ib2xzLgotICAgYHN5bWJvbF9ibG9ja19waW5uZWQnIGxldHMgbWFya19waW5u
ZWRfc3ltYm9scyBzY2FuIG9ubHkgMTVLIHN5bWJvbHMgcmF0aGVyCi0gICB0aGFuIDMwSyB0byBm
aW5kIHRoZSAxMEsgc3ltYm9scyB3ZSBuZWVkIHRvIG1hcmsuICAqLwotc3RhdGljIHN0cnVjdCBz
eW1ib2xfYmxvY2sgKnN5bWJvbF9ibG9ja19waW5uZWQ7CiAKIC8qIExpc3Qgb2YgZnJlZSBzeW1i
b2xzLiAgKi8KIApAQCAtMzU4Nyw3ICszNTQxLDYgQEAgaW5pdF9zeW1ib2wgKExpc3BfT2JqZWN0
IHZhbCwgTGlzcF9PYmplY3QgbmFtZSkKICAgcC0+dS5zLmludGVybmVkID0gU1lNQk9MX1VOSU5U
RVJORUQ7CiAgIHAtPnUucy50cmFwcGVkX3dyaXRlID0gU1lNQk9MX1VOVFJBUFBFRF9XUklURTsK
ICAgcC0+dS5zLmRlY2xhcmVkX3NwZWNpYWwgPSBmYWxzZTsKLSAgcC0+dS5zLnBpbm5lZCA9IGZh
bHNlOwogfQogCiBERUZVTiAoIm1ha2Utc3ltYm9sIiwgRm1ha2Vfc3ltYm9sLCBTbWFrZV9zeW1i
b2wsIDEsIDEsIDAsCkBAIC01MTUxLDggKzUxMDQsNiBAQCB2YWxpZF9saXNwX29iamVjdF9wIChM
aXNwX09iamVjdCBvYmopCiAgICAgcmV0dXJuIDE7CiAKICAgdm9pZCAqcCA9IFhQTlRSIChvYmop
OwotICBpZiAoUFVSRV9QIChwKSkKLSAgICByZXR1cm4gMTsKIAogICBpZiAoU1lNQk9MUCAob2Jq
KSAmJiBjX3N5bWJvbF9wIChwKSkKICAgICByZXR1cm4gKChjaGFyICopIHAgLSAoY2hhciAqKSBs
aXNwc3ltKSAlIHNpemVvZiBsaXNwc3ltWzBdID09IDA7CkBAIC01MjA4LDI5NiArNTE1OSw4IEBA
IHZhbGlkX2xpc3Bfb2JqZWN0X3AgKExpc3BfT2JqZWN0IG9iaikKICAgcmV0dXJuIDA7CiB9CiAK
LS8qKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioq
KioqKioqKioqKioqKioqKgotCQkgICAgICAgUHVyZSBTdG9yYWdlIE1hbmFnZW1lbnQKLSAqKioq
KioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioq
KioqKioqKioqKi8KLQotLyogQWxsb2NhdGUgcm9vbSBmb3IgU0laRSBieXRlcyBmcm9tIHB1cmUg
TGlzcCBzdG9yYWdlIGFuZCByZXR1cm4gYQotICAgcG9pbnRlciB0byBpdC4gIFRZUEUgaXMgdGhl
IExpc3AgdHlwZSBmb3Igd2hpY2ggdGhlIG1lbW9yeSBpcwotICAgYWxsb2NhdGVkLiAgVFlQRSA8
IDAgbWVhbnMgaXQncyBub3QgdXNlZCBmb3IgYSBMaXNwIG9iamVjdCwKLSAgIGFuZCB0aGF0IHRo
ZSByZXN1bHQgc2hvdWxkIGhhdmUgYW4gYWxpZ25tZW50IG9mIC1UWVBFLgotCi0gICBUaGUgYnl0
ZXMgYXJlIGluaXRpYWxseSB6ZXJvLgotCi0gICBJZiBwdXJlIHNwYWNlIGlzIGV4aGF1c3RlZCwg
YWxsb2NhdGUgc3BhY2UgZnJvbSB0aGUgaGVhcC4gIFRoaXMgaXMKLSAgIG1lcmVseSBhbiBleHBl
ZGllbnQgdG8gbGV0IEVtYWNzIHdhcm4gdGhhdCBwdXJlIHNwYWNlIHdhcyBleGhhdXN0ZWQKLSAg
IGFuZCB0aGF0IEVtYWNzIHNob3VsZCBiZSByZWJ1aWx0IHdpdGggYSBsYXJnZXIgcHVyZSBzcGFj
ZS4gICovCi0KLXN0YXRpYyB2b2lkICoKLXB1cmVfYWxsb2MgKHNpemVfdCBzaXplLCBpbnQgdHlw
ZSkKLXsKLSAgdm9pZCAqcmVzdWx0OwotCi0gYWdhaW46Ci0gIGlmICh0eXBlID49IDApCi0gICAg
ewotICAgICAgLyogQWxsb2NhdGUgc3BhY2UgZm9yIGEgTGlzcCBvYmplY3QgZnJvbSB0aGUgYmVn
aW5uaW5nIG9mIHRoZSBmcmVlCi0JIHNwYWNlIHdpdGggdGFraW5nIGFjY291bnQgb2YgYWxpZ25t
ZW50LiAgKi8KLSAgICAgIHJlc3VsdCA9IHBvaW50ZXJfYWxpZ24gKHB1cmViZWcgKyBwdXJlX2J5
dGVzX3VzZWRfbGlzcCwgTElTUF9BTElHTk1FTlQpOwotICAgICAgcHVyZV9ieXRlc191c2VkX2xp
c3AgPSAoKGNoYXIgKilyZXN1bHQgLSAoY2hhciAqKXB1cmViZWcpICsgc2l6ZTsKLSAgICB9Ci0g
IGVsc2UKLSAgICB7Ci0gICAgICAvKiBBbGxvY2F0ZSBzcGFjZSBmb3IgYSBub24tTGlzcCBvYmpl
Y3QgZnJvbSB0aGUgZW5kIG9mIHRoZSBmcmVlCi0JIHNwYWNlLiAgKi8KLSAgICAgIHB0cmRpZmZf
dCB1bmFsaWduZWRfbm9uX2xpc3AgPSBwdXJlX2J5dGVzX3VzZWRfbm9uX2xpc3AgKyBzaXplOwot
ICAgICAgY2hhciAqdW5hbGlnbmVkID0gcHVyZWJlZyArIHB1cmVfc2l6ZSAtIHVuYWxpZ25lZF9u
b25fbGlzcDsKLSAgICAgIGludCBkZWNyID0gKGludHB0cl90KSB1bmFsaWduZWQgJiAoLTEgLSB0
eXBlKTsKLSAgICAgIHB1cmVfYnl0ZXNfdXNlZF9ub25fbGlzcCA9IHVuYWxpZ25lZF9ub25fbGlz
cCArIGRlY3I7Ci0gICAgICByZXN1bHQgPSB1bmFsaWduZWQgLSBkZWNyOwotICAgIH0KLSAgcHVy
ZV9ieXRlc191c2VkID0gcHVyZV9ieXRlc191c2VkX2xpc3AgKyBwdXJlX2J5dGVzX3VzZWRfbm9u
X2xpc3A7Ci0KLSAgaWYgKHB1cmVfYnl0ZXNfdXNlZCA8PSBwdXJlX3NpemUpCi0gICAgcmV0dXJu
IHJlc3VsdDsKLQotICAvKiBEb24ndCBhbGxvY2F0ZSBhIGxhcmdlIGFtb3VudCBoZXJlLAotICAg
ICBiZWNhdXNlIGl0IG1pZ2h0IGdldCBtbWFwJ2QgYW5kIHRoZW4gaXRzIGFkZHJlc3MKLSAgICAg
bWlnaHQgbm90IGJlIHVzYWJsZS4gICovCi0gIGludCBzbWFsbF9hbW91bnQgPSAxMDAwMDsKLSAg
ZWFzc2VydCAoc2l6ZSA8PSBzbWFsbF9hbW91bnQgLSBMSVNQX0FMSUdOTUVOVCk7Ci0gIHB1cmVi
ZWcgPSB4emFsbG9jIChzbWFsbF9hbW91bnQpOwotICBwdXJlX3NpemUgPSBzbWFsbF9hbW91bnQ7
Ci0gIHB1cmVfYnl0ZXNfdXNlZF9iZWZvcmVfb3ZlcmZsb3cgKz0gcHVyZV9ieXRlc191c2VkIC0g
c2l6ZTsKLSAgcHVyZV9ieXRlc191c2VkID0gMDsKLSAgcHVyZV9ieXRlc191c2VkX2xpc3AgPSBw
dXJlX2J5dGVzX3VzZWRfbm9uX2xpc3AgPSAwOwotCi0gIC8qIENhbid0IEdDIGlmIHB1cmUgc3Rv
cmFnZSBvdmVyZmxvd2VkIGJlY2F1c2Ugd2UgY2FuJ3QgZGV0ZXJtaW5lCi0gICAgIGlmIHNvbWV0
aGluZyBpcyBhIHB1cmUgb2JqZWN0IG9yIG5vdC4gICovCi0gIGdhcmJhZ2VfY29sbGVjdGlvbl9p
bmhpYml0ZWQrKzsKLSAgZ290byBhZ2FpbjsKLX0KLQotCi0jaWZkZWYgSEFWRV9VTkVYRUMKLQot
LyogUHJpbnQgYSB3YXJuaW5nIGlmIFBVUkVTSVpFIGlzIHRvbyBzbWFsbC4gICovCi0KLXZvaWQK
LWNoZWNrX3B1cmVfc2l6ZSAodm9pZCkKLXsKLSAgaWYgKHB1cmVfYnl0ZXNfdXNlZF9iZWZvcmVf
b3ZlcmZsb3cpCi0gICAgbWVzc2FnZSAoKCJlbWFjczowOlB1cmUgTGlzcCBzdG9yYWdlIG92ZXJm
bG93IChhcHByb3guICUicEkiZCIKLQkgICAgICAiIGJ5dGVzIG5lZWRlZCkiKSwKLQkgICAgIHB1
cmVfYnl0ZXNfdXNlZCArIHB1cmVfYnl0ZXNfdXNlZF9iZWZvcmVfb3ZlcmZsb3cpOwotfQotI2Vu
ZGlmCi0KLQotLyogRmluZCB0aGUgYnl0ZSBzZXF1ZW5jZSB7REFUQVswXSwgLi4uLCBEQVRBW05C
WVRFUy0xXSwgJ1wwJ30gZnJvbQotICAgdGhlIG5vbi1MaXNwIGRhdGEgcG9vbCBvZiB0aGUgcHVy
ZSBzdG9yYWdlLCBhbmQgcmV0dXJuIGl0cyBzdGFydAotICAgYWRkcmVzcy4gIFJldHVybiBOVUxM
IGlmIG5vdCBmb3VuZC4gICovCi0KLXN0YXRpYyBjaGFyICoKLWZpbmRfc3RyaW5nX2RhdGFfaW5f
cHVyZSAoY29uc3QgY2hhciAqZGF0YSwgcHRyZGlmZl90IG5ieXRlcykKLXsKLSAgaW50IGk7Ci0g
IHB0cmRpZmZfdCBza2lwLCBibV9za2lwWzI1Nl0sIGxhc3RfY2hhcl9za2lwLCBpbmZpbml0eSwg
c3RhcnQsIHN0YXJ0X21heDsKLSAgY29uc3QgdW5zaWduZWQgY2hhciAqcDsKLSAgY2hhciAqbm9u
X2xpc3BfYmVnOwotCi0gIGlmIChwdXJlX2J5dGVzX3VzZWRfbm9uX2xpc3AgPD0gbmJ5dGVzKQot
ICAgIHJldHVybiBOVUxMOwotCi0gIC8qIFNldCB1cCB0aGUgQm95ZXItTW9vcmUgdGFibGUuICAq
LwotICBza2lwID0gbmJ5dGVzICsgMTsKLSAgZm9yIChpID0gMDsgaSA8IDI1NjsgaSsrKQotICAg
IGJtX3NraXBbaV0gPSBza2lwOwotCi0gIHAgPSAoY29uc3QgdW5zaWduZWQgY2hhciAqKSBkYXRh
OwotICB3aGlsZSAoLS1za2lwID4gMCkKLSAgICBibV9za2lwWypwKytdID0gc2tpcDsKLQotICBs
YXN0X2NoYXJfc2tpcCA9IGJtX3NraXBbJ1wwJ107Ci0KLSAgbm9uX2xpc3BfYmVnID0gcHVyZWJl
ZyArIHB1cmVfc2l6ZSAtIHB1cmVfYnl0ZXNfdXNlZF9ub25fbGlzcDsKLSAgc3RhcnRfbWF4ID0g
cHVyZV9ieXRlc191c2VkX25vbl9saXNwIC0gKG5ieXRlcyArIDEpOwotCi0gIC8qIFNlZSB0aGUg
Y29tbWVudHMgaW4gdGhlIGZ1bmN0aW9uIGBib3llcl9tb29yZScgKHNlYXJjaC5jKSBmb3IgdGhl
Ci0gICAgIHVzZSBvZiBgaW5maW5pdHknLiAgKi8KLSAgaW5maW5pdHkgPSBwdXJlX2J5dGVzX3Vz
ZWRfbm9uX2xpc3AgKyAxOwotICBibV9za2lwWydcMCddID0gaW5maW5pdHk7Ci0KLSAgcCA9IChj
b25zdCB1bnNpZ25lZCBjaGFyICopIG5vbl9saXNwX2JlZyArIG5ieXRlczsKLSAgc3RhcnQgPSAw
OwotICBkbwotICAgIHsKLSAgICAgIC8qIENoZWNrIHRoZSBsYXN0IGNoYXJhY3RlciAoPT0gJ1ww
JykuICAqLwotICAgICAgZG8KLQl7Ci0JICBzdGFydCArPSBibV9za2lwWyoocCArIHN0YXJ0KV07
Ci0JfQotICAgICAgd2hpbGUgKHN0YXJ0IDw9IHN0YXJ0X21heCk7Ci0KLSAgICAgIGlmIChzdGFy
dCA8IGluZmluaXR5KQotCS8qIENvdWxkbid0IGZpbmQgdGhlIGxhc3QgY2hhcmFjdGVyLiAgKi8K
LQlyZXR1cm4gTlVMTDsKLQotICAgICAgLyogTm8gbGVzcyB0aGFuIGBpbmZpbml0eScgbWVhbnMg
d2UgY291bGQgZmluZCB0aGUgbGFzdAotCSBjaGFyYWN0ZXIgYXQgYHBbc3RhcnQgLSBpbmZpbml0
eV0nLiAgKi8KLSAgICAgIHN0YXJ0IC09IGluZmluaXR5OwotCi0gICAgICAvKiBDaGVjayB0aGUg
cmVtYWluaW5nIGNoYXJhY3RlcnMuICAqLwotICAgICAgaWYgKG1lbWNtcCAoZGF0YSwgbm9uX2xp
c3BfYmVnICsgc3RhcnQsIG5ieXRlcykgPT0gMCkKLQkvKiBGb3VuZC4gICovCi0JcmV0dXJuIG5v
bl9saXNwX2JlZyArIHN0YXJ0OwotCi0gICAgICBzdGFydCArPSBsYXN0X2NoYXJfc2tpcDsKLSAg
ICB9Ci0gIHdoaWxlIChzdGFydCA8PSBzdGFydF9tYXgpOwotCi0gIHJldHVybiBOVUxMOwotfQot
Ci0KLS8qIFJldHVybiBhIHN0cmluZyBhbGxvY2F0ZWQgaW4gcHVyZSBzcGFjZS4gIERBVEEgaXMg
YSBidWZmZXIgaG9sZGluZwotICAgTkNIQVJTIGNoYXJhY3RlcnMsIGFuZCBOQllURVMgYnl0ZXMg
b2Ygc3RyaW5nIGRhdGEuICBNVUxUSUJZVEUKLSAgIG1lYW5zIG1ha2UgdGhlIHJlc3VsdCBzdHJp
bmcgbXVsdGlieXRlLgotCi0gICBNdXN0IGdldCBhbiBlcnJvciBpZiBwdXJlIHN0b3JhZ2UgaXMg
ZnVsbCwgc2luY2UgaWYgaXQgY2Fubm90IGhvbGQKLSAgIGEgbGFyZ2Ugc3RyaW5nIGl0IG1heSBi
ZSBhYmxlIHRvIGhvbGQgY29uc2VzIHRoYXQgcG9pbnQgdG8gdGhhdAotICAgc3RyaW5nOyB0aGVu
IHRoZSBzdHJpbmcgaXMgbm90IHByb3RlY3RlZCBmcm9tIGdjLiAgKi8KLQotTGlzcF9PYmplY3QK
LW1ha2VfcHVyZV9zdHJpbmcgKGNvbnN0IGNoYXIgKmRhdGEsCi0JCSAgcHRyZGlmZl90IG5jaGFy
cywgcHRyZGlmZl90IG5ieXRlcywgYm9vbCBtdWx0aWJ5dGUpCi17Ci0gIExpc3BfT2JqZWN0IHN0
cmluZzsKLSAgc3RydWN0IExpc3BfU3RyaW5nICpzID0gcHVyZV9hbGxvYyAoc2l6ZW9mICpzLCBM
aXNwX1N0cmluZyk7Ci0gIHMtPnUucy5kYXRhID0gKHVuc2lnbmVkIGNoYXIgKikgZmluZF9zdHJp
bmdfZGF0YV9pbl9wdXJlIChkYXRhLCBuYnl0ZXMpOwotICBpZiAocy0+dS5zLmRhdGEgPT0gTlVM
TCkKLSAgICB7Ci0gICAgICBzLT51LnMuZGF0YSA9IHB1cmVfYWxsb2MgKG5ieXRlcyArIDEsIC0x
KTsKLSAgICAgIG1lbWNweSAocy0+dS5zLmRhdGEsIGRhdGEsIG5ieXRlcyk7Ci0gICAgICBzLT51
LnMuZGF0YVtuYnl0ZXNdID0gJ1wwJzsKLSAgICB9Ci0gIHMtPnUucy5zaXplID0gbmNoYXJzOwot
ICBzLT51LnMuc2l6ZV9ieXRlID0gbXVsdGlieXRlID8gbmJ5dGVzIDogLTE7Ci0gIHMtPnUucy5p
bnRlcnZhbHMgPSBOVUxMOwotICBYU0VUU1RSSU5HIChzdHJpbmcsIHMpOwotICByZXR1cm4gc3Ry
aW5nOwotfQotCi0vKiBSZXR1cm4gYSBzdHJpbmcgYWxsb2NhdGVkIGluIHB1cmUgc3BhY2UuICBE
byBub3QKLSAgIGFsbG9jYXRlIHRoZSBzdHJpbmcgZGF0YSwganVzdCBwb2ludCB0byBEQVRBLiAg
Ki8KLQotTGlzcF9PYmplY3QKLW1ha2VfcHVyZV9jX3N0cmluZyAoY29uc3QgY2hhciAqZGF0YSwg
cHRyZGlmZl90IG5jaGFycykKLXsKLSAgTGlzcF9PYmplY3Qgc3RyaW5nOwotICBzdHJ1Y3QgTGlz
cF9TdHJpbmcgKnMgPSBwdXJlX2FsbG9jIChzaXplb2YgKnMsIExpc3BfU3RyaW5nKTsKLSAgcy0+
dS5zLnNpemUgPSBuY2hhcnM7Ci0gIHMtPnUucy5zaXplX2J5dGUgPSAtMjsKLSAgcy0+dS5zLmRh
dGEgPSAodW5zaWduZWQgY2hhciAqKSBkYXRhOwotICBzLT51LnMuaW50ZXJ2YWxzID0gTlVMTDsK
LSAgWFNFVFNUUklORyAoc3RyaW5nLCBzKTsKLSAgcmV0dXJuIHN0cmluZzsKLX0KLQotc3RhdGlj
IExpc3BfT2JqZWN0IHB1cmVjb3B5IChMaXNwX09iamVjdCBvYmopOwotCi0vKiBSZXR1cm4gYSBj
b25zIGFsbG9jYXRlZCBmcm9tIHB1cmUgc3BhY2UuICBHaXZlIGl0IHB1cmUgY29waWVzCi0gICBv
ZiBDQVIgYXMgY2FyIGFuZCBDRFIgYXMgY2RyLiAgKi8KLQotTGlzcF9PYmplY3QKLXB1cmVfY29u
cyAoTGlzcF9PYmplY3QgY2FyLCBMaXNwX09iamVjdCBjZHIpCi17Ci0gIExpc3BfT2JqZWN0IG5l
dzsKLSAgc3RydWN0IExpc3BfQ29ucyAqcCA9IHB1cmVfYWxsb2MgKHNpemVvZiAqcCwgTGlzcF9D
b25zKTsKLSAgWFNFVENPTlMgKG5ldywgcCk7Ci0gIFhTRVRDQVIgKG5ldywgcHVyZWNvcHkgKGNh
cikpOwotICBYU0VUQ0RSIChuZXcsIHB1cmVjb3B5IChjZHIpKTsKLSAgcmV0dXJuIG5ldzsKLX0K
LQotCi0vKiBWYWx1ZSBpcyBhIGZsb2F0IG9iamVjdCB3aXRoIHZhbHVlIE5VTSBhbGxvY2F0ZWQg
ZnJvbSBwdXJlIHNwYWNlLiAgKi8KLQotc3RhdGljIExpc3BfT2JqZWN0Ci1tYWtlX3B1cmVfZmxv
YXQgKGRvdWJsZSBudW0pCi17Ci0gIExpc3BfT2JqZWN0IG5ldzsKLSAgc3RydWN0IExpc3BfRmxv
YXQgKnAgPSBwdXJlX2FsbG9jIChzaXplb2YgKnAsIExpc3BfRmxvYXQpOwotICBYU0VURkxPQVQg
KG5ldywgcCk7Ci0gIFhGTE9BVF9JTklUIChuZXcsIG51bSk7Ci0gIHJldHVybiBuZXc7Ci19Ci0K
LS8qIFZhbHVlIGlzIGEgYmlnbnVtIG9iamVjdCB3aXRoIHZhbHVlIFZBTFVFIGFsbG9jYXRlZCBm
cm9tIHB1cmUKLSAgIHNwYWNlLiAgKi8KLQogc3RhdGljIExpc3BfT2JqZWN0Ci1tYWtlX3B1cmVf
YmlnbnVtIChMaXNwX09iamVjdCB2YWx1ZSkKLXsKLSAgbXB6X3QgY29uc3QgKm4gPSB4YmlnbnVt
X3ZhbCAodmFsdWUpOwotICBzaXplX3QgaSwgbmxpbWJzID0gbXB6X3NpemUgKCpuKTsKLSAgc2l6
ZV90IG5ieXRlcyA9IG5saW1icyAqIHNpemVvZiAobXBfbGltYl90KTsKLSAgbXBfbGltYl90ICpw
dXJlX2xpbWJzOwotICBtcF9zaXplX3QgbmV3X3NpemU7Ci0KLSAgc3RydWN0IExpc3BfQmlnbnVt
ICpiID0gcHVyZV9hbGxvYyAoc2l6ZW9mICpiLCBMaXNwX1ZlY3Rvcmxpa2UpOwotICBYU0VUUFZF
Q1RZUEVTSVpFIChiLCBQVkVDX0JJR05VTSwgMCwgVkVDU0laRSAoc3RydWN0IExpc3BfQmlnbnVt
KSk7Ci0KLSAgaW50IGxpbWJfYWxpZ25tZW50ID0gYWxpZ25vZiAobXBfbGltYl90KTsKLSAgcHVy
ZV9saW1icyA9IHB1cmVfYWxsb2MgKG5ieXRlcywgLSBsaW1iX2FsaWdubWVudCk7Ci0gIGZvciAo
aSA9IDA7IGkgPCBubGltYnM7ICsraSkKLSAgICBwdXJlX2xpbWJzW2ldID0gbXB6X2dldGxpbWJu
ICgqbiwgaSk7Ci0KLSAgbmV3X3NpemUgPSBubGltYnM7Ci0gIGlmIChtcHpfc2duICgqbikgPCAw
KQotICAgIG5ld19zaXplID0gLW5ld19zaXplOwotCi0gIG1wel9yb2luaXRfbiAoYi0+dmFsdWUs
IHB1cmVfbGltYnMsIG5ld19zaXplKTsKLQotICByZXR1cm4gbWFrZV9saXNwX3B0ciAoYiwgTGlz
cF9WZWN0b3JsaWtlKTsKLX0KLQotLyogUmV0dXJuIGEgdmVjdG9yIHdpdGggcm9vbSBmb3IgTEVO
IExpc3BfT2JqZWN0cyBhbGxvY2F0ZWQgZnJvbQotICAgcHVyZSBzcGFjZS4gICovCi0KLXN0YXRp
YyBMaXNwX09iamVjdAotbWFrZV9wdXJlX3ZlY3RvciAocHRyZGlmZl90IGxlbikKLXsKLSAgTGlz
cF9PYmplY3QgbmV3OwotICBzaXplX3Qgc2l6ZSA9IGhlYWRlcl9zaXplICsgbGVuICogd29yZF9z
aXplOwotICBzdHJ1Y3QgTGlzcF9WZWN0b3IgKnAgPSBwdXJlX2FsbG9jIChzaXplLCBMaXNwX1Zl
Y3Rvcmxpa2UpOwotICBYU0VUVkVDVE9SIChuZXcsIHApOwotICBYVkVDVE9SIChuZXcpLT5oZWFk
ZXIuc2l6ZSA9IGxlbjsKLSAgcmV0dXJuIG5ldzsKLX0KLQotLyogQ29weSBhbGwgY29udGVudHMg
YW5kIHBhcmFtZXRlcnMgb2YgVEFCTEUgdG8gYSBuZXcgdGFibGUgYWxsb2NhdGVkCi0gICBmcm9t
IHB1cmUgc3BhY2UsIHJldHVybiB0aGUgcHVyaWZpZWQgdGFibGUuICAqLwotc3RhdGljIHN0cnVj
dCBMaXNwX0hhc2hfVGFibGUgKgotcHVyZWNvcHlfaGFzaF90YWJsZSAoc3RydWN0IExpc3BfSGFz
aF9UYWJsZSAqdGFibGUpCi17Ci0gIGVhc3NlcnQgKE5JTFAgKHRhYmxlLT53ZWFrKSk7Ci0gIGVh
c3NlcnQgKHRhYmxlLT5wdXJlY29weSk7Ci0KLSAgc3RydWN0IExpc3BfSGFzaF9UYWJsZSAqcHVy
ZSA9IHB1cmVfYWxsb2MgKHNpemVvZiAqcHVyZSwgTGlzcF9WZWN0b3JsaWtlKTsKLSAgc3RydWN0
IGhhc2hfdGFibGVfdGVzdCBwdXJlX3Rlc3QgPSB0YWJsZS0+dGVzdDsKLQotICAvKiBQdXJlY29w
eSB0aGUgaGFzaCB0YWJsZSB0ZXN0LiAgKi8KLSAgcHVyZV90ZXN0Lm5hbWUgPSBwdXJlY29weSAo
dGFibGUtPnRlc3QubmFtZSk7Ci0gIHB1cmVfdGVzdC51c2VyX2hhc2hfZnVuY3Rpb24gPSBwdXJl
Y29weSAodGFibGUtPnRlc3QudXNlcl9oYXNoX2Z1bmN0aW9uKTsKLSAgcHVyZV90ZXN0LnVzZXJf
Y21wX2Z1bmN0aW9uID0gcHVyZWNvcHkgKHRhYmxlLT50ZXN0LnVzZXJfY21wX2Z1bmN0aW9uKTsK
LQotICBwdXJlLT5oZWFkZXIgPSB0YWJsZS0+aGVhZGVyOwotICBwdXJlLT53ZWFrID0gcHVyZWNv
cHkgKFFuaWwpOwotICBwdXJlLT5oYXNoID0gcHVyZWNvcHkgKHRhYmxlLT5oYXNoKTsKLSAgcHVy
ZS0+bmV4dCA9IHB1cmVjb3B5ICh0YWJsZS0+bmV4dCk7Ci0gIHB1cmUtPmluZGV4ID0gcHVyZWNv
cHkgKHRhYmxlLT5pbmRleCk7Ci0gIHB1cmUtPmNvdW50ID0gdGFibGUtPmNvdW50OwotICBwdXJl
LT5uZXh0X2ZyZWUgPSB0YWJsZS0+bmV4dF9mcmVlOwotICBwdXJlLT5wdXJlY29weSA9IHRhYmxl
LT5wdXJlY29weTsKLSAgZWFzc2VydCAoIXB1cmUtPm11dGFibGUpOwotICBwdXJlLT5yZWhhc2hf
dGhyZXNob2xkID0gdGFibGUtPnJlaGFzaF90aHJlc2hvbGQ7Ci0gIHB1cmUtPnJlaGFzaF9zaXpl
ID0gdGFibGUtPnJlaGFzaF9zaXplOwotICBwdXJlLT5rZXlfYW5kX3ZhbHVlID0gcHVyZWNvcHkg
KHRhYmxlLT5rZXlfYW5kX3ZhbHVlKTsKLSAgcHVyZS0+dGVzdCA9IHB1cmVfdGVzdDsKLQotICBy
ZXR1cm4gcHVyZTsKLX0KK3B1cmVjb3B5IChMaXNwX09iamVjdCBvYmopOwogCiBERUZVTiAoInB1
cmVjb3B5IiwgRnB1cmVjb3B5LCBTcHVyZWNvcHksIDEsIDEsIDAsCiAgICAgICAgZG9jOiAvKiBN
YWtlIGEgY29weSBvZiBvYmplY3QgT0JKIGluIHB1cmUgc3RvcmFnZS4KQEAgLTU1MTQsMTAwICs1
MTc3LDIzIEBAIERFRlVOICgicHVyZWNvcHkiLCBGcHVyZWNvcHksIFNwdXJlY29weSwgMSwgMSwg
MCwKICAgICByZXR1cm4gcHVyZWNvcHkgKG9iaik7CiB9CiAKLS8qIFBpbm5lZCBvYmplY3RzIGFy
ZSBtYXJrZWQgYmVmb3JlIGV2ZXJ5IEdDIGN5Y2xlLiAgKi8KLXN0YXRpYyBzdHJ1Y3QgcGlubmVk
X29iamVjdAotewotICBMaXNwX09iamVjdCBvYmplY3Q7Ci0gIHN0cnVjdCBwaW5uZWRfb2JqZWN0
ICpuZXh0OwotfSAqcGlubmVkX29iamVjdHM7Ci0KIHN0YXRpYyBMaXNwX09iamVjdAogcHVyZWNv
cHkgKExpc3BfT2JqZWN0IG9iaikKIHsKLSAgaWYgKEZJWE5VTVAgKG9iaikKLSAgICAgIHx8ICgh
IFNZTUJPTFAgKG9iaikgJiYgUFVSRV9QIChYUE5UUiAob2JqKSkpCi0gICAgICB8fCBTVUJSUCAo
b2JqKSkKKyAgaWYgKEZJWE5VTVAgKG9iaikgfHwgU1VCUlAgKG9iaikpCiAgICAgcmV0dXJuIG9i
ajsgICAgLyogQWxyZWFkeSBwdXJlLiAgKi8KIAotICBpZiAoU1RSSU5HUCAob2JqKSAmJiBYU1RS
SU5HIChvYmopLT51LnMuaW50ZXJ2YWxzKQotICAgIG1lc3NhZ2Vfd2l0aF9zdHJpbmcgKCJEcm9w
cGluZyB0ZXh0LXByb3BlcnRpZXMgd2hpbGUgbWFraW5nIHN0cmluZyBgJXMnIHB1cmUiLAotCQkJ
IG9iaiwgdHJ1ZSk7Ci0KICAgaWYgKEhBU0hfVEFCTEVfUCAoVnB1cmlmeV9mbGFnKSkgLyogSGFz
aCBjb25zaW5nLiAgKi8KICAgICB7CiAgICAgICBMaXNwX09iamVjdCB0bXAgPSBGZ2V0aGFzaCAo
b2JqLCBWcHVyaWZ5X2ZsYWcsIFFuaWwpOwogICAgICAgaWYgKCFOSUxQICh0bXApKQogCXJldHVy
biB0bXA7CisgICAgICBGcHV0aGFzaCAob2JqLCBvYmosIFZwdXJpZnlfZmxhZyk7CiAgICAgfQog
Ci0gIGlmIChDT05TUCAob2JqKSkKLSAgICBvYmogPSBwdXJlX2NvbnMgKFhDQVIgKG9iaiksIFhD
RFIgKG9iaikpOwotICBlbHNlIGlmIChGTE9BVFAgKG9iaikpCi0gICAgb2JqID0gbWFrZV9wdXJl
X2Zsb2F0IChYRkxPQVRfREFUQSAob2JqKSk7Ci0gIGVsc2UgaWYgKFNUUklOR1AgKG9iaikpCi0g
ICAgb2JqID0gbWFrZV9wdXJlX3N0cmluZyAoU1NEQVRBIChvYmopLCBTQ0hBUlMgKG9iaiksCi0J
CQkgICAgU0JZVEVTIChvYmopLAotCQkJICAgIFNUUklOR19NVUxUSUJZVEUgKG9iaikpOwotICBl
bHNlIGlmIChIQVNIX1RBQkxFX1AgKG9iaikpCi0gICAgewotICAgICAgc3RydWN0IExpc3BfSGFz
aF9UYWJsZSAqdGFibGUgPSBYSEFTSF9UQUJMRSAob2JqKTsKLSAgICAgIC8qIERvIG5vdCBwdXJp
ZnkgaGFzaCB0YWJsZXMgd2hpY2ggaGF2ZW4ndCBiZWVuIGRlZmluZWQgd2l0aAotICAgICAgICAg
OnB1cmVjb3B5IGFzIG5vbi1uaWwgb3IgYXJlIHdlYWsgLSB0aGV5IGFyZW4ndCBndWFyYW50ZWVk
IHRvCi0gICAgICAgICBub3QgY2hhbmdlLiAgKi8KLSAgICAgIGlmICghTklMUCAodGFibGUtPndl
YWspIHx8ICF0YWJsZS0+cHVyZWNvcHkpCi0gICAgICAgIHsKLSAgICAgICAgICAvKiBJbnN0ZWFk
LCBhZGQgdGhlIGhhc2ggdGFibGUgdG8gdGhlIGxpc3Qgb2YgcGlubmVkIG9iamVjdHMsCi0gICAg
ICAgICAgICAgc28gdGhhdCBpdCB3aWxsIGJlIG1hcmtlZCBkdXJpbmcgR0MuICAqLwotICAgICAg
ICAgIHN0cnVjdCBwaW5uZWRfb2JqZWN0ICpvID0geG1hbGxvYyAoc2l6ZW9mICpvKTsKLSAgICAg
ICAgICBvLT5vYmplY3QgPSBvYmo7Ci0gICAgICAgICAgby0+bmV4dCA9IHBpbm5lZF9vYmplY3Rz
OwotICAgICAgICAgIHBpbm5lZF9vYmplY3RzID0gbzsKLSAgICAgICAgICByZXR1cm4gb2JqOyAv
KiBEb24ndCBoYXNoIGNvbnMgaXQuICAqLwotICAgICAgICB9Ci0KLSAgICAgIHN0cnVjdCBMaXNw
X0hhc2hfVGFibGUgKmggPSBwdXJlY29weV9oYXNoX3RhYmxlICh0YWJsZSk7Ci0gICAgICBYU0VU
X0hBU0hfVEFCTEUgKG9iaiwgaCk7Ci0gICAgfQotICBlbHNlIGlmIChDT01QSUxFRFAgKG9iaikg
fHwgVkVDVE9SUCAob2JqKSB8fCBSRUNPUkRQIChvYmopKQotICAgIHsKLSAgICAgIHN0cnVjdCBM
aXNwX1ZlY3RvciAqb2JqcCA9IFhWRUNUT1IgKG9iaik7Ci0gICAgICBwdHJkaWZmX3QgbmJ5dGVz
ID0gdmVjdG9yX25ieXRlcyAob2JqcCk7Ci0gICAgICBzdHJ1Y3QgTGlzcF9WZWN0b3IgKnZlYyA9
IHB1cmVfYWxsb2MgKG5ieXRlcywgTGlzcF9WZWN0b3JsaWtlKTsKLSAgICAgIHJlZ2lzdGVyIHB0
cmRpZmZfdCBpOwotICAgICAgcHRyZGlmZl90IHNpemUgPSBBU0laRSAob2JqKTsKLSAgICAgIGlm
IChzaXplICYgUFNFVURPVkVDVE9SX0ZMQUcpCi0Jc2l6ZSAmPSBQU0VVRE9WRUNUT1JfU0laRV9N
QVNLOwotICAgICAgbWVtY3B5ICh2ZWMsIG9ianAsIG5ieXRlcyk7Ci0gICAgICBmb3IgKGkgPSAw
OyBpIDwgc2l6ZTsgaSsrKQotCXZlYy0+Y29udGVudHNbaV0gPSBwdXJlY29weSAodmVjLT5jb250
ZW50c1tpXSk7Ci0gICAgICBYU0VUVkVDVE9SIChvYmosIHZlYyk7Ci0gICAgfQotICBlbHNlIGlm
IChTWU1CT0xQIChvYmopKQotICAgIHsKLSAgICAgIGlmICghWFNZTUJPTCAob2JqKS0+dS5zLnBp
bm5lZCAmJiAhY19zeW1ib2xfcCAoWFNZTUJPTCAob2JqKSkpCi0JeyAvKiBXZSBjYW4ndCBwdXJp
ZnkgdGhlbSwgYnV0IHRoZXkgYXBwZWFyIGluIG1hbnkgcHVyZSBvYmplY3RzLgotCSAgICAgTWFy
ayB0aGVtIGFzIGBwaW5uZWQnIHNvIHdlIGtub3cgdG8gbWFyayB0aGVtIGF0IGV2ZXJ5IEdDIGN5
Y2xlLiAgKi8KLQkgIFhTWU1CT0wgKG9iaiktPnUucy5waW5uZWQgPSB0cnVlOwotCSAgc3ltYm9s
X2Jsb2NrX3Bpbm5lZCA9IHN5bWJvbF9ibG9jazsKLQl9Ci0gICAgICAvKiBEb24ndCBoYXNoLWNv
bnMgaXQuICAqLwotICAgICAgcmV0dXJuIG9iajsKLSAgICB9Ci0gIGVsc2UgaWYgKEJJR05VTVAg
KG9iaikpCi0gICAgb2JqID0gbWFrZV9wdXJlX2JpZ251bSAob2JqKTsKLSAgZWxzZQotICAgIHsK
LSAgICAgIEFVVE9fU1RSSU5HIChmbXQsICJEb24ndCBrbm93IGhvdyB0byBwdXJpZnk6ICVTIik7
Ci0gICAgICBGc2lnbmFsIChRZXJyb3IsIGxpc3QxIChDQUxMTiAoRmZvcm1hdCwgZm10LCBvYmop
KSk7Ci0gICAgfQotCi0gIGlmIChIQVNIX1RBQkxFX1AgKFZwdXJpZnlfZmxhZykpIC8qIEhhc2gg
Y29uc2luZy4gICovCi0gICAgRnB1dGhhc2ggKG9iaiwgb2JqLCBWcHVyaWZ5X2ZsYWcpOwotCiAg
IHJldHVybiBvYmo7CiB9CiAKLQogDAogLyoqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioq
KioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqKioqCiAJCQkgIFByb3RlY3Rpb24g
ZnJvbSBHQwpAQCAtNTc5OCwzMSArNTM4NCw2IEBAIGNvbXBhY3RfdW5kb19saXN0IChMaXNwX09i
amVjdCBsaXN0KQogICByZXR1cm4gbGlzdDsKIH0KIAotc3RhdGljIHZvaWQKLW1hcmtfcGlubmVk
X29iamVjdHMgKHZvaWQpCi17Ci0gIGZvciAoc3RydWN0IHBpbm5lZF9vYmplY3QgKnBvYmogPSBw
aW5uZWRfb2JqZWN0czsgcG9iajsgcG9iaiA9IHBvYmotPm5leHQpCi0gICAgbWFya19vYmplY3Qg
KHBvYmotPm9iamVjdCk7Ci19Ci0KLXN0YXRpYyB2b2lkCi1tYXJrX3Bpbm5lZF9zeW1ib2xzICh2
b2lkKQotewotICBzdHJ1Y3Qgc3ltYm9sX2Jsb2NrICpzYmxrOwotICBpbnQgbGltID0gKHN5bWJv
bF9ibG9ja19waW5uZWQgPT0gc3ltYm9sX2Jsb2NrCi0JICAgICA/IHN5bWJvbF9ibG9ja19pbmRl
eCA6IFNZTUJPTF9CTE9DS19TSVpFKTsKLQotICBmb3IgKHNibGsgPSBzeW1ib2xfYmxvY2tfcGlu
bmVkOyBzYmxrOyBzYmxrID0gc2Jsay0+bmV4dCkKLSAgICB7Ci0gICAgICBzdHJ1Y3QgTGlzcF9T
eW1ib2wgKnN5bSA9IHNibGstPnN5bWJvbHMsICplbmQgPSBzeW0gKyBsaW07Ci0gICAgICBmb3Ig
KDsgc3ltIDwgZW5kOyArK3N5bSkKLQlpZiAoc3ltLT51LnMucGlubmVkKQotCSAgbWFya19vYmpl
Y3QgKG1ha2VfbGlzcF9zeW1ib2wgKHN5bSkpOwotCi0gICAgICBsaW0gPSBTWU1CT0xfQkxPQ0tf
U0laRTsKLSAgICB9Ci19Ci0KIHN0YXRpYyB2b2lkCiB2aXNpdF92ZWN0b3JsaWtlX3Jvb3QgKHN0
cnVjdCBnY19yb290X3Zpc2l0b3IgdmlzaXRvciwKICAgICAgICAgICAgICAgICAgICAgICAgc3Ry
dWN0IExpc3BfVmVjdG9yICpwdHIsCkBAIC02MDgzLDggKzU2NDQsNiBAQCBnYXJiYWdlX2NvbGxl
Y3QgKHZvaWQpCiAgIHN0cnVjdCBnY19yb290X3Zpc2l0b3IgdmlzaXRvciA9IHsgLnZpc2l0ID0g
bWFya19vYmplY3Rfcm9vdF92aXNpdG9yIH07CiAgIHZpc2l0X3N0YXRpY19nY19yb290cyAodmlz
aXRvcik7CiAKLSAgbWFya19waW5uZWRfb2JqZWN0cyAoKTsKLSAgbWFya19waW5uZWRfc3ltYm9s
cyAoKTsKICAgbWFya190ZXJtaW5hbHMgKCk7CiAgIG1hcmtfa2JvYXJkcyAoKTsKICAgbWFya190
aHJlYWRzICgpOwpAQCAtNjE5MywxMCArNTc1Miw2IEBAIERFRlVOICgiZ2FyYmFnZS1jb2xsZWN0
IiwgRmdhcmJhZ2VfY29sbGVjdCwgU2dhcmJhZ2VfY29sbGVjdCwgMCwgMCwgIiIsCiAgIGtlZXBz
IGFyb3VuZCBmb3IgZnV0dXJlIGFsbG9jYXRpb25zIChtYXliZSBiZWNhdXNlIGl0IGRvZXMgbm90
IGtub3cgaG93CiAgIHRvIHJldHVybiB0aGVtIHRvIHRoZSBPUykuCiAKLUhvd2V2ZXIsIGlmIHRo
ZXJlIHdhcyBvdmVyZmxvdyBpbiBwdXJlIHNwYWNlLCBhbmQgRW1hY3Mgd2FzIGR1bXBlZAotdXNp
bmcgdGhlICd1bmV4ZWMnIG1ldGhvZCwgYGdhcmJhZ2UtY29sbGVjdCcgcmV0dXJucyBuaWwsIGJl
Y2F1c2UKLXJlYWwgR0MgY2FuJ3QgYmUgZG9uZS4KLQogTm90ZSB0aGF0IGNhbGxpbmcgdGhpcyBm
dW5jdGlvbiBkb2VzIG5vdCBndWFyYW50ZWUgdGhhdCBhYnNvbHV0ZWx5IGFsbAogdW5yZWFjaGFi
bGUgb2JqZWN0cyB3aWxsIGJlIGdhcmJhZ2UtY29sbGVjdGVkLiAgRW1hY3MgdXNlcyBhCiBtYXJr
LWFuZC1zd2VlcCBnYXJiYWdlIGNvbGxlY3RvciwgYnV0IGlzIGNvbnNlcnZhdGl2ZSB3aGVuIGl0
IGNvbWVzIHRvCkBAIC02NTY2LDggKzYxMjEsOCBAQCBtYXJrX29iamVjdHMgKExpc3BfT2JqZWN0
ICpvYmosIHB0cmRpZmZfdCBuKQogbWFya19vYmplY3QgKExpc3BfT2JqZWN0IGFyZykKIHsKICAg
cmVnaXN0ZXIgTGlzcF9PYmplY3Qgb2JqOwotICB2b2lkICpwbzsKICNpZiBHQ19DSEVDS19NQVJL
RURfT0JKRUNUUworICB2b2lkICpwbzsKICAgc3RydWN0IG1lbV9ub2RlICptID0gTlVMTDsKICNl
bmRpZgogICBwdHJkaWZmX3QgY2RyX2NvdW50ID0gMDsKQEAgLTY1NzUsMTAgKzYxMzAsNiBAQCBt
YXJrX29iamVjdCAoTGlzcF9PYmplY3QgYXJnKQogICBvYmogPSBhcmc7CiAgbG9vcDoKIAotICBw
byA9IFhQTlRSIChvYmopOwotICBpZiAoUFVSRV9QIChwbykpCi0gICAgcmV0dXJuOwotCiAgIGxh
c3RfbWFya2VkW2xhc3RfbWFya2VkX2luZGV4KytdID0gb2JqOwogICBsYXN0X21hcmtlZF9pbmRl
eCAmPSBMQVNUX01BUktFRF9TSVpFIC0gMTsKIApAQCAtNjU4Nyw2ICs2MTM4LDggQEAgbWFya19v
YmplY3QgKExpc3BfT2JqZWN0IGFyZykKICAgICAgYnkgfjgwJS4gICovCiAjaWYgR0NfQ0hFQ0tf
TUFSS0VEX09CSkVDVFMKIAorICBwbyA9IFhQTlRSIChvYmopOworCiAgIC8qIENoZWNrIHRoYXQg
dGhlIG9iamVjdCBwb2ludGVkIHRvIGJ5IFBPIGlzIGtub3duIHRvIGJlIGEgTGlzcAogICAgICBz
dHJ1Y3R1cmUgYWxsb2NhdGVkIGZyb20gdGhlIGhlYXAuICAqLwogI2RlZmluZSBDSEVDS19BTExP
Q0FURUQoKQkJCVwKQEAgLTY3NzEsMTEgKzYzMjQsMTAgQEAgI2RlZmluZSBDSEVDS19BTExPQ0FU
RURfQU5EX0xJVkVfU1lNQk9MKCkJCSgodm9pZCkgMCkKIAkgICAgYnJlYWs7CiAJICBkZWZhdWx0
OiBlbWFjc19hYm9ydCAoKTsKIAkgIH0KLQlpZiAoIVBVUkVfUCAoWFNUUklORyAocHRyLT51LnMu
bmFtZSkpKQotICAgICAgICAgIHNldF9zdHJpbmdfbWFya2VkIChYU1RSSU5HIChwdHItPnUucy5u
YW1lKSk7CisJc2V0X3N0cmluZ19tYXJrZWQgKFhTVFJJTkcgKHB0ci0+dS5zLm5hbWUpKTsKICAg
ICAgICAgbWFya19pbnRlcnZhbF90cmVlIChzdHJpbmdfaW50ZXJ2YWxzIChwdHItPnUucy5uYW1l
KSk7CiAJLyogSW5uZXIgbG9vcCB0byBtYXJrIG5leHQgc3ltYm9sIGluIHRoaXMgYnVja2V0LCBp
ZiBhbnkuICAqLwotCXBvID0gcHRyID0gcHRyLT51LnMubmV4dDsKKwlwdHIgPSBwdHItPnUucy5u
ZXh0OwogCWlmIChwdHIpCiAJICBnb3RvIG5leHRzeW07CiAgICAgICB9CkBAIC02ODg2LDcgKzY0
MzgsNyBAQCBzdXJ2aXZlc19nY19wIChMaXNwX09iamVjdCBvYmopCiAgICAgICBlbWFjc19hYm9y
dCAoKTsKICAgICB9CiAKLSAgcmV0dXJuIHN1cnZpdmVzX3AgfHwgUFVSRV9QIChYUE5UUiAob2Jq
KSk7CisgIHJldHVybiBzdXJ2aXZlc19wOwogfQogCiAKQEAgLTc0NzQsOCArNzAyNiw2IEBAIGlu
aXRfYWxsb2Nfb25jZSAodm9pZCkKIHN0YXRpYyB2b2lkCiBpbml0X2FsbG9jX29uY2VfZm9yX3Bk
dW1wZXIgKHZvaWQpCiB7Ci0gIHB1cmViZWcgPSBQVVJFQkVHOwotICBwdXJlX3NpemUgPSBQVVJF
U0laRTsKICAgbWVtX2luaXQgKCk7CiAKICNpZmRlZiBET1VHX0xFQV9NQUxMT0MKQEAgLTc1MTks
NyArNzA2OSw3IEBAIHN5bXNfb2ZfYWxsb2MgKHZvaWQpCiAgIFZnY19jb25zX3BlcmNlbnRhZ2Ug
PSBtYWtlX2Zsb2F0ICgwLjEpOwogCiAgIERFRlZBUl9JTlQgKCJwdXJlLWJ5dGVzLXVzZWQiLCBw
dXJlX2J5dGVzX3VzZWQsCi0JICAgICAgZG9jOiAvKiBOdW1iZXIgb2YgYnl0ZXMgb2Ygc2hhcmVh
YmxlIExpc3AgZGF0YSBhbGxvY2F0ZWQgc28gZmFyLiAgKi8pOworCSAgICAgIGRvYzogLyogTm8g
bG9uZ2VyIHVzZWQuICAqLyk7CiAKICAgREVGVkFSX0lOVCAoImNvbnMtY2VsbHMtY29uc2VkIiwg
Y29uc19jZWxsc19jb25zZWQsCiAJICAgICAgZG9jOiAvKiBOdW1iZXIgb2YgY29ucyBjZWxscyB0
aGF0IGhhdmUgYmVlbiBjb25zZWQgc28gZmFyLiAgKi8pOwpAQCAtNzU0NCwxMCArNzA5NCw3IEBA
IHN5bXNfb2ZfYWxsb2MgKHZvaWQpCiAJICAgICAgZG9jOiAvKiBOdW1iZXIgb2Ygc3RyaW5ncyB0
aGF0IGhhdmUgYmVlbiBjb25zZWQgc28gZmFyLiAgKi8pOwogCiAgIERFRlZBUl9MSVNQICgicHVy
aWZ5LWZsYWciLCBWcHVyaWZ5X2ZsYWcsCi0JICAgICAgIGRvYzogLyogTm9uLW5pbCBtZWFucyBs
b2FkaW5nIExpc3AgY29kZSBpbiBvcmRlciB0byBkdW1wIGFuIGV4ZWN1dGFibGUuCi1UaGlzIG1l
YW5zIHRoYXQgY2VydGFpbiBvYmplY3RzIHNob3VsZCBiZSBhbGxvY2F0ZWQgaW4gc2hhcmVkIChw
dXJlKSBzcGFjZS4KLUl0IGNhbiBhbHNvIGJlIHNldCB0byBhIGhhc2gtdGFibGUsIGluIHdoaWNo
IGNhc2UgdGhpcyB0YWJsZSBpcyB1c2VkIHRvCi1kbyBoYXNoLWNvbnNpbmcgb2YgdGhlIG9iamVj
dHMgYWxsb2NhdGVkIHRvIHB1cmUgc3BhY2UuICAqLyk7CisJICAgICAgIGRvYzogLyogTm8gbG9u
Z2VyIHVzZWQuICAqLyk7CiAKICAgREVGVkFSX0JPT0wgKCJnYXJiYWdlLWNvbGxlY3Rpb24tbWVz
c2FnZXMiLCBnYXJiYWdlX2NvbGxlY3Rpb25fbWVzc2FnZXMsCiAJICAgICAgIGRvYzogLyogTm9u
LW5pbCBtZWFucyBkaXNwbGF5IG1lc3NhZ2VzIGF0IHN0YXJ0IGFuZCBlbmQgb2YgZ2FyYmFnZSBj
b2xsZWN0aW9uLiAgKi8pOwpAQCAtNzU2MywxMCArNzExMCwxMCBAQCBzeW1zX29mX2FsbG9jICh2
b2lkKQogICAvKiBXZSBidWlsZCB0aGlzIGluIGFkdmFuY2UgYmVjYXVzZSBpZiB3ZSB3YWl0IHVu
dGlsIHdlIG5lZWQgaXQsIHdlIG1pZ2h0CiAgICAgIG5vdCBiZSBhYmxlIHRvIGFsbG9jYXRlIHRo
ZSBtZW1vcnkgdG8gaG9sZCBpdC4gICovCiAgIFZtZW1vcnlfc2lnbmFsX2RhdGEKLSAgICA9IHB1
cmVfbGlzdCAoUWVycm9yLAotCQkgYnVpbGRfcHVyZV9jX3N0cmluZyAoIk1lbW9yeSBleGhhdXN0
ZWQtLXVzZSIKLQkJCQkgICAgICAiIE0teCBzYXZlLXNvbWUtYnVmZmVycyB0aGVuIgotCQkJCSAg
ICAgICIgZXhpdCBhbmQgcmVzdGFydCBFbWFjcyIpKTsKKyAgICA9IGxpc3QgKFFlcnJvciwKKwkg
ICAgYnVpbGRfc3RyaW5nICgiTWVtb3J5IGV4aGF1c3RlZC0tdXNlIgorCQkJICAiIE0teCBzYXZl
LXNvbWUtYnVmZmVycyB0aGVuIgorCQkJICAiIGV4aXQgYW5kIHJlc3RhcnQgRW1hY3MiKSk7CiAK
ICAgREVGVkFSX0xJU1AgKCJtZW1vcnktZnVsbCIsIFZtZW1vcnlfZnVsbCwKIAkgICAgICAgZG9j
OiAvKiBOb24tbmlsIG1lYW5zIEVtYWNzIGNhbm5vdCBnZXQgbXVjaCBtb3JlIExpc3AgbWVtb3J5
LiAgKi8pOwpkaWZmIC0tZ2l0IGEvc3JjL2J1ZmZlci5jIGIvc3JjL2J1ZmZlci5jCmluZGV4IDVi
ZDliMzc3MDJmM2YuLjY5Y2IxYThlOTA0YTQgMTAwNjQ0Ci0tLSBhL3NyYy9idWZmZXIuYworKysg
Yi9zcmMvYnVmZmVyLmMKQEAgLTUyNjYsOCArNTI2Niw4IEBAIGluaXRfYnVmZmVyX29uY2UgKHZv
aWQpCiAgIHNldF9idWZmZXJfaW50ZXJ2YWxzICgmYnVmZmVyX2RlZmF1bHRzLCBOVUxMKTsKICAg
c2V0X2J1ZmZlcl9pbnRlcnZhbHMgKCZidWZmZXJfbG9jYWxfc3ltYm9scywgTlVMTCk7CiAgIC8q
IFRoaXMgaXMgbm90IHN0cmljdGx5IG5lY2Vzc2FyeSwgYnV0IGxldCdzIG1ha2UgdGhlbSBpbml0
aWFsaXplZC4gICovCi0gIGJzZXRfbmFtZSAoJmJ1ZmZlcl9kZWZhdWx0cywgYnVpbGRfcHVyZV9j
X3N0cmluZyAoIiAqYnVmZmVyLWRlZmF1bHRzKiIpKTsKLSAgYnNldF9uYW1lICgmYnVmZmVyX2xv
Y2FsX3N5bWJvbHMsIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIgKmJ1ZmZlci1sb2NhbC1zeW1ib2xz
KiIpKTsKKyAgYnNldF9uYW1lICgmYnVmZmVyX2RlZmF1bHRzLCBidWlsZF9zdHJpbmcgKCIgKmJ1
ZmZlci1kZWZhdWx0cyoiKSk7CisgIGJzZXRfbmFtZSAoJmJ1ZmZlcl9sb2NhbF9zeW1ib2xzLCBi
dWlsZF9zdHJpbmcgKCIgKmJ1ZmZlci1sb2NhbC1zeW1ib2xzKiIpKTsKICAgQlVGRkVSX1BWRUNf
SU5JVCAoJmJ1ZmZlcl9kZWZhdWx0cyk7CiAgIEJVRkZFUl9QVkVDX0lOSVQgKCZidWZmZXJfbG9j
YWxfc3ltYm9scyk7CiAKQEAgLTUyNzUsNyArNTI3NSw3IEBAIGluaXRfYnVmZmVyX29uY2UgKHZv
aWQpCiAgIC8qIE11c3QgZG8gdGhlc2UgYmVmb3JlIG1ha2luZyB0aGUgZmlyc3QgYnVmZmVyISAq
LwogCiAgIC8qIHJlYWwgc2V0dXAgaXMgZG9uZSBpbiBiaW5kaW5ncy5lbCAqLwotICBic2V0X21v
ZGVfbGluZV9mb3JtYXQgKCZidWZmZXJfZGVmYXVsdHMsIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIl
LSIpKTsKKyAgYnNldF9tb2RlX2xpbmVfZm9ybWF0ICgmYnVmZmVyX2RlZmF1bHRzLCBidWlsZF9z
dHJpbmcgKCIlLSIpKTsKICAgYnNldF9oZWFkZXJfbGluZV9mb3JtYXQgKCZidWZmZXJfZGVmYXVs
dHMsIFFuaWwpOwogICBic2V0X3RhYl9saW5lX2Zvcm1hdCAoJmJ1ZmZlcl9kZWZhdWx0cywgUW5p
bCk7CiAgIGJzZXRfYWJicmV2X21vZGUgKCZidWZmZXJfZGVmYXVsdHMsIFFuaWwpOwpAQCAtNTM0
Miw3ICs1MzQyLDcgQEAgaW5pdF9idWZmZXJfb25jZSAodm9pZCkKICAgY3VycmVudF9idWZmZXIg
PSAwOwogICBwZHVtcGVyX3JlbWVtYmVyX2x2X3B0cl9yYXcgKCZjdXJyZW50X2J1ZmZlciwgTGlz
cF9WZWN0b3JsaWtlKTsKIAotICBRU0Z1bmRhbWVudGFsID0gYnVpbGRfcHVyZV9jX3N0cmluZyAo
IkZ1bmRhbWVudGFsIik7CisgIFFTRnVuZGFtZW50YWwgPSBidWlsZF9zdHJpbmcgKCJGdW5kYW1l
bnRhbCIpOwogCiAgIERFRlNZTSAoUWZ1bmRhbWVudGFsX21vZGUsICJmdW5kYW1lbnRhbC1tb2Rl
Iik7CiAgIGJzZXRfbWFqb3JfbW9kZSAoJmJ1ZmZlcl9kZWZhdWx0cywgUWZ1bmRhbWVudGFsX21v
ZGUpOwpAQCAtNTM1NiwxMCArNTM1NiwxMCBAQCBpbml0X2J1ZmZlcl9vbmNlICh2b2lkKQogCiAg
IC8qIFN1cGVyLW1hZ2ljIGludmlzaWJsZSBidWZmZXIuICAqLwogICBWcHJpbjFfdG9fc3RyaW5n
X2J1ZmZlciA9Ci0gICAgRmdldF9idWZmZXJfY3JlYXRlIChidWlsZF9wdXJlX2Nfc3RyaW5nICgi
IHByaW4xIiksIFF0KTsKKyAgICBGZ2V0X2J1ZmZlcl9jcmVhdGUgKGJ1aWxkX3N0cmluZyAoIiBw
cmluMSIpLCBRdCk7CiAgIFZidWZmZXJfYWxpc3QgPSBRbmlsOwogCi0gIEZzZXRfYnVmZmVyIChG
Z2V0X2J1ZmZlcl9jcmVhdGUgKGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIqc2NyYXRjaCoiKSwgUW5p
bCkpOworICBGc2V0X2J1ZmZlciAoRmdldF9idWZmZXJfY3JlYXRlIChidWlsZF9zdHJpbmcgKCIq
c2NyYXRjaCoiKSwgUW5pbCkpOwogCiAgIGluaGliaXRfbW9kaWZpY2F0aW9uX2hvb2tzID0gMDsK
IH0KQEAgLTU1MzQsOSArNTUzNCw5IEBAIHN5bXNfb2ZfYnVmZmVyICh2b2lkKQogCSAgICAgICBR
b3ZlcndyaXRlX21vZGVfYmluYXJ5KSk7CiAKICAgRnB1dCAoUXByb3RlY3RlZF9maWVsZCwgUWVy
cm9yX2NvbmRpdGlvbnMsCi0JcHVyZV9saXN0IChRcHJvdGVjdGVkX2ZpZWxkLCBRZXJyb3IpKTsK
KwlsaXN0IChRcHJvdGVjdGVkX2ZpZWxkLCBRZXJyb3IpKTsKICAgRnB1dCAoUXByb3RlY3RlZF9m
aWVsZCwgUWVycm9yX21lc3NhZ2UsCi0JYnVpbGRfcHVyZV9jX3N0cmluZyAoIkF0dGVtcHQgdG8g
bW9kaWZ5IGEgcHJvdGVjdGVkIGZpZWxkIikpOworCWJ1aWxkX3N0cmluZyAoIkF0dGVtcHQgdG8g
bW9kaWZ5IGEgcHJvdGVjdGVkIGZpZWxkIikpOwogCiAgIERFRlZBUl9QRVJfQlVGRkVSICgidGFi
LWxpbmUtZm9ybWF0IiwKIAkJICAgICAmQlZBUiAoY3VycmVudF9idWZmZXIsIHRhYl9saW5lX2Zv
cm1hdCksCmRpZmYgLS1naXQgYS9zcmMvY2FsbGludC5jIGIvc3JjL2NhbGxpbnQuYwppbmRleCAx
ODYyNDYzNzg0M2YyLi44ZjhhNzcxMzEwNTU3IDEwMDY0NAotLS0gYS9zcmMvY2FsbGludC5jCisr
KyBiL3NyYy9jYWxsaW50LmMKQEAgLTgyNCwxMCArODI0LDEwIEBAIHN5bXNfb2ZfY2FsbGludCAo
dm9pZCkKICAgY2FsbGludF9tZXNzYWdlID0gUW5pbDsKICAgc3RhdGljcHJvICgmY2FsbGludF9t
ZXNzYWdlKTsKIAotICBwcmVzZXJ2ZWRfZm5zID0gcHVyZV9saXN0IChpbnRlcm5fY19zdHJpbmcg
KCJyZWdpb24tYmVnaW5uaW5nIiksCi0JCQkgICAgIGludGVybl9jX3N0cmluZyAoInJlZ2lvbi1l
bmQiKSwKLQkJCSAgICAgaW50ZXJuX2Nfc3RyaW5nICgicG9pbnQiKSwKLQkJCSAgICAgaW50ZXJu
X2Nfc3RyaW5nICgibWFyayIpKTsKKyAgcHJlc2VydmVkX2ZucyA9IGxpc3QgKGludGVybl9jX3N0
cmluZyAoInJlZ2lvbi1iZWdpbm5pbmciKSwKKwkJCWludGVybl9jX3N0cmluZyAoInJlZ2lvbi1l
bmQiKSwKKwkJCWludGVybl9jX3N0cmluZyAoInBvaW50IiksCisJCQlpbnRlcm5fY19zdHJpbmcg
KCJtYXJrIikpOwogICBzdGF0aWNwcm8gKCZwcmVzZXJ2ZWRfZm5zKTsKIAogICBERUZTWU0gKFFs
aXN0LCAibGlzdCIpOwpkaWZmIC0tZ2l0IGEvc3JjL2NhdGVnb3J5LmMgYi9zcmMvY2F0ZWdvcnku
YwppbmRleCBlYzhmNjFmN2YwMDJmLi45MDdkYjE0NTU3NzhiIDEwMDY0NAotLS0gYS9zcmMvY2F0
ZWdvcnkuYworKysgYi9zcmMvY2F0ZWdvcnkuYwpAQCAtNTMsNyArNTMsNyBAQCBoYXNoX2dldF9j
YXRlZ29yeV9zZXQgKExpc3BfT2JqZWN0IHRhYmxlLCBMaXNwX09iamVjdCBjYXRlZ29yeV9zZXQp
CiAgICAgICAodGFibGUsIDEsCiAgICAgICAgbWFrZV9oYXNoX3RhYmxlIChoYXNodGVzdF9lcXVh
bCwgREVGQVVMVF9IQVNIX1NJWkUsCiAJCQlERUZBVUxUX1JFSEFTSF9TSVpFLCBERUZBVUxUX1JF
SEFTSF9USFJFU0hPTEQsCi0JCQlRbmlsLCBmYWxzZSkpOworCQkJUW5pbCkpOwogICBzdHJ1Y3Qg
TGlzcF9IYXNoX1RhYmxlICpoID0gWEhBU0hfVEFCTEUgKFhDSEFSX1RBQkxFICh0YWJsZSktPmV4
dHJhc1sxXSk7CiAgIExpc3BfT2JqZWN0IGhhc2g7CiAgIHB0cmRpZmZfdCBpID0gaGFzaF9sb29r
dXAgKGgsIGNhdGVnb3J5X3NldCwgJmhhc2gpOwpAQCAtMTIwLDggKzEyMCw2IEBAIERFRlVOICgi
ZGVmaW5lLWNhdGVnb3J5IiwgRmRlZmluZV9jYXRlZ29yeSwgU2RlZmluZV9jYXRlZ29yeSwgMiwg
MywgMCwKIAogICBpZiAoIU5JTFAgKENBVEVHT1JZX0RPQ1NUUklORyAodGFibGUsIFhGSVhOQVQg
KGNhdGVnb3J5KSkpKQogICAgIGVycm9yICgiQ2F0ZWdvcnkgYCVjJyBpcyBhbHJlYWR5IGRlZmlu
ZWQiLCAoaW50KSBYRklYTkFUIChjYXRlZ29yeSkpOwotICBpZiAoIU5JTFAgKFZwdXJpZnlfZmxh
ZykpCi0gICAgZG9jc3RyaW5nID0gRnB1cmVjb3B5IChkb2NzdHJpbmcpOwogICBTRVRfQ0FURUdP
UllfRE9DU1RSSU5HICh0YWJsZSwgWEZJWE5BVCAoY2F0ZWdvcnkpLCBkb2NzdHJpbmcpOwogCiAg
IHJldHVybiBRbmlsOwpkaWZmIC0tZ2l0IGEvc3JjL2NvZGluZy5jIGIvc3JjL2NvZGluZy5jCmlu
ZGV4IDczOWRkNmFkY2I1ZmMuLmJmN2Q0OTJmNTQ2YzcgMTAwNjQ0Ci0tLSBhL3NyYy9jb2Rpbmcu
YworKysgYi9zcmMvY29kaW5nLmMKQEAgLTExNjUwLDcgKzExNjUwLDcgQEAgc3ltc19vZl9jb2Rp
bmcgKHZvaWQpCiAgIFZjb2RlX2NvbnZlcnNpb25fcmV1c2VkX3dvcmtidWYgPSBRbmlsOwogCiAg
IHN0YXRpY3BybyAoJlZjb2RlX2NvbnZlcnNpb25fd29ya2J1Zl9uYW1lKTsKLSAgVmNvZGVfY29u
dmVyc2lvbl93b3JrYnVmX25hbWUgPSBidWlsZF9wdXJlX2Nfc3RyaW5nICgiICpjb2RlLWNvbnZl
cnNpb24td29yayoiKTsKKyAgVmNvZGVfY29udmVyc2lvbl93b3JrYnVmX25hbWUgPSBidWlsZF9z
dHJpbmcgKCIgKmNvZGUtY29udmVyc2lvbi13b3JrKiIpOwogCiAgIHJldXNlZF93b3JrYnVmX2lu
X3VzZSA9IGZhbHNlOwogICBQRFVNUEVSX1JFTUVNQkVSX1NDQUxBUiAocmV1c2VkX3dvcmtidWZf
aW5fdXNlKTsKQEAgLTExNzE0LDkgKzExNzE0LDkgQEAgc3ltc19vZl9jb2RpbmcgKHZvaWQpCiAg
IC8qIEVycm9yIHNpZ25hbGVkIHdoZW4gdGhlcmUncyBhIHByb2JsZW0gd2l0aCBkZXRlY3Rpbmcg
YSBjb2Rpbmcgc3lzdGVtLiAgKi8KICAgREVGU1lNIChRY29kaW5nX3N5c3RlbV9lcnJvciwgImNv
ZGluZy1zeXN0ZW0tZXJyb3IiKTsKICAgRnB1dCAoUWNvZGluZ19zeXN0ZW1fZXJyb3IsIFFlcnJv
cl9jb25kaXRpb25zLAotCXB1cmVfbGlzdCAoUWNvZGluZ19zeXN0ZW1fZXJyb3IsIFFlcnJvcikp
OworCWxpc3QgKFFjb2Rpbmdfc3lzdGVtX2Vycm9yLCBRZXJyb3IpKTsKICAgRnB1dCAoUWNvZGlu
Z19zeXN0ZW1fZXJyb3IsIFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVfY19zdHJpbmcgKCJJ
bnZhbGlkIGNvZGluZyBzeXN0ZW0iKSk7CisJYnVpbGRfc3RyaW5nICgiSW52YWxpZCBjb2Rpbmcg
c3lzdGVtIikpOwogCiAgIERFRlNZTSAoUXRyYW5zbGF0aW9uX3RhYmxlLCAidHJhbnNsYXRpb24t
dGFibGUiKTsKICAgRnB1dCAoUXRyYW5zbGF0aW9uX3RhYmxlLCBRY2hhcl90YWJsZV9leHRyYV9z
bG90cywgbWFrZV9maXhudW0gKDIpKTsKQEAgLTExOTkxLDIyICsxMTk5MSwyMiBAQCBzeW1zX29m
X2NvZGluZyAodm9pZCkKICAgREVGVkFSX0xJU1AgKCJlb2wtbW5lbW9uaWMtdW5peCIsIGVvbF9t
bmVtb25pY191bml4LAogCSAgICAgICBkb2M6IC8qCiBTdHJpbmcgZGlzcGxheWVkIGluIG1vZGUg
bGluZSBmb3IgVU5JWC1saWtlIChMRikgZW5kLW9mLWxpbmUgZm9ybWF0LiAgKi8pOwotICBlb2xf
bW5lbW9uaWNfdW5peCA9IGJ1aWxkX3B1cmVfY19zdHJpbmcgKCI6Iik7CisgIGVvbF9tbmVtb25p
Y191bml4ID0gYnVpbGRfc3RyaW5nICgiOiIpOwogCiAgIERFRlZBUl9MSVNQICgiZW9sLW1uZW1v
bmljLWRvcyIsIGVvbF9tbmVtb25pY19kb3MsCiAJICAgICAgIGRvYzogLyoKIFN0cmluZyBkaXNw
bGF5ZWQgaW4gbW9kZSBsaW5lIGZvciBET1MtbGlrZSAoQ1JMRikgZW5kLW9mLWxpbmUgZm9ybWF0
LiAgKi8pOwotICBlb2xfbW5lbW9uaWNfZG9zID0gYnVpbGRfcHVyZV9jX3N0cmluZyAoIlxcIik7
CisgIGVvbF9tbmVtb25pY19kb3MgPSBidWlsZF9zdHJpbmcgKCJcXCIpOwogCiAgIERFRlZBUl9M
SVNQICgiZW9sLW1uZW1vbmljLW1hYyIsIGVvbF9tbmVtb25pY19tYWMsCiAJICAgICAgIGRvYzog
LyoKIFN0cmluZyBkaXNwbGF5ZWQgaW4gbW9kZSBsaW5lIGZvciBNQUMtbGlrZSAoQ1IpIGVuZC1v
Zi1saW5lIGZvcm1hdC4gICovKTsKLSAgZW9sX21uZW1vbmljX21hYyA9IGJ1aWxkX3B1cmVfY19z
dHJpbmcgKCIvIik7CisgIGVvbF9tbmVtb25pY19tYWMgPSBidWlsZF9zdHJpbmcgKCIvIik7CiAK
ICAgREVGVkFSX0xJU1AgKCJlb2wtbW5lbW9uaWMtdW5kZWNpZGVkIiwgZW9sX21uZW1vbmljX3Vu
ZGVjaWRlZCwKIAkgICAgICAgZG9jOiAvKgogU3RyaW5nIGRpc3BsYXllZCBpbiBtb2RlIGxpbmUg
d2hlbiBlbmQtb2YtbGluZSBmb3JtYXQgaXMgbm90IHlldCBkZXRlcm1pbmVkLiAgKi8pOwotICBl
b2xfbW5lbW9uaWNfdW5kZWNpZGVkID0gYnVpbGRfcHVyZV9jX3N0cmluZyAoIjoiKTsKKyAgZW9s
X21uZW1vbmljX3VuZGVjaWRlZCA9IGJ1aWxkX3N0cmluZyAoIjoiKTsKIAogICBERUZWQVJfTElT
UCAoImVuYWJsZS1jaGFyYWN0ZXItdHJhbnNsYXRpb24iLCBWZW5hYmxlX2NoYXJhY3Rlcl90cmFu
c2xhdGlvbiwKIAkgICAgICAgZG9jOiAvKgpAQCAtMTIxNDYsNyArMTIxNDYsNyBAQCBzeXN0ZW0g
KGUuZy4gYGlzby0yMDIyLTdiaXQnKS4KICAgICAgIGludGVybl9jX3N0cmluZyAoIjpmb3ItdW5p
Ynl0ZSIpLAogICAgICAgYXJnc1tjb2RpbmdfYXJnX2Zvcl91bmlieXRlXSA9IFF0LAogICAgICAg
aW50ZXJuX2Nfc3RyaW5nICgiOmRvY3N0cmluZyIpLAotICAgICAgKGJ1aWxkX3B1cmVfY19zdHJp
bmcKKyAgICAgIChidWlsZF9zdHJpbmcKICAgICAgICAoIkRvIG5vIGNvbnZlcnNpb24uXG4iCiAJ
IlxuIgogCSJXaGVuIHlvdSB2aXNpdCBhIGZpbGUgd2l0aCB0aGlzIGNvZGluZywgdGhlIGZpbGUg
aXMgcmVhZCBpbnRvIGFcbiIKQEAgLTEyMTY2LDcgKzEyMTY2LDcgQEAgc3lzdGVtIChlLmcuIGBp
c28tMjAyMi03Yml0JykuCiAgIHBsaXN0WzhdID0gaW50ZXJuX2Nfc3RyaW5nICgiOmNoYXJzZXQt
bGlzdCIpOwogICBwbGlzdFs5XSA9IGFyZ3NbY29kaW5nX2FyZ19jaGFyc2V0X2xpc3RdID0gbGlz
dDEgKFFhc2NpaSk7CiAgIHBsaXN0WzExXSA9IGFyZ3NbY29kaW5nX2FyZ19mb3JfdW5pYnl0ZV0g
PSBRbmlsOwotICBwbGlzdFsxM10gPSBidWlsZF9wdXJlX2Nfc3RyaW5nICgiTm8gY29udmVyc2lv
biBvbiBlbmNvZGluZywgIgorICBwbGlzdFsxM10gPSBidWlsZF9zdHJpbmcgKCJObyBjb252ZXJz
aW9uIG9uIGVuY29kaW5nLCAiCiAJCQkJICAgImF1dG9tYXRpYyBjb252ZXJzaW9uIG9uIGRlY29k
aW5nLiIpOwogICBwbGlzdFsxNV0gPSBhcmdzW2NvZGluZ19hcmdfZW9sX3R5cGVdID0gUW5pbDsK
ICAgYXJnc1tjb2RpbmdfYXJnX3BsaXN0XSA9IENBTExNQU5ZIChGbGlzdCwgcGxpc3QpOwpkaWZm
IC0tZ2l0IGEvc3JjL2NvbmZfcG9zdC5oIGIvc3JjL2NvbmZfcG9zdC5oCmluZGV4IDE3NmFiMjhi
MjFhYjIuLmRhNTVhMWZiNTRhYmMgMTAwNjQ0Ci0tLSBhL3NyYy9jb25mX3Bvc3QuaAorKysgYi9z
cmMvY29uZl9wb3N0LmgKQEAgLTE2Myw0MSArMTYzLDggQEAgI2RlZmluZSBlbWFjc19yYWlzZShz
aWcpIG1zZG9zX2ZhdGFsX3NpZ25hbCAoc2lnKQogCiAvKiBEQVRBX1NUQVJUIGlzIG5lZWRlZCBi
eSB2bS1saW1pdC5jIGFuZCB1bmV4Y29mZi5jLiAqLwogI2RlZmluZSBEQVRBX1NUQVJUICgmZXRl
eHQgKyAxKQotCi0vKiBEZWZpbmUgb25lIG9mIHRoZXNlIGZvciBlYXNpZXIgY29uZGl0aW9uYWxz
LiAgKi8KLSNpZmRlZiBIQVZFX1hfV0lORE9XUwotLyogV2UgbmVlZCBhIGxpdHRsZSBleHRyYSBz
cGFjZSwgc2VlIC4uLy4uL2xpc3AvbG9hZHVwLmVsIGFuZCB0aGUKLSAgIGNvbW1lbnRhcnkgYmVs
b3csIGluIHRoZSBub24tWCBicmFuY2guICBUaGUgMTQwS0IgbnVtYmVyIHdhcwotICAgbWVhc3Vy
ZWQgb24gR05VL0xpbnV4IGFuZCBvbiBNUy1XaW5kb3dzLiAgKi8KLSNkZWZpbmUgU1lTVEVNX1BV
UkVTSVpFX0VYVFJBICgtMTcwMDAwKzE0MDAwMCkKLSNlbHNlCi0vKiBXZSBuZWVkIGEgbGl0dGxl
IGV4dHJhIHNwYWNlLCBzZWUgLi4vLi4vbGlzcC9sb2FkdXAuZWwuCi0gICBBcyBvZiAyMDA5MTAy
NCwgRE9TLXNwZWNpZmljIGZpbGVzIHVzZSB1cCA2MktCIG9mIHB1cmUgc3BhY2UuICBCdXQKLSAg
IG92ZXJhbGwsIHdlIGVuZCB1cCB3YXN0aW5nIDEzMEtCIG9mIHB1cmUgc3BhY2UsIGJlY2F1c2UK
LSAgIEJBU0VfUFVSRVNJWkUgc3RhcnRzIGF0IDEuNDdNQiwgd2hpbGUgd2UgbmVlZCBvbmx5IDEu
M01CIChpbmNsdWRpbmcKLSAgIG5vbi1ET1Mgc3BlY2lmaWMgZmlsZXMgYW5kIGxvYWQgaGlzdG9y
eTsgdGhlIGxhdHRlciBpcyBhYm91dCA1NUssCi0gICBidXQgZGVwZW5kcyBvbiB0aGUgZGVwdGgg
b2YgdGhlIHRvcC1sZXZlbCBFbWFjcyBkaXJlY3RvcnkgaW4gdGhlCi0gICBkaXJlY3RvcnkgdHJl
ZSkuICBHaXZlbiB0aGUgdW5rbm93biBwb2xpY3kgb2YgZGlmZmVyZW50IERQTUkKLSAgIGhvc3Rz
IHJlZ2FyZGluZyBsb2FkaW5nIG9mIHVudG91Y2hlZCBwYWdlcywgSSdtIG5vdCBnb2luZyB0byBy
aXNrCi0gICBlbmxhcmdpbmcgRW1hY3MgZm9vdHByaW50IGJ5IGFub3RoZXIgMTAwKyBLQnl0ZXMu
ICAqLwotI2RlZmluZSBTWVNURU1fUFVSRVNJWkVfRVhUUkEgKC0xNzAwMDArOTAwMDApCi0jZW5k
aWYKICNlbmRpZiAgLyogTVNET1MgKi8KIAotLyogbWFjT1MgLyBHTlVzdGVwIG5lZWQgYSBiaXQg
bW9yZSBwdXJlIG1lbW9yeS4gIE9mIHRoZSBleGlzdGluZyBrbm9icywKLSAgIFNZU1RFTV9QVVJF
U0laRV9FWFRSQSBzZWVtcyBsaWtlIHRoZSBsZWFzdCBsaWtlbHkgdG8gY2F1c2UgcHJvYmxlbXMu
ICAqLwotI2lmZGVmIEhBVkVfTlMKLSNpZiBkZWZpbmVkIE5TX0lNUExfR05VU1RFUAotIyAgZGVm
aW5lIFNZU1RFTV9QVVJFU0laRV9FWFRSQSAzMDAwMAotI2VsaWYgZGVmaW5lZCBEQVJXSU5fT1MK
LSMgIGRlZmluZSBTWVNURU1fUFVSRVNJWkVfRVhUUkEgMjAwMDAwCi0jZW5kaWYKLSNlbmRpZgot
Ci0jaWZkZWYgQ1lHV0lOCi0jZGVmaW5lIFNZU1RFTV9QVVJFU0laRV9FWFRSQSA1MDAwMAotI2Vu
ZGlmCi0KICNpZiBkZWZpbmVkIEhBVkVfTlRHVUkgJiYgIWRlZmluZWQgRGViUHJpbnQKICMgaWZk
ZWYgRU1BQ1NERUJVRwogZXh0ZXJuIHZvaWQgX0RlYlByaW50IChjb25zdCBjaGFyICpmbXQsIC4u
Lik7CmRpZmYgLS1naXQgYS9zcmMvZGF0YS5jIGIvc3JjL2RhdGEuYwppbmRleCAwZmE0OTFiMTdh
MTE0Li4yYThjNzI0NmZhZTY1IDEwMDY0NAotLS0gYS9zcmMvZGF0YS5jCisrKyBiL3NyYy9kYXRh
LmMKQEAgLTMwLDcgKzMwLDYgQEAKIAogI2luY2x1ZGUgImxpc3AuaCIKICNpbmNsdWRlICJiaWdu
dW0uaCIKLSNpbmNsdWRlICJwdXJlc2l6ZS5oIgogI2luY2x1ZGUgImNoYXJhY3Rlci5oIgogI2lu
Y2x1ZGUgImJ1ZmZlci5oIgogI2luY2x1ZGUgImtleWJvYXJkLmgiCkBAIC0xNDksMTIgKzE0OCw2
IEBAIHdyb25nX3R5cGVfYXJndW1lbnQgKExpc3BfT2JqZWN0IHByZWRpY2F0ZSwgTGlzcF9PYmpl
Y3QgdmFsdWUpCiAgIHhzaWduYWwyIChRd3JvbmdfdHlwZV9hcmd1bWVudCwgcHJlZGljYXRlLCB2
YWx1ZSk7CiB9CiAKLXZvaWQKLXB1cmVfd3JpdGVfZXJyb3IgKExpc3BfT2JqZWN0IG9iaikKLXsK
LSAgeHNpZ25hbDIgKFFlcnJvciwgYnVpbGRfc3RyaW5nICgiQXR0ZW1wdCB0byBtb2RpZnkgcmVh
ZC1vbmx5IG9iamVjdCIpLCBvYmopOwotfQotCiB2b2lkCiBhcmdzX291dF9vZl9yYW5nZSAoTGlz
cF9PYmplY3QgYTEsIExpc3BfT2JqZWN0IGEyKQogewpAQCAtNjI1LDcgKzYxOCw2IEBAIERFRlVO
ICgic2V0Y2FyIiwgRnNldGNhciwgU3NldGNhciwgMiwgMiwgMCwKICAgKHJlZ2lzdGVyIExpc3Bf
T2JqZWN0IGNlbGwsIExpc3BfT2JqZWN0IG5ld2NhcikKIHsKICAgQ0hFQ0tfQ09OUyAoY2VsbCk7
Ci0gIENIRUNLX0lNUFVSRSAoY2VsbCwgWENPTlMgKGNlbGwpKTsKICAgWFNFVENBUiAoY2VsbCwg
bmV3Y2FyKTsKICAgcmV0dXJuIG5ld2NhcjsKIH0KQEAgLTYzNSw3ICs2MjcsNiBAQCBERUZVTiAo
InNldGNkciIsIEZzZXRjZHIsIFNzZXRjZHIsIDIsIDIsIDAsCiAgIChyZWdpc3RlciBMaXNwX09i
amVjdCBjZWxsLCBMaXNwX09iamVjdCBuZXdjZHIpCiB7CiAgIENIRUNLX0NPTlMgKGNlbGwpOwot
ICBDSEVDS19JTVBVUkUgKGNlbGwsIFhDT05TIChjZWxsKSk7CiAgIFhTRVRDRFIgKGNlbGwsIG5l
d2Nkcik7CiAgIHJldHVybiBuZXdjZHI7CiB9CkBAIC03OTgsMTAgKzc4OSw2IEBAIERFRlVOICgi
ZGVmYWxpYXMiLCBGZGVmYWxpYXMsIFNkZWZhbGlhcywgMiwgMywgMCwKICAgKHJlZ2lzdGVyIExp
c3BfT2JqZWN0IHN5bWJvbCwgTGlzcF9PYmplY3QgZGVmaW5pdGlvbiwgTGlzcF9PYmplY3QgZG9j
c3RyaW5nKQogewogICBDSEVDS19TWU1CT0wgKHN5bWJvbCk7Ci0gIGlmICghTklMUCAoVnB1cmlm
eV9mbGFnKQotICAgICAgLyogSWYgYGRlZmluaXRpb24nIGlzIGEga2V5bWFwLCBpbW11dGFibGUg
KGFuZCBjb3B5aW5nKSBpcyB3cm9uZy4gICovCi0gICAgICAmJiAhS0VZTUFQUCAoZGVmaW5pdGlv
bikpCi0gICAgZGVmaW5pdGlvbiA9IEZwdXJlY29weSAoZGVmaW5pdGlvbik7CiAKICAgewogICAg
IGJvb2wgYXV0b2xvYWQgPSBBVVRPTE9BRFAgKGRlZmluaXRpb24pOwpAQCAtMjM3NSw3ICsyMzYy
LDYgQEAgREVGVU4gKCJhc2V0IiwgRmFzZXQsIFNhc2V0LCAzLCAzLCAwLAogCiAgIGlmIChWRUNU
T1JQIChhcnJheSkpCiAgICAgewotICAgICAgQ0hFQ0tfSU1QVVJFIChhcnJheSwgWFZFQ1RPUiAo
YXJyYXkpKTsKICAgICAgIGlmIChpZHh2YWwgPCAwIHx8IGlkeHZhbCA+PSBBU0laRSAoYXJyYXkp
KQogCWFyZ3Nfb3V0X29mX3JhbmdlIChhcnJheSwgaWR4KTsKICAgICAgIEFTRVQgKGFycmF5LCBp
ZHh2YWwsIG5ld2VsdCk7CkBAIC0yMzk5LDcgKzIzODUsNiBAQCBERUZVTiAoImFzZXQiLCBGYXNl
dCwgU2FzZXQsIDMsIDMsIDAsCiAgICAgfQogICBlbHNlIC8qIFNUUklOR1AgKi8KICAgICB7Ci0g
ICAgICBDSEVDS19JTVBVUkUgKGFycmF5LCBYU1RSSU5HIChhcnJheSkpOwogICAgICAgaWYgKGlk
eHZhbCA8IDAgfHwgaWR4dmFsID49IFNDSEFSUyAoYXJyYXkpKQogCWFyZ3Nfb3V0X29mX3Jhbmdl
IChhcnJheSwgaWR4KTsKICAgICAgIENIRUNLX0NIQVJBQ1RFUiAobmV3ZWx0KTsKQEAgLTM4ODEs
NyArMzg2Niw3IEBAIHN5bXNfb2ZfZGF0YSAodm9pZCkKIAogICBERUZTWU0gKFFjZHIsICJjZHIi
KTsKIAotICBlcnJvcl90YWlsID0gcHVyZV9jb25zIChRZXJyb3IsIFFuaWwpOworICBlcnJvcl90
YWlsID0gRmNvbnMgKFFlcnJvciwgUW5pbCk7CiAKICAgLyogRVJST1IgaXMgdXNlZCBhcyBhIHNp
Z25hbGVyIGZvciByYW5kb20gZXJyb3JzIGZvciB3aGljaCBub3RoaW5nIGVsc2UgaXMKICAgICAg
cmlnaHQuICAqLwpAQCAtMzg4OSwxMSArMzg3NCwxMSBAQCBzeW1zX29mX2RhdGEgKHZvaWQpCiAg
IEZwdXQgKFFlcnJvciwgUWVycm9yX2NvbmRpdGlvbnMsCiAJZXJyb3JfdGFpbCk7CiAgIEZwdXQg
KFFlcnJvciwgUWVycm9yX21lc3NhZ2UsCi0JYnVpbGRfcHVyZV9jX3N0cmluZyAoImVycm9yIikp
OworCWJ1aWxkX3N0cmluZyAoImVycm9yIikpOwogCiAjZGVmaW5lIFBVVF9FUlJPUihzeW0sIHRh
aWwsIG1zZykJCQlcCi0gIEZwdXQgKHN5bSwgUWVycm9yX2NvbmRpdGlvbnMsIHB1cmVfY29ucyAo
c3ltLCB0YWlsKSk7IFwKLSAgRnB1dCAoc3ltLCBRZXJyb3JfbWVzc2FnZSwgYnVpbGRfcHVyZV9j
X3N0cmluZyAobXNnKSkKKyAgRnB1dCAoc3ltLCBRZXJyb3JfY29uZGl0aW9ucywgRmNvbnMgKHN5
bSwgdGFpbCkpOyBcCisgIEZwdXQgKHN5bSwgUWVycm9yX21lc3NhZ2UsIGJ1aWxkX3N0cmluZyAo
bXNnKSkKIAogICBQVVRfRVJST1IgKFFxdWl0LCBRbmlsLCAiUXVpdCIpOwogCkBAIC0zOTIxLDE0
ICszOTA2LDE0IEBAICNkZWZpbmUgUFVUX0VSUk9SKHN5bSwgdGFpbCwgbXNnKQkJCVwKICAgUFVU
X0VSUk9SIChRbm9fY2F0Y2gsIGVycm9yX3RhaWwsICJObyBjYXRjaCBmb3IgdGFnIik7CiAgIFBV
VF9FUlJPUiAoUWVuZF9vZl9maWxlLCBlcnJvcl90YWlsLCAiRW5kIG9mIGZpbGUgZHVyaW5nIHBh
cnNpbmciKTsKIAotICBhcml0aF90YWlsID0gcHVyZV9jb25zIChRYXJpdGhfZXJyb3IsIGVycm9y
X3RhaWwpOworICBhcml0aF90YWlsID0gRmNvbnMgKFFhcml0aF9lcnJvciwgZXJyb3JfdGFpbCk7
CiAgIEZwdXQgKFFhcml0aF9lcnJvciwgUWVycm9yX2NvbmRpdGlvbnMsIGFyaXRoX3RhaWwpOwot
ICBGcHV0IChRYXJpdGhfZXJyb3IsIFFlcnJvcl9tZXNzYWdlLCBidWlsZF9wdXJlX2Nfc3RyaW5n
ICgiQXJpdGhtZXRpYyBlcnJvciIpKTsKKyAgRnB1dCAoUWFyaXRoX2Vycm9yLCBRZXJyb3JfbWVz
c2FnZSwgYnVpbGRfc3RyaW5nICgiQXJpdGhtZXRpYyBlcnJvciIpKTsKIAogICBQVVRfRVJST1Ig
KFFiZWdpbm5pbmdfb2ZfYnVmZmVyLCBlcnJvcl90YWlsLCAiQmVnaW5uaW5nIG9mIGJ1ZmZlciIp
OwogICBQVVRfRVJST1IgKFFlbmRfb2ZfYnVmZmVyLCBlcnJvcl90YWlsLCAiRW5kIG9mIGJ1ZmZl
ciIpOwogICBQVVRfRVJST1IgKFFidWZmZXJfcmVhZF9vbmx5LCBlcnJvcl90YWlsLCAiQnVmZmVy
IGlzIHJlYWQtb25seSIpOwotICBQVVRfRVJST1IgKFF0ZXh0X3JlYWRfb25seSwgcHVyZV9jb25z
IChRYnVmZmVyX3JlYWRfb25seSwgZXJyb3JfdGFpbCksCisgIFBVVF9FUlJPUiAoUXRleHRfcmVh
ZF9vbmx5LCBGY29ucyAoUWJ1ZmZlcl9yZWFkX29ubHksIGVycm9yX3RhaWwpLAogCSAgICAgIlRl
eHQgaXMgcmVhZC1vbmx5Iik7CiAgIFBVVF9FUlJPUiAoUWluaGliaXRlZF9pbnRlcmFjdGlvbiwg
ZXJyb3JfdGFpbCwKIAkgICAgICJVc2VyIGludGVyYWN0aW9uIHdoaWxlIGluaGliaXRlZCIpOwpk
aWZmIC0tZ2l0IGEvc3JjL2RidXNiaW5kLmMgYi9zcmMvZGJ1c2JpbmQuYwppbmRleCBjMDA1NDc0
ZDQ0MDlmLi4yMzgxNDJiOTU2MDZjIDEwMDY0NAotLS0gYS9zcmMvZGJ1c2JpbmQuYworKysgYi9z
cmMvZGJ1c2JpbmQuYwpAQCAtMTg2OCw3ICsxODY4LDcgQEAgc3ltc19vZl9kYnVzYmluZCAodm9p
ZCkKICAgRnB1dCAoUWRidXNfZXJyb3IsIFFlcnJvcl9jb25kaXRpb25zLAogCWxpc3QyIChRZGJ1
c19lcnJvciwgUWVycm9yKSk7CiAgIEZwdXQgKFFkYnVzX2Vycm9yLCBRZXJyb3JfbWVzc2FnZSwK
LQlidWlsZF9wdXJlX2Nfc3RyaW5nICgiRC1CdXMgZXJyb3IiKSk7CisJYnVpbGRfc3RyaW5nICgi
RC1CdXMgZXJyb3IiKSk7CiAKICAgLyogTGlzcCBzeW1ib2xzIG9mIHRoZSBzeXN0ZW0gYW5kIHNl
c3Npb24gYnVzZXMuICAqLwogICBERUZTWU0gKFFDc3lzdGVtLCAiOnN5c3RlbSIpOwpAQCAtMTkx
MSw3ICsxOTExLDcgQEAgc3ltc19vZl9kYnVzYmluZCAodm9pZCkKIAkgICAgICAgVmRidXNfY29t
cGlsZWRfdmVyc2lvbiwKICAgICBkb2M6IC8qIFRoZSB2ZXJzaW9uIG9mIEQtQnVzIEVtYWNzIGlz
IGNvbXBpbGVkIGFnYWluc3QuICAqLyk7CiAjaWZkZWYgREJVU19WRVJTSU9OX1NUUklORwotICBW
ZGJ1c19jb21waWxlZF92ZXJzaW9uID0gYnVpbGRfcHVyZV9jX3N0cmluZyAoREJVU19WRVJTSU9O
X1NUUklORyk7CisgIFZkYnVzX2NvbXBpbGVkX3ZlcnNpb24gPSBidWlsZF9zdHJpbmcgKERCVVNf
VkVSU0lPTl9TVFJJTkcpOwogI2Vsc2UKICAgVmRidXNfY29tcGlsZWRfdmVyc2lvbiA9IFFuaWw7
CiAjZW5kaWYKZGlmZiAtLWdpdCBhL3NyYy9kZXBzLm1rIGIvc3JjL2RlcHMubWsKaW5kZXggZWRh
MmVkNjMzODI1Mi4uMzI5MmNmMjAxY2Y3NCAxMDA2NDQKLS0tIGEvc3JjL2RlcHMubWsKKysrIGIv
c3JjL2RlcHMubWsKQEAgLTEzMiwxMCArMTMyLDEwIEBAIGluc2RlbC5vOgoga2V5Ym9hcmQubzog
a2V5Ym9hcmQuYyB0ZXJtY2hhci5oIHRlcm1ob29rcy5oIHRlcm1vcHRzLmggYnVmZmVyLmggY2hh
cmFjdGVyLmggXAogICAgY29tbWFuZHMuaCBmcmFtZS5oIHdpbmRvdy5oIG1hY3Jvcy5oIGRpc3B0
YWIuaCBrZXlib2FyZC5oIHN5c3NpZ25hbC5oIFwKICAgIHN5c3RpbWUuaCBzeW50YXguaCAkKElO
VEVSVkFMU19IKSBibG9ja2lucHV0LmggYXRpbWVyLmggY29tcG9zaXRlLmggXAotICAgeHRlcm0u
aCBwdXJlc2l6ZS5oIG1zZG9zLmgga2V5bWFwLmggdzMydGVybS5oIG5zdGVybS5oIG5zZ3VpLmgg
Y29kaW5nLmggXAorICAgeHRlcm0uaCBtc2Rvcy5oIGtleW1hcC5oIHczMnRlcm0uaCBuc3Rlcm0u
aCBuc2d1aS5oIGNvZGluZy5oIFwKICAgIHByb2Nlc3MuaCAuLi9saWIvdW5pc3RkLmggZ251dGxz
LmggbGlzcC5oIGdsb2JhbHMuaCAkKGNvbmZpZ19oKQoga2V5bWFwLm86IGtleW1hcC5jIGJ1ZmZl
ci5oIGNvbW1hbmRzLmgga2V5Ym9hcmQuaCB0ZXJtaG9va3MuaCBibG9ja2lucHV0LmggXAotICAg
YXRpbWVyLmggc3lzdGltZS5oIHB1cmVzaXplLmggY2hhcmFjdGVyLmggY2hhcnNldC5oICQoSU5U
RVJWQUxTX0gpIFwKKyAgIGF0aW1lci5oIHN5c3RpbWUuaCBjaGFyYWN0ZXIuaCBjaGFyc2V0Lmgg
JChJTlRFUlZBTFNfSCkgXAogICAga2V5bWFwLmggd2luZG93LmggY29kaW5nLmggZnJhbWUuaCBs
aXNwLmggZ2xvYmFscy5oICQoY29uZmlnX2gpCiBsYXN0ZmlsZS5vOiBsYXN0ZmlsZS5jICQoY29u
ZmlnX2gpCiBtYWNyb3MubzogbWFjcm9zLmMgd2luZG93LmggYnVmZmVyLmggY29tbWFuZHMuaCBt
YWNyb3MuaCBrZXlib2FyZC5oIG1zZG9zLmggXApAQCAtMjY3LDEyICsyNjcsMTIgQEAgeHNldHRp
bmdzLm86CiAgICBhdGltZXIuaCB0ZXJtb3B0cy5oIGdsb2JhbHMuaAogCiAjIyBUaGUgZmlsZXMg
b2YgTGlzcCBwcm9wZXIuCi1hbGxvYy5vOiBhbGxvYy5jIHByb2Nlc3MuaCBmcmFtZS5oIHdpbmRv
dy5oIGJ1ZmZlci5oICBwdXJlc2l6ZS5oIHN5c3NpZ25hbC5oIFwKK2FsbG9jLm86IGFsbG9jLmMg
cHJvY2Vzcy5oIGZyYW1lLmggd2luZG93LmggYnVmZmVyLmggc3lzc2lnbmFsLmggXAogICAga2V5
Ym9hcmQuaCBibG9ja2lucHV0LmggYXRpbWVyLmggc3lzdGltZS5oIGNoYXJhY3Rlci5oIGxpc3Au
aCAkKGNvbmZpZ19oKSBcCiAgICAkKElOVEVSVkFMU19IKSB0ZXJtaG9va3MuaCBnbnV0bHMuaCBj
b2RpbmcuaCAuLi9saWIvdW5pc3RkLmggZ2xvYmFscy5oCiBieXRlY29kZS5vOiBieXRlY29kZS5j
IGJ1ZmZlci5oIHN5bnRheC5oIGNoYXJhY3Rlci5oIHdpbmRvdy5oIGRpc3BleHRlcm4uaCBcCiAg
IGxpc3AuaCBnbG9iYWxzLmggJChjb25maWdfaCkgbXNkb3MuaAotZGF0YS5vOiBkYXRhLmMgYnVm
ZmVyLmggcHVyZXNpemUuaCBjaGFyYWN0ZXIuaCBzeXNzaWduYWwuaCBrZXlib2FyZC5oIGZyYW1l
LmggXAorZGF0YS5vOiBkYXRhLmMgYnVmZmVyLmggY2hhcmFjdGVyLmggc3lzc2lnbmFsLmgga2V5
Ym9hcmQuaCBmcmFtZS5oIFwKICAgIHRlcm1ob29rcy5oIHN5c3RpbWUuaCBjb2RpbmcuaCBjb21w
b3NpdGUuaCBkaXNwZXh0ZXJuLmggZm9udC5oIGNjbC5oIFwKICAgIGxpc3AuaCBnbG9iYWxzLmgg
JChjb25maWdfaCkgbXNkb3MuaAogZXZhbC5vOiBldmFsLmMgY29tbWFuZHMuaCBrZXlib2FyZC5o
IGJsb2NraW5wdXQuaCBhdGltZXIuaCBzeXN0aW1lLmggZnJhbWUuaCBcCkBAIC0yOTUsNyArMjk1
LDcgQEAgbHJlYWQubzoKIGNvbXBvc2l0ZS5vOiBjb21wb3NpdGUuYyBjb21wb3NpdGUuaCBidWZm
ZXIuaCBjaGFyYWN0ZXIuaCBjb2RpbmcuaCBmb250LmggXAogICAgY2NsLmggZnJhbWUuaCB0ZXJt
aG9va3MuaCAkKElOVEVSVkFMU19IKSB3aW5kb3cuaCBcCiAgICBsaXNwLmggZ2xvYmFscy5oICQo
Y29uZmlnX2gpCi1pbnRlcnZhbHMubzogaW50ZXJ2YWxzLmMgYnVmZmVyLmggJChJTlRFUlZBTFNf
SCkga2V5Ym9hcmQuaCBwdXJlc2l6ZS5oIFwKK2ludGVydmFscy5vOiBpbnRlcnZhbHMuYyBidWZm
ZXIuaCAkKElOVEVSVkFMU19IKSBrZXlib2FyZC5oIFwKICAgIGtleW1hcC5oIGxpc3AuaCBnbG9i
YWxzLmggJChjb25maWdfaCkgc3lzdGltZS5oIGNvZGluZy5oCiB0ZXh0cHJvcC5vOiB0ZXh0cHJv
cC5jIGJ1ZmZlci5oIHdpbmRvdy5oICQoSU5URVJWQUxTX0gpIFwKICAgIGxpc3AuaCBnbG9iYWxz
LmggJChjb25maWdfaCkKZGlmZiAtLWdpdCBhL3NyYy9kb2MuYyBiL3NyYy9kb2MuYwppbmRleCAx
MzA3YWE1ZWU5MjMzLi4yMTM2ZjkxNDI5N2RkIDEwMDY0NAotLS0gYS9zcmMvZG9jLmMKKysrIGIv
c3JjL2RvYy5jCkBAIC00OTAsOCArNDkwLDYgQEAgc3RvcmVfZnVuY3Rpb25fZG9jc3RyaW5nIChM
aXNwX09iamVjdCBvYmosIEVNQUNTX0lOVCBvZmZzZXQpCiAJewogCSAgdGVtID0gRmNkciAoRmNk
ciAoZnVuKSk7CiAJICBpZiAoQ09OU1AgKHRlbSkgJiYgRklYTlVNUCAoWENBUiAodGVtKSkpCi0J
ICAgIC8qIEZJWE1FOiBUaGlzIG1vZGlmaWVzIHR5cGljYWxseSBwdXJlIGhhc2gtY29ucydkIGRh
dGEsIHNvIGl0cwotCSAgICAgICBjb3JyZWN0bmVzcyBpcyBxdWl0ZSBkZWxpY2F0ZS4gICovCiAJ
ICAgIFhTRVRDQVIgKHRlbSwgbWFrZV9maXhudW0gKG9mZnNldCkpOwogCX0KICAgICB9CkBAIC01
NzUsNyArNTczLDYgQEAgREVGVU4gKCJTbmFyZi1kb2N1bWVudGF0aW9uIiwgRnNuYXJmX2RvY3Vt
ZW50YXRpb24sIFNzbmFyZl9kb2N1bWVudGF0aW9uLAogICAgICAgaW50IGkgPSBBUlJBWUVMVFMg
KGJ1aWxkb2JqKTsKICAgICAgIHdoaWxlICgwIDw9IC0taSkKIAlWYnVpbGRfZmlsZXMgPSBGY29u
cyAoYnVpbGRfc3RyaW5nIChidWlsZG9ialtpXSksIFZidWlsZF9maWxlcyk7Ci0gICAgICBWYnVp
bGRfZmlsZXMgPSBGcHVyZWNvcHkgKFZidWlsZF9maWxlcyk7CiAgICAgfQogCiAgIGZkID0gZW1h
Y3Nfb3BlbiAobmFtZSwgT19SRE9OTFksIDApOwpkaWZmIC0tZ2l0IGEvc3JjL2VtYWNzLW1vZHVs
ZS5jIGIvc3JjL2VtYWNzLW1vZHVsZS5jCmluZGV4IGY4ZmI1NGMwNzI4MjMuLjg5NmFlNjU2ODVl
ODQgMTAwNjQ0Ci0tLSBhL3NyYy9lbWFjcy1tb2R1bGUuYworKysgYi9zcmMvZW1hY3MtbW9kdWxl
LmMKQEAgLTE2MDAsNDQgKzE2MDAsNDQgQEAgc3ltc19vZl9tb2R1bGUgKHZvaWQpCiAgIFZtb2R1
bGVfcmVmc19oYXNoCiAgICAgPSBtYWtlX2hhc2hfdGFibGUgKGhhc2h0ZXN0X2VxLCBERUZBVUxU
X0hBU0hfU0laRSwKIAkJICAgICAgIERFRkFVTFRfUkVIQVNIX1NJWkUsIERFRkFVTFRfUkVIQVNI
X1RIUkVTSE9MRCwKLQkJICAgICAgIFFuaWwsIGZhbHNlKTsKKwkJICAgICAgIFFuaWwpOwogCiAg
IERFRlNZTSAoUW1vZHVsZV9sb2FkX2ZhaWxlZCwgIm1vZHVsZS1sb2FkLWZhaWxlZCIpOwogICBG
cHV0IChRbW9kdWxlX2xvYWRfZmFpbGVkLCBRZXJyb3JfY29uZGl0aW9ucywKLQlwdXJlX2xpc3Qg
KFFtb2R1bGVfbG9hZF9mYWlsZWQsIFFlcnJvcikpOworCWxpc3QgKFFtb2R1bGVfbG9hZF9mYWls
ZWQsIFFlcnJvcikpOwogICBGcHV0IChRbW9kdWxlX2xvYWRfZmFpbGVkLCBRZXJyb3JfbWVzc2Fn
ZSwKLSAgICAgICAgYnVpbGRfcHVyZV9jX3N0cmluZyAoIk1vZHVsZSBsb2FkIGZhaWxlZCIpKTsK
KyAgICAgICAgYnVpbGRfc3RyaW5nICgiTW9kdWxlIGxvYWQgZmFpbGVkIikpOwogCiAgIERFRlNZ
TSAoUW1vZHVsZV9vcGVuX2ZhaWxlZCwgIm1vZHVsZS1vcGVuLWZhaWxlZCIpOwogICBGcHV0IChR
bW9kdWxlX29wZW5fZmFpbGVkLCBRZXJyb3JfY29uZGl0aW9ucywKLQlwdXJlX2xpc3QgKFFtb2R1
bGVfb3Blbl9mYWlsZWQsIFFtb2R1bGVfbG9hZF9mYWlsZWQsIFFlcnJvcikpOworCWxpc3QgKFFt
b2R1bGVfb3Blbl9mYWlsZWQsIFFtb2R1bGVfbG9hZF9mYWlsZWQsIFFlcnJvcikpOwogICBGcHV0
IChRbW9kdWxlX29wZW5fZmFpbGVkLCBRZXJyb3JfbWVzc2FnZSwKLSAgICAgICAgYnVpbGRfcHVy
ZV9jX3N0cmluZyAoIk1vZHVsZSBjb3VsZCBub3QgYmUgb3BlbmVkIikpOworICAgICAgICBidWls
ZF9zdHJpbmcgKCJNb2R1bGUgY291bGQgbm90IGJlIG9wZW5lZCIpKTsKIAogICBERUZTWU0gKFFt
b2R1bGVfbm90X2dwbF9jb21wYXRpYmxlLCAibW9kdWxlLW5vdC1ncGwtY29tcGF0aWJsZSIpOwog
ICBGcHV0IChRbW9kdWxlX25vdF9ncGxfY29tcGF0aWJsZSwgUWVycm9yX2NvbmRpdGlvbnMsCi0J
cHVyZV9saXN0IChRbW9kdWxlX25vdF9ncGxfY29tcGF0aWJsZSwgUW1vZHVsZV9sb2FkX2ZhaWxl
ZCwgUWVycm9yKSk7CisJbGlzdCAoUW1vZHVsZV9ub3RfZ3BsX2NvbXBhdGlibGUsIFFtb2R1bGVf
bG9hZF9mYWlsZWQsIFFlcnJvcikpOwogICBGcHV0IChRbW9kdWxlX25vdF9ncGxfY29tcGF0aWJs
ZSwgUWVycm9yX21lc3NhZ2UsCi0gICAgICAgIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCJNb2R1bGUg
aXMgbm90IEdQTCBjb21wYXRpYmxlIikpOworICAgICAgICBidWlsZF9zdHJpbmcgKCJNb2R1bGUg
aXMgbm90IEdQTCBjb21wYXRpYmxlIikpOwogCiAgIERFRlNZTSAoUW1pc3NpbmdfbW9kdWxlX2lu
aXRfZnVuY3Rpb24sICJtaXNzaW5nLW1vZHVsZS1pbml0LWZ1bmN0aW9uIik7CiAgIEZwdXQgKFFt
aXNzaW5nX21vZHVsZV9pbml0X2Z1bmN0aW9uLCBRZXJyb3JfY29uZGl0aW9ucywKLQlwdXJlX2xp
c3QgKFFtaXNzaW5nX21vZHVsZV9pbml0X2Z1bmN0aW9uLCBRbW9kdWxlX2xvYWRfZmFpbGVkLAot
CQkgICBRZXJyb3IpKTsKKwlsaXN0IChRbWlzc2luZ19tb2R1bGVfaW5pdF9mdW5jdGlvbiwgUW1v
ZHVsZV9sb2FkX2ZhaWxlZCwKKwkgICAgICBRZXJyb3IpKTsKICAgRnB1dCAoUW1pc3NpbmdfbW9k
dWxlX2luaXRfZnVuY3Rpb24sIFFlcnJvcl9tZXNzYWdlLAotICAgICAgICBidWlsZF9wdXJlX2Nf
c3RyaW5nICgiTW9kdWxlIGRvZXMgbm90IGV4cG9ydCBhbiAiCisgICAgICAgIGJ1aWxkX3N0cmlu
ZyAoIk1vZHVsZSBkb2VzIG5vdCBleHBvcnQgYW4gIgogICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAiaW5pdGlhbGl6YXRpb24gZnVuY3Rpb24iKSk7CiAKICAgREVGU1lNIChRbW9kdWxlX2lu
aXRfZmFpbGVkLCAibW9kdWxlLWluaXQtZmFpbGVkIik7CiAgIEZwdXQgKFFtb2R1bGVfaW5pdF9m
YWlsZWQsIFFlcnJvcl9jb25kaXRpb25zLAotCXB1cmVfbGlzdCAoUW1vZHVsZV9pbml0X2ZhaWxl
ZCwgUW1vZHVsZV9sb2FkX2ZhaWxlZCwgUWVycm9yKSk7CisJbGlzdCAoUW1vZHVsZV9pbml0X2Zh
aWxlZCwgUW1vZHVsZV9sb2FkX2ZhaWxlZCwgUWVycm9yKSk7CiAgIEZwdXQgKFFtb2R1bGVfaW5p
dF9mYWlsZWQsIFFlcnJvcl9tZXNzYWdlLAotICAgICAgICBidWlsZF9wdXJlX2Nfc3RyaW5nICgi
TW9kdWxlIGluaXRpYWxpemF0aW9uIGZhaWxlZCIpKTsKKyAgICAgICAgYnVpbGRfc3RyaW5nICgi
TW9kdWxlIGluaXRpYWxpemF0aW9uIGZhaWxlZCIpKTsKIAogICBERUZTWU0gKFFpbnZhbGlkX2Fy
aXR5LCAiaW52YWxpZC1hcml0eSIpOwotICBGcHV0IChRaW52YWxpZF9hcml0eSwgUWVycm9yX2Nv
bmRpdGlvbnMsIHB1cmVfbGlzdCAoUWludmFsaWRfYXJpdHksIFFlcnJvcikpOworICBGcHV0IChR
aW52YWxpZF9hcml0eSwgUWVycm9yX2NvbmRpdGlvbnMsIGxpc3QgKFFpbnZhbGlkX2FyaXR5LCBR
ZXJyb3IpKTsKICAgRnB1dCAoUWludmFsaWRfYXJpdHksIFFlcnJvcl9tZXNzYWdlLAotICAgICAg
ICBidWlsZF9wdXJlX2Nfc3RyaW5nICgiSW52YWxpZCBmdW5jdGlvbiBhcml0eSIpKTsKKyAgICAg
ICAgYnVpbGRfc3RyaW5nICgiSW52YWxpZCBmdW5jdGlvbiBhcml0eSIpKTsKIAogICBERUZTWU0g
KFFtb2R1bGVfZnVuY3Rpb25fcCwgIm1vZHVsZS1mdW5jdGlvbi1wIik7CiAgIERFRlNZTSAoUXVu
aWNvZGVfc3RyaW5nX3AsICJ1bmljb2RlLXN0cmluZy1wIik7CmRpZmYgLS1naXQgYS9zcmMvZW1h
Y3MuYyBiL3NyYy9lbWFjcy5jCmluZGV4IGZkMDg2NjdmM2ZkNGYuLjAzZWM2MzQ2NGRhZjUgMTAw
NjQ0Ci0tLSBhL3NyYy9lbWFjcy5jCisrKyBiL3NyYy9lbWFjcy5jCkBAIC04OCw3ICs4OCw2IEBA
ICNkZWZpbmUgTUFJTl9QUk9HUkFNCiAjaW5jbHVkZSAic3ludGF4LmgiCiAjaW5jbHVkZSAic3lz
c2VsZWN0LmgiCiAjaW5jbHVkZSAic3lzdGltZS5oIgotI2luY2x1ZGUgInB1cmVzaXplLmgiCiAK
ICNpbmNsdWRlICJnZXRwYWdlc2l6ZS5oIgogI2luY2x1ZGUgImdudXRscy5oIgpAQCAtMTU0NCw3
ICsxNTQzLDkgQEAgbWFpbiAoaW50IGFyZ2MsIGNoYXIgKiphcmd2KQogICBpZiAoIWluaXRpYWxp
emVkKQogICAgIHsKICAgICAgIGluaXRfYWxsb2Nfb25jZSAoKTsKKyNpZmRlZiBIQVZFX1BEVU1Q
RVIKICAgICAgIGluaXRfcGR1bXBlcl9vbmNlICgpOworI2VuZGlmCiAgICAgICBpbml0X29iYXJy
YXlfb25jZSAoKTsKICAgICAgIGluaXRfZXZhbF9vbmNlICgpOwogICAgICAgaW5pdF9jaGFyc2V0
X29uY2UgKCk7CkBAIC0yNTA4LDggKzI1MDksNiBAQCBERUZVTiAoImR1bXAtZW1hY3MiLCBGZHVt
cF9lbWFjcywgU2R1bXBfZW1hY3MsIDIsIDIsIDAsCiAgIExpc3BfT2JqZWN0IHN5bWJvbDsKICAg
cHRyZGlmZl90IGNvdW50ID0gU1BFQ1BETF9JTkRFWCAoKTsKIAotICBjaGVja19wdXJlX3NpemUg
KCk7Ci0KICAgaWYgKCEgbm9uaW50ZXJhY3RpdmUpCiAgICAgZXJyb3IgKCJEdW1waW5nIEVtYWNz
IHdvcmtzIG9ubHkgaW4gYmF0Y2ggbW9kZSIpOwogCmRpZmYgLS1naXQgYS9zcmMvZXZhbC5jIGIv
c3JjL2V2YWwuYwppbmRleCBkZGFhOGVkZDgxNzA2Li5jMDcxN2Y4Y2YxMjRkIDEwMDY0NAotLS0g
YS9zcmMvZXZhbC5jCisrKyBiL3NyYy9ldmFsLmMKQEAgLTc4NSw4ICs3ODUsNiBAQCBERUZVTiAo
ImludGVybmFsLS1kZWZpbmUtdW5pbml0aWFsaXplZC12YXJpYWJsZSIsCiAgIFhTWU1CT0wgKHN5
bWJvbCktPnUucy5kZWNsYXJlZF9zcGVjaWFsID0gdHJ1ZTsKICAgaWYgKCFOSUxQIChkb2MpKQog
ICAgIHsKLSAgICAgIGlmICghTklMUCAoVnB1cmlmeV9mbGFnKSkKLQlkb2MgPSBGcHVyZWNvcHkg
KGRvYyk7CiAgICAgICBGcHV0IChzeW1ib2wsIFF2YXJpYWJsZV9kb2N1bWVudGF0aW9uLCBkb2Mp
OwogICAgIH0KICAgTE9BREhJU1RfQVRUQUNIIChzeW1ib2wpOwpAQCAtOTAzLDggKzkwMSw2IEBA
IERFRlVOICgiZGVmY29uc3QiLCBGZGVmY29uc3QsIFNkZWZjb25zdCwgMiwgVU5FVkFMTEVELCAw
LAogCiAgIEZpbnRlcm5hbF9fZGVmaW5lX3VuaW5pdGlhbGl6ZWRfdmFyaWFibGUgKHN5bSwgZG9j
c3RyaW5nKTsKICAgdGVtID0gZXZhbF9zdWIgKFhDQVIgKFhDRFIgKGFyZ3MpKSk7Ci0gIGlmICgh
TklMUCAoVnB1cmlmeV9mbGFnKSkKLSAgICB0ZW0gPSBGcHVyZWNvcHkgKHRlbSk7CiAgIEZzZXRf
ZGVmYXVsdCAoc3ltLCB0ZW0pOyAgICAgIC8qIEZJWE1FOiBzZXQtZGVmYXVsdC10b3BsZXZlbC12
YWx1ZT8gKi8KICAgRnB1dCAoc3ltLCBRcmlza3lfbG9jYWxfdmFyaWFibGUsIFF0KTsgLyogRklY
TUU6IFdoeT8gICovCiAgIHJldHVybiBzeW07CkBAIC0yMTA3LDEyICsyMTAzLDYgQEAgREVGVU4g
KCJhdXRvbG9hZCIsIEZhdXRvbG9hZCwgU2F1dG9sb2FkLCAyLCA1LCAwLAogICAgICAgJiYgIUFV
VE9MT0FEUCAoWFNZTUJPTCAoZnVuY3Rpb24pLT51LnMuZnVuY3Rpb24pKQogICAgIHJldHVybiBR
bmlsOwogCi0gIGlmICghTklMUCAoVnB1cmlmeV9mbGFnKSAmJiBFUSAoZG9jc3RyaW5nLCBtYWtl
X2ZpeG51bSAoMCkpKQotICAgIC8qIGByZWFkMScgaW4gbHJlYWQuYyBoYXMgZm91bmQgdGhlIGRv
Y3N0cmluZyBzdGFydGluZyB3aXRoICJcCi0gICAgICAgYW5kIGFzc3VtZWQgdGhlIGRvY3N0cmlu
ZyB3aWxsIGJlIHByb3ZpZGVkIGJ5IFNuYXJmLWRvY3VtZW50YXRpb24sIHNvIGl0Ci0gICAgICAg
cGFzc2VkIHVzIDAgaW5zdGVhZC4gIEJ1dCB0aGF0IGxlYWRzIHRvIGFjY2lkZW50YWwgc2hhcmlu
ZyBpbiBwdXJlY29weSdzCi0gICAgICAgaGFzaC1jb25zaW5nLCBzbyB3ZSB1c2UgYSAoaG9wZWZ1
bGx5KSB1bmlxdWUgaW50ZWdlciBpbnN0ZWFkLiAgKi8KLSAgICBkb2NzdHJpbmcgPSBtYWtlX3Vm
aXhudW0gKFhIQVNIIChmdW5jdGlvbikpOwogICByZXR1cm4gRmRlZmFsaWFzIChmdW5jdGlvbiwK
IAkJICAgIGxpc3Q1IChRYXV0b2xvYWQsIGZpbGUsIGRvY3N0cmluZywgaW50ZXJhY3RpdmUsIHR5
cGUpLAogCQkgICAgUW5pbCk7CkBAIC00MzU0LDcgKzQzNDQsNyBAQCBzeW1zX29mX2V2YWwgKHZv
aWQpCiAgICAgIGFsc28gdXNlIHNvbWV0aGluZyBsaWtlIEZjb25zIChRbmlsLCBRbmlsKSwgYnV0
IGpzb24uYyB0cmVhdHMgYW55CiAgICAgIGNvbnMgY2VsbCBhcyBlcnJvciBkYXRhLCBzbyB1c2Ug
YW4gdW5pbnRlcm5lZCBzeW1ib2wgaW5zdGVhZC4gICovCiAgIFFjYXRjaF9hbGxfbWVtb3J5X2Z1
bGwKLSAgICA9IEZtYWtlX3N5bWJvbCAoYnVpbGRfcHVyZV9jX3N0cmluZyAoImNhdGNoLWFsbC1t
ZW1vcnktZnVsbCIpKTsKKyAgICA9IEZtYWtlX3N5bWJvbCAoYnVpbGRfc3RyaW5nICgiY2F0Y2gt
YWxsLW1lbW9yeS1mdWxsIikpOwogCiAgIGRlZnN1YnIgKCZTb3IpOwogICBkZWZzdWJyICgmU2Fu
ZCk7CmRpZmYgLS1naXQgYS9zcmMvZmlsZWlvLmMgYi9zcmMvZmlsZWlvLmMKaW5kZXggNzQxZTI5
N2QyOWMyYy4uNWQ0Mzg4NjVlMjA5MiAxMDA2NDQKLS0tIGEvc3JjL2ZpbGVpby5jCisrKyBiL3Ny
Yy9maWxlaW8uYwpAQCAtNjI5NCwzNCArNjI5NCwzNCBAQCBzeW1zX29mX2ZpbGVpbyAodm9pZCkK
ICAgREVGU1lNIChRY2FyX2xlc3NfdGhhbl9jYXIsICJjYXItbGVzcy10aGFuLWNhciIpOwogCiAg
IEZwdXQgKFFmaWxlX2Vycm9yLCBRZXJyb3JfY29uZGl0aW9ucywKLQlGcHVyZWNvcHkgKGxpc3Qy
IChRZmlsZV9lcnJvciwgUWVycm9yKSkpOworCWxpc3QyIChRZmlsZV9lcnJvciwgUWVycm9yKSk7
CiAgIEZwdXQgKFFmaWxlX2Vycm9yLCBRZXJyb3JfbWVzc2FnZSwKLQlidWlsZF9wdXJlX2Nfc3Ry
aW5nICgiRmlsZSBlcnJvciIpKTsKKwlidWlsZF9zdHJpbmcgKCJGaWxlIGVycm9yIikpOwogCiAg
IEZwdXQgKFFmaWxlX2FscmVhZHlfZXhpc3RzLCBRZXJyb3JfY29uZGl0aW9ucywKLQlGcHVyZWNv
cHkgKGxpc3QzIChRZmlsZV9hbHJlYWR5X2V4aXN0cywgUWZpbGVfZXJyb3IsIFFlcnJvcikpKTsK
KwlsaXN0MyAoUWZpbGVfYWxyZWFkeV9leGlzdHMsIFFmaWxlX2Vycm9yLCBRZXJyb3IpKTsKICAg
RnB1dCAoUWZpbGVfYWxyZWFkeV9leGlzdHMsIFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVf
Y19zdHJpbmcgKCJGaWxlIGFscmVhZHkgZXhpc3RzIikpOworCWJ1aWxkX3N0cmluZyAoIkZpbGUg
YWxyZWFkeSBleGlzdHMiKSk7CiAKICAgRnB1dCAoUWZpbGVfZGF0ZV9lcnJvciwgUWVycm9yX2Nv
bmRpdGlvbnMsCi0JRnB1cmVjb3B5IChsaXN0MyAoUWZpbGVfZGF0ZV9lcnJvciwgUWZpbGVfZXJy
b3IsIFFlcnJvcikpKTsKKwlsaXN0MyAoUWZpbGVfZGF0ZV9lcnJvciwgUWZpbGVfZXJyb3IsIFFl
cnJvcikpOwogICBGcHV0IChRZmlsZV9kYXRlX2Vycm9yLCBRZXJyb3JfbWVzc2FnZSwKLQlidWls
ZF9wdXJlX2Nfc3RyaW5nICgiQ2Fubm90IHNldCBmaWxlIGRhdGUiKSk7CisJYnVpbGRfc3RyaW5n
ICgiQ2Fubm90IHNldCBmaWxlIGRhdGUiKSk7CiAKICAgRnB1dCAoUWZpbGVfbWlzc2luZywgUWVy
cm9yX2NvbmRpdGlvbnMsCi0JRnB1cmVjb3B5IChsaXN0MyAoUWZpbGVfbWlzc2luZywgUWZpbGVf
ZXJyb3IsIFFlcnJvcikpKTsKKwlsaXN0MyAoUWZpbGVfbWlzc2luZywgUWZpbGVfZXJyb3IsIFFl
cnJvcikpOwogICBGcHV0IChRZmlsZV9taXNzaW5nLCBRZXJyb3JfbWVzc2FnZSwKLQlidWlsZF9w
dXJlX2Nfc3RyaW5nICgiRmlsZSBpcyBtaXNzaW5nIikpOworCWJ1aWxkX3N0cmluZyAoIkZpbGUg
aXMgbWlzc2luZyIpKTsKIAogICBGcHV0IChRZmlsZV9ub3RpZnlfZXJyb3IsIFFlcnJvcl9jb25k
aXRpb25zLAotCUZwdXJlY29weSAobGlzdDMgKFFmaWxlX25vdGlmeV9lcnJvciwgUWZpbGVfZXJy
b3IsIFFlcnJvcikpKTsKKwlsaXN0MyAoUWZpbGVfbm90aWZ5X2Vycm9yLCBRZmlsZV9lcnJvciwg
UWVycm9yKSk7CiAgIEZwdXQgKFFmaWxlX25vdGlmeV9lcnJvciwgUWVycm9yX21lc3NhZ2UsCi0J
YnVpbGRfcHVyZV9jX3N0cmluZyAoIkZpbGUgbm90aWZpY2F0aW9uIGVycm9yIikpOworCWJ1aWxk
X3N0cmluZyAoIkZpbGUgbm90aWZpY2F0aW9uIGVycm9yIikpOwogCiAgIEZwdXQgKFFyZW1vdGVf
ZmlsZV9lcnJvciwgUWVycm9yX2NvbmRpdGlvbnMsCiAJRnB1cmVjb3B5IChsaXN0MyAoUXJlbW90
ZV9maWxlX2Vycm9yLCBRZmlsZV9lcnJvciwgUWVycm9yKSkpOwogICBGcHV0IChRcmVtb3RlX2Zp
bGVfZXJyb3IsIFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVfY19zdHJpbmcgKCJSZW1vdGUg
ZmlsZSBlcnJvciIpKTsKKwlidWlsZF9zdHJpbmcgKCJSZW1vdGUgZmlsZSBlcnJvciIpKTsKIAog
ICBERUZWQVJfTElTUCAoImZpbGUtbmFtZS1oYW5kbGVyLWFsaXN0IiwgVmZpbGVfbmFtZV9oYW5k
bGVyX2FsaXN0LAogCSAgICAgICBkb2M6IC8qIEFsaXN0IG9mIGVsZW1lbnRzIChSRUdFWFAgLiBI
QU5ETEVSKSBmb3IgZmlsZSBuYW1lcyBoYW5kbGVkIHNwZWNpYWxseS4KZGlmZiAtLWdpdCBhL3Ny
Yy9mbnMuYyBiL3NyYy9mbnMuYwppbmRleCA3OTE0YmQ0Nzc5MGE5Li5hMjJiNjMzZWM3Mzg2IDEw
MDY0NAotLS0gYS9zcmMvZm5zLmMKKysrIGIvc3JjL2Zucy5jCkBAIC0zNiw3ICszNiw2IEBAIENv
cHlyaWdodCAoQykgMTk4NS0xOTg3LCAxOTkzLTE5OTUsIDE5OTctMjAyMSBGcmVlIFNvZnR3YXJl
IEZvdW5kYXRpb24sCiAjaW5jbHVkZSAiYnVmZmVyLmgiCiAjaW5jbHVkZSAiaW50ZXJ2YWxzLmgi
CiAjaW5jbHVkZSAid2luZG93LmgiCi0jaW5jbHVkZSAicHVyZXNpemUuaCIKICNpbmNsdWRlICJn
bnV0bHMuaCIKIAogc3RhdGljIHZvaWQgc29ydF92ZWN0b3JfY29weSAoTGlzcF9PYmplY3QsIHB0
cmRpZmZfdCwKQEAgLTI2MDIsNyArMjYwMSw2IEBAIERFRlVOICgiZmlsbGFycmF5IiwgRmZpbGxh
cnJheSwgU2ZpbGxhcnJheSwgMiwgMiwgMCwKICAgICAgIHNpemUgPSBTQ0hBUlMgKGFycmF5KTsK
ICAgICAgIGlmIChzaXplICE9IDApCiAJewotCSAgQ0hFQ0tfSU1QVVJFIChhcnJheSwgWFNUUklO
RyAoYXJyYXkpKTsKIAkgIHVuc2lnbmVkIGNoYXIgc3RyW01BWF9NVUxUSUJZVEVfTEVOR1RIXTsK
IAkgIGludCBsZW47CiAJICBpZiAoU1RSSU5HX01VTFRJQllURSAoYXJyYXkpKQpAQCAtMjY0NCw3
ICsyNjQyLDYgQEAgREVGVU4gKCJjbGVhci1zdHJpbmciLCBGY2xlYXJfc3RyaW5nLCBTY2xlYXJf
c3RyaW5nLAogICBwdHJkaWZmX3QgbGVuID0gU0JZVEVTIChzdHJpbmcpOwogICBpZiAobGVuICE9
IDAgfHwgU1RSSU5HX01VTFRJQllURSAoc3RyaW5nKSkKICAgICB7Ci0gICAgICBDSEVDS19JTVBV
UkUgKHN0cmluZywgWFNUUklORyAoc3RyaW5nKSk7CiAgICAgICBtZW1zZXQgKFNEQVRBIChzdHJp
bmcpLCAwLCBsZW4pOwogICAgICAgU1RSSU5HX1NFVF9DSEFSUyAoc3RyaW5nLCBsZW4pOwogICAg
ICAgU1RSSU5HX1NFVF9VTklCWVRFIChzdHJpbmcpOwpAQCAtNDE3OSwxNiArNDE3NiwxMiBAQCBo
YXNoX2luZGV4X3NpemUgKHN0cnVjdCBMaXNwX0hhc2hfVGFibGUgKmgsIHB0cmRpZmZfdCBzaXpl
KQogICAgc2l6ZSBleGNlZWRzIFJFSEFTSF9USFJFU0hPTEQuCiAKICAgIFdFQUsgc3BlY2lmaWVz
IHRoZSB3ZWFrbmVzcyBvZiB0aGUgdGFibGUuICBJZiBub24tbmlsLCBpdCBtdXN0IGJlCi0gICBv
bmUgb2YgdGhlIHN5bWJvbHMgYGtleScsIGB2YWx1ZScsIGBrZXktb3ItdmFsdWUnLCBvciBga2V5
LWFuZC12YWx1ZScuCi0KLSAgIElmIFBVUkVDT1BZIGlzIG5vbi1uaWwsIHRoZSB0YWJsZSBjYW4g
YmUgY29waWVkIHRvIHB1cmUgc3RvcmFnZSB2aWEKLSAgIGBwdXJlY29weScgd2hlbiBFbWFjcyBp
cyBiZWluZyBkdW1wZWQuIFN1Y2ggdGFibGVzIGNhbiBubyBsb25nZXIgYmUKLSAgIGNoYW5nZWQg
YWZ0ZXIgcHVyZWNvcHkuICAqLworICAgb25lIG9mIHRoZSBzeW1ib2xzIGBrZXknLCBgdmFsdWUn
LCBga2V5LW9yLXZhbHVlJywgb3IgYGtleS1hbmQtdmFsdWUnLiAqLwogCiBMaXNwX09iamVjdAog
bWFrZV9oYXNoX3RhYmxlIChzdHJ1Y3QgaGFzaF90YWJsZV90ZXN0IHRlc3QsIEVNQUNTX0lOVCBz
aXplLAogCQkgZmxvYXQgcmVoYXNoX3NpemUsIGZsb2F0IHJlaGFzaF90aHJlc2hvbGQsCi0JCSBM
aXNwX09iamVjdCB3ZWFrLCBib29sIHB1cmVjb3B5KQorCQkgTGlzcF9PYmplY3Qgd2VhaykKIHsK
ICAgc3RydWN0IExpc3BfSGFzaF9UYWJsZSAqaDsKICAgTGlzcF9PYmplY3QgdGFibGU7CkBAIC00
MjE3LDcgKzQyMTAsNiBAQCBtYWtlX2hhc2hfdGFibGUgKHN0cnVjdCBoYXNoX3RhYmxlX3Rlc3Qg
dGVzdCwgRU1BQ1NfSU5UIHNpemUsCiAgIGgtPm5leHQgPSBtYWtlX3ZlY3RvciAoc2l6ZSwgbWFr
ZV9maXhudW0gKC0xKSk7CiAgIGgtPmluZGV4ID0gbWFrZV92ZWN0b3IgKGhhc2hfaW5kZXhfc2l6
ZSAoaCwgc2l6ZSksIG1ha2VfZml4bnVtICgtMSkpOwogICBoLT5uZXh0X3dlYWsgPSBOVUxMOwot
ICBoLT5wdXJlY29weSA9IHB1cmVjb3B5OwogICBoLT5tdXRhYmxlID0gdHJ1ZTsKIAogICAvKiBT
ZXQgdXAgdGhlIGZyZWUgbGlzdC4gICovCkBAIC00MzE4LDExICs0MzEwLDYgQEAgbWF5YmVfcmVz
aXplX2hhc2hfdGFibGUgKHN0cnVjdCBMaXNwX0hhc2hfVGFibGUgKmgpCiAJICAgIHNldF9oYXNo
X25leHRfc2xvdCAoaCwgaSwgSEFTSF9JTkRFWCAoaCwgc3RhcnRfb2ZfYnVja2V0KSk7CiAJICAg
IHNldF9oYXNoX2luZGV4X3Nsb3QgKGgsIHN0YXJ0X29mX2J1Y2tldCwgaSk7CiAJICB9Ci0KLSNp
ZmRlZiBFTkFCTEVfQ0hFQ0tJTkcKLSAgICAgIGlmIChIQVNIX1RBQkxFX1AgKFZwdXJpZnlfZmxh
ZykgJiYgWEhBU0hfVEFCTEUgKFZwdXJpZnlfZmxhZykgPT0gaCkKLQltZXNzYWdlICgiR3Jvd2lu
ZyBoYXNoIHRhYmxlIHRvOiAlInBEImQiLCBuZXh0X3NpemUpOwotI2VuZGlmCiAgICAgfQogfQog
CkBAIC00Mzg1LDcgKzQzNzIsNiBAQCBjaGVja19tdXRhYmxlX2hhc2hfdGFibGUgKExpc3BfT2Jq
ZWN0IG9iaiwgc3RydWN0IExpc3BfSGFzaF9UYWJsZSAqaCkKIHsKICAgaWYgKCFoLT5tdXRhYmxl
KQogICAgIHNpZ25hbF9lcnJvciAoImhhc2ggdGFibGUgdGVzdCBtb2RpZmllcyB0YWJsZSIsIG9i
aik7Ci0gIGVhc3NlcnQgKCFQVVJFX1AgKGgpKTsKIH0KIAogLyogUHV0IGFuIGVudHJ5IGludG8g
aGFzaCB0YWJsZSBIIHRoYXQgYXNzb2NpYXRlcyBLRVkgd2l0aCBWQUxVRS4KQEAgLTQ4NzYsMTYg
KzQ4NjIsMTAgQEAgREVGVU4gKCJtYWtlLWhhc2gtdGFibGUiLCBGbWFrZV9oYXNoX3RhYmxlLCBT
bWFrZV9oYXNoX3RhYmxlLCAwLCBNQU5ZLCAwLAogV0VBSy4gIFdFQUsgdCBpcyBlcXVpdmFsZW50
IHRvIGBrZXktYW5kLXZhbHVlJy4gIERlZmF1bHQgdmFsdWUgb2YgV0VBSwogaXMgbmlsLgogCi06
cHVyZWNvcHkgUFVSRUNPUFkgLS0gSWYgUFVSRUNPUFkgaXMgbm9uLW5pbCwgdGhlIHRhYmxlIGNh
biBiZSBjb3BpZWQKLXRvIHB1cmUgc3RvcmFnZSB3aGVuIEVtYWNzIGlzIGJlaW5nIGR1bXBlZCwg
bWFraW5nIHRoZSBjb250ZW50cyBvZiB0aGUKLXRhYmxlIHJlYWQgb25seS4gQW55IGZ1cnRoZXIg
Y2hhbmdlcyB0byBwdXJpZmllZCB0YWJsZXMgd2lsbCByZXN1bHQKLWluIGFuIGVycm9yLgotCiB1
c2FnZTogKG1ha2UtaGFzaC10YWJsZSAmcmVzdCBLRVlXT1JELUFSR1MpICAqLykKICAgKHB0cmRp
ZmZfdCBuYXJncywgTGlzcF9PYmplY3QgKmFyZ3MpCiB7CiAgIExpc3BfT2JqZWN0IHRlc3QsIHdl
YWs7Ci0gIGJvb2wgcHVyZWNvcHk7CiAgIHN0cnVjdCBoYXNoX3RhYmxlX3Rlc3QgdGVzdGRlc2M7
CiAgIHB0cmRpZmZfdCBpOwogICBVU0VfU0FGRV9BTExPQ0E7CkBAIC00OTE5LDkgKzQ4OTksOCBA
QCBERUZVTiAoIm1ha2UtaGFzaC10YWJsZSIsIEZtYWtlX2hhc2hfdGFibGUsIFNtYWtlX2hhc2hf
dGFibGUsIDAsIE1BTlksIDAsCiAgICAgICB0ZXN0ZGVzYy5jbXBmbiA9IGNtcGZuX3VzZXJfZGVm
aW5lZDsKICAgICB9CiAKLSAgLyogU2VlIGlmIHRoZXJlJ3MgYSBgOnB1cmVjb3B5IFBVUkVDT1BZ
JyBhcmd1bWVudC4gICovCi0gIGkgPSBnZXRfa2V5X2FyZyAoUUNwdXJlY29weSwgbmFyZ3MsIGFy
Z3MsIHVzZWQpOwotICBwdXJlY29weSA9IGkgJiYgIU5JTFAgKGFyZ3NbaV0pOworICAvKiBJZ25v
cmUgYSBgOnB1cmVjb3B5IFBVUkVDT1BZJyBhcmd1bWVudC4gICovCisgIGdldF9rZXlfYXJnIChR
Q3B1cmVjb3B5LCBuYXJncywgYXJncywgdXNlZCk7CiAgIC8qIFNlZSBpZiB0aGVyZSdzIGEgYDpz
aXplIFNJWkUnIGFyZ3VtZW50LiAgKi8KICAgaSA9IGdldF9rZXlfYXJnIChRQ3NpemUsIG5hcmdz
LCBhcmdzLCB1c2VkKTsKICAgTGlzcF9PYmplY3Qgc2l6ZV9hcmcgPSBpID8gYXJnc1tpXSA6IFFu
aWw7CkBAIC00OTcxLDggKzQ5NTAsNyBAQCBERUZVTiAoIm1ha2UtaGFzaC10YWJsZSIsIEZtYWtl
X2hhc2hfdGFibGUsIFNtYWtlX2hhc2hfdGFibGUsIDAsIE1BTlksIDAsCiAgICAgICBzaWduYWxf
ZXJyb3IgKCJJbnZhbGlkIGFyZ3VtZW50IGxpc3QiLCBhcmdzW2ldKTsKIAogICBTQUZFX0ZSRUUg
KCk7Ci0gIHJldHVybiBtYWtlX2hhc2hfdGFibGUgKHRlc3RkZXNjLCBzaXplLCByZWhhc2hfc2l6
ZSwgcmVoYXNoX3RocmVzaG9sZCwgd2VhaywKLQkJCSAgcHVyZWNvcHkpOworICByZXR1cm4gbWFr
ZV9oYXNoX3RhYmxlICh0ZXN0ZGVzYywgc2l6ZSwgcmVoYXNoX3NpemUsIHJlaGFzaF90aHJlc2hv
bGQsIHdlYWspOwogfQogCiAKZGlmZiAtLWdpdCBhL3NyYy9mb250c2V0LmMgYi9zcmMvZm9udHNl
dC5jCmluZGV4IDMzMmJlNmMzOWQxMWYuLjA0MjFjYTQ5YzczNjEgMTAwNjQ0Ci0tLSBhL3NyYy9m
b250c2V0LmMKKysrIGIvc3JjL2ZvbnRzZXQuYwpAQCAtMjEyOSw3ICsyMTI5LDcgQEAgc3ltc19v
Zl9mb250c2V0ICh2b2lkKQogICBzZXRfZm9udHNldF9pZCAoVmRlZmF1bHRfZm9udHNldCwgbWFr
ZV9maXhudW0gKDApKTsKICAgc2V0X2ZvbnRzZXRfbmFtZQogICAgIChWZGVmYXVsdF9mb250c2V0
LAotICAgICBidWlsZF9wdXJlX2Nfc3RyaW5nICgiLSotKi0qLSotKi0qLSotKi0qLSotKi0qLWZv
bnRzZXQtZGVmYXVsdCIpKTsKKyAgICAgYnVpbGRfc3RyaW5nICgiLSotKi0qLSotKi0qLSotKi0q
LSotKi0qLWZvbnRzZXQtZGVmYXVsdCIpKTsKICAgQVNFVCAoVmZvbnRzZXRfdGFibGUsIDAsIFZk
ZWZhdWx0X2ZvbnRzZXQpOwogICBuZXh0X2ZvbnRzZXRfaWQgPSAxOwogICBQRFVNUEVSX1JFTUVN
QkVSX1NDQUxBUiAobmV4dF9mb250c2V0X2lkKTsKQEAgLTIxODcsNyArMjE4Nyw3IEBAIHN5bXNf
b2ZfZm9udHNldCAodm9pZCkKIAkgICAgICAgZG9jOiAvKiBBbGlzdCBvZiBmb250c2V0IG5hbWVz
IHZzIHRoZSBhbGlhc2VzLiAgKi8pOwogICBWZm9udHNldF9hbGlhc19hbGlzdAogICAgID0gbGlz
dDEgKEZjb25zIChGT05UU0VUX05BTUUgKFZkZWZhdWx0X2ZvbnRzZXQpLAotCQkgICAgYnVpbGRf
cHVyZV9jX3N0cmluZyAoImZvbnRzZXQtZGVmYXVsdCIpKSk7CisJCSAgICBidWlsZF9zdHJpbmcg
KCJmb250c2V0LWRlZmF1bHQiKSkpOwogCiAgIERFRlZBUl9MSVNQICgidmVydGljYWwtY2VudGVy
aW5nLWZvbnQtcmVnZXhwIiwKIAkgICAgICAgVnZlcnRpY2FsX2NlbnRlcmluZ19mb250X3JlZ2V4
cCwKZGlmZiAtLWdpdCBhL3NyYy9mcmFtZS5jIGIvc3JjL2ZyYW1lLmMKaW5kZXggYTYyMzQ3YzFm
YjJhOS4uNjUyZDI2NjU0MzkwZCAxMDA2NDQKLS0tIGEvc3JjL2ZyYW1lLmMKKysrIGIvc3JjL2Zy
YW1lLmMKQEAgLTExMDgsNyArMTEwOCw3IEBAIG1ha2VfaW5pdGlhbF9mcmFtZSAodm9pZCkKICAg
VmZyYW1lX2xpc3QgPSBGY29ucyAoZnJhbWUsIFZmcmFtZV9saXN0KTsKIAogICB0dHlfZnJhbWVf
Y291bnQgPSAxOwotICBmc2V0X25hbWUgKGYsIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCJGMSIpKTsK
KyAgZnNldF9uYW1lIChmLCBidWlsZF9zdHJpbmcgKCJGMSIpKTsKIAogICBTRVRfRlJBTUVfVklT
SUJMRSAoZiwgMSk7CiAKZGlmZiAtLWdpdCBhL3NyYy9pbWFnZS5jIGIvc3JjL2ltYWdlLmMKaW5k
ZXggODEzN2RiZWE4ZDdlYy4uYzczODU0OGQzODJhNyAxMDA2NDQKLS0tIGEvc3JjL2ltYWdlLmMK
KysrIGIvc3JjL2ltYWdlLmMKQEAgLTQ4MDgsNyArNDgwOCw3IEBAIHhwbV9tYWtlX2NvbG9yX3Rh
YmxlX2ggKHZvaWQgKCoqcHV0X2Z1bmMpIChMaXNwX09iamVjdCwgY29uc3QgY2hhciAqLCBpbnQs
CiAgICpnZXRfZnVuYyA9IHhwbV9nZXRfY29sb3JfdGFibGVfaDsKICAgcmV0dXJuIG1ha2VfaGFz
aF90YWJsZSAoaGFzaHRlc3RfZXF1YWwsIERFRkFVTFRfSEFTSF9TSVpFLAogCQkJICBERUZBVUxU
X1JFSEFTSF9TSVpFLCBERUZBVUxUX1JFSEFTSF9USFJFU0hPTEQsCi0JCQkgIFFuaWwsIGZhbHNl
KTsKKwkJCSAgUW5pbCk7CiB9CiAKIHN0YXRpYyB2b2lkCmRpZmYgLS1naXQgYS9zcmMvaW50ZXJ2
YWxzLmMgYi9zcmMvaW50ZXJ2YWxzLmMKaW5kZXggZjg4YTQxZjI1NDkxNy4uNWI2OWFmMjQ0OWE2
OCAxMDA2NDQKLS0tIGEvc3JjL2ludGVydmFscy5jCisrKyBiL3NyYy9pbnRlcnZhbHMuYwpAQCAt
NDQsNyArNDQsNiBAQAogI2luY2x1ZGUgImxpc3AuaCIKICNpbmNsdWRlICJpbnRlcnZhbHMuaCIK
ICNpbmNsdWRlICJidWZmZXIuaCIKLSNpbmNsdWRlICJwdXJlc2l6ZS5oIgogI2luY2x1ZGUgImtl
eW1hcC5oIgogCiAvKiBUZXN0IGZvciBtZW1iZXJzaGlwLCBhbGxvd2luZyBmb3IgdCAoYWN0dWFs
bHkgYW55IG5vbi1jb25zKSB0byBtZWFuIHRoZQpAQCAtMTAxLDcgKzEwMCw2IEBAIGNyZWF0ZV9y
b290X2ludGVydmFsIChMaXNwX09iamVjdCBwYXJlbnQpCiAgICAgfQogICBlbHNlCiAgICAgewot
ICAgICAgQ0hFQ0tfSU1QVVJFIChwYXJlbnQsIFhTVFJJTkcgKHBhcmVudCkpOwogICAgICAgbmV3
LT50b3RhbF9sZW5ndGggPSBTQ0hBUlMgKHBhcmVudCk7CiAgICAgICBlYXNzZXJ0IChUT1RBTF9M
RU5HVEggKG5ldykgPj0gMCk7CiAgICAgICBzZXRfc3RyaW5nX2ludGVydmFscyAocGFyZW50LCBu
ZXcpOwpkaWZmIC0tZ2l0IGEvc3JjL2pzb24uYyBiL3NyYy9qc29uLmMKaW5kZXggM2YxZDI3YWQ3
ZmI3Zi4uY2NiMDQwNWM0ZTA2OSAxMDA2NDQKLS0tIGEvc3JjL2pzb24uYworKysgYi9zcmMvanNv
bi5jCkBAIC0xMTEwLDggKzExMTAsOCBAQCBkZWZpbmVfZXJyb3IgKExpc3BfT2JqZWN0IG5hbWUs
IGNvbnN0IGNoYXIgKm1lc3NhZ2UsIExpc3BfT2JqZWN0IHBhcmVudCkKICAgZWFzc2VydCAoQ09O
U1AgKHBhcmVudF9jb25kaXRpb25zKSk7CiAgIGVhc3NlcnQgKCFOSUxQIChGbWVtcSAocGFyZW50
LCBwYXJlbnRfY29uZGl0aW9ucykpKTsKICAgZWFzc2VydCAoTklMUCAoRm1lbXEgKG5hbWUsIHBh
cmVudF9jb25kaXRpb25zKSkpOwotICBGcHV0IChuYW1lLCBRZXJyb3JfY29uZGl0aW9ucywgcHVy
ZV9jb25zIChuYW1lLCBwYXJlbnRfY29uZGl0aW9ucykpOwotICBGcHV0IChuYW1lLCBRZXJyb3Jf
bWVzc2FnZSwgYnVpbGRfcHVyZV9jX3N0cmluZyAobWVzc2FnZSkpOworICBGcHV0IChuYW1lLCBR
ZXJyb3JfY29uZGl0aW9ucywgRmNvbnMgKG5hbWUsIHBhcmVudF9jb25kaXRpb25zKSk7CisgIEZw
dXQgKG5hbWUsIFFlcnJvcl9tZXNzYWdlLCBidWlsZF9zdHJpbmcgKG1lc3NhZ2UpKTsKIH0KIAog
dm9pZApkaWZmIC0tZ2l0IGEvc3JjL2tleWJvYXJkLmMgYi9zcmMva2V5Ym9hcmQuYwppbmRleCA5
ZWU0YzRmNmQ2ODM5Li4xYzg2MmExNTc1OWFmIDEwMDY0NAotLS0gYS9zcmMva2V5Ym9hcmQuYwor
KysgYi9zcmMva2V5Ym9hcmQuYwpAQCAtMTEwOSw4ICsxMTA5LDYgQEAgdG9wX2xldmVsXzEgKExp
c3BfT2JqZWN0IGlnbm9yZSkKICAgLyogT24gZW50cnkgdG8gdGhlIG91dGVyIGxldmVsLCBydW4g
dGhlIHN0YXJ0dXAgZmlsZS4gICovCiAgIGlmICghTklMUCAoVnRvcF9sZXZlbCkpCiAgICAgaW50
ZXJuYWxfY29uZGl0aW9uX2Nhc2UgKHRvcF9sZXZlbF8yLCBRZXJyb3IsIGNtZF9lcnJvcik7Ci0g
IGVsc2UgaWYgKCFOSUxQIChWcHVyaWZ5X2ZsYWcpKQotICAgIG1lc3NhZ2UxICgiQmFyZSBpbXB1
cmUgRW1hY3MgKHN0YW5kYXJkIExpc3AgY29kZSBub3QgbG9hZGVkKSIpOwogICBlbHNlCiAgICAg
bWVzc2FnZTEgKCJCYXJlIEVtYWNzIChzdGFuZGFyZCBMaXNwIGNvZGUgbm90IGxvYWRlZCkiKTsK
ICAgcmV0dXJuIFFuaWw7CkBAIC0xMTQ1OCwxNCArMTE0NTYsMTQgQEAgc3ltc19vZl9rZXlib2Fy
ZCAodm9pZCkKICAgcGVuZGluZ19mdW5jYWxscyA9IFFuaWw7CiAgIHN0YXRpY3BybyAoJnBlbmRp
bmdfZnVuY2FsbHMpOwogCi0gIFZsaXNweV9tb3VzZV9zdGVtID0gYnVpbGRfcHVyZV9jX3N0cmlu
ZyAoIm1vdXNlIik7CisgIFZsaXNweV9tb3VzZV9zdGVtID0gYnVpbGRfc3RyaW5nICgibW91c2Ui
KTsKICAgc3RhdGljcHJvICgmVmxpc3B5X21vdXNlX3N0ZW0pOwogCi0gIHJlZ3VsYXJfdG9wX2xl
dmVsX21lc3NhZ2UgPSBidWlsZF9wdXJlX2Nfc3RyaW5nICgiQmFjayB0byB0b3AgbGV2ZWwiKTsK
KyAgcmVndWxhcl90b3BfbGV2ZWxfbWVzc2FnZSA9IGJ1aWxkX3N0cmluZyAoIkJhY2sgdG8gdG9w
IGxldmVsIik7CiAgIHN0YXRpY3BybyAoJnJlZ3VsYXJfdG9wX2xldmVsX21lc3NhZ2UpOwogI2lm
ZGVmIEhBVkVfU1RBQ0tfT1ZFUkZMT1dfSEFORExJTkcKICAgcmVjb3Zlcl90b3BfbGV2ZWxfbWVz
c2FnZQotICAgID0gYnVpbGRfcHVyZV9jX3N0cmluZyAoIlJlLWVudGVyaW5nIHRvcCBsZXZlbCBh
ZnRlciBDIHN0YWNrIG92ZXJmbG93Iik7CisgICAgPSBidWlsZF9zdHJpbmcgKCJSZS1lbnRlcmlu
ZyB0b3AgbGV2ZWwgYWZ0ZXIgQyBzdGFjayBvdmVyZmxvdyIpOwogICBzdGF0aWNwcm8gKCZyZWNv
dmVyX3RvcF9sZXZlbF9tZXNzYWdlKTsKICNlbmRpZgogICBERUZWQVJfTElTUCAoImludGVybmFs
LS10b3AtbGV2ZWwtbWVzc2FnZSIsIFZpbnRlcm5hbF9fdG9wX2xldmVsX21lc3NhZ2UsCmRpZmYg
LS1naXQgYS9zcmMva2V5bWFwLmMgYi9zcmMva2V5bWFwLmMKaW5kZXggNzgyOTMxZmFkZmY2YS4u
ZGNhNGZjZTliMTNmOCAxMDA2NDQKLS0tIGEvc3JjL2tleW1hcC5jCisrKyBiL3NyYy9rZXltYXAu
YwpAQCAtNTAsNyArNTAsNiBAQAogI2luY2x1ZGUgImtleWJvYXJkLmgiCiAjaW5jbHVkZSAidGVy
bWhvb2tzLmgiCiAjaW5jbHVkZSAiYmxvY2tpbnB1dC5oIgotI2luY2x1ZGUgInB1cmVzaXplLmgi
CiAjaW5jbHVkZSAiaW50ZXJ2YWxzLmgiCiAjaW5jbHVkZSAia2V5bWFwLmgiCiAjaW5jbHVkZSAi
d2luZG93LmgiCkBAIC0xMTcsOCArMTE2LDYgQEAgREVGVU4gKCJtYWtlLXNwYXJzZS1rZXltYXAi
LCBGbWFrZV9zcGFyc2Vfa2V5bWFwLCBTbWFrZV9zcGFyc2Vfa2V5bWFwLCAwLCAxLCAwLAogewog
ICBpZiAoIU5JTFAgKHN0cmluZykpCiAgICAgewotICAgICAgaWYgKCFOSUxQIChWcHVyaWZ5X2Zs
YWcpKQotCXN0cmluZyA9IEZwdXJlY29weSAoc3RyaW5nKTsKICAgICAgIHJldHVybiBsaXN0MiAo
UWtleW1hcCwgc3RyaW5nKTsKICAgICB9CiAgIHJldHVybiBsaXN0MSAoUWtleW1hcCk7CkBAIC0y
OTYsNyArMjkzLDYgQEAgREVGVU4gKCJzZXQta2V5bWFwLXBhcmVudCIsIEZzZXRfa2V5bWFwX3Bh
cmVudCwgU3NldF9rZXltYXBfcGFyZW50LCAyLCAyLCAwLAogCSBJZiB3ZSBjYW1lIHRvIHRoZSBl
bmQsIGFkZCB0aGUgcGFyZW50IGluIFBSRVYuICAqLwogICAgICAgaWYgKCFDT05TUCAobGlzdCkg
fHwgS0VZTUFQUCAobGlzdCkpCiAJewotCSAgQ0hFQ0tfSU1QVVJFIChwcmV2LCBYQ09OUyAocHJl
dikpOwogCSAgWFNFVENEUiAocHJldiwgcGFyZW50KTsKIAkgIHJldHVybiBwYXJlbnQ7CiAJfQpA
QCAtNzM0LDcgKzczMCw3IEBAIHN0b3JlX2luX2tleW1hcCAoTGlzcF9PYmplY3Qga2V5bWFwLCBy
ZWdpc3RlciBMaXNwX09iamVjdCBpZHgsIExpc3BfT2JqZWN0IGRlZikKIAogICAvKiBJZiB3ZSBh
cmUgcHJlcGFyaW5nIHRvIGR1bXAsIGFuZCBERUYgaXMgYSBtZW51IGVsZW1lbnQKICAgICAgd2l0
aCBhIG1lbnUgaXRlbSBpbmRpY2F0b3IsIGNvcHkgaXQgdG8gZW5zdXJlIGl0IGlzIG5vdCBwdXJl
LiAgKi8KLSAgaWYgKENPTlNQIChkZWYpICYmIFBVUkVfUCAoWENPTlMgKGRlZikpCisgIGlmIChD
T05TUCAoZGVmKQogICAgICAgJiYgKEVRIChYQ0FSIChkZWYpLCBRbWVudV9pdGVtKSB8fCBTVFJJ
TkdQIChYQ0FSIChkZWYpKSkpCiAgICAgZGVmID0gRmNvbnMgKFhDQVIgKGRlZiksIFhDRFIgKGRl
ZikpOwogCkBAIC03NzgsNyArNzc0LDYgQEAgc3RvcmVfaW5fa2V5bWFwIChMaXNwX09iamVjdCBr
ZXltYXAsIHJlZ2lzdGVyIExpc3BfT2JqZWN0IGlkeCwgTGlzcF9PYmplY3QgZGVmKQogCSAgewog
CSAgICBpZiAoRklYTkFUUCAoaWR4KSAmJiBYRklYTkFUIChpZHgpIDwgQVNJWkUgKGVsdCkpCiAJ
ICAgICAgewotCQlDSEVDS19JTVBVUkUgKGVsdCwgWFZFQ1RPUiAoZWx0KSk7CiAJCUFTRVQgKGVs
dCwgWEZJWE5BVCAoaWR4KSwgZGVmKTsKIAkJcmV0dXJuIGRlZjsKIAkgICAgICB9CkBAIC04MzEs
NyArODI2LDYgQEAgc3RvcmVfaW5fa2V5bWFwIChMaXNwX09iamVjdCBrZXltYXAsIHJlZ2lzdGVy
IExpc3BfT2JqZWN0IGlkeCwgTGlzcF9PYmplY3QgZGVmKQogCSAgICAgIH0KIAkgICAgZWxzZSBp
ZiAoRVEgKGlkeCwgWENBUiAoZWx0KSkpCiAJICAgICAgewotCQlDSEVDS19JTVBVUkUgKGVsdCwg
WENPTlMgKGVsdCkpOwogCQlYU0VUQ0RSIChlbHQsIGRlZik7CiAJCXJldHVybiBkZWY7CiAJICAg
ICAgfQpAQCAtODc3LDcgKzg3MSw2IEBAIHN0b3JlX2luX2tleW1hcCAoTGlzcF9PYmplY3Qga2V5
bWFwLCByZWdpc3RlciBMaXNwX09iamVjdCBpZHgsIExpc3BfT2JqZWN0IGRlZikKIAl9CiAgICAg
ICBlbHNlCiAJZWx0ID0gRmNvbnMgKGlkeCwgZGVmKTsKLSAgICAgIENIRUNLX0lNUFVSRSAoaW5z
ZXJ0aW9uX3BvaW50LCBYQ09OUyAoaW5zZXJ0aW9uX3BvaW50KSk7CiAgICAgICBYU0VUQ0RSIChp
bnNlcnRpb25fcG9pbnQsIEZjb25zIChlbHQsIFhDRFIgKGluc2VydGlvbl9wb2ludCkpKTsKICAg
ICB9CiAgIH0KQEAgLTMxMjEsMTIgKzMxMTQsMTIgQEAgc3ltc19vZl9rZXltYXAgKHZvaWQpCiAg
IGN1cnJlbnRfZ2xvYmFsX21hcCA9IFFuaWw7CiAgIHN0YXRpY3BybyAoJmN1cnJlbnRfZ2xvYmFs
X21hcCk7CiAKLSAgZXhjbHVkZV9rZXlzID0gcHVyZV9saXN0Ci0gICAgKHB1cmVfY29ucyAoYnVp
bGRfcHVyZV9jX3N0cmluZyAoIkRFTCIpLCBidWlsZF9wdXJlX2Nfc3RyaW5nICgiXFxkIikpLAot
ICAgICBwdXJlX2NvbnMgKGJ1aWxkX3B1cmVfY19zdHJpbmcgKCJUQUIiKSwgYnVpbGRfcHVyZV9j
X3N0cmluZyAoIlxcdCIpKSwKLSAgICAgcHVyZV9jb25zIChidWlsZF9wdXJlX2Nfc3RyaW5nICgi
UkVUIiksIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCJcXHIiKSksCi0gICAgIHB1cmVfY29ucyAoYnVp
bGRfcHVyZV9jX3N0cmluZyAoIkVTQyIpLCBidWlsZF9wdXJlX2Nfc3RyaW5nICgiXFxlIikpLAot
ICAgICBwdXJlX2NvbnMgKGJ1aWxkX3B1cmVfY19zdHJpbmcgKCJTUEMiKSwgYnVpbGRfcHVyZV9j
X3N0cmluZyAoIiAiKSkpOworICBleGNsdWRlX2tleXMgPSBsaXN0CisgICAgKEZjb25zIChidWls
ZF9zdHJpbmcgKCJERUwiKSwgYnVpbGRfc3RyaW5nICgiXFxkIikpLAorICAgICBGY29ucyAoYnVp
bGRfc3RyaW5nICgiVEFCIiksIGJ1aWxkX3N0cmluZyAoIlxcdCIpKSwKKyAgICAgRmNvbnMgKGJ1
aWxkX3N0cmluZyAoIlJFVCIpLCBidWlsZF9zdHJpbmcgKCJcXHIiKSksCisgICAgIEZjb25zIChi
dWlsZF9zdHJpbmcgKCJFU0MiKSwgYnVpbGRfc3RyaW5nICgiXFxlIikpLAorICAgICBGY29ucyAo
YnVpbGRfc3RyaW5nICgiU1BDIiksIGJ1aWxkX3N0cmluZyAoIiAiKSkpOwogICBzdGF0aWNwcm8g
KCZleGNsdWRlX2tleXMpOwogCiAgIERFRlZBUl9MSVNQICgibWluaWJ1ZmZlci1sb2NhbC1tYXAi
LCBWbWluaWJ1ZmZlcl9sb2NhbF9tYXAsCkBAIC0zMTc2LDEzICszMTY5LDEyIEBAIHN5bXNfb2Zf
a2V5bWFwICh2b2lkKQogICBERUZTWU0gKFFtb2RlX2xpbmUsICJtb2RlLWxpbmUiKTsKIAogICBz
dGF0aWNwcm8gKCZWbW91c2VfZXZlbnRzKTsKLSAgVm1vdXNlX2V2ZW50cyA9IHB1cmVfbGlzdCAo
UW1lbnVfYmFyLCBRdGFiX2JhciwgUXRvb2xfYmFyLAotCQkJICAgICBRdGFiX2xpbmUsIFFoZWFk
ZXJfbGluZSwgUW1vZGVfbGluZSwKLQkJCSAgICAgaW50ZXJuX2Nfc3RyaW5nICgibW91c2UtMSIp
LAotCQkJICAgICBpbnRlcm5fY19zdHJpbmcgKCJtb3VzZS0yIiksCi0JCQkgICAgIGludGVybl9j
X3N0cmluZyAoIm1vdXNlLTMiKSwKLQkJCSAgICAgaW50ZXJuX2Nfc3RyaW5nICgibW91c2UtNCIp
LAotCQkJICAgICBpbnRlcm5fY19zdHJpbmcgKCJtb3VzZS01IikpOworICBWbW91c2VfZXZlbnRz
ID0gbGlzdCAoUW1lbnVfYmFyLCBRdG9vbF9iYXIsIFFoZWFkZXJfbGluZSwgUW1vZGVfbGluZSwK
KwkJCWludGVybl9jX3N0cmluZyAoIm1vdXNlLTEiKSwKKwkJCWludGVybl9jX3N0cmluZyAoIm1v
dXNlLTIiKSwKKwkJCWludGVybl9jX3N0cmluZyAoIm1vdXNlLTMiKSwKKwkJCWludGVybl9jX3N0
cmluZyAoIm1vdXNlLTQiKSwKKwkJCWludGVybl9jX3N0cmluZyAoIm1vdXNlLTUiKSk7CiAKICAg
LyogS2V5bWFwIHVzZWQgZm9yIG1pbmlidWZmZXJzIHdoZW4gZG9pbmcgY29tcGxldGlvbi4gICov
CiAgIC8qIEtleW1hcCB1c2VkIGZvciBtaW5pYnVmZmVycyB3aGVuIGRvaW5nIGNvbXBsZXRpb24g
YW5kIHJlcXVpcmUgYSBtYXRjaC4gICovCmRpZmYgLS1naXQgYS9zcmMvbGlzcC5oIGIvc3JjL2xp
c3AuaAppbmRleCBiOTVmMzg5Yjg5MDI0Li43NTgwMjcyZTVjN2YzIDEwMDY0NAotLS0gYS9zcmMv
bGlzcC5oCisrKyBiL3NyYy9saXNwLmgKQEAgLTgyMyw5ICs4MjMsNiBAQCAjZGVmaW5lIFhVTlRB
RyhhLCB0eXBlLCBjdHlwZSkgKChjdHlwZSAqKSBcCiAJIHNwZWNpYWwgKHdpdGggYGRlZnZhcicg
ZXRjKSwgYW5kIHNob3VsZG4ndCBiZSBsZXhpY2FsbHkgYm91bmQuICAqLwogICAgICAgYm9vbF9i
ZiBkZWNsYXJlZF9zcGVjaWFsIDogMTsKIAotICAgICAgLyogVHJ1ZSBpZiBwb2ludGVkIHRvIGZy
b20gcHVyZXNwYWNlIGFuZCBoZW5jZSBjYW4ndCBiZSBHQydkLiAgKi8KLSAgICAgIGJvb2xfYmYg
cGlubmVkIDogMTsKLQogICAgICAgLyogVGhlIHN5bWJvbCdzIG5hbWUsIGFzIGEgTGlzcCBzdHJp
bmcuICAqLwogICAgICAgTGlzcF9PYmplY3QgbmFtZTsKIApAQCAtMTUzNCwyMCArMTUzMSwxNCBA
QCAjZGVmaW5lIFNUUklOR19CWVRFU19CT1VORCAgXAogLyogTWFyayBTVFIgYXMgYSB1bmlieXRl
IHN0cmluZy4gICovCiAjZGVmaW5lIFNUUklOR19TRVRfVU5JQllURShTVFIpCQkJCVwKICAgZG8g
ewkJCQkJCQlcCi0gICAgaWYgKFhTVFJJTkcgKFNUUiktPnUucy5zaXplID09IDApCQkJXAotICAg
ICAgKFNUUikgPSBlbXB0eV91bmlieXRlX3N0cmluZzsJCQlcCi0gICAgZWxzZQkJCQkJCVwKLSAg
ICAgIFhTVFJJTkcgKFNUUiktPnUucy5zaXplX2J5dGUgPSAtMTsJCVwKKyAgICBYU1RSSU5HIChT
VFIpLT51LnMuc2l6ZV9ieXRlID0gLTE7CQkJXAogICB9IHdoaWxlIChmYWxzZSkKIAogLyogTWFy
ayBTVFIgYXMgYSBtdWx0aWJ5dGUgc3RyaW5nLiAgQXNzdXJlIHRoYXQgU1RSIGNvbnRhaW5zIG9u
bHkKICAgIEFTQ0lJIGNoYXJhY3RlcnMgaW4gYWR2YW5jZS4gICovCi0jZGVmaW5lIFNUUklOR19T
RVRfTVVMVElCWVRFKFNUUikJCQlcCi0gIGRvIHsJCQkJCQkJXAotICAgIGlmIChYU1RSSU5HIChT
VFIpLT51LnMuc2l6ZSA9PSAwKQkJCVwKLSAgICAgIChTVFIpID0gZW1wdHlfbXVsdGlieXRlX3N0
cmluZzsJCQlcCi0gICAgZWxzZQkJCQkJCVwKLSAgICAgIFhTVFJJTkcgKFNUUiktPnUucy5zaXpl
X2J5dGUgPSBYU1RSSU5HIChTVFIpLT51LnMuc2l6ZTsgXAorI2RlZmluZSBTVFJJTkdfU0VUX01V
TFRJQllURShTVFIpCQkJCVwKKyAgZG8gewkJCQkJCQkJXAorICAgIFhTVFJJTkcgKFNUUiktPnUu
cy5zaXplX2J5dGUgPSBYU1RSSU5HIChTVFIpLT51LnMuc2l6ZTsJXAogICB9IHdoaWxlIChmYWxz
ZSkKIAogLyogQ29udmVuaWVuY2UgZnVuY3Rpb25zIGZvciBkZWFsaW5nIHdpdGggTGlzcCBzdHJp
bmdzLiAgKi8KQEAgLTIzMDEsMTIgKzIyOTIsOCBAQCAjZGVmaW5lIERFRlNZTShzeW0sIG5hbWUp
IC8qIGVtcHR5ICovCiAgIC8qIEluZGV4IG9mIGZpcnN0IGZyZWUgZW50cnkgaW4gZnJlZSBsaXN0
LCBvciAtMSBpZiBub25lLiAgKi8KICAgcHRyZGlmZl90IG5leHRfZnJlZTsKIAotICAvKiBUcnVl
IGlmIHRoZSB0YWJsZSBjYW4gYmUgcHVyZWNvcGllZC4gIFRoZSB0YWJsZSBjYW5ub3QgYmUKLSAg
ICAgY2hhbmdlZCBhZnRlcndhcmRzLiAgKi8KLSAgYm9vbCBwdXJlY29weTsKLQogICAvKiBUcnVl
IGlmIHRoZSB0YWJsZSBpcyBtdXRhYmxlLiAgT3JkaW5hcmlseSB0YWJsZXMgYXJlIG11dGFibGUs
IGJ1dAotICAgICBwdXJlIHRhYmxlcyBhcmUgbm90LCBhbmQgd2hpbGUgYSB0YWJsZSBpcyBiZWlu
ZyBtdXRhdGVkIGl0IGlzCisgICAgIHNvbWUgdGFibGVzIGFyZSBub3QsIGFuZCB3aGlsZSBhIHRh
YmxlIGlzIGJlaW5nIG11dGF0ZWQgaXQgaXMKICAgICAgaW1tdXRhYmxlIGZvciByZWN1cnNpdmUg
YXR0ZW1wdHMgdG8gbXV0YXRlIGl0LiAgKi8KICAgYm9vbCBtdXRhYmxlOwogCkBAIC0zNTk5LDcg
KzM1ODYsNyBAQCAjZGVmaW5lIENPTlNfVE9fSU5URUdFUihjb25zLCB0eXBlLCB2YXIpCQkJCVwK
IExpc3BfT2JqZWN0IGhhc2hmbl9lcXVhbCAoTGlzcF9PYmplY3QsIHN0cnVjdCBMaXNwX0hhc2hf
VGFibGUgKik7CiBMaXNwX09iamVjdCBoYXNoZm5fdXNlcl9kZWZpbmVkIChMaXNwX09iamVjdCwg
c3RydWN0IExpc3BfSGFzaF9UYWJsZSAqKTsKIExpc3BfT2JqZWN0IG1ha2VfaGFzaF90YWJsZSAo
c3RydWN0IGhhc2hfdGFibGVfdGVzdCwgRU1BQ1NfSU5ULCBmbG9hdCwgZmxvYXQsCi0gICAgICAg
ICAgICAgICAgICAgICAgICAgICAgIExpc3BfT2JqZWN0LCBib29sKTsKKyAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgTGlzcF9PYmplY3QpOwogcHRyZGlmZl90IGhhc2hfbG9va3VwIChzdHJ1
Y3QgTGlzcF9IYXNoX1RhYmxlICosIExpc3BfT2JqZWN0LCBMaXNwX09iamVjdCAqKTsKIHB0cmRp
ZmZfdCBoYXNoX3B1dCAoc3RydWN0IExpc3BfSGFzaF9UYWJsZSAqLCBMaXNwX09iamVjdCwgTGlz
cF9PYmplY3QsCiAJCSAgICBMaXNwX09iamVjdCk7CkBAIC0zNzU1LDcgKzM3NDIsNiBAQCB2ZXJp
ZnkgKEZMVF9SQURJWCA9PSAyIHx8IEZMVF9SQURJWCA9PSAxNik7CiAKIC8qIERlZmluZWQgaW4g
YWxsb2MuYy4gICovCiBleHRlcm4gdm9pZCAqbXlfaGVhcF9zdGFydCAodm9pZCk7Ci1leHRlcm4g
dm9pZCBjaGVja19wdXJlX3NpemUgKHZvaWQpOwogdW5zaWduZWQgY2hhciAqcmVzaXplX3N0cmlu
Z19kYXRhIChMaXNwX09iamVjdCwgcHRyZGlmZl90LCBpbnQsIGludCk7CiBleHRlcm4gdm9pZCBt
YWxsb2Nfd2FybmluZyAoY29uc3QgY2hhciAqKTsKIGV4dGVybiBBVk9JRCBtZW1vcnlfZnVsbCAo
c2l6ZV90KTsKQEAgLTM4MTMsMTEgKzM3OTksOCBAQCBmbHVzaF9zdGFja19jYWxsX2Z1bmMgKHZv
aWQgKCpmdW5jKSAodm9pZCAqYXJnKSwgdm9pZCAqYXJnKQogZXh0ZXJuIExpc3BfT2JqZWN0IGxp
c3Q1IChMaXNwX09iamVjdCwgTGlzcF9PYmplY3QsIExpc3BfT2JqZWN0LCBMaXNwX09iamVjdCwK
IAkJCSAgTGlzcF9PYmplY3QpOwogZXh0ZXJuIExpc3BfT2JqZWN0IGxpc3RuIChwdHJkaWZmX3Qs
IExpc3BfT2JqZWN0LCAuLi4pOwotZXh0ZXJuIExpc3BfT2JqZWN0IHB1cmVfbGlzdG4gKHB0cmRp
ZmZfdCwgTGlzcF9PYmplY3QsIC4uLik7CiAjZGVmaW5lIGxpc3QoLi4uKSBcCiAgIGxpc3RuIChB
UlJBWUVMVFMgKCgoTGlzcF9PYmplY3QgW10pIHtfX1ZBX0FSR1NfX30pKSwgX19WQV9BUkdTX18p
Ci0jZGVmaW5lIHB1cmVfbGlzdCguLi4pIFwKLSAgcHVyZV9saXN0biAoQVJSQVlFTFRTICgoKExp
c3BfT2JqZWN0IFtdKSB7X19WQV9BUkdTX199KSksIF9fVkFfQVJHU19fKQogCiBlbnVtIGdjX3Jv
b3RfdHlwZQogewpAQCAtMzg5MCwxNyArMzg3Myw2IEBAIGJ1aWxkX3VuaWJ5dGVfc3RyaW5nIChj
b25zdCBjaGFyICpzdHIpCiBleHRlcm4gTGlzcF9PYmplY3QgbWFrZV9zdHJpbmdfZnJvbV9ieXRl
cyAoY29uc3QgY2hhciAqLCBwdHJkaWZmX3QsIHB0cmRpZmZfdCk7CiBleHRlcm4gTGlzcF9PYmpl
Y3QgbWFrZV9zcGVjaWZpZWRfc3RyaW5nIChjb25zdCBjaGFyICosCiAJCQkJCSAgcHRyZGlmZl90
LCBwdHJkaWZmX3QsIGJvb2wpOwotZXh0ZXJuIExpc3BfT2JqZWN0IG1ha2VfcHVyZV9zdHJpbmcg
KGNvbnN0IGNoYXIgKiwgcHRyZGlmZl90LCBwdHJkaWZmX3QsIGJvb2wpOwotZXh0ZXJuIExpc3Bf
T2JqZWN0IG1ha2VfcHVyZV9jX3N0cmluZyAoY29uc3QgY2hhciAqLCBwdHJkaWZmX3QpOwotCi0v
KiBNYWtlIGEgc3RyaW5nIGFsbG9jYXRlZCBpbiBwdXJlIHNwYWNlLCB1c2UgU1RSIGFzIHN0cmlu
ZyBkYXRhLiAgKi8KLQotSU5MSU5FIExpc3BfT2JqZWN0Ci1idWlsZF9wdXJlX2Nfc3RyaW5nIChj
b25zdCBjaGFyICpzdHIpCi17Ci0gIHJldHVybiBtYWtlX3B1cmVfY19zdHJpbmcgKHN0ciwgc3Ry
bGVuIChzdHIpKTsKLX0KLQogLyogTWFrZSBhIHN0cmluZyBmcm9tIHRoZSBkYXRhIGF0IFNUUiwg
dHJlYXRpbmcgaXQgYXMgbXVsdGlieXRlIGlmIHRoZQogICAgZGF0YSB3YXJyYW50cy4gICovCiAK
QEAgLTM5MTAsNyArMzg4Miw2IEBAIGJ1aWxkX3N0cmluZyAoY29uc3QgY2hhciAqc3RyKQogICBy
ZXR1cm4gbWFrZV9zdHJpbmcgKHN0ciwgc3RybGVuIChzdHIpKTsKIH0KIAotZXh0ZXJuIExpc3Bf
T2JqZWN0IHB1cmVfY29ucyAoTGlzcF9PYmplY3QsIExpc3BfT2JqZWN0KTsKIGV4dGVybiBMaXNw
X09iamVjdCBtYWtlX3ZlY3RvciAocHRyZGlmZl90LCBMaXNwX09iamVjdCk7CiBleHRlcm4gc3Ry
dWN0IExpc3BfVmVjdG9yICphbGxvY2F0ZV9uaWxfdmVjdG9yIChwdHJkaWZmX3QpOwogCmRpZmYg
LS1naXQgYS9zcmMvbHJlYWQuYyBiL3NyYy9scmVhZC5jCmluZGV4IGRlYTFiMjMyZmZmODMuLjAz
M2U5YmE0MWFmMTYgMTAwNjQ0Ci0tLSBhL3NyYy9scmVhZC5jCisrKyBiL3NyYy9scmVhZC5jCkBA
IC0yMDk4LDEzICsyMDk4LDEzIEBAIHJlYWRldmFsbG9vcCAoTGlzcF9PYmplY3QgcmVhZGNoYXJm
dW4sCiAJcmVhZF9vYmplY3RzX21hcAogCSAgPSBtYWtlX2hhc2hfdGFibGUgKGhhc2h0ZXN0X2Vx
LCBERUZBVUxUX0hBU0hfU0laRSwKIAkJCSAgICAgREVGQVVMVF9SRUhBU0hfU0laRSwgREVGQVVM
VF9SRUhBU0hfVEhSRVNIT0xELAotCQkJICAgICBRbmlsLCBmYWxzZSk7CisJCQkgICAgIFFuaWwp
OwogICAgICAgaWYgKCEgSEFTSF9UQUJMRV9QIChyZWFkX29iamVjdHNfY29tcGxldGVkKQogCSAg
fHwgWEhBU0hfVEFCTEUgKHJlYWRfb2JqZWN0c19jb21wbGV0ZWQpLT5jb3VudCkKIAlyZWFkX29i
amVjdHNfY29tcGxldGVkCiAJICA9IG1ha2VfaGFzaF90YWJsZSAoaGFzaHRlc3RfZXEsIERFRkFV
TFRfSEFTSF9TSVpFLAogCQkJICAgICBERUZBVUxUX1JFSEFTSF9TSVpFLCBERUZBVUxUX1JFSEFT
SF9USFJFU0hPTEQsCi0JCQkgICAgIFFuaWwsIGZhbHNlKTsKKwkJCSAgICAgUW5pbCk7CiAgICAg
ICBpZiAoIU5JTFAgKFZwdXJpZnlfZmxhZykgJiYgYyA9PSAnKCcpCiAJewogCSAgdmFsID0gcmVh
ZF9saXN0ICgwLCByZWFkY2hhcmZ1bik7CkBAIC0yMzIxLDEyICsyMzIxLDEyIEBAIHJlYWRfaW50
ZXJuYWxfc3RhcnQgKExpc3BfT2JqZWN0IHN0cmVhbSwgTGlzcF9PYmplY3Qgc3RhcnQsIExpc3Bf
T2JqZWN0IGVuZCkKICAgICAgIHx8IFhIQVNIX1RBQkxFIChyZWFkX29iamVjdHNfbWFwKS0+Y291
bnQpCiAgICAgcmVhZF9vYmplY3RzX21hcAogICAgICAgPSBtYWtlX2hhc2hfdGFibGUgKGhhc2h0
ZXN0X2VxLCBERUZBVUxUX0hBU0hfU0laRSwgREVGQVVMVF9SRUhBU0hfU0laRSwKLQkJCSBERUZB
VUxUX1JFSEFTSF9USFJFU0hPTEQsIFFuaWwsIGZhbHNlKTsKKwkJCSBERUZBVUxUX1JFSEFTSF9U
SFJFU0hPTEQsIFFuaWwpOwogICBpZiAoISBIQVNIX1RBQkxFX1AgKHJlYWRfb2JqZWN0c19jb21w
bGV0ZWQpCiAgICAgICB8fCBYSEFTSF9UQUJMRSAocmVhZF9vYmplY3RzX2NvbXBsZXRlZCktPmNv
dW50KQogICAgIHJlYWRfb2JqZWN0c19jb21wbGV0ZWQKICAgICAgID0gbWFrZV9oYXNoX3RhYmxl
IChoYXNodGVzdF9lcSwgREVGQVVMVF9IQVNIX1NJWkUsIERFRkFVTFRfUkVIQVNIX1NJWkUsCi0J
CQkgREVGQVVMVF9SRUhBU0hfVEhSRVNIT0xELCBRbmlsLCBmYWxzZSk7CisJCQkgREVGQVVMVF9S
RUhBU0hfVEhSRVNIT0xELCBRbmlsKTsKICAgaWYgKEVRIChWcmVhZF93aXRoX3N5bWJvbF9wb3Np
dGlvbnMsIFF0KQogICAgICAgfHwgRVEgKFZyZWFkX3dpdGhfc3ltYm9sX3Bvc2l0aW9ucywgc3Ry
ZWFtKSkKICAgICBWcmVhZF9zeW1ib2xfcG9zaXRpb25zX2xpc3QgPSBRbmlsOwpAQCAtMjg5Niwx
MSArMjg5Niw2IEBAIHJlYWQxIChMaXNwX09iamVjdCByZWFkY2hhcmZ1biwgaW50ICpwY2gsIGJv
b2wgZmlyc3RfaW5fbGlzdCkKIAkgICAgICBpZiAoIU5JTFAgKHBhcmFtc1twYXJhbV9jb3VudCAr
IDFdKSkKIAkJcGFyYW1fY291bnQgKz0gMjsKIAotICAgICAgICAgICAgICBwYXJhbXNbcGFyYW1f
Y291bnRdID0gUUNwdXJlY29weTsKLSAgICAgICAgICAgICAgcGFyYW1zW3BhcmFtX2NvdW50ICsg
MV0gPSBGcGxpc3RfZ2V0ICh0bXAsIFFwdXJlY29weSk7Ci0gICAgICAgICAgICAgIGlmICghTklM
UCAocGFyYW1zW3BhcmFtX2NvdW50ICsgMV0pKQotICAgICAgICAgICAgICAgIHBhcmFtX2NvdW50
ICs9IDI7Ci0KIAkgICAgICAvKiBUaGlzIGlzIHRoZSBoYXNoIHRhYmxlIGRhdGEuICAqLwogCSAg
ICAgIGRhdGEgPSBGcGxpc3RfZ2V0ICh0bXAsIFFkYXRhKTsKIApAQCAtMzIxMCwxMyArMzIwNSwx
MyBAQCByZWFkMSAoTGlzcF9PYmplY3QgcmVhZGNoYXJmdW4sIGludCAqcGNoLCBib29sIGZpcnN0
X2luX2xpc3QpCiAJICAgICAgLyogTm8gc3ltYm9sIGNoYXJhY3RlciBmb2xsb3dzLCB0aGlzIGlz
IHRoZSBlbXB0eQogCQkgc3ltYm9sLiAgKi8KIAkgICAgICBVTlJFQUQgKGMpOwotCSAgICAgIHJl
dHVybiBGbWFrZV9zeW1ib2wgKGVtcHR5X3VuaWJ5dGVfc3RyaW5nKTsKKwkgICAgICByZXR1cm4g
Rm1ha2Vfc3ltYm9sIChidWlsZF9zdHJpbmcgKCIiKSk7CiAJICAgIH0KIAkgIGdvdG8gcmVhZF9z
eW1ib2w7CiAJfQogICAgICAgLyogIyMgaXMgdGhlIGVtcHR5IHN5bWJvbC4gICovCiAgICAgICBp
ZiAoYyA9PSAnIycpCi0JcmV0dXJuIEZpbnRlcm4gKGVtcHR5X3VuaWJ5dGVfc3RyaW5nLCBRbmls
KTsKKwlyZXR1cm4gRmludGVybiAoYnVpbGRfc3RyaW5nICgiIiksIFFuaWwpOwogCiAgICAgICBp
ZiAoYyA+PSAnMCcgJiYgYyA8PSAnOScpCiAJewpAQCAtMzYxMiw5ICszNjA3LDggQEAgcmVhZDEg
KExpc3BfT2JqZWN0IHJlYWRjaGFyZnVuLCBpbnQgKnBjaCwgYm9vbCBmaXJzdF9pbl9saXN0KQog
CSAgaWYgKHVuaW50ZXJuZWRfc3ltYm9sKQogCSAgICB7CiAJICAgICAgTGlzcF9PYmplY3QgbmFt
ZQotCQk9ICgoISBOSUxQIChWcHVyaWZ5X2ZsYWcpCi0JCSAgICA/IG1ha2VfcHVyZV9zdHJpbmcg
OiBtYWtlX3NwZWNpZmllZF9zdHJpbmcpCi0JCSAgIChyZWFkX2J1ZmZlciwgbmNoYXJzLCBuYnl0
ZXMsIG11bHRpYnl0ZSkpOworCQk9IG1ha2Vfc3BlY2lmaWVkX3N0cmluZyAocmVhZF9idWZmZXIs
IG5jaGFycywgbmJ5dGVzLAorCQkJCQkgbXVsdGlieXRlKTsKIAkgICAgICByZXN1bHQgPSBGbWFr
ZV9zeW1ib2wgKG5hbWUpOwogCSAgICB9CiAJICBlbHNlCkBAIC00MjA0LDEwICs0MTk4LDggQEAg
aW50ZXJuX2Nfc3RyaW5nXzEgKGNvbnN0IGNoYXIgKnN0ciwgcHRyZGlmZl90IGxlbikKIAogICBp
ZiAoIVNZTUJPTFAgKHRlbSkpCiAgICAgewotICAgICAgLyogQ3JlYXRpbmcgYSBub24tcHVyZSBz
dHJpbmcgZnJvbSBhIHN0cmluZyBsaXRlcmFsIG5vdCBpbXBsZW1lbnRlZCB5ZXQuCi0JIFdlIGNv
dWxkIGp1c3QgdXNlIG1ha2Vfc3RyaW5nIGhlcmUgYW5kIGxpdmUgd2l0aCB0aGUgZXh0cmEgY29w
eS4gICovCiAgICAgICBlYXNzZXJ0ICghTklMUCAoVnB1cmlmeV9mbGFnKSk7Ci0gICAgICB0ZW0g
PSBpbnRlcm5fZHJpdmVyIChtYWtlX3B1cmVfY19zdHJpbmcgKHN0ciwgbGVuKSwgb2JhcnJheSwg
dGVtKTsKKyAgICAgIHRlbSA9IGludGVybl9kcml2ZXIgKG1ha2Vfc3RyaW5nIChzdHIsIGxlbiks
IG9iYXJyYXksIHRlbSk7CiAgICAgfQogICByZXR1cm4gdGVtOwogfQpAQCAtNDIxNiw3ICs0MjA4
LDcgQEAgaW50ZXJuX2Nfc3RyaW5nXzEgKGNvbnN0IGNoYXIgKnN0ciwgcHRyZGlmZl90IGxlbikK
IGRlZmluZV9zeW1ib2wgKExpc3BfT2JqZWN0IHN5bSwgY2hhciBjb25zdCAqc3RyKQogewogICBw
dHJkaWZmX3QgbGVuID0gc3RybGVuIChzdHIpOwotICBMaXNwX09iamVjdCBzdHJpbmcgPSBtYWtl
X3B1cmVfY19zdHJpbmcgKHN0ciwgbGVuKTsKKyAgTGlzcF9PYmplY3Qgc3RyaW5nID0gbWFrZV9z
dHJpbmcgKHN0ciwgbGVuKTsKICAgaW5pdF9zeW1ib2wgKHN5bSwgc3RyaW5nKTsKIAogICAvKiBR
dW5ib3VuZCBpcyB1bmludGVybmVkLCBzbyB0aGF0IGl0J3Mgbm90IGNvbmZ1c2VkIHdpdGggYW55
IHN5bWJvbApAQCAtNDI0Myw4ICs0MjM1LDcgQEAgREVGVU4gKCJpbnRlcm4iLCBGaW50ZXJuLCBT
aW50ZXJuLCAxLCAyLCAwLAogCiAgIHRlbSA9IG9ibG9va3VwIChvYmFycmF5LCBTU0RBVEEgKHN0
cmluZyksIFNDSEFSUyAoc3RyaW5nKSwgU0JZVEVTIChzdHJpbmcpKTsKICAgaWYgKCFTWU1CT0xQ
ICh0ZW0pKQotICAgIHRlbSA9IGludGVybl9kcml2ZXIgKE5JTFAgKFZwdXJpZnlfZmxhZykgPyBz
dHJpbmcgOiBGcHVyZWNvcHkgKHN0cmluZyksCi0JCQkgb2JhcnJheSwgdGVtKTsKKyAgICB0ZW0g
PSBpbnRlcm5fZHJpdmVyIChzdHJpbmcsIG9iYXJyYXksIHRlbSk7CiAgIHJldHVybiB0ZW07CiB9
CiAKQEAgLTQ4OTMsMjMgKzQ4ODQsMjMgQEAgc3ltc19vZl9scmVhZCAodm9pZCkKIHRvIHRoZSBz
cGVjaWZpZWQgZmlsZSBuYW1lIGlmIGEgc3VmZml4IGlzIGFsbG93ZWQgb3IgcmVxdWlyZWQuICAq
Lyk7CiAjaWZkZWYgSEFWRV9NT0RVTEVTCiAjaWZkZWYgTU9EVUxFU19TRUNPTkRBUllfU1VGRklY
Ci0gIFZsb2FkX3N1ZmZpeGVzID0gbGlzdDQgKGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIuZWxjIiks
Ci0JCQkgIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIuZWwiKSwKLQkJCSAgYnVpbGRfcHVyZV9jX3N0
cmluZyAoTU9EVUxFU19TVUZGSVgpLAotICAgICAgICAgICAgICAgICAgICAgICAgICBidWlsZF9w
dXJlX2Nfc3RyaW5nIChNT0RVTEVTX1NFQ09OREFSWV9TVUZGSVgpKTsKKyAgVmxvYWRfc3VmZml4
ZXMgPSBsaXN0NCAoYnVpbGRfc3RyaW5nICgiLmVsYyIpLAorCQkJICBidWlsZF9zdHJpbmcgKCIu
ZWwiKSwKKwkJCSAgYnVpbGRfc3RyaW5nIChNT0RVTEVTX1NVRkZJWCksCisgICAgICAgICAgICAg
ICAgICAgICAgICAgIGJ1aWxkX3N0cmluZyAoTU9EVUxFU19TRUNPTkRBUllfU1VGRklYKSk7CiAj
ZWxzZQotICBWbG9hZF9zdWZmaXhlcyA9IGxpc3QzIChidWlsZF9wdXJlX2Nfc3RyaW5nICgiLmVs
YyIpLAotCQkJICBidWlsZF9wdXJlX2Nfc3RyaW5nICgiLmVsIiksCi0JCQkgIGJ1aWxkX3B1cmVf
Y19zdHJpbmcgKE1PRFVMRVNfU1VGRklYKSk7CisgIFZsb2FkX3N1ZmZpeGVzID0gbGlzdDMgKGJ1
aWxkX3N0cmluZyAoIi5lbGMiKSwKKwkJCSAgYnVpbGRfc3RyaW5nICgiLmVsIiksCisJCQkgIGJ1
aWxkX3N0cmluZyAoTU9EVUxFU19TVUZGSVgpKTsKICNlbmRpZgogI2Vsc2UKLSAgVmxvYWRfc3Vm
Zml4ZXMgPSBsaXN0MiAoYnVpbGRfcHVyZV9jX3N0cmluZyAoIi5lbGMiKSwKLQkJCSAgYnVpbGRf
cHVyZV9jX3N0cmluZyAoIi5lbCIpKTsKKyAgVmxvYWRfc3VmZml4ZXMgPSBsaXN0MiAoYnVpbGRf
c3RyaW5nICgiLmVsYyIpLAorCQkJICBidWlsZF9zdHJpbmcgKCIuZWwiKSk7CiAjZW5kaWYKICAg
REVGVkFSX0xJU1AgKCJtb2R1bGUtZmlsZS1zdWZmaXgiLCBWbW9kdWxlX2ZpbGVfc3VmZml4LAog
CSAgICAgICBkb2M6IC8qIFN1ZmZpeCBvZiBsb2FkYWJsZSBtb2R1bGUgZmlsZSwgb3IgbmlsIGlm
IG1vZHVsZXMgYXJlIG5vdCBzdXBwb3J0ZWQuICAqLyk7CiAjaWZkZWYgSEFWRV9NT0RVTEVTCi0g
IFZtb2R1bGVfZmlsZV9zdWZmaXggPSBidWlsZF9wdXJlX2Nfc3RyaW5nIChNT0RVTEVTX1NVRkZJ
WCk7CisgIFZtb2R1bGVfZmlsZV9zdWZmaXggPSBidWlsZF9zdHJpbmcgKE1PRFVMRVNfU1VGRklY
KTsKICNlbHNlCiAgIFZtb2R1bGVfZmlsZV9zdWZmaXggPSBRbmlsOwogI2VuZGlmCkBAIC01MDUy
LDcgKzUwNDMsNyBAQCBzeW1zX29mX2xyZWFkICh2b2lkKQogV2hlbiB0aGUgcmVndWxhciBleHBy
ZXNzaW9uIG1hdGNoZXMsIHRoZSBmaWxlIGlzIGNvbnNpZGVyZWQgdG8gYmUgc2FmZQogdG8gbG9h
ZC4gICovKTsKICAgVmJ5dGVjb21wX3ZlcnNpb25fcmVnZXhwCi0gICAgPSBidWlsZF9wdXJlX2Nf
c3RyaW5nICgiXjs7Oy5cXChpbiBFbWFjcyB2ZXJzaW9uXFx8Ynl0ZWNvbXAgdmVyc2lvbiBGU0Zc
XCkiKTsKKyAgICA9IGJ1aWxkX3N0cmluZyAoIl47OzsuXFwoaW4gRW1hY3MgdmVyc2lvblxcfGJ5
dGVjb21wIHZlcnNpb24gRlNGXFwpIik7CiAKICAgREVGU1lNIChRbGV4aWNhbF9iaW5kaW5nLCAi
bGV4aWNhbC1iaW5kaW5nIik7CiAgIERFRlZBUl9MSVNQICgibGV4aWNhbC1iaW5kaW5nIiwgVmxl
eGljYWxfYmluZGluZywKZGlmZiAtLWdpdCBhL3NyYy9wZHVtcGVyLmMgYi9zcmMvcGR1bXBlci5j
CmluZGV4IDMzNzc0MmZkYTRhZGUuLmRkMjQ4NmNkMWEwZTUgMTAwNjQ0Ci0tLSBhL3NyYy9wZHVt
cGVyLmMKKysrIGIvc3JjL3BkdW1wZXIuYwpAQCAtMjQwMyw3ICsyNDAzLDcgQEAgZHVtcF9zeW1i
b2wgKHN0cnVjdCBkdW1wX2NvbnRleHQgKmN0eCwKICAgICAgICAgICAgICBMaXNwX09iamVjdCBv
YmplY3QsCiAgICAgICAgICAgICAgZHVtcF9vZmYgb2Zmc2V0KQogewotI2lmIENIRUNLX1NUUlVD
VFMgJiYgIWRlZmluZWQgSEFTSF9MaXNwX1N5bWJvbF85OTlEQzI2REVDCisjaWYgQ0hFQ0tfU1RS
VUNUUyAmJiAhZGVmaW5lZCBIQVNIX0xpc3BfU3ltYm9sX0REMkU2MDEzQjQKICMgZXJyb3IgIkxp
c3BfU3ltYm9sIGNoYW5nZWQuIFNlZSBDSEVDS19TVFJVQ1RTIGNvbW1lbnQgaW4gY29uZmlnLmgu
IgogI2VuZGlmCiAjaWYgQ0hFQ0tfU1RSVUNUUyAmJiAhZGVmaW5lZCAoSEFTSF9zeW1ib2xfcmVk
aXJlY3RfQURCNEY1QjExMykKQEAgLTI0NDAsNyArMjQ0MCw2IEBAIGR1bXBfc3ltYm9sIChzdHJ1
Y3QgZHVtcF9jb250ZXh0ICpjdHgsCiAgIERVTVBfRklFTERfQ09QWSAoJm91dCwgc3ltYm9sLCB1
LnMudHJhcHBlZF93cml0ZSk7CiAgIERVTVBfRklFTERfQ09QWSAoJm91dCwgc3ltYm9sLCB1LnMu
aW50ZXJuZWQpOwogICBEVU1QX0ZJRUxEX0NPUFkgKCZvdXQsIHN5bWJvbCwgdS5zLmRlY2xhcmVk
X3NwZWNpYWwpOwotICBEVU1QX0ZJRUxEX0NPUFkgKCZvdXQsIHN5bWJvbCwgdS5zLnBpbm5lZCk7
CiAgIGR1bXBfZmllbGRfbHYgKGN0eCwgJm91dCwgc3ltYm9sLCAmc3ltYm9sLT51LnMubmFtZSwg
V0VJR0hUX1NUUk9ORyk7CiAgIHN3aXRjaCAoc3ltYm9sLT51LnMucmVkaXJlY3QpCiAgICAgewpA
QCAtMjY1Nyw3ICsyNjU2LDcgQEAgZHVtcF9oYXNoX3RhYmxlIChzdHJ1Y3QgZHVtcF9jb250ZXh0
ICpjdHgsCiAgICAgICAgICAgICAgICAgIExpc3BfT2JqZWN0IG9iamVjdCwKICAgICAgICAgICAg
ICAgICAgZHVtcF9vZmYgb2Zmc2V0KQogewotI2lmIENIRUNLX1NUUlVDVFMgJiYgIWRlZmluZWQg
SEFTSF9MaXNwX0hhc2hfVGFibGVfNkQ2M0VEQjYxOAorI2lmIENIRUNLX1NUUlVDVFMgJiYgIWRl
ZmluZWQgSEFTSF9MaXNwX0hhc2hfVGFibGVfMjAzODIxQzdFRgogIyBlcnJvciAiTGlzcF9IYXNo
X1RhYmxlIGNoYW5nZWQuIFNlZSBDSEVDS19TVFJVQ1RTIGNvbW1lbnQgaW4gY29uZmlnLmguIgog
I2VuZGlmCiAgIGNvbnN0IHN0cnVjdCBMaXNwX0hhc2hfVGFibGUgKmhhc2hfaW4gPSBYSEFTSF9U
QUJMRSAob2JqZWN0KTsKQEAgLTI2NzMsNyArMjY3Miw2IEBAIGR1bXBfaGFzaF90YWJsZSAoc3Ry
dWN0IGR1bXBfY29udGV4dCAqY3R4LAogICAgICB0aGVtIGFzIGNsb3NlIHRvIHRoZSBoYXNoIHRh
YmxlIGFzIHBvc3NpYmxlLiAgKi8KICAgRFVNUF9GSUVMRF9DT1BZIChvdXQsIGhhc2gsIGNvdW50
KTsKICAgRFVNUF9GSUVMRF9DT1BZIChvdXQsIGhhc2gsIG5leHRfZnJlZSk7Ci0gIERVTVBfRklF
TERfQ09QWSAob3V0LCBoYXNoLCBwdXJlY29weSk7CiAgIERVTVBfRklFTERfQ09QWSAob3V0LCBo
YXNoLCBtdXRhYmxlKTsKICAgRFVNUF9GSUVMRF9DT1BZIChvdXQsIGhhc2gsIHJlaGFzaF90aHJl
c2hvbGQpOwogICBEVU1QX0ZJRUxEX0NPUFkgKG91dCwgaGFzaCwgcmVoYXNoX3NpemUpOwpAQCAt
NTQ2Nyw4ICs1NDY1LDYgQEAgREVGVU4gKCJwZHVtcGVyLXN0YXRzIiwgRnBkdW1wZXJfc3RhdHMs
IFNwZHVtcGVyX3N0YXRzLCAwLCAwLCAwLAogCQlGY29ucyAoUWR1bXBfZmlsZV9uYW1lLCBkdW1w
X2ZuKSk7CiB9CiAKLSNlbmRpZiAvKiBIQVZFX1BEVU1QRVIgKi8KLQogDAogc3RhdGljIHZvaWQK
IHRoYXdfaGFzaF90YWJsZXMgKHZvaWQpCkBAIC01NDgzLDYgKzU0NzksNyBAQCBpbml0X3BkdW1w
ZXJfb25jZSAodm9pZCkKIHsKICAgcGR1bXBlcl9kb19ub3dfYW5kX2FmdGVyX2xvYWQgKHRoYXdf
aGFzaF90YWJsZXMpOwogfQorI2VuZGlmIC8qIEhBVkVfUERVTVBFUiAqLwogCiB2b2lkCiBzeW1z
X29mX3BkdW1wZXIgKHZvaWQpCmRpZmYgLS1naXQgYS9zcmMvcHJpbnQuYyBiL3NyYy9wcmludC5j
CmluZGV4IDE0YWY5MTk1NDc1ZWYuLmRmMDA4Y2YzYjEyOTYgMTAwNjQ0Ci0tLSBhL3NyYy9wcmlu
dC5jCisrKyBiL3NyYy9wcmludC5jCkBAIC0xNTgxLDEyICsxNTgxLDYgQEAgcHJpbnRfdmVjdG9y
bGlrZSAoTGlzcF9PYmplY3Qgb2JqLCBMaXNwX09iamVjdCBwcmludGNoYXJmdW4sIGJvb2wgZXNj
YXBlZmxhZywKIAlwcmludF9vYmplY3QgKEZoYXNoX3RhYmxlX3JlaGFzaF90aHJlc2hvbGQgKG9i
aiksCiAJCSAgICAgIHByaW50Y2hhcmZ1biwgZXNjYXBlZmxhZyk7CiAKLQlpZiAoaC0+cHVyZWNv
cHkpCi0JICB7Ci0JICAgIHByaW50X2Nfc3RyaW5nICgiIHB1cmVjb3B5ICIsIHByaW50Y2hhcmZ1
bik7Ci0JICAgIHByaW50X29iamVjdCAoaC0+cHVyZWNvcHkgPyBRdCA6IFFuaWwsIHByaW50Y2hh
cmZ1biwgZXNjYXBlZmxhZyk7Ci0JICB9Ci0KIAlwcmludF9jX3N0cmluZyAoIiBkYXRhICIsIHBy
aW50Y2hhcmZ1bik7CiAKIAkvKiBQcmludCB0aGUgZGF0YSBoZXJlIGFzIGEgcGxpc3QuICovCmRp
ZmYgLS1naXQgYS9zcmMvcHJvY2Vzcy5jIGIvc3JjL3Byb2Nlc3MuYwppbmRleCBiOThiYzI5N2Ez
ZjNmLi45MGExMTQxYWI2NTY0IDEwMDY0NAotLS0gYS9zcmMvcHJvY2Vzcy5jCisrKyBiL3NyYy9w
cm9jZXNzLmMKQEAgLTg1NjYsNyArODU2Niw3IEBAIHN5bXNfb2ZfcHJvY2VzcyAodm9pZCkKICAg
IGNvbnN0IHN0cnVjdCBzb2NrZXRfb3B0aW9ucyAqc29wdDsKIAogI2RlZmluZSBBRERfU1VCRkVB
VFVSRShrZXksIHZhbCkgXAotICBzdWJmZWF0dXJlcyA9IHB1cmVfY29ucyAocHVyZV9jb25zIChr
ZXksIHB1cmVfY29ucyAodmFsLCBRbmlsKSksIHN1YmZlYXR1cmVzKQorICBzdWJmZWF0dXJlcyA9
IEZjb25zIChGY29ucyAoa2V5LCBGY29ucyAodmFsLCBRbmlsKSksIHN1YmZlYXR1cmVzKQogCiAg
ICBBRERfU1VCRkVBVFVSRSAoUUNub3dhaXQsIFF0KTsKICNpZmRlZiBEQVRBR1JBTV9TT0NLRVRT
CkBAIC04NTg4LDcgKzg1ODgsNyBAQCAjZGVmaW5lIEFERF9TVUJGRUFUVVJFKGtleSwgdmFsKSBc
CiAgICBBRERfU1VCRkVBVFVSRSAoUUNzZXJ2ZXIsIFF0KTsKIAogICAgZm9yIChzb3B0ID0gc29j
a2V0X29wdGlvbnM7IHNvcHQtPm5hbWU7IHNvcHQrKykKLSAgICAgc3ViZmVhdHVyZXMgPSBwdXJl
X2NvbnMgKGludGVybl9jX3N0cmluZyAoc29wdC0+bmFtZSksIHN1YmZlYXR1cmVzKTsKKyAgICAg
c3ViZmVhdHVyZXMgPSBGY29ucyAoaW50ZXJuX2Nfc3RyaW5nIChzb3B0LT5uYW1lKSwgc3ViZmVh
dHVyZXMpOwogCiAgICBGcHJvdmlkZSAoaW50ZXJuX2Nfc3RyaW5nICgibWFrZS1uZXR3b3JrLXBy
b2Nlc3MiKSwgc3ViZmVhdHVyZXMpOwogIH0KZGlmZiAtLWdpdCBhL3NyYy9wcm9maWxlci5jIGIv
c3JjL3Byb2ZpbGVyLmMKaW5kZXggMjFhZTI0NDdhYTRlZS4uNDRiZjU3ZWJhMjA3OCAxMDA2NDQK
LS0tIGEvc3JjL3Byb2ZpbGVyLmMKKysrIGIvc3JjL3Byb2ZpbGVyLmMKQEAgLTYzLDcgKzYzLDcg
QEAgbWFrZV9sb2cgKHZvaWQpCiAgIExpc3BfT2JqZWN0IGxvZyA9IG1ha2VfaGFzaF90YWJsZSAo
aGFzaHRlc3RfcHJvZmlsZXIsIGhlYXBfc2l6ZSwKIAkJCQkgICAgIERFRkFVTFRfUkVIQVNIX1NJ
WkUsCiAJCQkJICAgICBERUZBVUxUX1JFSEFTSF9USFJFU0hPTEQsCi0JCQkJICAgICBRbmlsLCBm
YWxzZSk7CisJCQkJICAgICBRbmlsKTsKICAgc3RydWN0IExpc3BfSGFzaF9UYWJsZSAqaCA9IFhI
QVNIX1RBQkxFIChsb2cpOwogCiAgIC8qIFdoYXQgaXMgc3BlY2lhbCBhYm91dCBvdXIgaGFzaC10
YWJsZXMgaXMgdGhhdCB0aGUgdmFsdWVzIGFyZSBwcmUtZmlsbGVkCmRpZmYgLS1naXQgYS9zcmMv
cHVyZXNpemUuaCBiL3NyYy9wdXJlc2l6ZS5oCmRlbGV0ZWQgZmlsZSBtb2RlIDEwMDY0NAppbmRl
eCA4MTFkMGI0ZDM2OTUyLi4wMDAwMDAwMDAwMDAwCi0tLSBhL3NyYy9wdXJlc2l6ZS5oCisrKyAv
ZGV2L251bGwKQEAgLTEsMTE1ICswLDAgQEAKLS8qIEhvdyBtdWNoIHJlYWQtb25seSBMaXNwIHN0
b3JhZ2UgYSBkdW1wZWQgRW1hY3MgbmVlZHMuCi0gICBDb3B5cmlnaHQgKEMpIDE5OTMsIDIwMDEt
MjAyMSBGcmVlIFNvZnR3YXJlIEZvdW5kYXRpb24sIEluYy4KLQotVGhpcyBmaWxlIGlzIHBhcnQg
b2YgR05VIEVtYWNzLgotCi1HTlUgRW1hY3MgaXMgZnJlZSBzb2Z0d2FyZTogeW91IGNhbiByZWRp
c3RyaWJ1dGUgaXQgYW5kL29yIG1vZGlmeQotaXQgdW5kZXIgdGhlIHRlcm1zIG9mIHRoZSBHTlUg
R2VuZXJhbCBQdWJsaWMgTGljZW5zZSBhcyBwdWJsaXNoZWQgYnkKLXRoZSBGcmVlIFNvZnR3YXJl
IEZvdW5kYXRpb24sIGVpdGhlciB2ZXJzaW9uIDMgb2YgdGhlIExpY2Vuc2UsIG9yIChhdAoteW91
ciBvcHRpb24pIGFueSBsYXRlciB2ZXJzaW9uLgotCi1HTlUgRW1hY3MgaXMgZGlzdHJpYnV0ZWQg
aW4gdGhlIGhvcGUgdGhhdCBpdCB3aWxsIGJlIHVzZWZ1bCwKLWJ1dCBXSVRIT1VUIEFOWSBXQVJS
QU5UWTsgd2l0aG91dCBldmVuIHRoZSBpbXBsaWVkIHdhcnJhbnR5IG9mCi1NRVJDSEFOVEFCSUxJ
VFkgb3IgRklUTkVTUyBGT1IgQSBQQVJUSUNVTEFSIFBVUlBPU0UuICBTZWUgdGhlCi1HTlUgR2Vu
ZXJhbCBQdWJsaWMgTGljZW5zZSBmb3IgbW9yZSBkZXRhaWxzLgotCi1Zb3Ugc2hvdWxkIGhhdmUg
cmVjZWl2ZWQgYSBjb3B5IG9mIHRoZSBHTlUgR2VuZXJhbCBQdWJsaWMgTGljZW5zZQotYWxvbmcg
d2l0aCBHTlUgRW1hY3MuICBJZiBub3QsIHNlZSA8aHR0cHM6Ly93d3cuZ251Lm9yZy9saWNlbnNl
cy8+LiAgKi8KLQotI2lmbmRlZiBFTUFDU19QVVJFU0laRV9ICi0jZGVmaW5lIEVNQUNTX1BVUkVT
SVpFX0gKLQotI2luY2x1ZGUgImxpc3AuaCIKLQotSU5MSU5FX0hFQURFUl9CRUdJTgotCi0vKiBE
ZWZpbmUgUFVSRVNJWkUsIHRoZSBudW1iZXIgb2YgYnl0ZXMgb2YgcHVyZSBMaXNwIGNvZGUgdG8g
bGVhdmUgc3BhY2UgZm9yLgotCi0gICBBdCBvbmUgcG9pbnQsIHRoaXMgd2FzIGRlZmluZWQgaW4g
Y29uZmlnLmgsIG1lYW5pbmcgdGhhdCBjaGFuZ2luZwotICAgUFVSRVNJWkUgd291bGQgbWFrZSBN
YWtlIHJlY29tcGlsZSBhbGwgb2YgRW1hY3MuICBCdXQgb25seSBhIGZldwotICAgZmlsZXMgYWN0
dWFsbHkgdXNlIFBVUkVTSVpFLCBzbyB3ZSBzcGxpdCBpdCBvdXQgdG8gaXRzIG93biAuaCBmaWxl
LgotCi0gICBNYWtlIHN1cmUgdG8gaW5jbHVkZSB0aGlzIGZpbGUgYWZ0ZXIgY29uZmlnLmgsIHNp
bmNlIHRoYXQgdGVsbHMgdXMKLSAgIHdoZXRoZXIgd2UgYXJlIHJ1bm5pbmcgWCB3aW5kb3dzLCB3
aGljaCB0ZWxscyB1cyBob3cgbXVjaCBwdXJlCi0gICBzdG9yYWdlIHRvIGFsbG9jYXRlLiAgKi8K
LQotLyogRmlyc3QgZGVmaW5lIGEgbWVhc3VyZSBvZiB0aGUgYW1vdW50IG9mIGRhdGEgd2UgaGF2
ZS4gICovCi0KLS8qIEEgc3lzdGVtIGNvbmZpZ3VyYXRpb24gZmlsZSBtYXkgc2V0IHRoaXMgdG8g
cmVxdWVzdCBhIGNlcnRhaW4gZXh0cmEKLSAgIGFtb3VudCBvZiBzdG9yYWdlLiAgVGhpcyBpcyBh
IGxvdCBtb3JlIHVwZGF0ZS1yb2J1c3QgdGhhdCBkZWZpbmluZwotICAgQkFTRV9QVVJFU0laRSBv
ciBldmVuIFBVUkVTSVpFIGRpcmVjdGx5LiAgKi8KLSNpZm5kZWYgU1lTVEVNX1BVUkVTSVpFX0VY
VFJBCi0jZGVmaW5lIFNZU1RFTV9QVVJFU0laRV9FWFRSQSAwCi0jZW5kaWYKLQotI2lmbmRlZiBT
SVRFTE9BRF9QVVJFU0laRV9FWFRSQQotI2RlZmluZSBTSVRFTE9BRF9QVVJFU0laRV9FWFRSQSAw
Ci0jZW5kaWYKLQotI2lmbmRlZiBCQVNFX1BVUkVTSVpFCi0jZGVmaW5lIEJBU0VfUFVSRVNJWkUg
KDIwMDAwMDAgKyBTWVNURU1fUFVSRVNJWkVfRVhUUkEgKyBTSVRFTE9BRF9QVVJFU0laRV9FWFRS
QSkKLSNlbmRpZgotCi0vKiBJbmNyZWFzZSBCQVNFX1BVUkVTSVpFIGJ5IGEgcmF0aW8gZGVwZW5k
aW5nIG9uIHRoZSBtYWNoaW5lJ3Mgd29yZCBzaXplLiAgKi8KLSNpZm5kZWYgUFVSRVNJWkVfUkFU
SU8KLSNpZiBFTUFDU19JTlRfTUFYID4+IDMxICE9IDAKLSNpZiBQVFJESUZGX01BWCA+PiAzMSAh
PSAwCi0jZGVmaW5lIFBVUkVTSVpFX1JBVElPIDEwIC8gNgkvKiBEb24ndCBzdXJyb3VuZCB3aXRo
IGAoKScuICAqLwotI2Vsc2UKLSNkZWZpbmUgUFVSRVNJWkVfUkFUSU8gOCAvIDYJLyogRG9uJ3Qg
c3Vycm91bmQgd2l0aCBgKCknLiAgKi8KLSNlbmRpZgotI2Vsc2UKLSNkZWZpbmUgUFVSRVNJWkVf
UkFUSU8gMQotI2VuZGlmCi0jZW5kaWYKLQotI2lmZGVmIEVOQUJMRV9DSEVDS0lORwotLyogRU5B
QkxFX0NIRUNLSU5HIHNvbWVob3cgaW5jcmVhc2VzIHRoZSBwdXJlc3BhY2UgdXNlZCwgcHJvYmFi
bHkgYmVjYXVzZQotICAgaXQgdGVuZHMgdG8gY2F1c2Ugc29tZSBtYWNybyBhcmd1bWVudHMgdG8g
YmUgZXZhbHVhdGVkIHR3aWNlLiAgVGhpcyBpcwotICAgYSBidWcsIGJ1dCBpdCdzIGRpZmZpY3Vs
dCB0byB0cmFjayBpdCBkb3duLiAgKi8KLSNkZWZpbmUgUFVSRVNJWkVfQ0hFQ0tJTkdfUkFUSU8g
MTIgLyAxMAkvKiBEb24ndCBzdXJyb3VuZCB3aXRoIGAoKScuICAqLwotI2Vsc2UKLSNkZWZpbmUg
UFVSRVNJWkVfQ0hFQ0tJTkdfUkFUSU8gMQotI2VuZGlmCi0KLS8qIFRoaXMgaXMgdGhlIGFjdHVh
bCBzaXplIGluIGJ5dGVzIHRvIGFsbG9jYXRlLiAgKi8KLSNpZm5kZWYgUFVSRVNJWkUKLSNkZWZp
bmUgUFVSRVNJWkUgIChCQVNFX1BVUkVTSVpFICogUFVSRVNJWkVfUkFUSU8gKiBQVVJFU0laRV9D
SEVDS0lOR19SQVRJTykKLSNlbmRpZgotCi1leHRlcm4gQVZPSUQgcHVyZV93cml0ZV9lcnJvciAo
TGlzcF9PYmplY3QpOwotCi1leHRlcm4gRU1BQ1NfSU5UIHB1cmVbXTsKLQotLyogVGhlIHB1cmVz
aXplX2hfKiBtYWNyb3MgYXJlIHByaXZhdGUgdG8gdGhpcyBpbmNsdWRlIGZpbGUuICAqLwotCi0v
KiBUcnVlIGlmIFBUUiBpcyBwdXJlLiAgKi8KLQotI2RlZmluZSBwdXJlc2l6ZV9oX1BVUkVfUChw
dHIpIFwKLSAgKCh1aW50cHRyX3QpIChwdHIpIC0gKHVpbnRwdHJfdCkgcHVyZSA8PSBQVVJFU0la
RSkKLQotSU5MSU5FIGJvb2wKLVBVUkVfUCAodm9pZCAqcHRyKQotewotICByZXR1cm4gcHVyZXNp
emVfaF9QVVJFX1AgKHB0cik7Ci19Ci0KLS8qIFNpZ25hbCBhbiBlcnJvciBpZiBPQkogaXMgcHVy
ZS4gIFBUUiBpcyBPQkogdW50YWdnZWQuICAqLwotCi0jZGVmaW5lIHB1cmVzaXplX2hfQ0hFQ0tf
SU1QVVJFKG9iaiwgcHRyKSBcCi0gIChQVVJFX1AgKHB0cikgPyBwdXJlX3dyaXRlX2Vycm9yIChv
YmopIDogKHZvaWQpIDApCi0KLUlOTElORSB2b2lkCi1DSEVDS19JTVBVUkUgKExpc3BfT2JqZWN0
IG9iaiwgdm9pZCAqcHRyKQotewotICBwdXJlc2l6ZV9oX0NIRUNLX0lNUFVSRSAob2JqLCBwdHIp
OwotfQotCi0jaWYgREVGSU5FX0tFWV9PUFNfQVNfTUFDUk9TCi0jIGRlZmluZSBQVVJFX1AocHRy
KSBwdXJlc2l6ZV9oX1BVUkVfUCAocHRyKQotIyBkZWZpbmUgQ0hFQ0tfSU1QVVJFKG9iaiwgcHRy
KSBwdXJlc2l6ZV9oX0NIRUNLX0lNUFVSRSAob2JqLCBwdHIpCi0jZW5kaWYKLQotSU5MSU5FX0hF
QURFUl9FTkQKLQotI2VuZGlmIC8qIEVNQUNTX1BVUkVTSVpFX0ggKi8KZGlmZiAtLWdpdCBhL3Ny
Yy9zZWFyY2guYyBiL3NyYy9zZWFyY2guYwppbmRleCBjNzU3YmYzZDFmMjgxLi41YTIxNGRiMDA5
MmQyIDEwMDY0NAotLS0gYS9zcmMvc2VhcmNoLmMKKysrIGIvc3JjL3NlYXJjaC5jCkBAIC0zMzU0
LDE5ICszMzU0LDE5IEBAIHN5bXNfb2Zfc2VhcmNoICh2b2lkKQogICBERUZTWU0gKFFpbnZhbGlk
X3JlZ2V4cCwgImludmFsaWQtcmVnZXhwIik7CiAKICAgRnB1dCAoUXNlYXJjaF9mYWlsZWQsIFFl
cnJvcl9jb25kaXRpb25zLAotCXB1cmVfbGlzdCAoUXNlYXJjaF9mYWlsZWQsIFFlcnJvcikpOwor
CWxpc3QgKFFzZWFyY2hfZmFpbGVkLCBRZXJyb3IpKTsKICAgRnB1dCAoUXNlYXJjaF9mYWlsZWQs
IFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVfY19zdHJpbmcgKCJTZWFyY2ggZmFpbGVkIikp
OworCWJ1aWxkX3N0cmluZyAoIlNlYXJjaCBmYWlsZWQiKSk7CiAKICAgRnB1dCAoUXVzZXJfc2Vh
cmNoX2ZhaWxlZCwgUWVycm9yX2NvbmRpdGlvbnMsCi0JcHVyZV9saXN0IChRdXNlcl9zZWFyY2hf
ZmFpbGVkLCBRdXNlcl9lcnJvciwgUXNlYXJjaF9mYWlsZWQsIFFlcnJvcikpOworCWxpc3QgKFF1
c2VyX3NlYXJjaF9mYWlsZWQsIFF1c2VyX2Vycm9yLCBRc2VhcmNoX2ZhaWxlZCwgUWVycm9yKSk7
CiAgIEZwdXQgKFF1c2VyX3NlYXJjaF9mYWlsZWQsIFFlcnJvcl9tZXNzYWdlLAotICAgICAgICBi
dWlsZF9wdXJlX2Nfc3RyaW5nICgiU2VhcmNoIGZhaWxlZCIpKTsKKyAgICAgICAgYnVpbGRfc3Ry
aW5nICgiU2VhcmNoIGZhaWxlZCIpKTsKIAogICBGcHV0IChRaW52YWxpZF9yZWdleHAsIFFlcnJv
cl9jb25kaXRpb25zLAotCXB1cmVfbGlzdCAoUWludmFsaWRfcmVnZXhwLCBRZXJyb3IpKTsKKwls
aXN0IChRaW52YWxpZF9yZWdleHAsIFFlcnJvcikpOwogICBGcHV0IChRaW52YWxpZF9yZWdleHAs
IFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVfY19zdHJpbmcgKCJJbnZhbGlkIHJlZ2V4cCIp
KTsKKwlidWlsZF9zdHJpbmcgKCJJbnZhbGlkIHJlZ2V4cCIpKTsKIAogICByZV9tYXRjaF9vYmpl
Y3QgPSBRbmlsOwogICBzdGF0aWNwcm8gKCZyZV9tYXRjaF9vYmplY3QpOwpkaWZmIC0tZ2l0IGEv
c3JjL3N5bnRheC5jIGIvc3JjL3N5bnRheC5jCmluZGV4IDlmYmY4ODUzNWYzZWMuLjk5M2Y5MWFm
MTlhYzAgMTAwNjQ0Ci0tLSBhL3NyYy9zeW50YXguYworKysgYi9zcmMvc3ludGF4LmMKQEAgLTM3
MTksOSArMzcxOSw5IEBAIHN5bXNfb2Zfc3ludGF4ICh2b2lkKQogCiAgIERFRlNZTSAoUXNjYW5f
ZXJyb3IsICJzY2FuLWVycm9yIik7CiAgIEZwdXQgKFFzY2FuX2Vycm9yLCBRZXJyb3JfY29uZGl0
aW9ucywKLQlwdXJlX2xpc3QgKFFzY2FuX2Vycm9yLCBRZXJyb3IpKTsKKwlsaXN0IChRc2Nhbl9l
cnJvciwgUWVycm9yKSk7CiAgIEZwdXQgKFFzY2FuX2Vycm9yLCBRZXJyb3JfbWVzc2FnZSwKLQli
dWlsZF9wdXJlX2Nfc3RyaW5nICgiU2NhbiBlcnJvciIpKTsKKwlidWlsZF9zdHJpbmcgKCJTY2Fu
IGVycm9yIikpOwogCiAgIERFRlZBUl9CT09MICgicGFyc2Utc2V4cC1pZ25vcmUtY29tbWVudHMi
LCBwYXJzZV9zZXhwX2lnbm9yZV9jb21tZW50cywKIAkgICAgICAgZG9jOiAvKiBOb24tbmlsIG1l
YW5zIGBmb3J3YXJkLXNleHAnLCBldGMuLCBzaG91bGQgdHJlYXQgY29tbWVudHMgYXMgd2hpdGVz
cGFjZS4gICovKTsKZGlmZiAtLWdpdCBhL3NyYy93MzJmbnMuYyBiL3NyYy93MzJmbnMuYwppbmRl
eCA5ZGIzNjdiZmFmZTc1Li4zYjNhZDJmNTViOWFhIDEwMDY0NAotLS0gYS9zcmMvdzMyZm5zLmMK
KysrIGIvc3JjL3czMmZucy5jCkBAIC0xMDM5MCw5ICsxMDM5MCw5IEBAIHN5bXNfb2ZfdzMyZm5z
ICh2b2lkKQogICBERUZTWU0gKFFqc29uLCAianNvbiIpOwogCiAgIEZwdXQgKFF1bmRlZmluZWRf
Y29sb3IsIFFlcnJvcl9jb25kaXRpb25zLAotCXB1cmVfbGlzdCAoUXVuZGVmaW5lZF9jb2xvciwg
UWVycm9yKSk7CisJbGlzdCAoUXVuZGVmaW5lZF9jb2xvciwgUWVycm9yKSk7CiAgIEZwdXQgKFF1
bmRlZmluZWRfY29sb3IsIFFlcnJvcl9tZXNzYWdlLAotCWJ1aWxkX3B1cmVfY19zdHJpbmcgKCJV
bmRlZmluZWQgY29sb3IiKSk7CisJYnVpbGRfc3RyaW5nICgiVW5kZWZpbmVkIGNvbG9yIikpOwog
CiAgIHN0YXRpY3BybyAoJnczMl9ncmFiYmVkX2tleXMpOwogICB3MzJfZ3JhYmJlZF9rZXlzID0g
UW5pbDsKZGlmZiAtLWdpdCBhL3NyYy94ZGlzcC5jIGIvc3JjL3hkaXNwLmMKaW5kZXggY2MwYTY4
OWJhMzJlOS4uMzgwOTkzNTBkNjc2MSAxMDA2NDQKLS0tIGEvc3JjL3hkaXNwLmMKKysrIGIvc3Jj
L3hkaXNwLmMKQEAgLTM0ODYyLDcgKzM0ODYyLDcgQEAgc3ltc19vZl94ZGlzcCAodm9pZCkKICAg
c3RhdGljcHJvICgmZWNob19hcmVhX2J1ZmZlclswXSk7CiAgIHN0YXRpY3BybyAoJmVjaG9fYXJl
YV9idWZmZXJbMV0pOwogCi0gIFZtZXNzYWdlc19idWZmZXJfbmFtZSA9IGJ1aWxkX3B1cmVfY19z
dHJpbmcgKCIqTWVzc2FnZXMqIik7CisgIFZtZXNzYWdlc19idWZmZXJfbmFtZSA9IGJ1aWxkX3N0
cmluZyAoIipNZXNzYWdlcyoiKTsKICAgc3RhdGljcHJvICgmVm1lc3NhZ2VzX2J1ZmZlcl9uYW1l
KTsKIAogICBtb2RlX2xpbmVfcHJvcHRyYW5zX2FsaXN0ID0gUW5pbDsKQEAgLTM0OTU0LDcgKzM0
OTU0LDcgQEAgc3ltc19vZl94ZGlzcCAodm9pZCkKICAgREVGVkFSX0xJU1AgKCJvdmVybGF5LWFy
cm93LXN0cmluZyIsIFZvdmVybGF5X2Fycm93X3N0cmluZywKICAgICBkb2M6IC8qIFN0cmluZyB0
byBkaXNwbGF5IGFzIGFuIGFycm93IGluIG5vbi13aW5kb3cgZnJhbWVzLgogU2VlIGFsc28gYG92
ZXJsYXktYXJyb3ctcG9zaXRpb24nLiAgKi8pOwotICBWb3ZlcmxheV9hcnJvd19zdHJpbmcgPSBi
dWlsZF9wdXJlX2Nfc3RyaW5nICgiPT4iKTsKKyAgVm92ZXJsYXlfYXJyb3dfc3RyaW5nID0gYnVp
bGRfc3RyaW5nICgiPT4iKTsKIAogICBERUZWQVJfTElTUCAoIm92ZXJsYXktYXJyb3ctdmFyaWFi
bGUtbGlzdCIsIFZvdmVybGF5X2Fycm93X3ZhcmlhYmxlX2xpc3QsCiAgICAgZG9jOiAvKiBMaXN0
IG9mIHZhcmlhYmxlcyAoc3ltYm9scykgd2hpY2ggaG9sZCBtYXJrZXJzIGZvciBvdmVybGF5IGFy
cm93cy4KQEAgLTM1MDc5LDE3ICszNTA3OSwxNyBAQCBzeW1zX29mX3hkaXNwICh2b2lkKQogVGhp
cyB2YXJpYWJsZSBoYXMgdGhlIHNhbWUgc3RydWN0dXJlIGFzIGBtb2RlLWxpbmUtZm9ybWF0JyAo
d2hpY2ggc2VlKSwKIGFuZCBpcyB1c2VkIG9ubHkgb24gZnJhbWVzIGZvciB3aGljaCBubyBleHBs
aWNpdCBuYW1lIGhhcyBiZWVuIHNldAogXChzZWUgYG1vZGlmeS1mcmFtZS1wYXJhbWV0ZXJzJyku
ICAqLyk7Ci0gIC8qIERvIG5vdCBuZXN0IGNhbGxzIHRvIHB1cmVfbGlzdC4gIFRoaXMgd29ya3Mg
YXJvdW5kIGEgYnVnIGluCisgIC8qIERvIG5vdCBuZXN0IGNhbGxzIHRvIGxpc3QuICBUaGlzIHdv
cmtzIGFyb3VuZCBhIGJ1ZyBpbgogICAgICBPcmFjbGUgRGV2ZWxvcGVyIFN0dWRpbyAxMi42LiAg
Ki8KICAgTGlzcF9PYmplY3QgaWNvbl90aXRsZV9uYW1lX2Zvcm1hdAotICAgID0gcHVyZV9saXN0
IChlbXB0eV91bmlieXRlX3N0cmluZywKLQkJIGJ1aWxkX3B1cmVfY19zdHJpbmcgKCIlYiAtIEdO
VSBFbWFjcyBhdCAiKSwKLQkJIGludGVybl9jX3N0cmluZyAoInN5c3RlbS1uYW1lIikpOworICAg
ID0gbGlzdCAoZW1wdHlfdW5pYnl0ZV9zdHJpbmcsCisJICAgIGJ1aWxkX3N0cmluZyAoIiViIC0g
R05VIEVtYWNzIGF0ICIpLAorCSAgICBpbnRlcm5fY19zdHJpbmcgKCJzeXN0ZW0tbmFtZSIpKTsK
ICAgVmljb25fdGl0bGVfZm9ybWF0CiAgICAgPSBWZnJhbWVfdGl0bGVfZm9ybWF0Ci0gICAgPSBw
dXJlX2xpc3QgKGludGVybl9jX3N0cmluZyAoIm11bHRpcGxlLWZyYW1lcyIpLAotCQkgYnVpbGRf
cHVyZV9jX3N0cmluZyAoIiViIiksCi0JCSBpY29uX3RpdGxlX25hbWVfZm9ybWF0KTsKKyAgICA9
IGxpc3QgKGludGVybl9jX3N0cmluZyAoIm11bHRpcGxlLWZyYW1lcyIpLAorCSAgICBidWlsZF9z
dHJpbmcgKCIlYiIpLAorCSAgICBpY29uX3RpdGxlX25hbWVfZm9ybWF0KTsKIAogICBERUZWQVJf
TElTUCAoIm1lc3NhZ2UtbG9nLW1heCIsIFZtZXNzYWdlX2xvZ19tYXgsCiAgICAgZG9jOiAvKiBN
YXhpbXVtIG51bWJlciBvZiBsaW5lcyB0byBrZWVwIGluIHRoZSBtZXNzYWdlIGxvZyBidWZmZXIu
CmRpZmYgLS1naXQgYS9zcmMveGZhY2VzLmMgYi9zcmMveGZhY2VzLmMKaW5kZXggYWI0NDQwZjQ2
YWQwZC4uNmNiMDhiMDQ3NWNiYSAxMDA2NDQKLS0tIGEvc3JjL3hmYWNlcy5jCisrKyBiL3NyYy94
ZmFjZXMuYwpAQCAtNzA0NCw3ICs3MDQ0LDcgQEAgc3ltc19vZl94ZmFjZXMgKHZvaWQpCiBUaGlz
IHN0aXBwbGUgcGF0dGVybiBpcyB1c2VkIG9uIG1vbm9jaHJvbWUgZGlzcGxheXMKIGluc3RlYWQg
b2Ygc2hhZGVzIG9mIGdyYXkgZm9yIGEgZmFjZSBiYWNrZ3JvdW5kIGNvbG9yLgogU2VlIGBzZXQt
ZmFjZS1zdGlwcGxlJyBmb3IgcG9zc2libGUgdmFsdWVzIGZvciB0aGlzIHZhcmlhYmxlLiAgKi8p
OwotICBWZmFjZV9kZWZhdWx0X3N0aXBwbGUgPSBidWlsZF9wdXJlX2Nfc3RyaW5nICgiZ3JheTMi
KTsKKyAgVmZhY2VfZGVmYXVsdF9zdGlwcGxlID0gYnVpbGRfc3RyaW5nICgiZ3JheTMiKTsKIAog
ICBERUZWQVJfTElTUCAoInR0eS1kZWZpbmVkLWNvbG9yLWFsaXN0IiwgVnR0eV9kZWZpbmVkX2Nv
bG9yX2FsaXN0LAogICAgZG9jOiAvKiBBbiBhbGlzdCBvZiBkZWZpbmVkIHRlcm1pbmFsIGNvbG9y
cyBhbmQgdGhlaXIgUkdCIHZhbHVlcy4KZGlmZiAtLWdpdCBhL3NyYy94Zm5zLmMgYi9zcmMveGZu
cy5jCmluZGV4IGQ5MDY0NDgxOWI2ZjUuLmU5ZWFkMzVjY2NjYjUgMTAwNjQ0Ci0tLSBhL3NyYy94
Zm5zLmMKKysrIGIvc3JjL3hmbnMuYwpAQCAtNzg3OCw5ICs3ODc4LDkgQEAgc3ltc19vZl94Zm5z
ICh2b2lkKQogI2VuZGlmCiAKICAgRnB1dCAoUXVuZGVmaW5lZF9jb2xvciwgUWVycm9yX2NvbmRp
dGlvbnMsCi0JcHVyZV9saXN0IChRdW5kZWZpbmVkX2NvbG9yLCBRZXJyb3IpKTsKKwlsaXN0IChR
dW5kZWZpbmVkX2NvbG9yLCBRZXJyb3IpKTsKICAgRnB1dCAoUXVuZGVmaW5lZF9jb2xvciwgUWVy
cm9yX21lc3NhZ2UsCi0JYnVpbGRfcHVyZV9jX3N0cmluZyAoIlVuZGVmaW5lZCBjb2xvciIpKTsK
KwlidWlsZF9zdHJpbmcgKCJVbmRlZmluZWQgY29sb3IiKSk7CiAKICAgREVGVkFSX0xJU1AgKCJ4
LXBvaW50ZXItc2hhcGUiLCBWeF9wb2ludGVyX3NoYXBlLAogICAgIGRvYzogLyogVGhlIHNoYXBl
IG9mIHRoZSBwb2ludGVyIHdoZW4gb3ZlciB0ZXh0LgpAQCAtODA5MSw3ICs4MDkxLDcgQEAgc3lt
c19vZl94Zm5zICh2b2lkKQogICAgIGNoYXIgZ3RrX3ZlcnNpb25bc2l6ZW9mICIuLiIgKyAzICog
SU5UX1NUUkxFTl9CT1VORCAoaW50KV07CiAgICAgaW50IGxlbiA9IHNwcmludGYgKGd0a192ZXJz
aW9uLCAiJWQuJWQuJWQiLAogCQkgICAgICAgR1RLX01BSk9SX1ZFUlNJT04sIEdUS19NSU5PUl9W
RVJTSU9OLCBHVEtfTUlDUk9fVkVSU0lPTik7Ci0gICAgVmd0a192ZXJzaW9uX3N0cmluZyA9IG1h
a2VfcHVyZV9zdHJpbmcgKGd0a192ZXJzaW9uLCBsZW4sIGxlbiwgZmFsc2UpOworICAgIFZndGtf
dmVyc2lvbl9zdHJpbmcgPSBtYWtlX3NwZWNpZmllZF9zdHJpbmcgKGd0a192ZXJzaW9uLCBsZW4s
IGxlbiwgZmFsc2UpOwogICB9CiAjZW5kaWYgLyogVVNFX0dUSyAqLwogCkBAIC04MTA1LDcgKzgx
MDUsOCBAQCBzeW1zX29mX3hmbnMgKHZvaWQpCiAgICAgaW50IGxlbiA9IHNwcmludGYgKGNhaXJv
X3ZlcnNpb24sICIlZC4lZC4lZCIsCiAJCSAgICAgICBDQUlST19WRVJTSU9OX01BSk9SLCBDQUlS
T19WRVJTSU9OX01JTk9SLAogICAgICAgICAgICAgICAgICAgICAgICBDQUlST19WRVJTSU9OX01J
Q1JPKTsKLSAgICBWY2Fpcm9fdmVyc2lvbl9zdHJpbmcgPSBtYWtlX3B1cmVfc3RyaW5nIChjYWly
b192ZXJzaW9uLCBsZW4sIGxlbiwgZmFsc2UpOworICAgIFZjYWlyb192ZXJzaW9uX3N0cmluZyA9
IG1ha2Vfc3BlY2lmaWVkX3N0cmluZyAoY2Fpcm9fdmVyc2lvbiwgbGVuLCBsZW4sCisJCQkJCQkg
ICBmYWxzZSk7CiAgIH0KICNlbmRpZgogCmRpZmYgLS1naXQgYS9zcmMveHRlcm0uYyBiL3NyYy94
dGVybS5jCmluZGV4IDc0NGI4MGM2OGEwMDIuLjQzN2MwOGI1MjZmNjAgMTAwNjQ0Ci0tLSBhL3Ny
Yy94dGVybS5jCisrKyBiL3NyYy94dGVybS5jCkBAIC0xMzY0OSw3ICsxMzY0OSw3IEBAIHN5bXNf
b2ZfeHRlcm0gKHZvaWQpCiAgIERFRlNZTSAoUWxhdGluXzEsICJsYXRpbi0xIik7CiAKICNpZmRl
ZiBVU0VfR1RLCi0gIHhnX2RlZmF1bHRfaWNvbl9maWxlID0gYnVpbGRfcHVyZV9jX3N0cmluZyAo
Imljb25zL2hpY29sb3Ivc2NhbGFibGUvYXBwcy9lbWFjcy5zdmciKTsKKyAgeGdfZGVmYXVsdF9p
Y29uX2ZpbGUgPSBidWlsZF9zdHJpbmcgKCJpY29ucy9oaWNvbG9yL3NjYWxhYmxlL2FwcHMvZW1h
Y3Muc3ZnIik7CiAgIHN0YXRpY3BybyAoJnhnX2RlZmF1bHRfaWNvbl9maWxlKTsKIAogICBERUZT
WU0gKFF4X2d0a19tYXBfc3RvY2ssICJ4LWd0ay1tYXAtc3RvY2siKTsKQEAgLTEzNzcwLDcgKzEz
NzcwLDcgQEAgc3ltc19vZl94dGVybSAodm9pZCkKICAgVnhfa2V5c3ltX3RhYmxlID0gbWFrZV9o
YXNoX3RhYmxlIChoYXNodGVzdF9lcWwsIDkwMCwKIAkJCQkgICAgIERFRkFVTFRfUkVIQVNIX1NJ
WkUsCiAJCQkJICAgICBERUZBVUxUX1JFSEFTSF9USFJFU0hPTEQsCi0JCQkJICAgICBRbmlsLCBm
YWxzZSk7CisJCQkJICAgICBRbmlsKTsKIAogICBERUZWQVJfQk9PTCAoIngtZnJhbWUtbm9ybWFs
aXplLWJlZm9yZS1tYXhpbWl6ZSIsCiAJICAgICAgIHhfZnJhbWVfbm9ybWFsaXplX2JlZm9yZV9t
YXhpbWl6ZSwKLS0gCjIuMzAuMQoK
--00000000000004c45c05bcc14a64--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 21:52:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 16:52:42 2021
Received: from localhost ([127.0.0.1]:60532 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHvti-0000gu-6I
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 16:52:42 -0500
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:35132)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1lHvtd-0000gT-PD
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 16:52:40 -0500
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id DEFA8160124;
 Thu,  4 Mar 2021 13:52:30 -0800 (PST)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id A5PhqZbb3Iuf; Thu,  4 Mar 2021 13:52:29 -0800 (PST)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id CAE0B160126;
 Thu,  4 Mar 2021 13:52:29 -0800 (PST)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id o6z5AwgWJXKy; Thu,  4 Mar 2021 13:52:29 -0800 (PST)
Received: from [192.168.1.9] (cpe-23-243-218-95.socal.res.rr.com
 [23.243.218.95])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 863FA160124;
 Thu,  4 Mar 2021 13:52:29 -0800 (PST)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>, Pip Cet <pipcet@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <4c1248b8-88cc-ca06-6bc8-9f0bb9a98c98@HIDDEN>
Date: Thu, 4 Mar 2021 13:52:29 -0800
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <87sg5bt1bp.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 Andreas Schwab <schwab@HIDDEN>, Stefan Kangas <stefankangas@HIDDEN>,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On 3/4/21 6:56 AM, Robert Pluim wrote:
>      Pip> - zero vector handling depends on Qnil being all zero in memory
> 
> I think Emacs already assumes Qnil == 0, since there are places that
> use ! to check for Qnil rather than using NILP.

The convention is to put a "verify (NIL_IS_ZERO);" near the rare bits of 
code that assume Qnil is all-bits-zero. This is to help out any 
hypothetical future developer who wants to change Qnil to be some other 
value. Currently there are only two such locations. (There is one other 
location that uses NIL_IS_ZERO for an optimization.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Mar 2021 17:45:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 12:45:58 2021
Received: from localhost ([127.0.0.1]:60110 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHs2s-0002z2-CA
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:45:58 -0500
Received: from lists.gnu.org ([209.51.188.17]:36826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lHs2p-0002yu-NU
 for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:45:53 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:53646)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lHs2p-0004W9-Fy
 for bug-gnu-emacs@HIDDEN; Thu, 04 Mar 2021 12:45:51 -0500
Received: from ciao.gmane.io ([116.202.254.214]:49604)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lHs2o-0006bz-1c
 for bug-gnu-emacs@HIDDEN; Thu, 04 Mar 2021 12:45:51 -0500
Received: from list by ciao.gmane.io with local (Exim 4.92)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1lHs2m-0005QW-7L
 for bug-gnu-emacs@HIDDEN; Thu, 04 Mar 2021 18:45:48 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
Date: Thu, 04 Mar 2021 17:45:42 +0000
Message-ID: <86lfb2vmm1.fsf@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <83a6ri2a2m.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (windows-nt)
Cancel-Lock: sha1:cKbhm/h+Z1ByS/PuFuKmoRdo0nI=
Received-SPF: pass client-ip=116.202.254.214;
 envelope-from=geb-bug-gnu-emacs@HIDDEN; helo=ciao.gmane.io
X-Spam_score_int: 5
X-Spam_score: 0.5
X-Spam_bar: /
X-Spam_report: (0.5 / 5.0 requ) BAYES_00=-1.9, DKIM_ADSP_CUSTOM_MED=0.001,
 FORGED_GMAIL_RCVD=1, FREEMAIL_FORGED_FROMDOMAIN=0.249, FREEMAIL_FROM=0.001,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, NML_ADSP_CUSTOM_MED=0.9,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.9 (/)

On Thu 04 Mar 2021, Eli Zaretskii wrote:

>> From: Robert Pluim <rpluim@HIDDEN>
>> Date: Thu, 04 Mar 2021 15:56:10 +0100
>> Cc: eggert@HIDDEN, Andreas Schwab <schwab@HIDDEN>,
>>  Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
>>  Andrea Corallo <akrl@HIDDEN>
>> 
>> I think Emacs already assumes Qnil == 0, since there are places that
>> use ! to check for Qnil rather than using NILP.
>
> Those are bugs that need to be fixed.  Fast.

Agree that they are bugs, but also see NIL_IS_ZERO and memclear() in lisp.h.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 17:18:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 12:18:35 2021
Received: from localhost ([127.0.0.1]:60061 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHrcN-0002H4-EK
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:18:35 -0500
Received: from mail-wm1-f44.google.com ([209.85.128.44]:56266)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lHrcI-0002Gf-I5
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:18:29 -0500
Received: by mail-wm1-f44.google.com with SMTP id w7so8752392wmb.5
 for <36649 <at> debbugs.gnu.org>; Thu, 04 Mar 2021 09:18:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=t90fa4RnteSbVuI0VuyMRbFsPwx3GOu2fftzhLKNFeE=;
 b=RJLI8umTOS4/WN/R2d9vhKS1tFu9S/zj8PSt0ia9C4Oiuw8Zt/6vjn2D+c9/GMsdgF
 KbLinAm97d/ZZNF15HkW92Q0OLVhu3xUoyTNEr28PWHLa3Qngvr9/u/SLOx0wDgOuVbv
 Nl2N4WO11MXkx74H2lnsA0iYbXTi0hWKw4wtbH4Lq2e3eaxm3EDaEKSbcasuyc5nqcJO
 yLNh9eVWT9vZoffIV2FgXeIe9f5ofwARspUfEYCpD9RFzmbhoHFlbBrcneaPddnb/1eX
 8wWtqHGBD8663u6cCTSQEs9fuGJFQ7Ki8jSAAL3hdYonWf3sVFx430B+tcGapuSSZBim
 M2CA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=t90fa4RnteSbVuI0VuyMRbFsPwx3GOu2fftzhLKNFeE=;
 b=Tf28OIhXENvCzolggt6qNFTbnJ2CEHQRNF5f4s3tQa7mRUydsYC4PZgEAWkGcaqKNV
 tDEEQa68yRH8NhMEwE32K7Pxn8Cn5vrX7lOqzC54KkObd440GWyvHU28r9oR5uzh4eDV
 +ulXwdsC4NB3m3gTNFboEzp6HOhfOMVVP2WcVW/eZbMJHdaQbjZmChSjQOUBN19pjAos
 OzCZhH/c+NTfvJU6DUQGx7jFB+Rf/EOdecnP3nh8KWj1kxzTLJmlVJ1q8S4mtQ8P7GT/
 JXg6y405xPIZ8owxhIap3w4zE8FY/H+xfKlBUptoLRW2LOvJ8G/WLN7twk13SX7HX7ot
 wdug==
X-Gm-Message-State: AOAM5318HQ2zYTxA6AML1Uy18J6pST+ahLN4LNDmjduSo5lvcl93auiW
 kou69lHYO+7muWPcbmslJWQ=
X-Google-Smtp-Source: ABdhPJzhHVyLM4c71biDILDnM1cEEJeg09mIanaPcaUQFITK3ld+DL5XTVJOO8agYu2unKhCuNZgIQ==
X-Received: by 2002:a1c:1f8f:: with SMTP id f137mr4995994wmf.66.1614878300596; 
 Thu, 04 Mar 2021 09:18:20 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id d7sm8407437wrs.42.2021.03.04.09.18.18
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 04 Mar 2021 09:18:19 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <83a6ri2a2m.fsf@HIDDEN>
 <87o8fyuay7.fsf@HIDDEN> <835z2626h6.fsf@HIDDEN>
Date: Thu, 04 Mar 2021 18:18:13 +0100
In-Reply-To: <835z2626h6.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 04 Mar
 2021 19:07:01 +0200")
Message-ID: <87czweu9be.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, schwab@HIDDEN, stefankangas@HIDDEN,
 pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Thu, 04 Mar 2021 19:07:01 +0200, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Robert Pluim <rpluim@HIDDEN>
    >> Cc: pipcet@HIDDEN,  eggert@HIDDEN,  schwab@HIDDEN,
    >> stefankangas@HIDDEN,  36649 <at> debbugs.gnu.org,  larsi@HIDDEN,
    >> akrl@HIDDEN
    >> Date: Thu, 04 Mar 2021 17:42:56 +0100
    >>=20
    >> >> I think Emacs already assumes Qnil =3D=3D 0, since there are plac=
es that
    >> >> use ! to check for Qnil rather than using NILP.
    >>=20
    Eli> Those are bugs that need to be fixed.  Fast.
    >>=20
    >> Hmm,
    >>=20
    >> ./configure --enable-check-lisp-object-type
    >>=20
    >> for emacs-master and emacs-27 builds fine, so maybe I=CA=BCm imagini=
ng things.

    Eli> "Imagination is more important than knowledge".  Albert Einstein.

:-) Tell that to the compiler

Robert
--=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 17:07:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 12:07:40 2021
Received: from localhost ([127.0.0.1]:60043 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHrRo-0001zM-9P
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:07:40 -0500
Received: from eggs.gnu.org ([209.51.188.92]:55340)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lHrRj-0001z6-ED
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 12:07:35 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36877)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lHrRb-0004zV-0s; Thu, 04 Mar 2021 12:07:23 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2977
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lHrRY-0003CY-J0; Thu, 04 Mar 2021 12:07:22 -0500
Date: Thu, 04 Mar 2021 19:07:01 +0200
Message-Id: <835z2626h6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <87o8fyuay7.fsf@HIDDEN> (message from Robert Pluim on Thu, 04
 Mar 2021 17:42:56 +0100)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <83a6ri2a2m.fsf@HIDDEN>
 <87o8fyuay7.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, schwab@HIDDEN, stefankangas@HIDDEN,
 pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Robert Pluim <rpluim@HIDDEN>
> Cc: pipcet@HIDDEN,  eggert@HIDDEN,  schwab@HIDDEN,
>   stefankangas@HIDDEN,  36649 <at> debbugs.gnu.org,  larsi@HIDDEN,
>   akrl@HIDDEN
> Date: Thu, 04 Mar 2021 17:42:56 +0100
> 
>     >> I think Emacs already assumes Qnil == 0, since there are places that
>     >> use ! to check for Qnil rather than using NILP.
> 
>     Eli> Those are bugs that need to be fixed.  Fast.
> 
> Hmm,
> 
> ./configure --enable-check-lisp-object-type
> 
> for emacs-master and emacs-27 builds fine, so maybe Iʼm imagining things.

"Imagination is more important than knowledge".  Albert Einstein.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 16:53:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 11:53:43 2021
Received: from localhost ([127.0.0.1]:60029 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHrEN-0001dw-06
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 11:53:43 -0500
Received: from mout.gmx.net ([212.227.17.22]:53211)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1lHrEK-0001di-Fa
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 11:53:41 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1614876799;
 bh=a4D8dD+W3malvUwUpIgm6T4gnwr/gNkk2lsQWGd3CP8=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=jcX5bus50CN/sgeyyJSrY4HHyPeoymCDhiCv430ZSH642JSQyq6XqRJgGkxuHsRLS
 zLbvoR6KqUKtGQ0jXLPjY6OQ6fZItszq8TfH1dmfbDzLq46mwjU2LlVy8fc9Nsya/p
 fk1UHg2phdMSFBfw0wsKtto2Rgk9ZTgLcM2ex9iM=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.213]) by mail.gmx.net (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1M2f5T-1lLRr731fr-0047q0; Thu, 04
 Mar 2021 17:53:19 +0100
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Eli Zaretskii <eliz@HIDDEN>, Robert Pluim <rpluim@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <83a6ri2a2m.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <845b0c94-7e52-af6b-8171-e0b6a1b840cc@HIDDEN>
Date: Thu, 4 Mar 2021 17:53:14 +0100
MIME-Version: 1.0
In-Reply-To: <83a6ri2a2m.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:2wK9MQxsbuaOVULwxz4ekl9othtgOcEA9hxExJ8rGbD1R/Et+YI
 9mNmmcHxh9mC+sMCmpcWrtjY3ET0SqiTfM2g4Q/SiAB7vKY3tVuD3jEEJjqjkg1X0r9jvBW
 LA0tnPRuD8KLpu8HH+gf81DAtcC4YdJw0FlOAnFQePRej+mqkIJZaljWftSL8rwNt7yoHrR
 z6JAG3m/fmlO7znb518Gw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:5zPncdNrUlM=:LooeS8F/+MjFZU0bQuTXJb
 oyEtERi6AQ0OG8IO6dWcxNaNsJ7t3VSvzi2k5T32NChcbEnz3y3/cbii3jXVh4javDbhOht8D
 GyLoC2t9i09mG4NAiWC8I2dToFBh7jwUDmIU5FSW3GGj4hK08fCgFXxxq2IbHW2Yqn7rSiGJC
 FuQrxNhtpaJiX1VmABQ/50U2x6orFZaVh6a+0YMZ4CaiSmZcUcyQhnAlcry0kSB1H6G8lMeaf
 AYQ925dt4GPuNPjNnr6QrkfZOfdxoy3gAdebLjt7sZqLGwx/I763EZxPgjl5nMqUv8NC70qHA
 d75od9PPERvqydO1rlWmR7wj8wZHDzNLzcoVin4VpoW9utpWnaikrUozvksTRLVkeKhE89rYs
 d0Ch96lV2UHUuOmjzIzCUZ7WH823E1u9YEacR5mapi9i/d1vJQSMrVxiMNxXcunI4sB5QWtRL
 n5rmLicT0jdddj/mCNLPclH5cDlC8BlL475PF5Ur+qSEe0ql3ax1fGIhJQsorWdrkGCLTr8UI
 qcmkz7z+MTiUNsRQkFkezlyTZ8arZi1oAazoIIMyHjPmynDiNQWhKXV8A5V4FhDx6JP17j1va
 pFPH+Zh/8KixjBB/KXURAOBpnm6hQHpGAm3RTZpgqXh3Ho1TMhcnEzvQ8rCViwwGhjmv27jfv
 +l4RA4bkjcwc/X7Zm07NW1Xrm/hoG6uMHr03Jblru3gpvI+TKzscUwIlJZQZEfwNPb9a2dNIr
 ySfBE2+J7Q1jfhToi00qx2RPrdm3XQFDFCYm0+ublRtUvXzMTfh8EkoNKf5PM03qnMWWs3Dvk
 CmM+NuPQJw2nqYN4Pch3e2Xo0zXW37H+SloqNQiku8MYKzd4AdansRzj1zCCiYnaYq3ZBH8r4
 abgb2sMwXqqkk8atfGdQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, schwab@HIDDEN, stefankangas@HIDDEN,
 pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> I think Emacs already assumes Qnil =3D=3D 0, since there are places t=
hat
 >> use ! to check for Qnil rather than using NILP.
 >
 > Those are bugs that need to be fixed.  Fast.

Here this would get me

=2E./../src/window.c: In function =E2=80=98select_window=E2=80=99:
=2E./../src/window.c:535:7: error: wrong type argument to unary exclamati=
on mark
    if (!norecord || EQ (norecord, Qmark_for_redisplay))
        ^

or

   CC       window.o
=2E./../src/window.c: In function =E2=80=98select_window=E2=80=99:
=2E./../src/window.c:535:17: error: invalid operands to binary =3D=3D (ha=
ve =E2=80=98Lisp_Object=E2=80=99 {aka =E2=80=98struct Lisp_Object=E2=80=99=
} and =E2=80=98int=E2=80=99)
    if ((norecord =3D=3D false) || EQ (norecord, Qmark_for_redisplay))
                  ^~

so I cannot imagine that we really had such bugs.  Unless you mean Lisp
variables explicitly defined via DEFVAR_BOOL.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 16:43:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 11:43:09 2021
Received: from localhost ([127.0.0.1]:60009 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHr45-0001Nz-1s
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 11:43:09 -0500
Received: from mail-wr1-f52.google.com ([209.85.221.52]:38048)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lHr43-0001NW-Iz
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 11:43:04 -0500
Received: by mail-wr1-f52.google.com with SMTP id d15so13145339wrv.5
 for <36649 <at> debbugs.gnu.org>; Thu, 04 Mar 2021 08:43:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=WhCgy4fBUKh76hCz30XtLizAhFXW1420gOE8VxfIVzE=;
 b=NgF31oe4AD7jM9nxtJiZVcdHsGoRSIOVa0WqpPgeUFnzGiM5cZp47BQeaKIfoMnn/J
 l5JHFD1u0ak9gsdUyFMckk4XuOMli0mS0PPpDba0jQ9Sfd6VGs8KI/rSazKdSS7SZ7tE
 WkvzjwnM3q3GP/2kBt3I5Kj1bkfsR8vKzeNTVPgehM7k97kNMtB4opXVsnORsjLp582m
 gC1vMPKS9rafEnUPa4SEZ/TzrOO9pcUp5+NtTyHxZI1YnYMMq/qIvJHqK0/uGK/vPY87
 +MeJVzzNRcp4NGddmqT2LfE6FTKTTYgWZE7x9vKgLmvOOwJApdXUzLfmAZMzza32ScAD
 Nkwg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=WhCgy4fBUKh76hCz30XtLizAhFXW1420gOE8VxfIVzE=;
 b=BVBaeg2wHyfZAdyO6+YuKHFDtlCEVwQiml/M/MaQvV/pZhhZy6tljQeBoknGEUBsWx
 vitOHO1x82kj5MhBX5xGtqafB8h7e+7ziYBBFgIArf7Xlg0qG0KLUytBwHAxphnKJp/V
 i5ZsHjhlCE5nSB78iF4OxXygtByPi1oVqM7Ff80mzzrmh7RHSmz6sK/fmdX1C/r/IFOV
 i9dpc+GHGxXYKsjkD9nEEwOnMzTiQBim7vj8AaJ9i3jqPFtuY875HKB2kdqjxEfUO1f2
 c0lNzrJ8blsevYv8QNL5K3cZqZT2MCSk/Eu4vcVnQvWhxPQbq0QqwZcKVu5H6gJDv6MJ
 a5ng==
X-Gm-Message-State: AOAM531XoBelrRdEMy5geyRfN1Lk0UPaxapVjIL07Dr3qGLjob9RSYJt
 kD1w5fgP+4Q30gZV4B9h+vw=
X-Google-Smtp-Source: ABdhPJzWCbCeot2Jfg5e7ZcIR0Rm7P1FgdAfUADOSsfXl0ORnTdq9wEgT3HXmFw+5ivWHCQn+RTBhQ==
X-Received: by 2002:adf:84e6:: with SMTP id 93mr4585110wrg.376.1614876177713; 
 Thu, 04 Mar 2021 08:42:57 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id 91sm15505392wrl.20.2021.03.04.08.42.56
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 04 Mar 2021 08:42:57 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN> <83a6ri2a2m.fsf@HIDDEN>
Date: Thu, 04 Mar 2021 17:42:56 +0100
In-Reply-To: <83a6ri2a2m.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 04 Mar
 2021 17:49:21 +0200")
Message-ID: <87o8fyuay7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, schwab@HIDDEN, stefankangas@HIDDEN,
 pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Thu, 04 Mar 2021 17:49:21 +0200, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Robert Pluim <rpluim@HIDDEN>
    >> Date: Thu, 04 Mar 2021 15:56:10 +0100
    >> Cc: eggert@HIDDEN, Andreas Schwab <schwab@HIDDEN>,
    >> Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi=
@gnus.org,
    >> Andrea Corallo <akrl@HIDDEN>
    >>=20
    >> I think Emacs already assumes Qnil =3D=3D 0, since there are places =
that
    >> use ! to check for Qnil rather than using NILP.

    Eli> Those are bugs that need to be fixed.  Fast.

Hmm,

./configure --enable-check-lisp-object-type

for emacs-master and emacs-27 builds fine, so maybe I=CA=BCm imagining thin=
gs.

Robert
--=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 15:49:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 10:49:56 2021
Received: from localhost ([127.0.0.1]:59963 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHqEa-0008Tl-P6
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 10:49:56 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58960)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1lHqEY-0008TV-9R
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 10:49:51 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34597)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1lHqER-00028r-Ey; Thu, 04 Mar 2021 10:49:43 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1940
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1lHqEQ-0002q5-AO; Thu, 04 Mar 2021 10:49:42 -0500
Date: Thu, 04 Mar 2021 17:49:21 +0200
Message-Id: <83a6ri2a2m.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-Reply-To: <87sg5bt1bp.fsf@HIDDEN> (message from Robert Pluim on Thu, 04
 Mar 2021 15:56:10 +0100)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 <87sg5bt1bp.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, schwab@HIDDEN, stefankangas@HIDDEN,
 pipcet@HIDDEN, 36649 <at> debbugs.gnu.org, larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> From: Robert Pluim <rpluim@HIDDEN>
> Date: Thu, 04 Mar 2021 15:56:10 +0100
> Cc: eggert@HIDDEN, Andreas Schwab <schwab@HIDDEN>,
>  Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
>  Andrea Corallo <akrl@HIDDEN>
> 
> I think Emacs already assumes Qnil == 0, since there are places that
> use ! to check for Qnil rather than using NILP.

Those are bugs that need to be fixed.  Fast.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 14:56:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 09:56:24 2021
Received: from localhost ([127.0.0.1]:59930 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHpOq-0007DJ-Ga
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 09:56:24 -0500
Received: from mail-wm1-f44.google.com ([209.85.128.44]:51387)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lHpOk-0007DD-Q5
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 09:56:22 -0500
Received: by mail-wm1-f44.google.com with SMTP id l22so8325001wme.1
 for <36649 <at> debbugs.gnu.org>; Thu, 04 Mar 2021 06:56:18 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version; bh=YtXNHkl6E53tCKiWSLNRyxc4l8gqdEQnoMQ/wWdxRwI=;
 b=hhjt8SRRk21/SqzdyQGi9IHxtzMjkJNbF/vKuvETAFZdwjINtqa1JQNXUWE/XHHfi/
 4GS8RdR+lahznCVzl3O5bnvQoCnHGUo4A5rRyB96VQnZHNwLHDg7NjO81pxFc8VVxsar
 Yq7GP3ayMB4slA7Gk4CX+gxJxPtNosdPlJlEisjCl5wVZfSWPg8ITqwO7l3BMo93PTI/
 rp4TgV21u00E7j4RsMiYoo90Q9mrbV8Fnw+pubZU0tBcSZ9E0MJVXUu3fADb5uQvIL0U
 pG3xfzEI+MvqLizGxS5Xtwu1vOiADQPbzfbCgnxeE9MM3hRQ7CfxgxkL805/CYGc60Vn
 qpSA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version;
 bh=YtXNHkl6E53tCKiWSLNRyxc4l8gqdEQnoMQ/wWdxRwI=;
 b=rTdNhHv+4YoiXc0SNkgAK1t3VUKjYyrhjm4VqJIM03WNsIuTC+Ciy8agkdCM3PX9wW
 Riix9rIeWB0GacuCfS/1Ugj3eI9i8yg6Lf41k9b/75nUThj/vvnLGD78GYsUT587VHNq
 4EowPq4fC9m4l2+JtgIoifL4arhRxuPjED61hBlkWPhm8uBushuT3ABV6Yjf+hD1H1ku
 2Oi8LdohLh1wJeEGBgqTlUXmScuFONVnZ/Nd4xF0EaUd0voAC0pgLZ1GXYDLRMmogPr3
 HwJioT4nCyi+h3TnN6/Qb4aa9EILJtp89I2xW8fhnFEiCEi8jWxxxJUxmrYOMjxSsW5J
 IdxQ==
X-Gm-Message-State: AOAM531aDovv/Vw7vM4KfHQ0tohpDgNTezX0qm1jctIdBNQNV0pP9WRB
 OFr/1eUaNmlpinZsOxLnO+M=
X-Google-Smtp-Source: ABdhPJzGY2ME/wQm34NUmSYWEpgIbWqjcbfVjlqKV1+NhR61RhKqTcfzsO1tycm9nXLYfFhfOtB/Rg==
X-Received: by 2002:a1c:1f94:: with SMTP id f142mr4406680wmf.180.1614869772622; 
 Thu, 04 Mar 2021 06:56:12 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id a6sm12788975wmm.0.2021.03.04.06.56.11
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 04 Mar 2021 06:56:11 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
 <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
Date: Thu, 04 Mar 2021 15:56:10 +0100
In-Reply-To: <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
 (Pip Cet's message of "Thu, 4 Mar 2021 12:55:34 +0000")
Message-ID: <87sg5bt1bp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: eggert@HIDDEN, Andreas Schwab <schwab@HIDDEN>,
 Stefan Kangas <stefankangas@HIDDEN>, 36649 <at> debbugs.gnu.org, larsi@HIDDEN,
 Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Thu, 4 Mar 2021 12:55:34 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> On Wed, Mar 3, 2021 at 3:34 PM Pip Cet <pipcet@HIDDEN> wrote:
    >> I have time for that now, so here's a revised patch as a first step.

    Pip> This patch removes pure space from Emacs 28.

Cool! Finally! Commit && push, damn the torpedoes.

    Pip> Changes:
    Pip> - now builds with --enable-checking=all

    Pip> Todo:
    Pip> - commit message not yet final.
    Pip> - zero vector handling depends on Qnil being all zero in memory

I think Emacs already assumes Qnil == 0, since there are places that
use ! to check for Qnil rather than using NILP.

Robert
-- 




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 4 Mar 2021 12:56:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 04 07:56:18 2021
Received: from localhost ([127.0.0.1]:58070 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHnWc-0007y5-SA
	for submit <at> debbugs.gnu.org; Thu, 04 Mar 2021 07:56:18 -0500
Received: from mail-oi1-f172.google.com ([209.85.167.172]:43300)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lHnWa-0007xf-M3
 for 36649 <at> debbugs.gnu.org; Thu, 04 Mar 2021 07:56:16 -0500
Received: by mail-oi1-f172.google.com with SMTP id d20so29951699oiw.10
 for <36649 <at> debbugs.gnu.org>; Thu, 04 Mar 2021 04:56:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=qIkmZpOoVCfcOrE95F6p5FZyGB7OYr3Pjl77ClV16go=;
 b=VZOeIXAjD+pk7mhC9Qbv3Cki9XHjAf3GtmjOrvVFYO8Dt6+c+gWdBKn7D4s+rUpUEg
 DHxJWMnP/biuuzyN7T9iQ0ruUcSBjLPZrVIZDOoFLF0yWWI35QRx+GkRphnn9gZSGNIi
 fpWCtHzLIdWXeHka3kqmGj46TCSFg5AfekMT2j5rhABBApA3dhfJSyeo9Kr8Aqdpiqvo
 FPfLGokOJwJipzsPnsb9etR+yIATJ3ytZwgypMzadEH0y2A3IiuqRTBAi4F9Ai+au8kp
 QEZOAAU/JLeLhKorwlxQpzfG5zM9xpMtRZVBuT+vT+++rCwi3KWZTZBVGK3J0PF6P83H
 1OpQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=qIkmZpOoVCfcOrE95F6p5FZyGB7OYr3Pjl77ClV16go=;
 b=tyfAPZF3C60DEDxcuBvq/McHIczVuaJ9f+y2J66Rp1NQ/GfGYlBpMKMR97sr61aKQR
 ltTLANpIQFg5y0gCn/Bnh8dPdqbVTid2i3kStcoYjVhka4encdTIrW2HwPLaAB35aEbA
 XB5PDMllRh6i6ptUtBPxQUaztlBNH/FR1iqZ+/Yt4RXERTxTPhsUEnFjH3C16PB6hK2O
 +Xn3EJ60w+U5zNaVlP+bMtuWyH7PL1eJAzOgpEfIXHmgRXLR1c5RkR2wYEkHzXiNqvqB
 HwVx4OfYc9Fr5b+mwOROFDN2+BMvc8pgqfI2QXbOEv3YM1aXyaYFtGta3VCt1PVJtp4J
 t0Jw==
X-Gm-Message-State: AOAM531++g4gTZiZXWMkK5CKkvZdC+Vzq7FhPP3DwopvN+Lj4X+6sEdN
 27qEMvcH0lou0XNXbDWCTTogaQ6Fsm2B1TMOVTw=
X-Google-Smtp-Source: ABdhPJzKkfnqnU0Cfozbzqevd22SlvAW95oLJM14vBA1YDTdDWB70G4mx0Ku0rN0a7mZ3mCWfvFfvTjCHaPq96sF1bM=
X-Received: by 2002:aca:af0e:: with SMTP id y14mr2921053oie.44.1614862571044; 
 Thu, 04 Mar 2021 04:56:11 -0800 (PST)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
 <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
In-Reply-To: <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Thu, 4 Mar 2021 12:55:34 +0000
Message-ID: <CAOqdjBcKEbb61YHCkN4_9sANAOyKEKoSc0ZGCrtjqeE0En6ERw@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Stefan Kangas <stefankangas@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000e8a40e05bcb57db3"
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN,
 Andreas Schwab <schwab@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--000000000000e8a40e05bcb57db3
Content-Type: text/plain; charset="UTF-8"

On Wed, Mar 3, 2021 at 3:34 PM Pip Cet <pipcet@HIDDEN> wrote:
> I have time for that now, so here's a revised patch as a first step.

This patch removes pure space from Emacs 28.

Changes:
- now builds with --enable-checking=all

Todo:
- commit message not yet final.
- zero vector handling depends on Qnil being all zero in memory

--000000000000e8a40e05bcb57db3
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Remove-pure-space-Bug-36649.patch"
Content-Disposition: attachment; 
	filename="0001-Remove-pure-space-Bug-36649.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kluvesfy0>
X-Attachment-Id: f_kluvesfy0
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--000000000000e8a40e05bcb57db3--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.
Added tag(s) patch. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 3 Mar 2021 15:35:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 03 10:35:23 2021
Received: from localhost ([127.0.0.1]:56694 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lHTX1-0003IT-Oe
	for submit <at> debbugs.gnu.org; Wed, 03 Mar 2021 10:35:23 -0500
Received: from mail-ot1-f46.google.com ([209.85.210.46]:33326)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lHTX0-0003IG-Iq
 for 36649 <at> debbugs.gnu.org; Wed, 03 Mar 2021 10:35:22 -0500
Received: by mail-ot1-f46.google.com with SMTP id 40so15554833otu.0
 for <36649 <at> debbugs.gnu.org>; Wed, 03 Mar 2021 07:35:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=X+LAUXe/ZYlg1KvN8zA3eTjYSwnDhSaU5+62PZEKViM=;
 b=TtN9iSH64MriuwxwdGZs/h9+D+Qj2+IeMpM/oNRN6KFsxHt4/kwXDXhFl9prwak6c7
 GiQpU3JDsSsxiKEQDgSAl+e0E+oy4j9InMiT+8QpNkxxUAl0wPqcN3JLIEippAbJi6nK
 NP07wgxFhCcH7Ep2iOxwQPk7tu8aKycOW8FnT1krBTZnXufFY9EDydvhRcITmbAy246u
 fWuM4a0bVTacr90n7n8FDE0PGaUlnJhniAdhh4LLjZAXF+PjE8Wv1kdGaovI9u7iHXgU
 UAwQzTcMqbdDeH0z7DeZrhww20yn/VnAztnzwBuxdlE3dzCh6A9Meo1O2qbhWLAhnxKA
 WC6g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=X+LAUXe/ZYlg1KvN8zA3eTjYSwnDhSaU5+62PZEKViM=;
 b=jemNcsV1dv0zqdhUnIx07oy6e7bxEofji7LVt7aNNzIMRm55KGcVLrCJxjy5AJEv/J
 LMZ+8t2b7JX1zZ/B7hrAVam8d4B9HUyoFfNq5C66+i9gLKc1SGe9OiqraBTegcTiiqkw
 C/sOzRHDSgwUcgJMD743dpznSNE4LAOajkwAqFZwf1NuGpxY2L1rtf4Xm4MzBBVR7BX0
 nuc8eC1xIqGjhi5GK7PfDBxBUdPt8/jN8a6xr5zBiGKZUAfoNcywbkbsr4gXNPeMHl8g
 zPEhyBM83A6zY38OSIO8JnOAlUSlcYGte/SIdFKXjucCZJPjQBXTapES65dGo2p5uX5N
 K2Zw==
X-Gm-Message-State: AOAM5318emw8Uw2hXQoPGRGUYWfUnRubhuxtgqkZpgBfSfiOkRI4SB9e
 4fN/r/LbKVVt1xmsxerFtSbFR/q4fhAj7ftJnDY=
X-Google-Smtp-Source: ABdhPJwCq0YJ3n1O1h3i5SNbtgnf6o/AiRvhiba3IIaNmZ9A6S0ysJqoFKpMeSaLKnsBffzgCRWPDXcfPgalcnpq+JE=
X-Received: by 2002:a05:6830:1682:: with SMTP id
 k2mr23048200otr.154.1614785716978; 
 Wed, 03 Mar 2021 07:35:16 -0800 (PST)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
In-Reply-To: <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Wed, 3 Mar 2021 15:34:40 +0000
Message-ID: <CAOqdjBc7iAp7=12t_azyzxjagwWW6wo4UP-qFE2YVADroi_aGA@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Stefan Kangas <stefankangas@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000000cb70a05bca3990a"
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN,
 Andreas Schwab <schwab@HIDDEN>, Andrea Corallo <akrl@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--0000000000000cb70a05bca3990a
Content-Type: text/plain; charset="UTF-8"

On Sun, Nov 15, 2020 at 3:19 PM Stefan Kangas <stefankangas@HIDDEN> wrote:
> Pip Cet <pipcet@HIDDEN> writes:
> > On Sat, Aug 22, 2020 at 9:59 AM Andreas Schwab <schwab@HIDDEN> wrote:
> >> On Aug 22 2020, Pip Cet wrote:
> >
> > So my suggestion would be to apply this patch first (removing the C
> > parts of pure space), then remove unexec, then turn purecopy into an
> > alias for identity and remove as many instances of it as possible.
> >
> > Just as a reminder, we're still putting a 3 MB block of zero bytes
> > into every emacs binary...
>
> To me, the above sounds like a reasonable plan, given the discussion in
> this thread and lack of any objections.

Thanks.

> > Should this be discussed on emacs-devel?
>
> Bringing this up on emacs-devel could perhaps get a few more eyes on
> this before it lands on master.  At the very least, it would inform
> everyone about the planned change.  So why not proceed to do that?

I have time for that now, so here's a revised patch as a first step.

--0000000000000cb70a05bca3990a
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Remove-pure-space-Bug-36649.patch"
Content-Disposition: attachment; 
	filename="0001-Remove-pure-space-Bug-36649.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_kltlnrga0>
X-Attachment-Id: f_kltlnrga0
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=
--0000000000000cb70a05bca3990a--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 15 Nov 2020 15:20:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 15 10:20:02 2020
Received: from localhost ([127.0.0.1]:53971 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1keJov-0005Ul-LV
	for submit <at> debbugs.gnu.org; Sun, 15 Nov 2020 10:20:02 -0500
Received: from mail-ej1-f51.google.com ([209.85.218.51]:35809)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefankangas@HIDDEN>) id 1keJos-0005UU-D4
 for 36649 <at> debbugs.gnu.org; Sun, 15 Nov 2020 10:20:00 -0500
Received: by mail-ej1-f51.google.com with SMTP id f23so20864981ejk.2
 for <36649 <at> debbugs.gnu.org>; Sun, 15 Nov 2020 07:19:58 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:in-reply-to:references:mime-version:date:message-id:subject:to
 :cc; bh=/S+4sGPjKREl+LNzSMdpuN3rUg1WboloRhEXIhreMkg=;
 b=n8aMFJiZVabwgEQXFde83Xk3zSXqCxPH6aaFYdwolCuczAepw5/aYHoqkdusATPJCD
 2LjXImFyE63PxqIdYBdOxa+ROJodkBoRRhzU9OrvKepLxGzMNRcTM86XnZ5zgimOqEGu
 gCqBTzw3cemWJyNsKCW+gD9A1304Ik64MEu8+8JliDKv+PdRwzC2YKFbafq72tqmzOfT
 t+Zp3sqIw5WjPBvguGu0bJtSDRka2tdzijbw1+TVOruv7MdzH+GsMAUmbSMfs2mP8u/V
 QAgeZajreDjfcP+YKbZ2nraykPL8zoU8hdJduZHh+bQWmP7CNjcRouzwjL236Qk/GKSP
 Riuw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:in-reply-to:references:mime-version:date
 :message-id:subject:to:cc;
 bh=/S+4sGPjKREl+LNzSMdpuN3rUg1WboloRhEXIhreMkg=;
 b=CcODQ7O7JqlIn3wok+KqIuCYQZqdt5ulv5vHU8D3wvuVnIvGFjn56K6YGwS06cAcAi
 wf7viGwylev2xYRkRpBNYpXd3HXXuxRVav0PuPPfPV/YETVoPlX1dRu3SoV7WdB8X5lB
 W3anXaoBg+d0HihSqvPNmV3SDwBwD0zPc2inxv3DaTwLLKpO5kK9VBak1rlPTWWCluBA
 9vOjmj5PfN5j3ruejtQldGBFyU15NlxLHxl/WxhUakGakSd4hBLSk0RDxGouAasW8hr1
 p3+3kKNukvlOz/FTCcVB1V1w/Aa8HIs6hOsN5l6VjHhiWmEgUEsB6jotNKJM2jjk2SOx
 M74Q==
X-Gm-Message-State: AOAM53280zXbRQR4+GPXt0y7MlPHhLfsNLVo1/8FSC3YcfPjC4jSyJab
 Kvd1b4bo7+rpn0OvivjY87wAJi3DZPquU+W07v0=
X-Google-Smtp-Source: ABdhPJyGntI7eWWDo5amIEgFBqAadsJu0n1EfuaZF4ZmbuvV+beo9Q5TM6LmkLnwsXNZmqaHI0dQ5Y1bmpOXrg51N04=
X-Received: by 2002:a17:906:4e90:: with SMTP id
 v16mr11374907eju.477.1605453592503; 
 Sun, 15 Nov 2020 07:19:52 -0800 (PST)
Received: from 753933720722 named unknown by gmailapi.google.com with
 HTTPREST; Sun, 15 Nov 2020 07:19:51 -0800
From: Stefan Kangas <stefankangas@HIDDEN>
In-Reply-To: <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
MIME-Version: 1.0
Date: Sun, 15 Nov 2020 07:19:51 -0800
Message-ID: <CADwFkm=njrAHmQOx0ZuKnti17XzvpRs9bGorwiz6tPaTMSEFwg@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Pip Cet <pipcet@HIDDEN>, Andreas Schwab <schwab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> On Sat, Aug 22, 2020 at 9:59 AM Andreas Schwab <schwab@HIDDEN> wrote:
>> On Aug 22 2020, Pip Cet wrote:
>> > +purecopy (Lisp_Object obj);
>> >
>> >  DEFUN ("purecopy", Fpurecopy, Spurecopy, 1, 1, 0,
>> >         doc: /* Make a copy of object OBJ in pure storage.
>>
>> Perhaps purecopy should be dropped or made a no-op?
>
> I believe that would be a logical next step, yes. The comment in
> loadup.el says hash-consing saves "around 11% of pure space", which
> sounds like it isn't worth the hassle to me.
>
> So my suggestion would be to apply this patch first (removing the C
> parts of pure space), then remove unexec, then turn purecopy into an
> alias for identity and remove as many instances of it as possible.
>
> Just as a reminder, we're still putting a 3 MB block of zero bytes
> into every emacs binary...

To me, the above sounds like a reasonable plan, given the discussion in
this thread and lack of any objections.

> Should this be discussed on emacs-devel?

Bringing this up on emacs-devel could perhaps get a few more eyes on
this before it lands on master.  At the very least, it would inform
everyone about the planned change.  So why not proceed to do that?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 28 Aug 2020 14:24:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 28 10:24:55 2020
Received: from localhost ([127.0.0.1]:47070 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kBfJH-0003Dn-KU
	for submit <at> debbugs.gnu.org; Fri, 28 Aug 2020 10:24:55 -0400
Received: from mx.sdf.org ([205.166.94.24]:56127)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1kBfJB-0003DX-SP
 for 36649 <at> debbugs.gnu.org; Fri, 28 Aug 2020 10:24:54 -0400
Received: from mab (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTP id 07SEOctg019702;
 Fri, 28 Aug 2020 14:24:38 GMT
From: Andrea Corallo <akrl@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
 <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
Date: Fri, 28 Aug 2020 14:24:38 +0000
In-Reply-To: <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
 (Pip Cet's message of "Fri, 28 Aug 2020 12:32:10 +0000")
Message-ID: <xjf7dti26hl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, eggert@HIDDEN,
 Andreas Schwab <schwab@HIDDEN>, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> Should this be discussed on emacs-devel? I've CC'd Andrea since I
> believe the native-comp branch interacts with pure space in
> complicated ways.

Hi Pip,

thanks, as this gets into master I'll do the required modifications into
native-comp.  It should bring some simplification in.

Ciao

  Andrea




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 28 Aug 2020 12:32:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 28 08:32:54 2020
Received: from localhost ([127.0.0.1]:45435 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kBdYs-00043g-AS
	for submit <at> debbugs.gnu.org; Fri, 28 Aug 2020 08:32:54 -0400
Received: from mail-ot1-f46.google.com ([209.85.210.46]:45570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1kBdYq-00043R-LY
 for 36649 <at> debbugs.gnu.org; Fri, 28 Aug 2020 08:32:53 -0400
Received: by mail-ot1-f46.google.com with SMTP id 5so612236otp.12
 for <36649 <at> debbugs.gnu.org>; Fri, 28 Aug 2020 05:32:52 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=OxXeW+087aMam9OP08EN4fVAmtp7jALjh9QTcvzs1f8=;
 b=DL6OhxyaqQ9nN6CxSFDSupCZnkFfYEaWCNz2p1L+uDXB1X6ULJ+3CjD0Ws/4zXIdMy
 Qh0JVIb0HtZ77KB4hxbfSo2t+yC9Cz6q3iJmek4HpmSIa0QGIdPBl0U+lDyWKuUKM3f5
 LM9iKmjnCXi/4qhX7lMcnFoJWxjzmKSOxfl6+0F5Qj7KcpiquywN2sY18ptk3V8vTvw0
 HD4zuHhQHHaRMHZiCDTIci0SGGHbxFN71FziczJ48wba07Z6nngKgEIv3+Zt15mWkOyw
 ARzL+4dXA9wRaPgq/j5tGQ14KOQ4/D7AMFN/nzIFtpXSS0dLA/DSOUYTG50VkX5Vcr7P
 kXaA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=OxXeW+087aMam9OP08EN4fVAmtp7jALjh9QTcvzs1f8=;
 b=t2Q6Kh/kWggqKPAuKMgxNSjZtbZytd8LOJmf68sfIgeWYRjajmXK+PUZtVq0rCWIPw
 WZaAKuhqSagp1jWWnO1CClGKdpTQKX9u9QVCcwYDN8mZaxvwuMgQPH3d3iDiUSvvP6fz
 Y6b2T25E+nDfKjc4PiOzkzSgaQ5uhc8uMk7NlfF2etDjcAT/cKi55IA+xQUGB312xaOM
 B6T0CUdwJc7eQTvLS894ABKIthdPxzh0rXMjTyioGFL7A05xx7qeTizMmJseDZ7H4+eZ
 jfCI8zRibDs+TobTl0gfVT8vbaABXvwiGhXQpCDkX69EbkFyV+xbwI9eVlm1lDtSQMY+
 yIgA==
X-Gm-Message-State: AOAM5326L5dCrFgKS+zndBE+FR35T+v0BAoESUvaoJSMCNIuuMDxSbWu
 mwL817DerQ+7XmmFJu+LCph6Tayn3mJMKBibbjI=
X-Google-Smtp-Source: ABdhPJwCYhTxmNyoNzWllvXlUYKlMPVbKPqR6d9MgU8FNS8/72VwoGjozWhhkuoHY1pcznd04cOduqRyyFP2q4QMlLI=
X-Received: by 2002:a9d:6d92:: with SMTP id x18mr916240otp.287.1598617966757; 
 Fri, 28 Aug 2020 05:32:46 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 <87h7svc87d.fsf@HIDDEN>
In-Reply-To: <87h7svc87d.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 28 Aug 2020 12:32:10 +0000
Message-ID: <CAOqdjBdpFCE0JYKVLVgfKGtrf00ZgTTjzztiKzrVEPsZE=HBcg@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Andreas Schwab <schwab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, eggert@HIDDEN,
 larsi@HIDDEN, akrl@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Aug 22, 2020 at 9:59 AM Andreas Schwab <schwab@HIDDEN> wrote:
> On Aug 22 2020, Pip Cet wrote:
> > +purecopy (Lisp_Object obj);
> >
> >  DEFUN ("purecopy", Fpurecopy, Spurecopy, 1, 1, 0,
> >         doc: /* Make a copy of object OBJ in pure storage.
>
> Perhaps purecopy should be dropped or made a no-op?

I believe that would be a logical next step, yes. The comment in
loadup.el says hash-consing saves "around 11% of pure space", which
sounds like it isn't worth the hassle to me.

So my suggestion would be to apply this patch first (removing the C
parts of pure space), then remove unexec, then turn purecopy into an
alias for identity and remove as many instances of it as possible.

Just as a reminder, we're still putting a 3 MB block of zero bytes
into every emacs binary...

Should this be discussed on emacs-devel? I've CC'd Andrea since I
believe the native-comp branch interacts with pure space in
complicated ways.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Aug 2020 17:37:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Aug 22 13:37:08 2020
Received: from localhost ([127.0.0.1]:51343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k9XRz-00057l-Vl
	for submit <at> debbugs.gnu.org; Sat, 22 Aug 2020 13:37:08 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:51398)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1k9XRw-00057D-S5
 for 36649 <at> debbugs.gnu.org; Sat, 22 Aug 2020 13:37:06 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 8DB821600EB;
 Sat, 22 Aug 2020 10:36:58 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id UisoEKxNddmf; Sat, 22 Aug 2020 10:36:57 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id D19D31600ED;
 Sat, 22 Aug 2020 10:36:57 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id iWsT1G0lKgbJ; Sat, 22 Aug 2020 10:36:57 -0700 (PDT)
Received: from [192.168.1.9] (cpe-75-82-69-226.socal.res.rr.com [75.82.69.226])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 83D0D1600EB;
 Sat, 22 Aug 2020 10:36:57 -0700 (PDT)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Pip Cet <pipcet@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Autocrypt: addr=eggert@HIDDEN; prefer-encrypt=mutual; keydata=
 LS0tLS1CRUdJTiBQR1AgUFVCTElDIEtFWSBCTE9DSy0tLS0tCgptUUlOQkV5QWNtUUJFQURB
 QXlIMnhvVHU3cHBHNUQzYThGTVpFb243NGRDdmM0K3ExWEEySjJ0QnkycHdhVHFmCmhweHhk
 R0E5Smo1MFVKM1BENGJTVUVnTjh0TFowc2FuNDdsNVhUQUZMaTI0NTZjaVNsNW04c0thSGxH
 ZHQ5WG0KQUF0bVhxZVpWSVlYL1VGUzk2ZkR6ZjR4aEVtbS95N0xiWUVQUWRVZHh1NDd4QTVL
 aFRZcDVibHRGM1dZRHoxWQpnZDdneDA3QXV3cDdpdzdlTnZub0RUQWxLQWw4S1lEWnpiRE5D
 UUdFYnBZM2VmWkl2UGRlSStGV1FONFcra2doCnkrUDZhdTZQcklJaFlyYWV1YTdYRGRiMkxT
 MWVuM1NzbUUzUWpxZlJxSS9BMnVlOEpNd3N2WGUvV0szOEV6czYKeDc0aVRhcUkzQUZINmls
 QWhEcXBNbmQvbXNTRVNORnQ3NkRpTzFaS1FNcjlhbVZQa25qZlBtSklTcWRoZ0IxRApsRWR3
 MzRzUk9mNlY4bVp3MHhmcVQ2UEtFNDZMY0ZlZnpzMGtiZzRHT1JmOHZqRzJTZjF0azVlVThN
 Qml5Ti9iClowM2JLTmpOWU1wT0REUVF3dVA4NGtZTGtYMndCeHhNQWhCeHdiRFZadWR6eERa
 SjFDMlZYdWpDT0pWeHEya2wKakJNOUVUWXVVR3FkNzVBVzJMWHJMdzYrTXVJc0hGQVlBZ1Jy
 NytLY3dEZ0JBZndoUEJZWDM0blNTaUhsbUxDKwpLYUhMZUNMRjVaSTJ2S20zSEVlQ1R0bE9n
 N3haRU9OZ3d6TCtmZEtvK0Q2U29DOFJSeEpLczhhM3NWZkk0dDZDCm5yUXp2SmJCbjZneGRn
 Q3U1aTI5SjFRQ1lyQ1l2cWwyVXlGUEFLK2RvOTkvMWpPWFQ0bTI4MzZqMXdBUkFRQUIKdENC
 UVlYVnNJRVZuWjJWeWRDQThaV2RuWlhKMFFHTnpMblZqYkdFdVpXUjFQb2tDUGdRVEFRSUFL
 QVVDVElCeQpaQUliQXdVSkVzd0RBQVlMQ1FnSEF3SUdGUWdDQ1FvTEJCWUNBd0VDSGdFQ0Y0
 QUFDZ2tRN1pmcERtS3FmalJSCkd3LytJajAzZGhZZllsL2dYVlJpdXpWMWdHcmJIayt0bmZy
 SS9DN2ZBZW9GelE1dFZnVmluU2hhUGtabzBIVFAKZjE4eDZJREVkQWlPOE1xbzF5cDBDdEht
 ekdNQ0o1MG80R3JnZmpscjZnLyt2dEVPS2JobGVzek4yWHBKdnB3TQoyUWdHdm4vbGFUTFV1
 OFBIOWFSV1RzN3FKSlpLS0tBYjRzeFljOTJGZWhQdTZGT0QwZERpeWhsREFxNGxPVjJtCmRC
 cHpRYmlvam9aelFMTVF3anBnQ1RLMjU3MmVLOUVPRVF5U1VUaFhyU0l6NkFTZW5wNE5ZVEZI
 czl0dUpRdlgKazlnWkRkUFNsM2JwKzQ3ZEd4bHhFV0xwQklNN3pJT053NGtzNGF6Z1Q4bnZE
 WnhBNUlaSHR2cUJsSkxCT2JZWQowTGU2MVdwMHkzVGxCRGgycWRLOGVZTDQyNlc0c2NFTVN1
 aWc1Z2I4T0F0UWlCVzZrMnNHVXh4ZWl2OG92V3U4CllBWmdLSmZ1b1dJK3VSbk1FZGRydVk4
 SnNvTTU0S2FLdlppa2tLczJiZzFuZHRMVnpIcEo2cUZaQzdRVmplSFUKaDYvQm1ndmRqV1Ba
 WUZUdE4rS0E5Q1dYM0dRS0tnTjN1dTk4OHl6bkQ3TG5COThUNEVVSDFIQS9HbmZCcU1WMQpn
 cHpUdlBjNHFWUWluQ21Ja0VGcDgzemwrRzVmQ2pKSjNXN2l2ekNuWW80S2hLTHBGVW05N29r
 VEtSMkxXM3haCnpFVzRjTFNXTzM4N01USzNDekRPeDVxZTZzNGE5MVp1Wk0vai9UUWRUTERh
 cU5uODNrQTRIcTQ4VUhYWXhjSWgKK05kOGsvM3c2bEZ1b0swd3JPRml5d2pMeCswdXI1am1t
 YmVjQkdIYzF4ZGhBRkc1QWcwRVRJQnlaQUVRQUthRgo2NzhUOXd5SDR3alRyVjFQejNjREVv
 U25WLzBaVXJPVDM3cDFkY0d5ai9JWHExeDY3MEhSVmFoQW1rMHNacFljCjI1UEY5RDVHUFlI
 RldsTmp1UFU5NnJEbmRYQjNoZWRtQlJoTGRDNGJBWGpJNERWK2JtZFZlK3EvSU1ubFpSYVYK
 bG05RWlNQ1ZBUjZ3MTNzUmV1N3FYa1c5cjNSd1kyQXpYc2twL3RBZTRCUktyMVptYnZpMm5i
 blE2ZXBFQzQycgpSYngwQjFFaGpiSVFaNUpIR2syNGlQVDdMZEJnbk5tb3M1d1lqendObGtN
 UUQ1VDBZZHpoazdKK1V4d0E1bTQ2Cm1PaFJEQzJyRlYvQTBnbTVUTHk4RFhqdi9Fc2M0Z1lu
 WWFpNlNRcW5VRVZoNUx1VjhZQ0pCbmlqcytUaXc3MXgKMWljbW42eEdJNDVFdWdKT2dlYyty
 THlwWWdwVnA0eDBISTVUODhxQlJZQ2t4SDNLZzhRbytFV05BOUE0TFJROQpEWDhuam9uYTBn
 ZjBzMDN0b2NLOGtCTjY2VW9xcVB0SEJuYzRlTWdCeW1DZmxLMTJlS2ZkMllZeG55ZzljWmF6
 CldBNVZzbHZUeHBtNzZoYmc1b2lBRUgvVmcvOE14SHlBblBoZnJnd3lQcm1KRWNWQmFmZHNw
 Sm5ZUXhCWU5jbzIKTEZQSWhsT3ZXaDhyNGF0K3MrTTNMYjI2b1VUY3psZ2RXMVNmM1NEQTc3
 Qk1SbkYwRlF5RSs3QXpWNzlNQk40eQpraXFhZXpReHRhRjFGeS90dmtoZmZTbzh1K2R3RzBF
 Z0poK3RlMzhnVGNJU1ZyMEdJUHBsTHo2WWhqcmJIclBSCkYxQ041VXVMOURCR2p4dU4zNVJM
 TlZFZnRhNlJVRmxSNk5jdFRqdnJBQkVCQUFHSkFpVUVHQUVDQUE4RkFreUEKY21RQ0d3d0ZD
 UkxNQXdBQUNna1E3WmZwRG1LcWZqU3JIQS8rS3pBS3ZUeFJoQTlNV05MeEl5SjdTNXVKMTZn
 cwpUM29DalpyQktHRWhLTU9HWDRPMEdBNlZPRXJ5TzdRUkNDWWFoM294U0czOElBbk5laXdK
 WGdVOUJ6a2s4NVVHCmJQRWQ3SEdGL1ZTZUhDUXdXb3U2anFVRFRTRHZuOVloTlRkRzBLWFBN
 NzRhQyt4cjJab3cxTzJtaFhpaGdXS0QKMER3KzBMWVBuVU9zUTBLT0Z4SFhYWUhtUnJTMU9a
 UFU1OUJMdmMrVFJoSWhhZlNIS0x3YlhLKzZja2t4Qng2aAo4ejVjY3BHMFFzNGJGaGRGWW5G
 ckVpZURMb0dtbkUyWUxoZFY2c3dKOVZOQ1M2cExpRW9oVDNmbTdhWG0xNXRaCk9JeXpNWmhI
 UlNBUGJsWHhRMFpTV2pxOG9ScmNZTkZ4YzRXMVVScEFrQkNPWUpvWHZRZkQ1TDNscUFsOFRD
 cUQKVXpZeGhIL3RKaGJEZEhycUhINzY3amFEYVRCMStUYWxwLzJBTUt3Y1hOT2Rpa2xHeGJt
 SFZHNllHbDZnOExyYgpzdTlOWkVJNHlMbEh6dWlrdGhKV2d6KzN2WmhWR3lObHQrSE5Jb0Y2
 Q2pETDJvbXU1Y0VxNFJESE00NFFxUGs2Cmw3TzBwVXZOMW1UNEIrUzFiMDhSS3BxbS9mZjAx
 NUUzN0hOVi9waUl2Smx4R0FZejhQU2Z1R0NCMXRoTVlxbG0KZ2RoZDkvQmFiR0ZiR0dZSEE2
 VTQvVDV6cVUrZjZ4SHkxU3NBUVoxTVNLbEx3ZWtCSVQrNC9jTFJHcUNIam5WMApxNUgvVDZh
 N3Q1bVBrYnpTck9MU280cHVqK0lUb05qWXlZSURCV3pobEExOWF2T2ErcnZVam1IdEQzc0ZO
 N2NYCld0a0dvaThidU5jYnk0VT0KPUFMNm8KLS0tLS1FTkQgUEdQIFBVQkxJQyBLRVkgQkxP
 Q0stLS0tLQo=
Organization: UCLA Computer Science Department
Message-ID: <6764df84-d6a9-9e12-f569-e6817e2ff30b@HIDDEN>
Date: Sat, 22 Aug 2020 10:36:57 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.10.0
MIME-Version: 1.0
In-Reply-To: <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -3.2 (---)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.2 (----)

On 8/22/20 1:55 AM, Pip Cet wrote:
> it appears like unexec builds are currently broken on master

At this point any effort to keep unexec builds working is wasted effort, except 
perhaps as an exercise in nostalgia.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Aug 2020 09:59:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Aug 22 05:59:24 2020
Received: from localhost ([127.0.0.1]:48902 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k9QJ2-000081-EW
	for submit <at> debbugs.gnu.org; Sat, 22 Aug 2020 05:59:24 -0400
Received: from mail-out.m-online.net ([212.18.0.9]:60724)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1k9QIz-00007R-6B
 for 36649 <at> debbugs.gnu.org; Sat, 22 Aug 2020 05:59:23 -0400
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4BYYkv6xmwz1qrfT;
 Sat, 22 Aug 2020 11:59:19 +0200 (CEST)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4BYYkv6RDZz1r57J;
 Sat, 22 Aug 2020 11:59:19 +0200 (CEST)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id 8Y1TzIVyPDdm; Sat, 22 Aug 2020 11:59:19 +0200 (CEST)
X-Auth-Info: Pvv94Wrb+98fYACWqQ5w1GtIp9fo9HouQbXcp31MsICI2rEc9gG1rlDQsul50q7d
Received: from igel.home (ppp-46-244-175-181.dynamic.mnet-online.de
 [46.244.175.181])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Sat, 22 Aug 2020 11:59:19 +0200 (CEST)
Received: by igel.home (Postfix, from userid 1000)
 id 7D42E2C0B3A; Sat, 22 Aug 2020 11:59:18 +0200 (CEST)
From: Andreas Schwab <schwab@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
 <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
X-Yow: Yow!  Is my fallout shelter termite proof?
Date: Sat, 22 Aug 2020 11:59:18 +0200
In-Reply-To: <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
 (Pip Cet's message of "Sat, 22 Aug 2020 08:55:21 +0000")
Message-ID: <87h7svc87d.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, eggert@HIDDEN,
 larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

On Aug 22 2020, Pip Cet wrote:

> +purecopy (Lisp_Object obj);
>  
>  DEFUN ("purecopy", Fpurecopy, Spurecopy, 1, 1, 0,
>         doc: /* Make a copy of object OBJ in pure storage.

Perhaps purecopy should be dropped or made a no-op?

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Aug 2020 08:56:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Aug 22 04:56:06 2020
Received: from localhost ([127.0.0.1]:48869 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k9PJm-00077N-9c
	for submit <at> debbugs.gnu.org; Sat, 22 Aug 2020 04:56:06 -0400
Received: from mail-oi1-f193.google.com ([209.85.167.193]:41474)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1k9PJk-00076t-O3
 for 36649 <at> debbugs.gnu.org; Sat, 22 Aug 2020 04:56:04 -0400
Received: by mail-oi1-f193.google.com with SMTP id b22so3635319oic.8
 for <36649 <at> debbugs.gnu.org>; Sat, 22 Aug 2020 01:56:04 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=mftMgtqMUddhaPKuzT6O91xWnB5YnTA1I/cKfnQUdGY=;
 b=SvNYPANnwhf2AY7Dg+bpOMQVZOSlLkgETEX3+i4mwDOuq64naLQxxCWmuaMgtYfRfI
 qcvSvULFq3551xSvNPo8C8WfBWkCAFsYqmBS2haDOPEx00wyn2japufCs4qhpglgYgbY
 VhSYPPgxPNN8JwvhCwEZtCPWDgEH3XiJqFUllioGsVuIWyBUjcbmXT6jxJreCg0cKAIX
 WEIyrCpvz/qSlLLPR+vdlMmkMDHdsj3r/EZW57/Ay8Ocr/hEsayi2d9yf6/kv1OmdNnY
 HjRFta6epCkeAndRu25dAHr5iw0g/1lpnd5bi5lvD9dl4V9sAdg6Y+vbxl5pHkO6Wp4q
 VNCg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=mftMgtqMUddhaPKuzT6O91xWnB5YnTA1I/cKfnQUdGY=;
 b=oSujTIw9hX+ZDTAICd9Zx0nTHAs1taeuRERbS4LqvVAn1C1Is9KbkSpHOZowA3qht6
 0CSezYWghVWxjVwb/m9s+xtuofqoMuOULv3P76PSUXF51UEKRY1qndj+rGFrtD0jYv0F
 aNX6giGl8x1LUXmZy4p2Q4PLIIsw5HEhpluonWwBfvr90RCzVVXu6kAQDjirmR1OHsuH
 +AXg7oNaSUhJqM8PQwR5EyEC5rqYYq5Tz6f1nlDp5ZTwQnsjQVK6wanc9MKEIshDFp5U
 HIiOW5HeeSagHkeYuSSE/FCoaj3uK83rJdT7A7rQO0/3xk3pTQMhfvzqYlJCa5YitA3u
 XowA==
X-Gm-Message-State: AOAM532PQBpkQgZqJ4FF1G5GZqkGMgdFEeGxZdZUBZi7tUlSij4lMJQq
 E/vcwG0Z9NySboknNF2UoAubd2K2CodcQ6RZHbQ=
X-Google-Smtp-Source: ABdhPJxTZ0Y0Rqp2otqdQgLFndb25ta1NA+Usqp2UtjzVVZNMyJeCse0K0XwazPVyKRMGVSNuN0ac0lzhQXgECuiU78=
X-Received: by 2002:aca:dc04:: with SMTP id t4mr4166905oig.30.1598086559011;
 Sat, 22 Aug 2020 01:55:59 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
In-Reply-To: <83d03kaz6f.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sat, 22 Aug 2020 08:55:21 +0000
Message-ID: <CAOqdjBcfZrFTyMHyNtTF14+dkgzD3xBxPPkaHoB89O_qW2Juag@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000abbbb605ad73853c"
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--000000000000abbbb605ad73853c
Content-Type: text/plain; charset="UTF-8"

On Fri, Aug 21, 2020 at 1:47 PM Eli Zaretskii <eliz@HIDDEN> wrote:
> > From: Pip Cet <pipcet@HIDDEN>
> > Date: Fri, 21 Aug 2020 13:04:47 +0000
> > Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
> >
> > On Fri, Aug 21, 2020 at 12:52 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> > > I didn't read this thread closely, but it seems like the conclusion that
> > > this patch should have been applied.  (It removes pure space,
> > > apparently?)
> > >
> > > The patch never was applied, though -- should it be applied now?
> >
> > I believe it's best to be careful with this one. Pure space affects GC
> > in subtle ways, and it also affects performance.
> >
> > See this thread:
> > https://lists.gnu.org/archive/html/emacs-devel/2019-07/msg00588.html
> >
> > I'd be happy to set up a separate branch for removing pure space if
> > that's preferred.
>
> What do we do with unexec builds, which are still supported?

I think that's an important question, but I don't think it's strongly
connected to pure space.

In fact, it appears like unexec builds are currently broken on master,
and on this GNU/Linux machine, I've got to force use of HYBRID_MALLOC
to get an unexec build starting at all. But, having done that, it
works with and without the patch, at first glance.

Rebased patch attached (but I just noticed  the commit message is no
longer complete).

--000000000000abbbb605ad73853c
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Remove-pure-space.patch"
Content-Disposition: attachment; filename="0001-Remove-pure-space.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_ke5ffoyc0>
X-Attachment-Id: f_ke5ffoyc0
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--000000000000abbbb605ad73853c--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Aug 2020 03:51:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 23:51:22 2020
Received: from localhost ([127.0.0.1]:48601 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k9KYs-00081e-LP
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 23:51:22 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39534)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rms@HIDDEN>) id 1k9KYq-00081Q-2p
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 23:51:21 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59602)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <rms@HIDDEN>)
 id 1k9KYj-0004xL-Pg; Fri, 21 Aug 2020 23:51:13 -0400
Received: from rms by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rms@HIDDEN>)
 id 1k9KYh-0002Ty-JA; Fri, 21 Aug 2020 23:51:11 -0400
Content-Type: text/plain; charset=Utf-8
From: Richard Stallman <rms@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
In-Reply-To: <83d03kaz6f.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 21
 Aug 2020 16:47:20 +0300)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
Message-Id: <E1k9KYh-0002Ty-JA@HIDDEN>
Date: Fri, 21 Aug 2020 23:51:11 -0400
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN, pipcet@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: rms@HIDDEN
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

[[[ To any NSA and FBI agents reading my email: please consider    ]]]
[[[ whether defending the US Constitution against all enemies,     ]]]
[[[ foreign or domestic, requires you to follow Snowden's example. ]]]

I don't think we should desupport unexec while the pdumper is so new.

-- 
Dr Richard Stallman
Chief GNUisance of the GNU Project (https://gnu.org)
Founder, Free Software Foundation (https://fsf.org)
Internet Hall-of-Famer (https://internethalloffame.org)






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Aug 2020 21:41:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 17:41:50 2020
Received: from localhost ([127.0.0.1]:48425 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k9EnG-0007hn-G9
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 17:41:50 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:39550)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1k9EnD-0007hZ-68
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 17:41:49 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id AC89D160084;
 Fri, 21 Aug 2020 14:41:41 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id u8CkBdB3fOV6; Fri, 21 Aug 2020 14:41:41 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 0770F1600C6;
 Fri, 21 Aug 2020 14:41:41 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id MVTZHaHXNtqN; Fri, 21 Aug 2020 14:41:40 -0700 (PDT)
Received: from [192.168.1.9] (cpe-75-82-69-226.socal.res.rr.com [75.82.69.226])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id BDF0A160084;
 Fri, 21 Aug 2020 14:41:40 -0700 (PDT)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Eli Zaretskii <eliz@HIDDEN>, Pip Cet <pipcet@HIDDEN>
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Autocrypt: addr=eggert@HIDDEN; prefer-encrypt=mutual; keydata=
 LS0tLS1CRUdJTiBQR1AgUFVCTElDIEtFWSBCTE9DSy0tLS0tCgptUUlOQkV5QWNtUUJFQURB
 QXlIMnhvVHU3cHBHNUQzYThGTVpFb243NGRDdmM0K3ExWEEySjJ0QnkycHdhVHFmCmhweHhk
 R0E5Smo1MFVKM1BENGJTVUVnTjh0TFowc2FuNDdsNVhUQUZMaTI0NTZjaVNsNW04c0thSGxH
 ZHQ5WG0KQUF0bVhxZVpWSVlYL1VGUzk2ZkR6ZjR4aEVtbS95N0xiWUVQUWRVZHh1NDd4QTVL
 aFRZcDVibHRGM1dZRHoxWQpnZDdneDA3QXV3cDdpdzdlTnZub0RUQWxLQWw4S1lEWnpiRE5D
 UUdFYnBZM2VmWkl2UGRlSStGV1FONFcra2doCnkrUDZhdTZQcklJaFlyYWV1YTdYRGRiMkxT
 MWVuM1NzbUUzUWpxZlJxSS9BMnVlOEpNd3N2WGUvV0szOEV6czYKeDc0aVRhcUkzQUZINmls
 QWhEcXBNbmQvbXNTRVNORnQ3NkRpTzFaS1FNcjlhbVZQa25qZlBtSklTcWRoZ0IxRApsRWR3
 MzRzUk9mNlY4bVp3MHhmcVQ2UEtFNDZMY0ZlZnpzMGtiZzRHT1JmOHZqRzJTZjF0azVlVThN
 Qml5Ti9iClowM2JLTmpOWU1wT0REUVF3dVA4NGtZTGtYMndCeHhNQWhCeHdiRFZadWR6eERa
 SjFDMlZYdWpDT0pWeHEya2wKakJNOUVUWXVVR3FkNzVBVzJMWHJMdzYrTXVJc0hGQVlBZ1Jy
 NytLY3dEZ0JBZndoUEJZWDM0blNTaUhsbUxDKwpLYUhMZUNMRjVaSTJ2S20zSEVlQ1R0bE9n
 N3haRU9OZ3d6TCtmZEtvK0Q2U29DOFJSeEpLczhhM3NWZkk0dDZDCm5yUXp2SmJCbjZneGRn
 Q3U1aTI5SjFRQ1lyQ1l2cWwyVXlGUEFLK2RvOTkvMWpPWFQ0bTI4MzZqMXdBUkFRQUIKdENC
 UVlYVnNJRVZuWjJWeWRDQThaV2RuWlhKMFFHTnpMblZqYkdFdVpXUjFQb2tDUGdRVEFRSUFL
 QVVDVElCeQpaQUliQXdVSkVzd0RBQVlMQ1FnSEF3SUdGUWdDQ1FvTEJCWUNBd0VDSGdFQ0Y0
 QUFDZ2tRN1pmcERtS3FmalJSCkd3LytJajAzZGhZZllsL2dYVlJpdXpWMWdHcmJIayt0bmZy
 SS9DN2ZBZW9GelE1dFZnVmluU2hhUGtabzBIVFAKZjE4eDZJREVkQWlPOE1xbzF5cDBDdEht
 ekdNQ0o1MG80R3JnZmpscjZnLyt2dEVPS2JobGVzek4yWHBKdnB3TQoyUWdHdm4vbGFUTFV1
 OFBIOWFSV1RzN3FKSlpLS0tBYjRzeFljOTJGZWhQdTZGT0QwZERpeWhsREFxNGxPVjJtCmRC
 cHpRYmlvam9aelFMTVF3anBnQ1RLMjU3MmVLOUVPRVF5U1VUaFhyU0l6NkFTZW5wNE5ZVEZI
 czl0dUpRdlgKazlnWkRkUFNsM2JwKzQ3ZEd4bHhFV0xwQklNN3pJT053NGtzNGF6Z1Q4bnZE
 WnhBNUlaSHR2cUJsSkxCT2JZWQowTGU2MVdwMHkzVGxCRGgycWRLOGVZTDQyNlc0c2NFTVN1
 aWc1Z2I4T0F0UWlCVzZrMnNHVXh4ZWl2OG92V3U4CllBWmdLSmZ1b1dJK3VSbk1FZGRydVk4
 SnNvTTU0S2FLdlppa2tLczJiZzFuZHRMVnpIcEo2cUZaQzdRVmplSFUKaDYvQm1ndmRqV1Ba
 WUZUdE4rS0E5Q1dYM0dRS0tnTjN1dTk4OHl6bkQ3TG5COThUNEVVSDFIQS9HbmZCcU1WMQpn
 cHpUdlBjNHFWUWluQ21Ja0VGcDgzemwrRzVmQ2pKSjNXN2l2ekNuWW80S2hLTHBGVW05N29r
 VEtSMkxXM3haCnpFVzRjTFNXTzM4N01USzNDekRPeDVxZTZzNGE5MVp1Wk0vai9UUWRUTERh
 cU5uODNrQTRIcTQ4VUhYWXhjSWgKK05kOGsvM3c2bEZ1b0swd3JPRml5d2pMeCswdXI1am1t
 YmVjQkdIYzF4ZGhBRkc1QWcwRVRJQnlaQUVRQUthRgo2NzhUOXd5SDR3alRyVjFQejNjREVv
 U25WLzBaVXJPVDM3cDFkY0d5ai9JWHExeDY3MEhSVmFoQW1rMHNacFljCjI1UEY5RDVHUFlI
 RldsTmp1UFU5NnJEbmRYQjNoZWRtQlJoTGRDNGJBWGpJNERWK2JtZFZlK3EvSU1ubFpSYVYK
 bG05RWlNQ1ZBUjZ3MTNzUmV1N3FYa1c5cjNSd1kyQXpYc2twL3RBZTRCUktyMVptYnZpMm5i
 blE2ZXBFQzQycgpSYngwQjFFaGpiSVFaNUpIR2syNGlQVDdMZEJnbk5tb3M1d1lqendObGtN
 UUQ1VDBZZHpoazdKK1V4d0E1bTQ2Cm1PaFJEQzJyRlYvQTBnbTVUTHk4RFhqdi9Fc2M0Z1lu
 WWFpNlNRcW5VRVZoNUx1VjhZQ0pCbmlqcytUaXc3MXgKMWljbW42eEdJNDVFdWdKT2dlYyty
 THlwWWdwVnA0eDBISTVUODhxQlJZQ2t4SDNLZzhRbytFV05BOUE0TFJROQpEWDhuam9uYTBn
 ZjBzMDN0b2NLOGtCTjY2VW9xcVB0SEJuYzRlTWdCeW1DZmxLMTJlS2ZkMllZeG55ZzljWmF6
 CldBNVZzbHZUeHBtNzZoYmc1b2lBRUgvVmcvOE14SHlBblBoZnJnd3lQcm1KRWNWQmFmZHNw
 Sm5ZUXhCWU5jbzIKTEZQSWhsT3ZXaDhyNGF0K3MrTTNMYjI2b1VUY3psZ2RXMVNmM1NEQTc3
 Qk1SbkYwRlF5RSs3QXpWNzlNQk40eQpraXFhZXpReHRhRjFGeS90dmtoZmZTbzh1K2R3RzBF
 Z0poK3RlMzhnVGNJU1ZyMEdJUHBsTHo2WWhqcmJIclBSCkYxQ041VXVMOURCR2p4dU4zNVJM
 TlZFZnRhNlJVRmxSNk5jdFRqdnJBQkVCQUFHSkFpVUVHQUVDQUE4RkFreUEKY21RQ0d3d0ZD
 UkxNQXdBQUNna1E3WmZwRG1LcWZqU3JIQS8rS3pBS3ZUeFJoQTlNV05MeEl5SjdTNXVKMTZn
 cwpUM29DalpyQktHRWhLTU9HWDRPMEdBNlZPRXJ5TzdRUkNDWWFoM294U0czOElBbk5laXdK
 WGdVOUJ6a2s4NVVHCmJQRWQ3SEdGL1ZTZUhDUXdXb3U2anFVRFRTRHZuOVloTlRkRzBLWFBN
 NzRhQyt4cjJab3cxTzJtaFhpaGdXS0QKMER3KzBMWVBuVU9zUTBLT0Z4SFhYWUhtUnJTMU9a
 UFU1OUJMdmMrVFJoSWhhZlNIS0x3YlhLKzZja2t4Qng2aAo4ejVjY3BHMFFzNGJGaGRGWW5G
 ckVpZURMb0dtbkUyWUxoZFY2c3dKOVZOQ1M2cExpRW9oVDNmbTdhWG0xNXRaCk9JeXpNWmhI
 UlNBUGJsWHhRMFpTV2pxOG9ScmNZTkZ4YzRXMVVScEFrQkNPWUpvWHZRZkQ1TDNscUFsOFRD
 cUQKVXpZeGhIL3RKaGJEZEhycUhINzY3amFEYVRCMStUYWxwLzJBTUt3Y1hOT2Rpa2xHeGJt
 SFZHNllHbDZnOExyYgpzdTlOWkVJNHlMbEh6dWlrdGhKV2d6KzN2WmhWR3lObHQrSE5Jb0Y2
 Q2pETDJvbXU1Y0VxNFJESE00NFFxUGs2Cmw3TzBwVXZOMW1UNEIrUzFiMDhSS3BxbS9mZjAx
 NUUzN0hOVi9waUl2Smx4R0FZejhQU2Z1R0NCMXRoTVlxbG0KZ2RoZDkvQmFiR0ZiR0dZSEE2
 VTQvVDV6cVUrZjZ4SHkxU3NBUVoxTVNLbEx3ZWtCSVQrNC9jTFJHcUNIam5WMApxNUgvVDZh
 N3Q1bVBrYnpTck9MU280cHVqK0lUb05qWXlZSURCV3pobEExOWF2T2ErcnZVam1IdEQzc0ZO
 N2NYCld0a0dvaThidU5jYnk0VT0KPUFMNm8KLS0tLS1FTkQgUEdQIFBVQkxJQyBLRVkgQkxP
 Q0stLS0tLQo=
Organization: UCLA Computer Science Department
Message-ID: <2a6bbeb0-5c49-c576-154f-c103a1f3976d@HIDDEN>
Date: Fri, 21 Aug 2020 14:41:40 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.10.0
MIME-Version: 1.0
In-Reply-To: <83d03kaz6f.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -4.4 (----)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.4 (-----)

On 8/21/20 6:47 AM, Eli Zaretskii wrote:
> What do we do with unexec builds, which are still supported?  Remove
> that support? or ignore the possibility of an unexec build?

It's a good time to remove unexec support. Nobody is using it, there's a good 
chance that it doesn't work nowadays on many platforms, and its continued 
presence in the source code is costing us all more than it's benefiting.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Aug 2020 15:26:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 11:26:41 2020
Received: from localhost ([127.0.0.1]:48088 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k98wC-0007y8-TU
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 11:26:41 -0400
Received: from mail-out.m-online.net ([212.18.0.9]:33022)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1k98w9-0007xx-Mc
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 11:26:39 -0400
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4BY5302TnDz1qrfh;
 Fri, 21 Aug 2020 17:26:35 +0200 (CEST)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4BY52z2SjWz1r12y;
 Fri, 21 Aug 2020 17:26:35 +0200 (CEST)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id TMSXV1mh0s1z; Fri, 21 Aug 2020 17:26:34 +0200 (CEST)
X-Auth-Info: ybK9LNfmqRMHAaeUIztr/STJiUS+F56mwLB1m2X2lVFVrUMcVKgb9frQMhiJmYnK
Received: from igel.home (ppp-46-244-185-194.dynamic.mnet-online.de
 [46.244.185.194])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Fri, 21 Aug 2020 17:26:34 +0200 (CEST)
Received: by igel.home (Postfix, from userid 1000)
 id ECF9D2C0AC2; Fri, 21 Aug 2020 17:26:33 +0200 (CEST)
From: Andreas Schwab <schwab@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 <83d03kaz6f.fsf@HIDDEN>
X-Yow: I want to kill everyone here with a cute colorful Hydrogen Bomb!!
Date: Fri, 21 Aug 2020 17:26:33 +0200
In-Reply-To: <83d03kaz6f.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 21 Aug
 2020 16:47:20 +0300")
Message-ID: <87pn7kuija.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN,
 Pip Cet <pipcet@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

On Aug 21 2020, Eli Zaretskii wrote:

> What do we do with unexec builds, which are still supported?  Remove
> that support? or ignore the possibility of an unexec build?

What do we gain by keeping unexec alive?

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Aug 2020 13:47:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 09:47:33 2020
Received: from localhost ([127.0.0.1]:45452 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k97OH-0001gT-7y
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 09:47:33 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39104)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1k97OG-0001cH-5s
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 09:47:32 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43608)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1k97OA-0001i8-3M; Fri, 21 Aug 2020 09:47:26 -0400
Received: from [176.228.60.248] (port=3809 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1k97O9-0008Bl-CT; Fri, 21 Aug 2020 09:47:25 -0400
Date: Fri, 21 Aug 2020 16:47:20 +0300
Message-Id: <83d03kaz6f.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
In-Reply-To: <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
 (message from Pip Cet on Fri, 21 Aug 2020 13:04:47 +0000)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
 <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, larsi@HIDDEN, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Pip Cet <pipcet@HIDDEN>
> Date: Fri, 21 Aug 2020 13:04:47 +0000
> Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
> 
> On Fri, Aug 21, 2020 at 12:52 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> > I didn't read this thread closely, but it seems like the conclusion that
> > this patch should have been applied.  (It removes pure space,
> > apparently?)
> >
> > The patch never was applied, though -- should it be applied now?
> 
> I believe it's best to be careful with this one. Pure space affects GC
> in subtle ways, and it also affects performance.
> 
> See this thread:
> https://lists.gnu.org/archive/html/emacs-devel/2019-07/msg00588.html
> 
> I'd be happy to set up a separate branch for removing pure space if
> that's preferred.

What do we do with unexec builds, which are still supported?  Remove
that support? or ignore the possibility of an unexec build?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Aug 2020 13:05:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 09:05:35 2020
Received: from localhost ([127.0.0.1]:45404 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k96jf-0004kS-1Q
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 09:05:35 -0400
Received: from mail-oi1-f174.google.com ([209.85.167.174]:41498)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1k96jd-0004kE-8o
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 09:05:33 -0400
Received: by mail-oi1-f174.google.com with SMTP id b22so1427237oic.8
 for <36649 <at> debbugs.gnu.org>; Fri, 21 Aug 2020 06:05:33 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=c7d69EXx+vzY54W19Wed1fjRoMoom4rL+QY3mijUyCo=;
 b=BBUSFx+XkZK3OF6c1x2T1I+hmsMO7WBuj1ZYq6AL6aTgVOxeEleUqbf+/3yrkxQjzq
 OqEbz4syTWiFGwCUcMNOQhO/FVgrM8ZdR0geFctjK4DfBqsWQx3klQYPr5nbtgHANK4d
 wusf2Y7ZfAMu22Xx69MkpNptqoR8T46ZMNbD+8Z1aUZXkSdysQTc0xIUnJ2itkvlWFFR
 sDZToBaR/AHwJB8eWta04iGQXfN4RFx7F0tBNxxZGaTxmT29Wyluubiy0lKX8uU7D9LA
 d7HOYDDjs8h3pLqhzJzzpNM5Hm4j/9CgOcukDi6wXfiNOMACDGgOaOdMNnJJao4tx+yM
 XCFQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=c7d69EXx+vzY54W19Wed1fjRoMoom4rL+QY3mijUyCo=;
 b=EbgGVlzDTXZJURGleE3ktz5MHuoiyyOr7xBgnOUnbgDZrZMJyb7wXlJjvAkkU2DEPD
 N3zV/RDbAUHnBr08ieY5557ErlKIuaI3KCC0tJAI32FY4CphnPRRJQFF74XaZTmYc1S9
 VMArs5RNJIZCklOd30XR57MNI+2X/3VQztPNnfF8Ea0PWXueOtAYxLoUO3tM+cp/kWZq
 m3V3ZymXMXHP0iVopN5P4RbYlMtAHt76TR40ZWHQM0NkY7yYhqtZsUI7/Ft36a8HAe8H
 UkZD7f+CV1j7Ege7SzmheZEPDuCclAiFY0XDzm6HbRVSGZyVAT/vk+SZwOsVYqmPAdTk
 Eh0Q==
X-Gm-Message-State: AOAM53016/AbFxYVy/1Io5n0Am8k9IYRvARet5p38AOvGyeYveAhgFSB
 oyxp02Cy1PgEGjB82BLHoIXMl40g5nuihaCku84=
X-Google-Smtp-Source: ABdhPJzgjN/C+yJyNJVCps/ZPokCQ96yTGZg41GhBQnEyawiJjaVwq0Nv5gdeEEUQJePmHPJdGbffSrbpR8g2TcRtVU=
X-Received: by 2002:aca:ed4e:: with SMTP id l75mr1723261oih.44.1598015127643; 
 Fri, 21 Aug 2020 06:05:27 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN> <87a6yo5fgy.fsf@HIDDEN>
In-Reply-To: <87a6yo5fgy.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Fri, 21 Aug 2020 13:04:47 +0000
Message-ID: <CAOqdjBfwmDosRyXWr=n2p-wWN9+vLVDniUjBUfJabWH=i+XX1A@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, Aug 21, 2020 at 12:52 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> I didn't read this thread closely, but it seems like the conclusion that
> this patch should have been applied.  (It removes pure space,
> apparently?)
>
> The patch never was applied, though -- should it be applied now?

I believe it's best to be careful with this one. Pure space affects GC
in subtle ways, and it also affects performance.

See this thread:
https://lists.gnu.org/archive/html/emacs-devel/2019-07/msg00588.html

I'd be happy to set up a separate branch for removing pure space if
that's preferred.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Aug 2020 12:52:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 21 08:52:09 2020
Received: from localhost ([127.0.0.1]:45356 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k96Wf-00026H-5m
	for submit <at> debbugs.gnu.org; Fri, 21 Aug 2020 08:52:09 -0400
Received: from quimby.gnus.org ([95.216.78.240]:42194)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1k96Wd-000261-OY
 for 36649 <at> debbugs.gnu.org; Fri, 21 Aug 2020 08:52:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:To:From:Sender:Reply-To:Cc:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=lbuYx1iX2oA74aTu+k2QVR+E144wyo8xHM8Gftt5EPY=; b=IlrBVatqAsP3wMa9gTAWJRaxAu
 P0BzFZOru+PPkjWFok5XWStKtq2NR+XnMwjsWeMO8M7PqZUFoM8ewZsnHbtd4/7qhrSIJIFOLsZTh
 xTvQT/4tuzYBDdLKuSowENHqbxVC58Q/KMoL8JUlzpPRnBS0O6ob3FwuzCJ7HM8m2aKA=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1k96WU-0003o2-SY; Fri, 21 Aug 2020 14:52:01 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>,  36649 <at> debbugs.gnu.org,  Paul Eggert
 <eggert@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 <m2imrtoqld.fsf@HIDDEN>
X-Now-Playing: The Raincoats's _The Raincoats_: "The Void"
Date: Fri, 21 Aug 2020 14:51:57 +0200
In-Reply-To: <m2imrtoqld.fsf@HIDDEN> (Robert Pluim's message of "Mon, 22
 Jul 2019 20:45:50 +0200")
Message-ID: <87a6yo5fgy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Robert Pluim <rpluim@HIDDEN> writes: > Pip> Attaching an
    updated patch. > > It works for me. I think Iʼm with Eli on the prospect
    of putting this > in emacs-27, there are other things Iʼd like to see fixed
    first > (thereʼs still a pot [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Robert Pluim <rpluim@HIDDEN> writes:

>     Pip> Attaching an updated patch.
>
> It works for me. I think I=CA=BCm with Eli on the prospect of putting this
> in emacs-27, there are other things I=CA=BCd like to see fixed first
> (there=CA=BCs still a potential TLS 1.3 issue that I=CA=BCve not had time=
 to
> look at).

I didn't read this thread closely, but it seems like the conclusion that
this patch should have been applied.  (It removes pure space,
apparently?)

The patch never was applied, though -- should it be applied now?

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 18:46:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 22 14:46:09 2019
Received: from localhost ([127.0.0.1]:33630 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpdK5-00073U-7j
	for submit <at> debbugs.gnu.org; Mon, 22 Jul 2019 14:46:09 -0400
Received: from mail-wm1-f43.google.com ([209.85.128.43]:38114)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpdJz-00072e-0Z
 for 36649 <at> debbugs.gnu.org; Mon, 22 Jul 2019 14:46:07 -0400
Received: by mail-wm1-f43.google.com with SMTP id s15so14952126wmj.3
 for <36649 <at> debbugs.gnu.org>; Mon, 22 Jul 2019 11:46:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version:content-transfer-encoding;
 bh=DN4P1c1Fnb0s/c05/T0ut3XIjXB35Fq2iqg++3QXppU=;
 b=T1YpOqqfSSdYT9xFotmRRj5MM2nYweqFXMv/RbasjkepMiQGQvAF5E5OfvEp8zHVel
 0VH6uIVkW955aVCpKUmG2ni39tTQvdXso70a8grzSv6A2fO4i+df4tAItdPJTq6PE/XX
 m0mMzZuOy172YxML/gaxgZORQKE8NagIWEUitE0M0sRfnm+3x18+3fJh7mOyZgrBKSgx
 6nbsa158BbbMfeP781RGnoQBq1x9s/o729dLpUsNFailqvHUdIIY0tv+V98eQ+Vtogvx
 mFD/B3kPKYSJfYcOtJn/w8+yIs7q1G091t+9/4ayl422Va/AOmN9Skmn/tXYeCgPm/gH
 hbQA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version
 :content-transfer-encoding;
 bh=DN4P1c1Fnb0s/c05/T0ut3XIjXB35Fq2iqg++3QXppU=;
 b=cozAS8EuBJBNA9V6XzhCMhlX0gaCM6eAL4WfsoJt8qe2GWIE0gLFAqBaHq45VfrNs0
 bbqwWptkaV6nu85srPqBsm0QzK1/V2S7vM+lVPARIUQAm/+BawzFKSN2C+y52odHSmr+
 8Vr9mIGphCNEj6ie4KSNRm2PVg0UjyocgRIkzj8Brkl0pep9XzIukyjJv+mY34kOEWDs
 cY5zJ0gsZ/VgngKGz6y/KLXjW/lvSslRki0Sbfxz4CcfUaHRqeu07JU4hpE6eDEIlzOy
 KWvDFJpldv5PD6AOnHAIyr7jIygtmx8dRwVvYILxaQCbGqK58MDage+JIU6k+IcyFLYQ
 prvQ==
X-Gm-Message-State: APjAAAU7ITbz9deEerAaPkRejxmf7B2MhkJFkmNUBOYasp6VnTkH6tpY
 A2khiZ6xuuxLBLItRZ+hTko=
X-Google-Smtp-Source: APXvYqz62u4kq9H6SPAZd4/DMen+2/clHEfYZ5nkX4kfa6Lw7g2PTr9i6k6VS13jaRrPPHdqzFKsqw==
X-Received: by 2002:a1c:7c08:: with SMTP id x8mr65062302wmc.19.1563821156926; 
 Mon, 22 Jul 2019 11:45:56 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:3d24:d28f:a442:63d2])
 by smtp.gmail.com with ESMTPSA id f2sm33394472wrq.48.2019.07.22.11.45.51
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Mon, 22 Jul 2019 11:45:52 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
 <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Mon, 22 Jul 2019 20:45:50 +0200
In-Reply-To: <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
 (Pip Cet's message of "Mon, 22 Jul 2019 15:03:55 +0000")
Message-ID: <m2imrtoqld.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Mon, 22 Jul 2019 15:03:55 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> On Mon, Jul 22, 2019 at 8:14 AM Robert Pluim <rpluim@HIDDEN> wr=
ote:
    >> >>>>> On Mon, 22 Jul 2019 03:58:29 +0000, Pip Cet <pipcet@HIDDEN>=
 said:
    >>=20
    Pip> On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> wr=
ote:
    Pip> Can you try again with this incremental patch?
    >> >>
    >> >> I offer two alternatives, both of which build and run:
    >>=20
    Pip> Oops, sorry. I think the second alternative might break
    Pip> live_vector_holding, though?
    >>=20
    >> OK. Here=CA=BCs hoping no other code in emacs tries to create a 0-le=
ngth
    >> vector :-)

    Pip> By modifying header.size? That would be a problem. (I'd say no one
    Pip> should ever do it, but I'd actually like to suggest it for hash
    Pip> tables...)

    Pip> Attaching an updated patch.

It works for me. I think I=CA=BCm with Eli on the prospect of putting this
in emacs-27, there are other things I=CA=BCd like to see fixed first
(there=CA=BCs still a potential TLS 1.3 issue that I=CA=BCve not had time to
look at).

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 15:46:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 22 11:46:27 2019
Received: from localhost ([127.0.0.1]:33509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpaWA-0001xS-SA
	for submit <at> debbugs.gnu.org; Mon, 22 Jul 2019 11:46:27 -0400
Received: from mail-wr1-f44.google.com ([209.85.221.44]:46003)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpaW9-0001xG-RX
 for 36649 <at> debbugs.gnu.org; Mon, 22 Jul 2019 11:46:26 -0400
Received: by mail-wr1-f44.google.com with SMTP id f9so39907795wre.12
 for <36649 <at> debbugs.gnu.org>; Mon, 22 Jul 2019 08:46:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=Lskoi/Z2Z0YnUX3dQpMAhZRm0+C0PQACMDrltwOfQM4=;
 b=ZbOEX+IWYQOCKYGEPsiQAylcir45JLJNy/NwyYyPWdiYP7Q3ewqB9RBBQkUeU9pjW8
 SZse7wlkCdkg1fhA1iuBOuQrbiQzQKeq5/sdd5v76u9h8+M1PWVzTIHOMn6vcSAQK2Is
 CBYggvYMnSS+Iz8tQxpFQd5CtkeC3MDduYuhcSrmtUrsJGW2GxHkvbw/D4oz6UznGcCH
 XKvpap2hvy44f7Dn4NlpEVOfZueOWx9rjd9qxILaiFwiDLuQ+/ZPVwWxOKqhj7N4m27I
 AVEVhc6GFO5NcNWD1zftg/eVtNtNCthyv/nc5aOVtvM7WvwEspvS7gwRAiRzvUF1GrXb
 SJhg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=Lskoi/Z2Z0YnUX3dQpMAhZRm0+C0PQACMDrltwOfQM4=;
 b=GnzbzU8L2H1g/1B6+g4ifGS9D+0w+vmIeXFtNswf8fIF7O4it2Iexs/bLsdIhvHojv
 TtyofvMmogT2MnZrUm49qduv/ueajEOpRtQR7i7gt1d7U2v3GkkmAOxAXTV/LQ54dM7o
 CLOFMyTtS6jxhzK1thBp84XBXeLAZBY/lrNTnGXmZo+zAGi4NgNyeBfHabzm2P4jZ3tq
 RQxj6MzsBZ1WsyH5jIZqoIsTc+lNFfpKmhen8tRn5WCFMk5pLIlXlKyF1veZgsijhI0/
 9BKu+D1OwbJUekSmrrWTqoVHK1qhWp+whH/vH5WWel5G0e+PjbRzxCATJ3pnSbhD3zMg
 PckQ==
X-Gm-Message-State: APjAAAWx8Bq2ecP7qeklO789PMQjBip9dj03VuX4xEVdXLVOsFG+AKEw
 coU/S21vUAG9h5w09jmfUcw=
X-Google-Smtp-Source: APXvYqx9OVvzTEcLpZ1Dh73k/GAe3n4N81hTYxpsWP0Ie+/nwwAJNsU5PxK5WlkyS9//6mmwAjvQCg==
X-Received: by 2002:adf:ed8a:: with SMTP id c10mr77932739wro.33.1563810379751; 
 Mon, 22 Jul 2019 08:46:19 -0700 (PDT)
Received: from rpluim-mac ([149.5.228.1])
 by smtp.gmail.com with ESMTPSA id e7sm37658528wmd.0.2019.07.22.08.46.18
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Mon, 22 Jul 2019 08:46:18 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN> <83ftmyqgz8.fsf@HIDDEN>
Date: Mon, 22 Jul 2019 17:46:17 +0200
In-Reply-To: <83ftmyqgz8.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 22 Jul
 2019 17:30:35 +0300")
Message-ID: <m2tvbenkc6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, eggert@HIDDEN, pipcet@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Mon, 22 Jul 2019 17:30:35 +0300, Eli Zaretskii <eliz@HIDDEN> said:

    >> From: Robert Pluim <rpluim@HIDDEN>
    >> Date: Mon, 22 Jul 2019 10:14:47 +0200
    >> Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
    >>=20
    >> >>>>> On Mon, 22 Jul 2019 03:58:29 +0000, Pip Cet <pipcet@HIDDEN>=
 said:
    >>=20
    Pip> On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> wr=
ote:
    Pip> Can you try again with this incremental patch?
    >> >>=20
    >> >> I offer two alternatives, both of which build and run:
    >>=20
    Pip> Oops, sorry. I think the second alternative might break
    Pip> live_vector_holding, though?
    >>=20
    >> OK. Here=CA=BCs hoping no other code in emacs tries to create a 0-le=
ngth
    >> vector :-)

    Eli> I think font.c (or fontset.c?) does.

If it does, that will be caught by allocate_vector, and this changes
allocate_vectorlike. Having said that, there are other callers of
allocate_vectorlike in alloc.c which don=CA=BCt check for a
zero-length. Maybe I=CA=BCm over-worrying here.

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 15:04:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 22 11:04:42 2019
Received: from localhost ([127.0.0.1]:33498 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpZrm-0000vc-7e
	for submit <at> debbugs.gnu.org; Mon, 22 Jul 2019 11:04:42 -0400
Received: from mail-oi1-f171.google.com ([209.85.167.171]:34431)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpZrh-0000vK-Ts
 for 36649 <at> debbugs.gnu.org; Mon, 22 Jul 2019 11:04:40 -0400
Received: by mail-oi1-f171.google.com with SMTP id l12so29827834oil.1
 for <36649 <at> debbugs.gnu.org>; Mon, 22 Jul 2019 08:04:37 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=uUQrFW6y3GfhSe9AtY/WY7xibjUcAHAtZIPbgJ19Hk4=;
 b=ONBa53TMKYjoPDxX5Upo01uYaIn/2Z5L6GKyrK5X3GWDU5pbou/gz8oJF09b8V8xC9
 0zNFGVpJ7WlxYUyDLryX/Wju+jJ8gU+HZdR3A5IAa4c+U0bp9DUpHTPeJQBEE5aGWBE0
 Sfqz5oh856+2w83muR6BodimT1+Te4YRffVKFLiPf7OyDbTVmvmpjdONLZn2TAmW/FgQ
 Rw2qSSp0gKTwQNtfxIvgZq1dw+aXm1OwzvXwpkV0IFTobytj/OaAn6GZtqvX4xwEXkeH
 JqXaEa7ZyVp0p5uUCTqQoXK6wGIEfW3vLdxCwEmfRx9BzN38MkOxAAeN5gLaaLXb0UHo
 81bA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=uUQrFW6y3GfhSe9AtY/WY7xibjUcAHAtZIPbgJ19Hk4=;
 b=ITlsAWJ/+AwPPdhtS3wfNJTT3+YMR1AIFV7kWWkOdvVSo96wNzD3j52eJg5ln01X7X
 gZykpwA9wWtXsFRCRctH2UlCv2snv2x9x8GGJZQkEMAI9Zj9siZUvcNGajH9aN4szsbE
 bqlHrtYhTbe+qZa08fl40VlqDyLwi1lIo27l/PmYn551F1OzV7Kfcc2KlIVoclimo5wJ
 e7fcld71TcEm9x/ksvK72Hvs6+wTv97+B5MhLKIb1lIEDq/8hld9A2QvoM+N1cTTTtjz
 q2MPz1yy2TC3IWQVZKu/b8m7Nia2V+cc1+xjzfu0d4mXs5PPc+P9byQSDvDhPTWX00CH
 67JQ==
X-Gm-Message-State: APjAAAUDrZsOQ/z48ZgTqGK+GPG2Tm6svghyjZkDI31/kDLAyIxrcIZO
 Zvip0mNe1NwThM9exvqbSr2Hr615H3Y5TayPMnY=
X-Google-Smtp-Source: APXvYqzJC/AXA0WDo5ohpyUbBcnOvjKsLQGYqCTpbr/6Ot6xmdPGuBsUPl5p1YEuesXEjrusrbeFcGI2pfGXH0RacWs=
X-Received: by 2002:aca:2303:: with SMTP id e3mr30618350oie.112.1563807872245; 
 Mon, 22 Jul 2019 08:04:32 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
In-Reply-To: <m236iypjt4.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Mon, 22 Jul 2019 15:03:55 +0000
Message-ID: <CAOqdjBeK_GdO8+1iaGZ-pCpBrgvhN_TNzhxx7=EdrcvQSsVU3A@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000b91173058e4664f7"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000b91173058e4664f7
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

On Mon, Jul 22, 2019 at 8:14 AM Robert Pluim <rpluim@HIDDEN> wrote:
> >>>>> On Mon, 22 Jul 2019 03:58:29 +0000, Pip Cet <pipcet@HIDDEN> said=
:
>
>     Pip> On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> =
wrote:
>     Pip> Can you try again with this incremental patch?
>     >>
>     >> I offer two alternatives, both of which build and run:
>
>     Pip> Oops, sorry. I think the second alternative might break
>     Pip> live_vector_holding, though?
>
> OK. Here=CA=BCs hoping no other code in emacs tries to create a 0-length
> vector :-)

By modifying header.size? That would be a problem. (I'd say no one
should ever do it, but I'd actually like to suggest it for hash
tables...)

>     Pip> Attaching an updated patch.
>
> I put this on top of it. The result builds, runs, and is sending this
> email.

Hmm. Apparently I'm building without XPM? I should investigate that.

Anyway, there's another make_hash_table in emacs-module.c, but I think
that's it.

--000000000000b91173058e4664f7
Content-Type: application/gzip; name="0001-Remove-pure-space.patch.gz"
Content-Disposition: attachment; filename="0001-Remove-pure-space.patch.gz"
Content-Transfer-Encoding: base64
Content-ID: <f_jyeijqol0>
X-Attachment-Id: f_jyeijqol0
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=
--000000000000b91173058e4664f7--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 14:30:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 22 10:30:56 2019
Received: from localhost ([127.0.0.1]:33473 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpZL6-0006Mv-8H
	for submit <at> debbugs.gnu.org; Mon, 22 Jul 2019 10:30:56 -0400
Received: from eggs.gnu.org ([209.51.188.92]:53208)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hpZL4-0006Mg-Db
 for 36649 <at> debbugs.gnu.org; Mon, 22 Jul 2019 10:30:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59748)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hpZKy-0004fp-T1; Mon, 22 Jul 2019 10:30:48 -0400
Received: from [176.228.60.248] (port=1527 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hpZKy-0003jI-24; Mon, 22 Jul 2019 10:30:48 -0400
Date: Mon, 22 Jul 2019 17:30:35 +0300
Message-Id: <83ftmyqgz8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-reply-to: <m236iypjt4.fsf@HIDDEN> (message from Robert Pluim on Mon, 22
 Jul 2019 10:14:47 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 <m236iypjt4.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, eggert@HIDDEN, pipcet@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Robert Pluim <rpluim@HIDDEN>
> Date: Mon, 22 Jul 2019 10:14:47 +0200
> Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
> 
> >>>>> On Mon, 22 Jul 2019 03:58:29 +0000, Pip Cet <pipcet@HIDDEN> said:
> 
>     Pip> On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> wrote:
>     Pip> Can you try again with this incremental patch?
>     >> 
>     >> I offer two alternatives, both of which build and run:
> 
>     Pip> Oops, sorry. I think the second alternative might break
>     Pip> live_vector_holding, though?
> 
> OK. Hereʼs hoping no other code in emacs tries to create a 0-length
> vector :-)

I think font.c (or fontset.c?) does.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 08:14:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 22 04:14:58 2019
Received: from localhost ([127.0.0.1]:59902 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpTTG-0002rZ-1R
	for submit <at> debbugs.gnu.org; Mon, 22 Jul 2019 04:14:58 -0400
Received: from mail-wm1-f45.google.com ([209.85.128.45]:51182)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpTTE-0002rL-DU
 for 36649 <at> debbugs.gnu.org; Mon, 22 Jul 2019 04:14:57 -0400
Received: by mail-wm1-f45.google.com with SMTP id v15so34197913wml.0
 for <36649 <at> debbugs.gnu.org>; Mon, 22 Jul 2019 01:14:56 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version:content-transfer-encoding;
 bh=OHltutE6o3mU9mx6rEII3gMQGtBbN9mVsmq2T9LKJ4Q=;
 b=PXctSJsOUp9wccZQDi0YSbSaKr68pxoqvfC1OiLY6ob8jFmlnHRoYWE6GVGN21at+P
 lTE7nkfzUcTfdsnAMnzjYJkaOxi6XgLV/V6yhO6UVytNMn/A7gWbfpae9fsheu76HyWB
 fJCyTbn6G7z+kc2lzYWdd7ykqlInBkcoFc/HojDPXVMK9y6FbjalsMFyB+/YncRCxS/k
 uJKRUjw9X9oX7wmID3zhJyqD2IvJPi5eNEVot2enOLIqpCNeBGzOSwI3C21ibmmbP5iz
 FdNwikNFbP6rBHR8eAdSGQ4Zzcs5yn6m4Hv1P9zh55zW9iK2C3whsgvkHKJGchufv5VZ
 5PeA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version
 :content-transfer-encoding;
 bh=OHltutE6o3mU9mx6rEII3gMQGtBbN9mVsmq2T9LKJ4Q=;
 b=B6Ez0USEPrQW7/EhLpp2R3dsXDVyteb4URS5jtWRpa4U8+YlyCgi2qTd08jD3BPisk
 rbsvkPp0JFPiIzu68b0toCd4CpVR+nmnium/E0GqgRHTIllAqE3jYwQjwq09ekj95j/T
 5guKSsIMNoELbbxU/4G5moyi/+ATtIkPSI1PXfzbV1tgZzO8kPGgoTnkMiITCb192vxg
 EH2HnkBLSQqBs4fmgg4yWSbmmbZ1R5ZXr7/Bt6eA5DWOSS9Xpd5r2j/W3fwyjr9AxsBI
 GfbJtB0IWvgPR1yUi7Z9wduuyTmKsthpEWHR4P0ewtmp3ClIOF1Y+h564eiKdxGkMTGL
 J9Ug==
X-Gm-Message-State: APjAAAWDWqCbgYYFv2idrocXDvjvjievZt6bM1bsShgUOKMEx6gHCiwJ
 osPRzu4xIKdEhcCq5jmHQR0=
X-Google-Smtp-Source: APXvYqx8g0cXgheQNUCiuXx2POvgwiohJ/fxJXp9SJtfGlYFZCaDOwl07UtR3mpMBI32z0dLzTdZUA==
X-Received: by 2002:a1c:9e4d:: with SMTP id h74mr65602648wme.9.1563783290386; 
 Mon, 22 Jul 2019 01:14:50 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id v16sm17158925wrn.28.2019.07.22.01.14.48
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Mon, 22 Jul 2019 01:14:48 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
 <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Mon, 22 Jul 2019 10:14:47 +0200
In-Reply-To: <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
 (Pip Cet's message of "Mon, 22 Jul 2019 03:58:29 +0000")
Message-ID: <m236iypjt4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Mon, 22 Jul 2019 03:58:29 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> wr=
ote:
    Pip> Can you try again with this incremental patch?
    >>=20
    >> I offer two alternatives, both of which build and run:

    Pip> Oops, sorry. I think the second alternative might break
    Pip> live_vector_holding, though?

OK. Here=CA=BCs hoping no other code in emacs tries to create a 0-length
vector :-)

    Pip> Attaching an updated patch.

I put this on top of it. The result builds, runs, and is sending this
email.

diff --git i/src/image.c w/src/image.c
index 355c849491..b21dff34d4 100644
--- i/src/image.c
+++ w/src/image.c
@@ -4596,7 +4596,7 @@ xpm_make_color_table_h (void (**put_func) (Lisp_Objec=
t, const char *, int,
   *get_func =3D xpm_get_color_table_h;
   return make_hash_table (hashtest_equal, DEFAULT_HASH_SIZE,
 			  DEFAULT_REHASH_SIZE, DEFAULT_REHASH_THRESHOLD,
-			  Qnil, false);
+			  Qnil);
 }
=20
 static void




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 22 Jul 2019 03:59:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 23:59:13 2019
Received: from localhost ([127.0.0.1]:59812 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpPTl-0002iu-B2
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 23:59:13 -0400
Received: from mail-ot1-f45.google.com ([209.85.210.45]:42899)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpPTj-0002ii-Uf
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 23:59:12 -0400
Received: by mail-ot1-f45.google.com with SMTP id l15so38756492otn.9
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 20:59:11 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=TM2kzoI2jylz9b2NsRYwaZl4rm4knLD0MhkATHz1MTQ=;
 b=NlR6NO6XU4Rj0CDnDj+YqiG8+brgUToIQVpS0u2JYamIFznrYQDHroLDa/mef9X5l3
 H6iDSr+Ge4brLuxCMQr8w1kSFD9qO/2lHRQiB4VXK4PWwu+DQYFV1cCRKSSAXjmDigSy
 hgreoF3yOpXw2B19Toq6splJbEm2s1YR6JBeVBdGpMcPsbCRZI+BY3pQkBcYnCluHGqi
 U0966YR3loSA+ox84pDYZhyk7nP9CNBBHCieDWTOMhIHeIldtBdEBzaP4lVi0/t2aPOD
 Xt5mUzvtriI5R170YUb52VwwcoFWDnkeZGwGD7qOIDvjeXUTA/EmtHbpGaJRpiy/1ICd
 WVnw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=TM2kzoI2jylz9b2NsRYwaZl4rm4knLD0MhkATHz1MTQ=;
 b=beQD+/pcNuaTxqzRzjpOMFAgUu7fpJok3QOCAHOqZmBghGqm8D+BU7mozkJdDkLBDD
 BFYCGUX7bR7//oM5wgt4y7GJ3pV47tTP0yUOj3FEY4wtovmYjbHT7NC7CaPi2lvEixCK
 IG+7Tb5/bqy9veByigWInE8SRSbxB0hIidI4/l3i495fpmD8g7T4KqPKgQMrTKyV+dc4
 os6OB1guS3ggP/pk10UKeSpQEMiCKC5rprH+Thkdk9ydnmESi4CmPbEsGMLczqW5w2n/
 IOcwKYdK0v1eyncoqaTnOa3LbAFAZVR1uUOqwj+kbghSGGQT/uidvDC8lCnCyErxftAr
 axew==
X-Gm-Message-State: APjAAAXD1BtaqZM82Ewqak1NH19qdo9oW6I0Lq8kOYduTDeXuz6vosvn
 PGkr4zmueBDVqHf1yA7Cx3XRfL8tsnfcXVDX17M=
X-Google-Smtp-Source: APXvYqwNa+/jAkS2DV552MnufKcMq6FxjPp8BuZ6nEOTrDRdeJCeNDv0AVt/J2ksLHHnDK7qQWx/4xEzKGvwj0TGi0E=
X-Received: by 2002:a9d:7352:: with SMTP id l18mr46087107otk.292.1563767946198; 
 Sun, 21 Jul 2019 20:59:06 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 <m2ftmzm96e.fsf@HIDDEN>
In-Reply-To: <m2ftmzm96e.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Mon, 22 Jul 2019 03:58:29 +0000
Message-ID: <CAOqdjBfO5p7hranKYnV8vUYsnFa-8kWty_cipzX0ragisQuCMw@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000f1e99b058e3d1896"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000f1e99b058e3d1896
Content-Type: text/plain; charset="UTF-8"

On Sun, Jul 21, 2019 at 8:20 PM Robert Pluim <rpluim@HIDDEN> wrote:
>     Pip> Can you try again with this incremental patch?
>
> I offer two alternatives, both of which build and run:

Oops, sorry. I think the second alternative might break
live_vector_holding, though?

Attaching an updated patch.

--000000000000f1e99b058e3d1896
Content-Type: application/gzip; name="0001-Remove-pure-space.patch.gz"
Content-Disposition: attachment; filename="0001-Remove-pure-space.patch.gz"
Content-Transfer-Encoding: base64
Content-ID: <f_jydv0vf00>
X-Attachment-Id: f_jydv0vf00
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--000000000000f1e99b058e3d1896--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 20:20:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 16:20:37 2019
Received: from localhost ([127.0.0.1]:59563 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpIJw-0002Fv-6K
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 16:20:37 -0400
Received: from mail-wr1-f49.google.com ([209.85.221.49]:39371)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpIJu-0002Fe-AY
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 16:20:35 -0400
Received: by mail-wr1-f49.google.com with SMTP id x4so37162894wrt.6
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 13:20:34 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version;
 bh=PYqckJMvpoKZx4jkgEfhzhoeavFJik6+h96ea7GrVe4=;
 b=kWX2HC1ui3nSpHEpKfw+J8ky5XcOkBOwwdNuKy1kvW9dm4rjuekvjwiJ3xACgvHBwt
 0N5VC8+DmE2/lM/+jyIbhw5kaaLTJkE49Vil8wQMiPVao46vzXMhG7kztlRYLQZckD5Z
 HtRws/ADE+gjwt6iU1Qe/uMzkItEvGE82rYwOq7+klYait85JwfSgaY+06CNDgEjFr4t
 UCe44C/ZRjfnQURTHCBnikYq/gLroD/0oXYxuAqxwIcFjSa6ceOEIXrLA2yOPN6mC7u4
 alOKhWXBcJQQ568x85GHMZO7QMETcCNVPPmR4WUARGD8A9uplFXXsP2EAwF88U1WrfOD
 cbHA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version;
 bh=PYqckJMvpoKZx4jkgEfhzhoeavFJik6+h96ea7GrVe4=;
 b=SWLj+m5b6iHICmSdbujhy17ewe1sJJ80/7ij48dMNzX93b1URmudrmRb2lJolNinZ2
 +PM8MUbJGPkV3wCnB3ZK9t34vZJ/U/28FEsnisr3ZZ4jIRVxsSbu37J1mYWDmzeiT6Lc
 7vWnM2b+JJmhMoTwVx7SJoOZ4JIWj/oN6mbVQNK5iwKVKXVW1F38Jt8f9v+GiudoFwr8
 Ixr9tR7bDftBtAe0AdcSf1JMYPTqSePlIGq4GbjHIGjUzfG22EFfSkXqy2ezJftPCw6s
 BiAcm6fTtDG/Tyxh8TDU9CvnqCwpaauIX4eRC3L/DyeTkjf90oY8D62uZKTm74YbxOjl
 jNTQ==
X-Gm-Message-State: APjAAAXgbXFxYsjForexM8Kg5hRkBoh22kG/SoPwKzSapoCiXT/96ANi
 vY4aC3MD3I/yYFBhCIDnFpQ=
X-Google-Smtp-Source: APXvYqxWsp6YB4ZHloMFUqeTVNNkLgYcaaATyGjITjJGv+w2GcIb2nrDzke9jKIZFH2c582cLcOf3w==
X-Received: by 2002:a5d:4b50:: with SMTP id w16mr62579904wrs.132.1563740428343; 
 Sun, 21 Jul 2019 13:20:28 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id c78sm54367101wmd.16.2019.07.21.13.20.26
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sun, 21 Jul 2019 13:20:27 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
 <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Sun, 21 Jul 2019 22:20:25 +0200
In-Reply-To: <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
 (Pip Cet's message of "Sun, 21 Jul 2019 19:35:01 +0000")
Message-ID: <m2ftmzm96e.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Sun, 21 Jul 2019 19:35:01 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> Thanks! I messed up quite badly initializing the zero vector, it turns
    Pip> out, so it was trying to initialize the first entry in the zero
    Pip> vector, which, er, obviously wasn't a good idea :-)

    Pip> Can you try again with this incremental patch?

I offer two alternatives, both of which build and run:

diff --git i/src/alloc.c w/src/alloc.c
index 1b55ad8cab..206f0ce8d7 100644
--- i/src/alloc.c
+++ w/src/alloc.c
@@ -3091,7 +3091,7 @@ #define VECTOR_ELTS_MAX \
 static struct Lisp_Vector *
 allocate_vectorlike (ptrdiff_t len)
 {
-  eassert (0 < len && len <= VECTOR_ELTS_MAX);
+  eassert (0 <= len && len <= VECTOR_ELTS_MAX);
   ptrdiff_t nbytes = header_size + len * word_size;
   struct Lisp_Vector *p;
 
@@ -3151,8 +3151,8 @@ allocate_vector (ptrdiff_t len)
 init_vectors (void)
 {
   zero_vector =
-    make_lisp_ptr (allocate_vectorlike (sizeof (struct Lisp_Vector)),
-		   Lisp_Vectorlike);
+    make_lisp_ptr (allocate_vectorlike (0), Lisp_Vectorlike);
+  XVECTOR(zero_vector)->header.size = 0;
   staticpro (&zero_vector);
 }
 

diff --git i/src/alloc.c w/src/alloc.c
index 1b55ad8cab..294aa9a2aa 100644
--- i/src/alloc.c
+++ w/src/alloc.c
@@ -3151,8 +3151,8 @@ allocate_vector (ptrdiff_t len)
 init_vectors (void)
 {
   zero_vector =
-    make_lisp_ptr (allocate_vectorlike (sizeof (struct Lisp_Vector)),
-		   Lisp_Vectorlike);
+    make_lisp_ptr (allocate_vectorlike (1), Lisp_Vectorlike);
+  XVECTOR(zero_vector)->header.size = 0;
   staticpro (&zero_vector);
 }
 




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 19:35:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 15:35:46 2019
Received: from localhost ([127.0.0.1]:59527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpHcX-000108-PR
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 15:35:46 -0400
Received: from mail-oi1-f173.google.com ([209.85.167.173]:43570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpHcV-0000zv-QH
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 15:35:44 -0400
Received: by mail-oi1-f173.google.com with SMTP id w79so28080208oif.10
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 12:35:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=B5dlhGF02dgT5lyOXgFxsiAXV4Wt4nYLD2s5IybBKJ4=;
 b=PNzEIMfSyHqxfUezZFZB5PqCezWt1XsY1tIbdIbERwroAfHRpnvpoY5MF7n71vhbBe
 OywAHwXyUS1uWb2fLdpSVQYZiE1r+0XuNui0MayCWcMv5iZ4TSuX6+p9SXyQURibM/g7
 U6o7YchSADOOd9pO/MfNu3oVzLyI4y8RVhqA7oJZ4i4IvDjHsVzzwYwKGqUIWjdoRe4a
 msGS/MrOKg57m+xx393/ZJ7vXNDNB2ZVkm1K4JMDzEc5IZHcx6qc+GYgq4/6jZal+zMH
 dEGuk+ln8y+bfj++oG8LMJxJ/AFJbggDpJn6uvLF+pDDA7gR+2dzUnqG9w1DN/4SJ8O3
 S9hQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=B5dlhGF02dgT5lyOXgFxsiAXV4Wt4nYLD2s5IybBKJ4=;
 b=dKrhMu2qdWwmzRr9Wi5ElStVqeHT2t2SaOcpbmCYdQjvOP9KS8kC8UTzvHAvUBtC8/
 mCBlG7MJMkeB6qcu/jZUXa7+TRY+x/CpmPcxoUdRDsX7iCRwibW3zwC60zwJJqkYxox0
 o0kawzBErdqUg7pFoGWLKMozsgpkIOD1E/n0yh3gzMdVstOLsi18GodsSC+BBB2YtXR6
 h0o3rdrY2dsM0COmEyABdIHKRDUwj2SFh9h7t6z05JsFfSP4ubG6Rrp54LGMSa5SliWk
 DiQ2ns9NDPFyoGUHFBpx71Cnt0oA9nXYIs+EEksPLZUZCq9BpQ3Gc0Om/3FTszsC+3nx
 k4Rw==
X-Gm-Message-State: APjAAAXcvlQKV0qyZ4fEJ/G7+YaY03rKaSN53YzI7JyOc/Y8L1ItcEQP
 d9Fi3GXYLkwmjlHmB4yooQBjDg7WmJGjCmLZgz8=
X-Google-Smtp-Source: APXvYqwPPLJR9VxpE5lpPg3uZdliFa9UtDN+RV3ZmCMsZMGt0CwqahDI6LXnLLNHRRkWwNCB+z6WpWnu8ZkZATgRYko=
X-Received: by 2002:aca:2303:: with SMTP id e3mr28776834oie.112.1563737737862; 
 Sun, 21 Jul 2019 12:35:37 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 <m2o91nmcc9.fsf@HIDDEN>
In-Reply-To: <m2o91nmcc9.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 21 Jul 2019 19:35:01 +0000
Message-ID: <CAOqdjBfi4Oq1oHAj+xPnS8f5bhQ8ze6A1uv6iDDL9e3phB_D+g@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000634cf3058e361044"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000634cf3058e361044
Content-Type: text/plain; charset="UTF-8"

On Sun, Jul 21, 2019 at 7:12 PM Robert Pluim <rpluim@HIDDEN> wrote:
> >>>>> On Sun, 21 Jul 2019 18:07:43 +0000, Pip Cet <pipcet@HIDDEN> said:
>     Pip> I'm not sure about debugging on macOS, but can you get a full
>     Pip> backtrace, or a core dump, or both? We're particularly interested in
>     Pip> what "i" is in mark_vectorlike.
>
> You want a lisp backtrace? I can always run under gdb if needed. As to
> 'i':
>
> (lldb) up
> frame #1: 0x000000010016dbec temacs`mark_object(arg=<unavailable>) at alloc.c:6082 [opt]
>    6079       {
>    6080         struct Lisp_Symbol *ptr = XSYMBOL (obj);
>    6081       nextsym:
> -> 6082         if (symbol_marked_p (ptr))
>    6083           break;
>    6084         CHECK_ALLOCATED_AND_LIVE_SYMBOL ();
>    6085         set_symbol_marked(ptr);
> (lldb)
> frame #2: 0x000000010016f2aa temacs`mark_vectorlike(header=0x0000000101803200) at alloc.c:5666:5 [opt]
>    5663      The distinction is used e.g. by Lisp_Process which places extra
>    5664      non-Lisp_Object fields at the end of the structure...  */
>    5665   for (i = 0; i < size; i++) /* ...and then mark its elements.  */
> -> 5666     mark_object (ptr->contents[i]);
>    5667 }
>    5668
>    5669 /* Like mark_vectorlike but optimized for char-tables (and
> (lldb) p i
> (ptrdiff_t) $0 = 0
> (lldb) p ptr->contents
> error: incomplete type 'Lisp_Object []' where a complete type is required
> (lldb) p ptr->contents[0]
> (Lisp_Object) $1 = 0x0008040000080400

Thanks! I messed up quite badly initializing the zero vector, it turns
out, so it was trying to initialize the first entry in the zero
vector, which, er, obviously wasn't a good idea :-)

Can you try again with this incremental patch?

--000000000000634cf3058e361044
Content-Type: text/x-patch; charset="US-ASCII"; 
	name="0001-Initialize-the-zero-vector-properly.patch"
Content-Disposition: attachment; 
	filename="0001-Initialize-the-zero-vector-properly.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_jydd1vnu0>
X-Attachment-Id: f_jydd1vnu0

RnJvbSA5MTEyMTE3MDVmM2UxY2IwZmFmYjQwN2MzNjNhM2E0OTJkYzk3MDIyIE1vbiBTZXAgMTcg
MDA6MDA6MDAgMjAwMQpGcm9tOiBQaXAgQ2V0IDxwaXBjZXRAZ21haWwuY29tPgpEYXRlOiBTdW4s
IDIxIEp1bCAyMDE5IDE5OjMyOjQ5ICswMDAwClN1YmplY3Q6IFtQQVRDSF0gSW5pdGlhbGl6ZSB0
aGUgemVybyB2ZWN0b3IgcHJvcGVybHkuCgotLS0KIHNyYy9hbGxvYy5jIHwgNCArKy0tCiAxIGZp
bGUgY2hhbmdlZCwgMiBpbnNlcnRpb25zKCspLCAyIGRlbGV0aW9ucygtKQoKZGlmZiAtLWdpdCBh
L3NyYy9hbGxvYy5jIGIvc3JjL2FsbG9jLmMKaW5kZXggZGY4YjFjYWY0ZS4uNWMxYmVjNzY2NiAx
MDA2NDQKLS0tIGEvc3JjL2FsbG9jLmMKKysrIGIvc3JjL2FsbG9jLmMKQEAgLTMxNTEsOCArMzE1
MSw4IEBAIGFsbG9jYXRlX3ZlY3RvciAocHRyZGlmZl90IGxlbikKIGluaXRfdmVjdG9ycyAodm9p
ZCkKIHsKICAgemVyb192ZWN0b3IgPQotICAgIG1ha2VfbGlzcF9wdHIgKGFsbG9jYXRlX3ZlY3Rv
cmxpa2UgKHNpemVvZiAoc3RydWN0IExpc3BfVmVjdG9yKSksCi0JCSAgIExpc3BfVmVjdG9ybGlr
ZSk7CisgICAgbWFrZV9saXNwX3B0ciAoYWxsb2NhdGVfdmVjdG9ybGlrZSAoMCksIExpc3BfVmVj
dG9ybGlrZSk7CisgIHplcm9fdmVjdG9yLT5oZWFkZXIuc2l6ZSA9IDA7CiAgIHN0YXRpY3BybyAo
Jnplcm9fdmVjdG9yKTsKIH0KIAotLSAKMi4yMi4wCgo=
--000000000000634cf3058e361044--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 19:12:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 15:12:16 2019
Received: from localhost ([127.0.0.1]:59510 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpHFn-0006Zs-Pe
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 15:12:16 -0400
Received: from mail-wm1-f66.google.com ([209.85.128.66]:39556)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpHFm-0006Zg-0h
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 15:12:14 -0400
Received: by mail-wm1-f66.google.com with SMTP id u25so22911499wmc.4
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 12:12:14 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version;
 bh=SwsHpLXCUuUrL3zJ4NRgRM9dOKnnB1He+80YtSTsr+A=;
 b=hq86k1Ae+wvWoo2DRl+ALREZnYSgyQiMsxv877ZdKvbDtNJ22cYGXLsj6ZzV1QIDWE
 iQUOjLUlJtvXJ47gHpSXmwwkMlTSVzMgk5pTFvyQ/cHff/5D/2X0IgwRDzoOtHYmG92H
 D4WUvSmkH2RXcTb1RaLiJrXTzzpaP2Pj8l0pV0t0ZbAb5stGA7zWsK8YXTpVLaRSNxHK
 bT+0vOhwQ2haJ6JdqoebOfNyXimfgppEB5Ng2VVa6quaIRQta5b1Ndocg2fVAW8rArff
 YJRmA4+4h5dIMLndO07+w1L/dIFs3NsBOUqAy1iGZexPEDct1d0MkDN/25j/FPLdRYnh
 T7qw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version;
 bh=SwsHpLXCUuUrL3zJ4NRgRM9dOKnnB1He+80YtSTsr+A=;
 b=h4IVuMEAqHfq0zS3LVhQSm4DcZdWW3njZ5/yndzsdg1m5mNgHKPVQn/GHrj6mJ1NyY
 yM01FcU+gVKJxw5luo/YdRZPRN6Z1X5IhU3uyu3AizjkJyRtKqeLdlNTFVtdfDNSC4cH
 gV17k9SlLyLJ7lWRR0M+vsAUsaaNRNpJRawpIflrGykSpQp4sIgfnuGb3AsjtlGM8ukH
 AjNeK65pW3IQAD4t88JumeNhSgkUm9kW2o7ALAyzfCXYEj8LNqV3pGoA1BkN/AqU8fVq
 v25KOXusVlUmwG5EJdGg3O7Z8VeWWIiHuljQDR0Zr/HGSK8OtDPIylMGNdMyYCcCGNrn
 6Gmg==
X-Gm-Message-State: APjAAAVYGH3CsfldxxlSdGIYZ+9NrCuxPTVhWz8y1rymCD4fEv+TTnD9
 sZMakaDuiKu1pFgexjikZuY=
X-Google-Smtp-Source: APXvYqwU3CqB4EH2HoUyl93m4jWv5JCSwJi/zhnToHdIbTq4MnKw1tYJAVsRXhqEJfaxSE07RTu2UA==
X-Received: by 2002:a05:600c:20ca:: with SMTP id
 y10mr28558703wmm.72.1563736328044; 
 Sun, 21 Jul 2019 12:12:08 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id h8sm37076646wmf.12.2019.07.21.12.12.06
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sun, 21 Jul 2019 12:12:07 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
 <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Sun, 21 Jul 2019 21:12:06 +0200
In-Reply-To: <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
 (Pip Cet's message of "Sun, 21 Jul 2019 18:07:43 +0000")
Message-ID: <m2o91nmcc9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Sun, 21 Jul 2019 18:07:43 +0000, Pip Cet <pipcet@HIDDEN> said:
    Pip> I'm not sure about debugging on macOS, but can you get a full
    Pip> backtrace, or a core dump, or both? We're particularly interested in
    Pip> what "i" is in mark_vectorlike.

You want a lisp backtrace? I can always run under gdb if needed. As to
'i':

(lldb) up
frame #1: 0x000000010016dbec temacs`mark_object(arg=<unavailable>) at alloc.c:6082 [opt]
   6079	      {
   6080		struct Lisp_Symbol *ptr = XSYMBOL (obj);
   6081	      nextsym:
-> 6082	        if (symbol_marked_p (ptr))
   6083	          break;
   6084	        CHECK_ALLOCATED_AND_LIVE_SYMBOL ();
   6085	        set_symbol_marked(ptr);
(lldb)
frame #2: 0x000000010016f2aa temacs`mark_vectorlike(header=0x0000000101803200) at alloc.c:5666:5 [opt]
   5663	     The distinction is used e.g. by Lisp_Process which places extra
   5664	     non-Lisp_Object fields at the end of the structure...  */
   5665	  for (i = 0; i < size; i++) /* ...and then mark its elements.  */
-> 5666	    mark_object (ptr->contents[i]);
   5667	}
   5668
   5669	/* Like mark_vectorlike but optimized for char-tables (and
(lldb) p i
(ptrdiff_t) $0 = 0
(lldb) p ptr->contents
error: incomplete type 'Lisp_Object []' where a complete type is required
(lldb) p ptr->contents[0]
(Lisp_Object) $1 = 0x0008040000080400

    Pip> Otherwise, the attached patch should produce (probably a lot of)
    Pip> information, the last lines of which would be interesting...

Since you broke Robert's Second Rule of printf debugging, I stuck an
extra 'mark ' on the front of the fprintf in 'mark_vectorlike' :-)

0x10320c9e0 nil
0x10320c9e0 nil
0x10320c9e0 nil
0x10321ab70 z-group
0x10320c9e0 nil
0x10321a6f0 x-frame-parameter
0x10320ca40 unbound
0x10321aba0 zero-width
0x10320c9e0 nil
0x10320c9e0 nil
0x10320ca40 unbound
mark 0
make[1]: *** [bootstrap-emacs.pdmp] Segmentation fault: 11
make: *** [src] Error 2





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 18:15:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 14:15:06 2019
Received: from localhost ([127.0.0.1]:59464 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpGMT-0002qd-NH
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 14:15:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50456)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hpGMR-0002pn-Aa
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 14:15:04 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43080)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hpGML-0001HZ-RN; Sun, 21 Jul 2019 14:14:57 -0400
Received: from [176.228.60.248] (port=3119 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hpGML-0000s2-4A; Sun, 21 Jul 2019 14:14:57 -0400
Date: Sun, 21 Jul 2019 21:14:41 +0300
Message-Id: <83muh7qmpa.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
In-reply-to: <m2sgqzmftx.fsf@HIDDEN> (message from Robert Pluim on Sun, 21
 Jul 2019 19:56:42 +0200)
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, eggert@HIDDEN, pipcet@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Robert Pluim <rpluim@HIDDEN>
> Date: Sun, 21 Jul 2019 19:56:42 +0200
> Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
> 
>     Pip> That's strange. Looking at the crash backtrace again, it seems that
>     Pip> this is the initial garbage collection, when everything should be
>     Pip> pristine. I still think it dies while marking the obarray, upon
>     Pip> encountering a symbol which has somehow become corrupted...
> 
> OK. How do we go about detecting which symbol that is?

etc/DEBUG has some advice for debugging crashes inside GC.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 18:08:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 14:08:27 2019
Received: from localhost ([127.0.0.1]:59459 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpGG2-0002gY-TS
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 14:08:27 -0400
Received: from mail-ot1-f54.google.com ([209.85.210.54]:35674)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpGG1-0002gJ-5u
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 14:08:25 -0400
Received: by mail-ot1-f54.google.com with SMTP id j19so37884480otq.2
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 11:08:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=LOnVyhddL2rsM1y0vyo10kZZiNHMiCXDNtUyM+sZhO0=;
 b=qK38B4sR0dbJhQlRMvQHDtjMcYbEk8grBqljlqxezi1nDPYdDfMhUaqY+kqzzWgkso
 rULKOeFtolc0vVf80MoQ8wI2YRKlT+HwNrnZWZavo4Ijx6f7jx/C6lBickSlhuSmxmi/
 8qi/g+k1UyyfhN+vegWIl9adA+o7PFNjx4YZUY4g+o65kTgEG2cu0t83s8z+GK2cD/VR
 HxRbJaj1i4b9dMacWI2NGpRbkonty2iyH1iSrhWFh+3CfQzstfsVin0vXxtfdi3kqKzU
 Mekuc2sOIJNiFZ30HzoREy3UFTtYaxmu8/PnKQkilnmzE0Ti6Kq0xS1DdFeb/uwpOPKl
 beew==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=LOnVyhddL2rsM1y0vyo10kZZiNHMiCXDNtUyM+sZhO0=;
 b=g+V/5/I9Qj9YmzeNPriFLZmJo1VjwsECmajuCvTYyFQRzCdUG+s24kjNzT/lkNC8uI
 k+Yzi/3VAK18cy0IkP+w6gEoM2Zoh+S3JIpg5Pyk4fKec6zm8zWvwf7EqrcyWdouxR2f
 dE14uHxUVwoIO+1VQileTNNNLReb9e/aKI0MT1+CatBsNiCSLgK3XA4QlVVmLRLkfrOT
 cmXdueV3yPF42O7gwYhWgAr/Q5PkcLFE76N3cY1KJsVzMqvSfmkn0eS13BEwpN4vu5n5
 d1FHBFY1gFW02wTCr+Njq65r8Hkp040IL9B40Zw3Q7rAohfwCecZum7xzehHEGc4I1ON
 eYTw==
X-Gm-Message-State: APjAAAVswg+rRHmPmHI+aIfRSEgUOOHhbCVjDgsDP1yTnZz1CJXLtz03
 Msc8cqk2bTkYsr3VEiJ1eahBZxT3aognshW5GZo=
X-Google-Smtp-Source: APXvYqxK1u0wad/M3/GWgR2TLqk9Ft2rCTDd5k9XKIP6qhOiAyhDC+t52jqX29XuY8YqXBTbAAnzqqsXqckQJGuY5KI=
X-Received: by 2002:a9d:744f:: with SMTP id p15mr26353445otk.287.1563732499715; 
 Sun, 21 Jul 2019 11:08:19 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 <m2sgqzmftx.fsf@HIDDEN>
In-Reply-To: <m2sgqzmftx.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 21 Jul 2019 18:07:43 +0000
Message-ID: <CAOqdjBfPvNKc2fj=0nUxZ8VsDH_h+dkFnQd_srOpUxWPjvs+WQ@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000002b7b11058e34d88e"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000002b7b11058e34d88e
Content-Type: text/plain; charset="UTF-8"

On Sun, Jul 21, 2019 at 5:56 PM Robert Pluim <rpluim@HIDDEN> wrote:
> >>>>> On Sun, 21 Jul 2019 17:43:05 +0000, Pip Cet <pipcet@HIDDEN> said:
>
>     Pip> On Sun, Jul 21, 2019 at 3:06 PM Robert Pluim <rpluim@HIDDEN> wrote:
>     >> Hmm, it crashed the first time I ran make, then I got distracted, so I
>     >> ran make again later, and this time it built:
>     >>
>     >> make[2]: Nothing to be done for `all'.
>     >> ELC      char-fold.elc
>     >> freeing symbol def-tmp-var
>
>     Pip> Hmm. So it worked with the second patch, but only when you reran make?
>     Pip> That's strange. Looking at the crash backtrace again, it seems that
>     Pip> this is the initial garbage collection, when everything should be
>     Pip> pristine. I still think it dies while marking the obarray, upon
>     Pip> encountering a symbol which has somehow become corrupted...
>
> OK. How do we go about detecting which symbol that is?

I'm not sure about debugging on macOS, but can you get a full
backtrace, or a core dump, or both? We're particularly interested in
what "i" is in mark_vectorlike.

Otherwise, the attached patch should produce (probably a lot of)
information, the last lines of which would be interesting...

--0000000000002b7b11058e34d88e
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Other-debugging-changes.patch"
Content-Disposition: attachment; 
	filename="0001-Other-debugging-changes.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_jyd9xfcr0>
X-Attachment-Id: f_jyd9xfcr0

RnJvbSBmMzY2ZDY2ZTgzZDc2ZGYxZDg5ZTI2NGI0NjNhNmY5MDM0NTlkMDI0IE1vbiBTZXAgMTcg
MDA6MDA6MDAgMjAwMQpGcm9tOiBQaXAgQ2V0IDxwaXBjZXRAZ21haWwuY29tPgpEYXRlOiBTdW4s
IDIxIEp1bCAyMDE5IDE4OjAzOjE3ICswMDAwClN1YmplY3Q6IFtQQVRDSF0gT3RoZXIgZGVidWdn
aW5nIGNoYW5nZXMuCgotLS0KIHNyYy9hbGxvYy5jIHwgNyArKysrKystCiAxIGZpbGUgY2hhbmdl
ZCwgNiBpbnNlcnRpb25zKCspLCAxIGRlbGV0aW9uKC0pCgpkaWZmIC0tZ2l0IGEvc3JjL2FsbG9j
LmMgYi9zcmMvYWxsb2MuYwppbmRleCAxYjU1YWQ4Y2FiLi5mZTk4ZWNhMDg2IDEwMDY0NAotLS0g
YS9zcmMvYWxsb2MuYworKysgYi9zcmMvYWxsb2MuYwpAQCAtNTY2Myw3ICs1NjYzLDEwIEBAIG1h
cmtfdmVjdG9ybGlrZSAodW5pb24gdmVjdG9ybGlrZV9oZWFkZXIgKmhlYWRlcikKICAgICAgVGhl
IGRpc3RpbmN0aW9uIGlzIHVzZWQgZS5nLiBieSBMaXNwX1Byb2Nlc3Mgd2hpY2ggcGxhY2VzIGV4
dHJhCiAgICAgIG5vbi1MaXNwX09iamVjdCBmaWVsZHMgYXQgdGhlIGVuZCBvZiB0aGUgc3RydWN0
dXJlLi4uICAqLwogICBmb3IgKGkgPSAwOyBpIDwgc2l6ZTsgaSsrKSAvKiAuLi5hbmQgdGhlbiBt
YXJrIGl0cyBlbGVtZW50cy4gICovCi0gICAgbWFya19vYmplY3QgKHB0ci0+Y29udGVudHNbaV0p
OworICAgIHsKKyAgICAgIGZwcmludGYgKHN0ZGVyciwgIiVkXG4iLCAoaW50KWkpOworICAgICAg
bWFya19vYmplY3QgKHB0ci0+Y29udGVudHNbaV0pOworICAgIH0KIH0KIAogLyogTGlrZSBtYXJr
X3ZlY3Rvcmxpa2UgYnV0IG9wdGltaXplZCBmb3IgY2hhci10YWJsZXMgKGFuZApAQCAtNjA3OSw2
ICs2MDgyLDggQEAgI2RlZmluZSBDSEVDS19BTExPQ0FURURfQU5EX0xJVkVfU1lNQk9MKCkJKCh2
b2lkKSAwKQogICAgICAgewogCXN0cnVjdCBMaXNwX1N5bWJvbCAqcHRyID0gWFNZTUJPTCAob2Jq
KTsKICAgICAgIG5leHRzeW06CisJaWYgKCFOSUxQIChwdHItPnUucy5uYW1lKSkKKwkgIGZwcmlu
dGYgKHN0ZGVyciwgIiVwICVzXG4iLCBwdHIsIFNEQVRBIChwdHItPnUucy5uYW1lKSk7CiAgICAg
ICAgIGlmIChzeW1ib2xfbWFya2VkX3AgKHB0cikpCiAgICAgICAgICAgYnJlYWs7CiAgICAgICAg
IENIRUNLX0FMTE9DQVRFRF9BTkRfTElWRV9TWU1CT0wgKCk7Ci0tIAoyLjIyLjAKCg==
--0000000000002b7b11058e34d88e--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 17:56:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 13:56:51 2019
Received: from localhost ([127.0.0.1]:59455 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpG4o-0000ET-Qy
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 13:56:51 -0400
Received: from mail-wr1-f54.google.com ([209.85.221.54]:43003)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpG4n-0000EF-KK
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 13:56:49 -0400
Received: by mail-wr1-f54.google.com with SMTP id x1so22024024wrr.9
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 10:56:49 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version;
 bh=ok6Ith4y4PdKNocWPFQfkUCX4PiGt1cR+koHlxQlbeE=;
 b=G6z/DF2azrpr8C/e3cygn37Ey+l8yWPqGoF7TMg/6xt/8mP/nbyLOks1RB4+urJnYl
 adp7pJRmk2ojD4EkTkG3xWesnww21VE72WL1cBQ9CFQYeQUfx+hY3KleOYNiypsytWiN
 pxJFw8+uoBivg0s7GhTvHmfUjMGO36uEQIfMjhMpRWcgVw2xEk87IOHXlvvza+FIA9Pn
 hKM+tQpc1sNRzxn9qVNxiVZPO1bo61IqZ7AsDsrbMZPIzXxKgaAmko0L9YDdWrwGUSqX
 c3SwqjmHIBbxXpi7Bxsn9JEPpUtzZwZx6dq3mlxXAXhu4sBHeK7fv2yMTG6Y+EUE7qFQ
 hZYg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version;
 bh=ok6Ith4y4PdKNocWPFQfkUCX4PiGt1cR+koHlxQlbeE=;
 b=e4zOlhgmrsrqXZSBpZEYMzTEmDAIQcp81qVShz8xHi27akZLVj2cVrjipchegMYbTu
 Du3RLVPD2+rjXR9GSmFQsWwQi8pdx9+l+GzNm8+rfiV6parC1J63p+JVum/QXfFuI0U6
 RZYv/aly4OxTT+kn7OeY0NKpqAwqTJ2sY39pWwOwgkWMtspM7gkpWzTvzE4vIK/DSfiu
 +kDYwprYVwMxoeQBnD6u06dCXjEVlu7srCJn0owCN2iujIUBdCua3vbBdTXfj5S6dvl1
 9Of0CJ+YrcfMnSP2Kic1R+WVVjs9ZVSAbSwDLcm/ySH+rpg+b7ZlqqD3dG9TCztEVJiY
 qVNQ==
X-Gm-Message-State: APjAAAUWZ9P4yn+CdG3+hIYrvEHO1lzd9AGoHI6ETNhif/VFInqOWJ43
 VjbLGsyEGUOJClq8eoSf6WM=
X-Google-Smtp-Source: APXvYqz2HW2I2iRvdiXYz5Gtlt+1+O862SlgUptG8JTn2vE1IevqYj467hep59hs9OwxpyD/v4EG7g==
X-Received: by 2002:a5d:428b:: with SMTP id k11mr38702603wrq.174.1563731803658; 
 Sun, 21 Jul 2019 10:56:43 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id l8sm66224175wrg.40.2019.07.21.10.56.42
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sun, 21 Jul 2019 10:56:42 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
 <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Sun, 21 Jul 2019 19:56:42 +0200
In-Reply-To: <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
 (Pip Cet's message of "Sun, 21 Jul 2019 17:43:05 +0000")
Message-ID: <m2sgqzmftx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Sun, 21 Jul 2019 17:43:05 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> On Sun, Jul 21, 2019 at 3:06 PM Robert Pluim <rpluim@HIDDEN> wrote:
    >> Hmm, it crashed the first time I ran make, then I got distracted, so I
    >> ran make again later, and this time it built:
    >> 
    >> make[2]: Nothing to be done for `all'.
    >> ELC      char-fold.elc
    >> freeing symbol def-tmp-var

    Pip> Hmm. So it worked with the second patch, but only when you reran make?
    Pip> That's strange. Looking at the crash backtrace again, it seems that
    Pip> this is the initial garbage collection, when everything should be
    Pip> pristine. I still think it dies while marking the obarray, upon
    Pip> encountering a symbol which has somehow become corrupted...

OK. How do we go about detecting which symbol that is?

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 17:43:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 13:43:49 2019
Received: from localhost ([127.0.0.1]:59423 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpFsD-0008J0-Mh
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 13:43:49 -0400
Received: from mail-ot1-f47.google.com ([209.85.210.47]:43969)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpFsB-0008Il-BG
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 13:43:48 -0400
Received: by mail-ot1-f47.google.com with SMTP id j11so13568984otp.10
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 10:43:47 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=i9VIOhCCXWSSVnuT1r+ltnJoyAqpWxcZniYZnhq+gZI=;
 b=ux8La9ulP4IOZ3kR2PHQhMLw+mYCIsK5oGb38HSc3RMo06+390bAu851dHQ4lzksPb
 X5ctw6Q2MMSF3H42yUZPKCZGeIXs+yfZRbDJ07WE17NEvxwfitHZ2tQAlrvcZCvivGUO
 a04Uf7w04Ao7OVvzNHgUsh6wXjQ40MBg0lZKYk9Fi5XF1q9Q49YNM99VYGr0R3d1Vhy9
 8wtPh1cl2I4P9jyPzybYRmed7CB24yuMfH1gOWwQ7lKUoCXUoV7/xiOeBTu/fYhjmkAV
 Cu0l5dIkymHp8rh2jUqT9VF70AMATpag7GBtnY+OaoWD3NEMajgy99vGbOGOXi1bK+vG
 nxlA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=i9VIOhCCXWSSVnuT1r+ltnJoyAqpWxcZniYZnhq+gZI=;
 b=AvuVDvzX+q/Nh8cRGzbPU/wiKxmnkp50z+8erWwPwEIEfzqPYsgyuQRAU40vCwwX9D
 nOcXt8+u55u7ZQYLDWCDODDEmHa1hITIROF5de3yOwQ2RlVCum/Od/yTpERMOkA0DQWF
 uUrj1mMeKMiw0I8a9sT43rEaE5LDUuWHvypHMSictEFQK33JTKVgfRMmMk2sXFl2VUMy
 pkqTReIaVpBGG9jAU2IyirDTtDu/YXzGRa3CcX//RSjmV/G6A+FtaYLUrxG8W8p9gOrP
 pdZ2zL7YruAB/ba/6KNKvWX+/xQOUzwSvs19LPBPVCtMPRWJ795naEM+lpejv0ftMA8V
 OaaA==
X-Gm-Message-State: APjAAAVrGkQE29HD7c1hbVK0/Q91Mbvz70EvkVl5dhm2d9DuqTM0NNHt
 TpUoMJjpFvO0cAfGlwCJhHb+hbaG9LmSf6JSFbI=
X-Google-Smtp-Source: APXvYqxE+xOMkIItfUVEeT5UdEVg/F06zvDmbuJKXcCaf4TSHDt7r8ll0WPq9BRChvsXPSTrxhWl/n2X4SEcphU4spk=
X-Received: by 2002:a9d:664c:: with SMTP id q12mr41407360otm.175.1563731021730; 
 Sun, 21 Jul 2019 10:43:41 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 <m2wogbmnqf.fsf@HIDDEN>
In-Reply-To: <m2wogbmnqf.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 21 Jul 2019 17:43:05 +0000
Message-ID: <CAOqdjBfVwDE-e7hZR_eKf1uoix8sGFWSyraW1jyFTne6bG3k=Q@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, Jul 21, 2019 at 3:06 PM Robert Pluim <rpluim@HIDDEN> wrote:

> Hmm, it crashed the first time I ran make, then I got distracted, so I
> ran make again later, and this time it built:
>
> make[2]: Nothing to be done for `all'.
>   ELC      char-fold.elc
> freeing symbol def-tmp-var

Hmm. So it worked with the second patch, but only when you reran make?
That's strange. Looking at the crash backtrace again, it seems that
this is the initial garbage collection, when everything should be
pristine. I still think it dies while marking the obarray, upon
encountering a symbol which has somehow become corrupted...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 15:06:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 11:06:14 2019
Received: from localhost ([127.0.0.1]:59297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpDPi-0006KW-5W
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 11:06:14 -0400
Received: from mail-wm1-f52.google.com ([209.85.128.52]:35436)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpDPd-0006KE-J3
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 11:06:12 -0400
Received: by mail-wm1-f52.google.com with SMTP id l2so32981064wmg.0
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 08:06:09 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version:content-transfer-encoding;
 bh=2mWvbYZlJIE4pge4GIi+QjuJhkTE/1BZlrrwRQaRXb8=;
 b=QA17vpA9FlLGzogKFTiG9RresMx9Irwu9jwMQ2enOY2RC9hEfWebEmjSv4iefFcP2f
 FVnFl+LSjW2Juk0IceT4WrYS4ljiS2dcimDgb45CwsOw9Y+NCA1+tLRLCW72a7GriTQr
 MLZVKUUZIfWSDqWaICRNEGHzw2OKgrkrzLT4+ithIoqO78x29cnHQ8lEYNmDHkRMmKz/
 YNhTMR88+PhU8PfgCq8znkhphQhk6nUVAXAxFwV9WV2qwpTip9Eh/oNdQl+LKCptOmnq
 n22tqjIpNXOs+j7CqggQjmsgQkFYzselQuZBkxo2Mt4q3uBs9kbDao7OX9wG7QAbq2Vc
 c4hg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version
 :content-transfer-encoding;
 bh=2mWvbYZlJIE4pge4GIi+QjuJhkTE/1BZlrrwRQaRXb8=;
 b=JVmmyBoDu8R+CM8NPvgBMl4Eqi9gtLDabWwp4NCK1UWaLna2xTnupnD0UKT48IRTmG
 c8pA8gbvOtXd0uyvodM5Veak5AME8IXLcfrh944UhOxU2xQFD9KT7I2xmL4KB/36lEWK
 gaHMmOtzc1zdF3Ph6HYAN/RN4awUlHi6FzKjpSutYUg0ZA/iKACoiV+d6wA/vzEP+fFM
 mCiyWSCGxuz6sQn+NvVPpvJ3ajOTvFWYykWcB5QataiBUiWIi454DT/AxOuxwKl3x8m/
 Kupbo2tSTNYAaWAmVH3s5RBS4ffWNEl+VAUhxN4vprd9849g4BvvVcsMLKKo1qJHqe50
 9OGQ==
X-Gm-Message-State: APjAAAWcE42IkVy9aSV0lnPdycu4UR36QIuTsWg916oM2Wy+Jr9XnFwA
 6BeXZOX9+pMtnyw039d1ipk=
X-Google-Smtp-Source: APXvYqy3c8iFkz46CN+KBaEQUAAB/kWvlxmkA5l24RcvxYrAVfG+1ZhK5VDcNftMDHUuIDYlW72Ebg==
X-Received: by 2002:a1c:63d7:: with SMTP id x206mr60071802wmb.19.1563721562912; 
 Sun, 21 Jul 2019 08:06:02 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id l8sm65384727wrg.40.2019.07.21.08.06.01
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sun, 21 Jul 2019 08:06:01 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
 <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Sun, 21 Jul 2019 17:06:00 +0200
In-Reply-To: <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
 (Pip Cet's message of "Sun, 21 Jul 2019 14:36:41 +0000")
Message-ID: <m2wogbmnqf.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Sun, 21 Jul 2019 14:36:41 +0000, Pip Cet <pipcet@HIDDEN> said:

    Pip> On Sun, Jul 21, 2019 at 1:44 PM Robert Pluim <rpluim@HIDDEN> wr=
ote:
    >> >>>>> On Sun, 21 Jul 2019 12:53:21 +0000, Pip Cet <pipcet@HIDDEN>=
 said:
    Pip> I think we should do (1) for now, since it simplifies the code eno=
ugh
    Pip> to introduce immutable objects "soon"; but until that time, we was=
te
    Pip> more space on duplicate objects that we no longer know to be
    Pip> immutable, so cannot merge.
    >>=20
    Pip> I'm attaching a first patch that removes pure space, pinned symbol=
s,
    Pip> pinned objects, but keeps Fpurecopy (for hash consing), and doesn't
    Pip> touch the Lisp codebase.
    >>=20
    >> This doesn=CA=BCt build for me on macOS. After adjusting the paramet=
ers to
    >> the call to make_hash_table in image.c, it crashes when dumping:

    Pip> Thanks for testing! Indeed, I'd only verified it builds here.

    Pip> My first guess is there's a symbol in the obarray which used to be
    Pip> pinned, but is now collected before it is interned.

    Pip> Can you try with the attached patch relative to the one I'd sent
    Pip> before, and see what the output is?

Hmm, it crashed the first time I ran make, then I got distracted, so I
ran make again later, and this time it built:

make[2]: Nothing to be done for `all'.
  ELC      char-fold.elc
freeing symbol def-tmp-var




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 14:37:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 10:37:25 2019
Received: from localhost ([127.0.0.1]:59256 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpCxp-0001II-5o
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 10:37:25 -0400
Received: from mail-oi1-f170.google.com ([209.85.167.170]:44380)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpCxn-0001I5-Av
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 10:37:23 -0400
Received: by mail-oi1-f170.google.com with SMTP id e189so27675302oib.11
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 07:37:23 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=98XvsXihjWDyCXP1fxjvhJTEFQBvjRWO1UUsNpa/zwM=;
 b=QOxrUWNMBVBFbhlGEVDqkAYxxzwWz+z4hJxyXwVz5BkPjdeyWNTY81I1q6vfFQhVp7
 u0NTU35ENmoPHERrzsfKSHHwPvK4jr0rI3TYaSc4rwZYhw5ON0YQC2+vCfIkkMoMp/GY
 97gU5vn+8KhEPO943zn/zfSLVRHkEaaWI8bSr9NzuirHhAfBZRqicFNnCD+AAi7ygXRX
 BDGbmTWqj1HyAU+5SYotJY7KAj6ARhXTM01Fv4L7+sBzyCjonSBJOZZQA8bkFbceic/z
 biAhUkECs+EGeNu5//pBFKQA09ree60R4NkXxyZq4JjWLGLBno34Dhex3O1EqMYLRPNt
 /mbg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=98XvsXihjWDyCXP1fxjvhJTEFQBvjRWO1UUsNpa/zwM=;
 b=hnbLMaUYPTnir9HfDiEcEd2UyVacbvb+pYQ12S4hrJTxS2U9y4pdKIJcAc9cMnq/b2
 m/yod8QbZeePAcLZDshNE2iLpEAjguGYhQMtoHwpQPhvzk7fCF/BwlUJF+3ZdUoPVQpx
 JZ1D+4rOD/2QsAS1IBzcXV4hjI3o1amZ1cbkXZRvZWnychu9KvuvbuHPV5Fvagf9KQZU
 Kx/wPERGLGbXafyd/tVzKGjsmIsfLGlct9FjmmW37TRgQvXhHjPfhZd33swN/NGB8gy6
 JqtLmqqeqT0/heSuU9yVngtKGQV/wGN7+nC+p+CZpfHt24OVSMshNRfLPKMe27ldjsat
 2q8Q==
X-Gm-Message-State: APjAAAWYFPU3bZ77bwTrMZHsqQRnRe0R4HXOjNjwbSGYWuy3Bh3sWMbU
 6PkoYj4Ki7sx4U4a1xV/Enxxliprk35bNG96p8Y=
X-Google-Smtp-Source: APXvYqyCCJFDpj/GWg659s9hFuZvVOle6wNvQY+PXgP+BClnuuV9+ln0QBUeLqAXQ84kPpyqVfg/c4YcquQps20S/FQ=
X-Received: by 2002:a05:6808:313:: with SMTP id
 i19mr31018355oie.30.1563719837675; 
 Sun, 21 Jul 2019 07:37:17 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 <m21ryjo624.fsf@HIDDEN>
In-Reply-To: <m21ryjo624.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 21 Jul 2019 14:36:41 +0000
Message-ID: <CAOqdjBcXoYick-UbTv+D=TaeHCOG5WAamGnyqpyLTKwPOzVqOg@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Robert Pluim <rpluim@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000741940058e31e5ff"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--000000000000741940058e31e5ff
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

On Sun, Jul 21, 2019 at 1:44 PM Robert Pluim <rpluim@HIDDEN> wrote:
> >>>>> On Sun, 21 Jul 2019 12:53:21 +0000, Pip Cet <pipcet@HIDDEN> said=
:
>     Pip> I think we should do (1) for now, since it simplifies the code e=
nough
>     Pip> to introduce immutable objects "soon"; but until that time, we w=
aste
>     Pip> more space on duplicate objects that we no longer know to be
>     Pip> immutable, so cannot merge.
>
>     Pip> I'm attaching a first patch that removes pure space, pinned symb=
ols,
>     Pip> pinned objects, but keeps Fpurecopy (for hash consing), and does=
n't
>     Pip> touch the Lisp codebase.
>
> This doesn=CA=BCt build for me on macOS. After adjusting the parameters t=
o
> the call to make_hash_table in image.c, it crashes when dumping:

Thanks for testing! Indeed, I'd only verified it builds here.

My first guess is there's a symbol in the obarray which used to be
pinned, but is now collected before it is interned.

Can you try with the attached patch relative to the one I'd sent
before, and see what the output is?

--000000000000741940058e31e5ff
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-debugging-changes.patch"
Content-Disposition: attachment; filename="0001-debugging-changes.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_jyd2e5nt0>
X-Attachment-Id: f_jyd2e5nt0

RnJvbSA0NWU4ZjdiZGJiYTQzZjYyN2IzOTk1NzM2NmI3MGRjYmRjNjU3NWE4IE1vbiBTZXAgMTcg
MDA6MDA6MDAgMjAwMQpGcm9tOiBQaXAgQ2V0IDxwaXBjZXRAZ21haWwuY29tPgpEYXRlOiBTdW4s
IDIxIEp1bCAyMDE5IDE0OjM1OjA0ICswMDAwClN1YmplY3Q6IFtQQVRDSF0gZGVidWdnaW5nIGNo
YW5nZXMKCi0tLQogc3JjL2FsbG9jLmMgfCAzICsrLQogc3JjL2ltYWdlLmMgfCAyICstCiAyIGZp
bGVzIGNoYW5nZWQsIDMgaW5zZXJ0aW9ucygrKSwgMiBkZWxldGlvbnMoLSkKCmRpZmYgLS1naXQg
YS9zcmMvYWxsb2MuYyBiL3NyYy9hbGxvYy5jCmluZGV4IGRmOGIxY2FmNGUuLjFiNTVhZDhjYWIg
MTAwNjQ0Ci0tLSBhL3NyYy9hbGxvYy5jCisrKyBiL3NyYy9hbGxvYy5jCkBAIC02NDI4LDYgKzY0
MjgsNyBAQCBzd2VlcF9zeW1ib2xzICh2b2lkKQogICAgICAgICB7CiAgICAgICAgICAgaWYgKCFz
eW0tPnUucy5nY21hcmtiaXQpCiAgICAgICAgICAgICB7CisJICAgICAgZnByaW50ZiAoc3RkZXJy
LCAiZnJlZWluZyBzeW1ib2wgJXNcbiIsIFNEQVRBIChzeW0tPnUucy5uYW1lKSk7CiAgICAgICAg
ICAgICAgIGlmIChzeW0tPnUucy5yZWRpcmVjdCA9PSBTWU1CT0xfTE9DQUxJWkVEKQogCQl7CiAg
ICAgICAgICAgICAgICAgICB4ZnJlZSAoU1lNQk9MX0JMViAoc3ltKSk7CkBAIC02NTE5LDEyICs2
NTIwLDEyIEBAIHN3ZWVwX2J1ZmZlcnMgKHZvaWQpCiBzdGF0aWMgdm9pZAogZ2Nfc3dlZXAgKHZv
aWQpCiB7CisgIHN3ZWVwX3N5bWJvbHMgKCk7CiAgIHN3ZWVwX3N0cmluZ3MgKCk7CiAgIGNoZWNr
X3N0cmluZ19ieXRlcyAoIW5vbmludGVyYWN0aXZlKTsKICAgc3dlZXBfY29uc2VzICgpOwogICBz
d2VlcF9mbG9hdHMgKCk7CiAgIHN3ZWVwX2ludGVydmFscyAoKTsKLSAgc3dlZXBfc3ltYm9scyAo
KTsKICAgc3dlZXBfYnVmZmVycyAoKTsKICAgc3dlZXBfdmVjdG9ycyAoKTsKICAgcGR1bXBlcl9j
bGVhcl9tYXJrcyAoKTsKZGlmZiAtLWdpdCBhL3NyYy9pbWFnZS5jIGIvc3JjL2ltYWdlLmMKaW5k
ZXggMzU1Yzg0OTQ5MS4uYjIxZGZmMzRkNCAxMDA2NDQKLS0tIGEvc3JjL2ltYWdlLmMKKysrIGIv
c3JjL2ltYWdlLmMKQEAgLTQ1OTYsNyArNDU5Niw3IEBAIHhwbV9tYWtlX2NvbG9yX3RhYmxlX2gg
KHZvaWQgKCoqcHV0X2Z1bmMpIChMaXNwX09iamVjdCwgY29uc3QgY2hhciAqLCBpbnQsCiAgICpn
ZXRfZnVuYyA9IHhwbV9nZXRfY29sb3JfdGFibGVfaDsKICAgcmV0dXJuIG1ha2VfaGFzaF90YWJs
ZSAoaGFzaHRlc3RfZXF1YWwsIERFRkFVTFRfSEFTSF9TSVpFLAogCQkJICBERUZBVUxUX1JFSEFT
SF9TSVpFLCBERUZBVUxUX1JFSEFTSF9USFJFU0hPTEQsCi0JCQkgIFFuaWwsIGZhbHNlKTsKKwkJ
CSAgUW5pbCk7CiB9CiAKIHN0YXRpYyB2b2lkCi0tIAoyLjIyLjAKCg==
--000000000000741940058e31e5ff--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 13:45:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 09:45:02 2019
Received: from localhost ([127.0.0.1]:58241 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpC98-0003ut-3z
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 09:45:02 -0400
Received: from mail-wr1-f42.google.com ([209.85.221.42]:45525)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1hpC96-0003uO-9K
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 09:45:00 -0400
Received: by mail-wr1-f42.google.com with SMTP id f9so36635498wre.12
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 06:45:00 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:mail-copies-to:gmane-reply-to-list
 :date:in-reply-to:message-id:mime-version:content-transfer-encoding;
 bh=h88p0JVhhD/SFKZ0GmKxrRojxz1j/bPv/ghIh/pNpLU=;
 b=YgGuhceSujuk+1qYhrvYMWtoNPI8Ln57QFeksTx7F7rBy+j6wPjsd2Ag66cwEbXLfk
 Y935rGZ/dKgg9EogyzeKaqEMSAAmTyaF7QhWVDd35cmIOytZOHyTWq65RJHIY1R0HjOX
 9IJPdXGvUDhyCiQ/oOzc01ia9O1GLt881yrY/Qxt6CV1SeyZ9OK8NAlak+Po3J9n5LPi
 mF00wHe9pA/9i4qJq1PSysUvqwPzfMzEQUpqgTp6BNhR5zbsWY7q+C3goX9i1rWzu33B
 aX2M97nUFyAIpwjBpzwaUh9VGIsfwjDBGoAVZckbOlIorJ5VjgMSmUzEvBEvD874dJn3
 6cbA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:mail-copies-to
 :gmane-reply-to-list:date:in-reply-to:message-id:mime-version
 :content-transfer-encoding;
 bh=h88p0JVhhD/SFKZ0GmKxrRojxz1j/bPv/ghIh/pNpLU=;
 b=XmFS+Kr26Pb30P3CpGTQ1eTBO726ujv7pAhUTC+NIJH2NMfSRFbXWml7BetK3ZJpZ4
 oMtkXcU79o6BCqtF7aJrm8JBINDDYo+24YzU8eR+yHHov9sipP41H1kFUK2DYkpoCC0p
 PiI9rPMYSPqBVvam6jRDe8lJ/6UoBfA1m6Nv79fUE12pkfF94Ls3yIHHWKjHr/BXggR4
 cNRYQxf5WMC/Y+ZhWJIDbksW+bmfrQCUb2UDLPyAI+qOkyvoVJyqBOY8MDx5sTrRW8rw
 jba1l6Sxaqs2+uO2+yoozMi9AN0A0n9h+j8U6ER1uqA0V/rzTauEOiEAIB3Qmnocv9qF
 Qqlg==
X-Gm-Message-State: APjAAAV91SRB4LXn07AuC+Ee67yyD8DgWd000QRX3NY+wZVeZ1zH3xIx
 iEXhAlRK8pRWru18Gau3mkY28sKp
X-Google-Smtp-Source: APXvYqyAl4sEp9EYi9dmher00DQF1WlasRqPuLIB0uLA7oZoySFvZ7Sytv2usr6Johf9lSTioQzRow==
X-Received: by 2002:adf:e483:: with SMTP id i3mr28563306wrm.210.1563716693809; 
 Sun, 21 Jul 2019 06:44:53 -0700 (PDT)
Received: from rpluim-mac ([2a01:e34:ecfc:a860:c53e:f59d:3814:6a60])
 by smtp.gmail.com with ESMTPSA id c6sm34347717wma.25.2019.07.21.06.44.52
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sun, 21 Jul 2019 06:44:52 -0700 (PDT)
From: Robert Pluim <rpluim@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
 <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
X-Debbugs-No-Ack: yes
Mail-Copies-To: never
Gmane-Reply-To-List: yes
Date: Sun, 21 Jul 2019 15:44:51 +0200
In-Reply-To: <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
 (Pip Cet's message of "Sun, 21 Jul 2019 12:53:21 +0000")
Message-ID: <m21ryjo624.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Sun, 21 Jul 2019 12:53:21 +0000, Pip Cet <pipcet@HIDDEN> said:
    Pip> I think we should do (1) for now, since it simplifies the code eno=
ugh
    Pip> to introduce immutable objects "soon"; but until that time, we was=
te
    Pip> more space on duplicate objects that we no longer know to be
    Pip> immutable, so cannot merge.

    Pip> I'm attaching a first patch that removes pure space, pinned symbol=
s,
    Pip> pinned objects, but keeps Fpurecopy (for hash consing), and doesn't
    Pip> touch the Lisp codebase.

This doesn=CA=BCt build for me on macOS. After adjusting the parameters to
the call to make_hash_table in image.c, it crashes when dumping:

make[1]: Nothing to be done for `charscript.el'.
rm -f bootstrap-emacs.pdmp
./temacs --batch  -l loadup --temacs=3Dpbootstrap
make: *** [bootstrap-emacs.pdmp] Segmentation fault: 11


* thread #1, queue =3D 'com.apple.main-thread', stop reason =3D EXC_BAD_ACC=
ESS (code=3DEXC_I386_GPFLT)
    frame #0: 0x000000010016dc70 temacs`mark_object [inlined] symbol_marked=
_p(s=3D0x00080401003fdde0) at alloc.c:3741:14 [opt]
   3738	{
   3739	  return pdumper_object_p (s)
   3740	    ? pdumper_marked_p (s)
-> 3741	    : s->u.s.gcmarkbit;
   3742	}
   3743

* thread #1, queue =3D 'com.apple.main-thread', stop reason =3D EXC_BAD_ACC=
ESS (code=3DEXC_I386_GPFLT)
  * frame #0: 0x000000010016dc70 temacs`mark_object [inlined] symbol_marked=
_p(s=3D0x00080401003fdde0) at alloc.c:3741:14 [opt]
    frame #1: 0x000000010016dc4c temacs`mark_object(arg=3D<unavailable>) at=
 alloc.c:6082 [opt]
    frame #2: 0x000000010016f30a temacs`mark_vectorlike(header=3D0x00000001=
01804000) at alloc.c:5666:5 [opt]
    frame #3: 0x000000010016d6e0 temacs`mark_object(arg=3D<unavailable>) at=
 alloc.c:5607:1 [opt] [artificial]
    frame #4: 0x000000010016c4cc temacs`garbage_collect_1 [inlined] mark_ob=
ject_root_visitor(root_ptr=3D<unavailable>, type=3DGC_ROOT_STATICPRO) at al=
loc.c:5303:3 [opt]
    frame #5: 0x000000010016c4c4 temacs`garbage_collect_1 at alloc.c:5295 [=
opt]
    frame #6: 0x000000010016c34f temacs`garbage_collect_1(gcst=3D0x00007ffe=
efbff248) at alloc.c:5427 [opt]
    frame #7: 0x000000010016c114 temacs`garbage_collect at alloc.c:5551:3 [=
opt]
    frame #8: 0x000000010019b836 temacs`eval_sub [inlined] maybe_gc at lisp=
.h:4974:5 [opt]
    frame #9: 0x000000010019b824 temacs`eval_sub(form=3D0x000000010302e843)=
 at eval.c:2166 [opt]
    frame #10: 0x00000001001a023a temacs`Feval(form=3D0x000000010302e843, l=
exical=3D<unavailable>) at eval.c:2089:28 [opt]
    frame #11: 0x000000010019f082 temacs`internal_condition_case(bfun=3D(te=
macs`top_level_2 at keyboard.c:1099), handlers=3D0x0000000000000090, hfun=
=3D(temacs`cmd_error at keyboard.c:919)) at eval.c:1347:25 [opt]
    frame #12: 0x00000001001107ed temacs`top_level_1(ignore=3D<unavailable>=
) at keyboard.c:1108:5 [opt]
    frame #13: 0x000000010019e617 temacs`internal_catch(tag=3D0x00000000000=
0c420, func=3D(temacs`top_level_1 at keyboard.c:1105), arg=3D0x000000000000=
0000) at eval.c:1108:25 [opt]
    frame #14: 0x00000001000fc16f temacs`command_loop at keyboard.c:1069:2 =
[opt]
    frame #15: 0x00000001000fc093 temacs`recursive_edit_1 at keyboard.c:714=
:9 [opt]
    frame #16: 0x00000001000fc3ac temacs`Frecursive_edit at keyboard.c:786:=
3 [opt]
    frame #17: 0x00000001000fa9b1 temacs`main(argc=3D<unavailable>, argv=3D=
0x00007ffeefbff6b8) at emacs.c:2085:3 [opt]
    frame #18: 0x00007fff7f9da3d5 libdyld.dylib`start + 1
    frame #19: 0x00007fff7f9da3d5 libdyld.dylib`start + 1
=20=20=20=20




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36649; Package emacs. Full text available.

Message received at 36649 <at> debbugs.gnu.org:


Received: (at 36649) by debbugs.gnu.org; 21 Jul 2019 12:54:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 21 08:54:03 2019
Received: from localhost ([127.0.0.1]:58201 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hpBLn-0002h2-HM
	for submit <at> debbugs.gnu.org; Sun, 21 Jul 2019 08:54:03 -0400
Received: from mail-oi1-f178.google.com ([209.85.167.178]:34947)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1hpBLm-0002gZ-T8
 for 36649 <at> debbugs.gnu.org; Sun, 21 Jul 2019 08:54:03 -0400
Received: by mail-oi1-f178.google.com with SMTP id a127so27653436oii.2
 for <36649 <at> debbugs.gnu.org>; Sun, 21 Jul 2019 05:54:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=LK8pNpnpMmL/0Fx8EftnjOE9dEXjVzkZWUQBwl4spJ4=;
 b=h9IHDFNyQPrkYIO8DWfB9csJUKp0jGAY3OVxnUI5mUbn8RVrxxpZi9ld4kODAFSm9F
 BSQymLtm9h1LdtH8bKA5oxTaXNp9Kg0B0N8LhN9GkaWcwY1T5PE0XE2wPna9Q5mFWiek
 R2pjSFZCZpFRrMwj5JDxsp9xS3+MG9ObYS1yBi829v4bylWNU0GpcKqA4E+HIe3n9PIy
 s5wfLOptiOYOf4ElsFKBf/vsrc1KqvaNu4lXeI8ZiZH0/n9GkyUe84fHV0QIJAlxet7z
 6I5KV/IqmNsFGoJsXoOyqBfh4lzOoN5c2t2Y/dMn/ledimLWajqdU+b/X1eY/6+aBqrV
 OTbA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=LK8pNpnpMmL/0Fx8EftnjOE9dEXjVzkZWUQBwl4spJ4=;
 b=lZg5CHjXBFIBYkhcs4bM0A1ZNAcPFELwhwaJUJTmeymW/71siJDUghDklReEXb1gxw
 eGxN7lRTpw2w5z5WVQp7GFvYwWM0fy46DUUleELo75XqpgbtkBt8lJ82HteSu8lxFRyP
 GLltZT7yFiPo34rM+r72zcJZvAmPKbPNDILGa0kNQaxea2F58u7x6Fu/xmIvTSMGlSaX
 thDliEON1r4fL10zk6nLW7po3iYt4XitDwmoFn41TXYlJZ8xbYFARZuoNfDk0Bk+lXR2
 S8kc3xzv7l+xTZEVGmYZTgxyR0sidveZFz1B+EmJFvh+8CJs3/1WrgoyLWFVo3jfRN9E
 NokQ==
X-Gm-Message-State: APjAAAVF2S15k0G71vLqzYkTBPLT4TinV8kHQfAYsXjQDFKuWjxh9Nmz
 swkmeBaOWfdt9YQFZU3QSjwDAlwh+y9ztrHI1Wc=
X-Google-Smtp-Source: APXvYqzDTJWfeCu5zBSs56A0rkJ3L0jHUjBhAzDSRHPDePE+GkvuMIB4V3+WuAGLDdcQs0iSrG60lUQHCGKtvcUuJFs=
X-Received: by 2002:aca:2303:: with SMTP id e3mr28158042oie.112.1563713637250; 
 Sun, 21 Jul 2019 05:53:57 -0700 (PDT)
MIME-Version: 1.0
References: <CAOqdjBc20okPT5GrpV2JNyCaYK8LDT5Z+Rb-UF0Ayf3mse=g9A@HIDDEN>
 <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
In-Reply-To: <bc2d941d-fdd9-0c99-3da0-953bd1f132fe@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 21 Jul 2019 12:53:21 +0000
Message-ID: <CAOqdjBdF0JgDJj1H5hc=XBnOxJc=dyCMb=+OhbVh1Tb6fiVnCQ@HIDDEN>
Subject: Re: bug#36649: 27.0.50; pure space and pdumper
To: Paul Eggert <eggert@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000e11ba9058e307302"
X-Debbugs-Envelope-To: 36649
Cc: 36649 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>

--000000000000e11ba9058e307302
Content-Type: text/plain; charset="UTF-8"

On Sun, Jul 21, 2019 at 7:29 AM Paul Eggert <eggert@HIDDEN> wrote:
> > I think we have the following options:
> >
> > 1. remove pure space entirely
> > 2. remove pure space, but leave PURE_P and CHECK_IMPURE as reminders
> > to do something about it.
> > 3. move pure space to BSS
> > 4. xmalloc() pure space, only when needed
> > 5. modify pdumper to mark and recognize pure objects
> > 6. do nothing and accept the wastefulness
>
> I suggest (1), since it will result in simpler code.

I think we should do (1) for now, since it simplifies the code enough
to introduce immutable objects "soon"; but until that time, we waste
more space on duplicate objects that we no longer know to be
immutable, so cannot merge.

I'm attaching a first patch that removes pure space, pinned symbols,
pinned objects, but keeps Fpurecopy (for hash consing), and doesn't
touch the Lisp codebase.

With this patch, I have:
-rw-r--r-- 2 pip pip 11102752 Jul 21 12:28 src/emacs.pdmp

before:
-rw-r--r-- 2 pip pip 10381464 Jul 21 12:29 src/emacs.pdmp

However, the (uncompressed) disk space requirement is about the same,
since the emacs binary is a lot smaller.

I think the next steps are to look at actual live memory usage (which
will increase due to the non-duplication of objects, but not by an
entire megabyte because some of that data is relocations), and GC
performance (no prediction here, it could improve or deteriorate).

--000000000000e11ba9058e307302
Content-Type: text/x-patch; charset="US-ASCII"; name="0001-Remove-pure-space.patch"
Content-Disposition: attachment; filename="0001-Remove-pure-space.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_jycyoi560>
X-Attachment-Id: f_jycyoi560
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